/**
 * \file
 *
 * \brief SAM D20/D21/R21doײ
 *
 * 쌠 (C) 2013-2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#include "bod.h"

/**
 * \brief do(BOD)Pʕ`Ԑݒ
 *
 * ^ꂽ`Ԑݒ\̂Ɋi[ꂽݒŗ^ꂽBODPʕ`Ԑݒ肵
 * B
 *
 * \param[in]  bod_id `Ԗ肷BODPʕ
 * \param[in]  conf   w肵BODɎgp`Ԑݒ
 *
 * \retval     STATUS_OK                 삪Ɋ
 * \retval     STATUS_ERR_INVALID_ARG    BOD܂B
 * \retval     STATUS_ERR_INVALID_OPTION vꂽBODق͎󂯓\Ȕ͈͊OłB
 */
enum status_code bod_set_config(
		const enum bod bod_id,
		struct bod_config *const conf)
{
	/*  */
	Assert(conf);

	uint32_t temp = 0;

	/* BODOuANA`ԂޯĎՕɕϊ */
	temp |= (uint32_t)conf->prescaler | (uint32_t)conf->action |
			(uint32_t)conf->mode;

	if (conf->mode == BOD_MODE_SAMPLED) {
		/* ̎擮ȂA̎ۯ */
		temp |= SYSCTRL_BOD33_CEN;
	}

	if (conf->hysteresis == true) {
		temp |= SYSCTRL_BOD33_HYST;
	}

	if (conf->run_in_standby == true) {
		temp |= SYSCTRL_BOD33_RUNSTDBY;
	}

	switch (bod_id) {
		case BOD_BOD33:
			if (conf->level > 0x3F) {
				return STATUS_ERR_INVALID_ARG;
			}

			SYSCTRL->BOD33.reg = SYSCTRL_BOD33_LEVEL(conf->level) |
					temp | SYSCTRL_BOD33_ENABLE;

			while (!(SYSCTRL->PCLKSR.reg & SYSCTRL_PCLKSR_B33SRDY)) {
				/* BOD33ڼ޽ҋ@ */
			}
			break;
		default:
			return STATUS_ERR_INVALID_ARG;
	}

	return STATUS_OK;
}
