/**
 * \file
 *
 * \brief SAM D20/D21/R21ъ֘A@\
 *
 * 쌠 (c) 2012 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef SYSTEM_H_INCLUDED
#define SYSTEM_H_INCLUDED

#include <compiler.h>
#include <clock.h>
#include <gclk.h>
#include <pinmux.h>

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \defgroup asfdoc_sam0_system_group SAM D20/D21/R21 ײ(SYSTEM)
 *
 * SAM D20/D21/R21޲p̂ײނ͊{I޲ɕKv޲̼
 * ֘A@\̌`ԐݒƊǗp̲̪񋟂܂B͒PӋ@\ɐ
 * ܂Aʰ޳Ӌ@\ɓnĊg܂B
 *
 * ̒PʕɂĈȉ̎Ӌ@\gp܂B:
 *
 * - SYSCTRL(ѐ)
 * - PM(d͊Ǘ)
 *
 * ̎̊Tv͎̒ʂłB:
 *  - \ref asfdoc_sam0_system_prerequisites
 *  - \ref asfdoc_sam0_system_module_overview
 *  - \ref asfdoc_sam0_system_special_considerations
 *  - \ref asfdoc_sam0_system_extra_info
 *  - \ref asfdoc_sam0_system_examples
 *  - \ref asfdoc_sam0_system_api_overview
 *
 *
 * \section asfdoc_sam0_system_prerequisites OKv
 *
 * ̒Pʕɑ΂鎖OKv͂܂B
 *
 *
 * \section asfdoc_sam0_system_module_overview PʕTv
 *
 *  ײނ͎gp҉p_ƁASẲpɑ΂ĕKvƂ(ۯAؾČ
 * fȂǂ̂悤)j޲@\Ԃ̲̪̏W񋟂܂B޲
 * 1̓ʂȖʂ𐧌䂷鑽̕Pʕ܂݂܂B
 *
 * - ъj(̒Pʕ)
 * - \ref asfdoc_sam0_system_clock_group " ۯ"(Pʕ)
 * - \ref asfdoc_sam0_system_interrupt_group "ъ荞ݐ"(Pʕ)
 * - \ref asfdoc_sam0_system_pinmux_group " ݑd퐧"(Pʕ)
 *
 *
 * \subsection asfdoc_sam0_system_module_overview_vref d
 * (AC,ADC,DAĈ悤)SAM D20/D21/R21޲̗lXȱ۸ޒPʕ͔rƕϊ
 * ߂̊_Ƃē悤Ɍ`Ԑݒ肳dKvłB
 *
 * SAM D20/D21/R21޲͓xmƌŒ޷ެߓd܂ޕ̊
 * ܂݂܂BAgd͓Kpł]܂ꂽӋ@\őIԂ
 * ł܂B
 *
 * \subsection asfdoc_sam0_system_module_overview_reset_cause  ؾČ
 * ̉pł޲ǂؾĂɊÂĈႤ۸т̗s
 * Kv邩܂BႦ΁AؾĂ̌ޯ (WDT)
 * A͉płُ̈ꂸAُ폈̌`ُL^KvƂ
 * 邩܂B
 *
 * ̗R̂߁AK؂Ȋ邱Ƃł悤ɁAŌ̼ ؾĂ̌
 * 擾邽߂API񋟂܂B
 *
 * \subsection asfdoc_sam0_system_module_overview_sleep_mode x~
 * SAM D20/D21/R21޲޲d͋x~ֈڍs鎞޲̂ǂ̸ۯ 
 * т܂͋֎~ɗ܂邩x~삪䂷邢̋x~
 * B\ref asfdoc_sam0_system_module_sleep_mode_table "\"͊ex~̸
 * ۯݒꗗɂ܂B
 *
 * \anchor asfdoc_sam0_system_module_sleep_mode_table
 * <table>
 *  <caption>SAM D20/D21/R21޲x~</caption>
 * 	<tr>
 * 		<th>x~</th>
 * 		<th>CPUۯ</th>
 * 		<th>AHBۯ</th>
 * 		<th>APBۯ</th>
 * 		<th>ۯ</th>
 * 		<th> ۯ</th>
 * 		<th>32kHz</th>
 * 		<th>Reg</th>
 * 		<th>RAM</th>
 * 	</tr>
 * 	<tr>
 * 		<td>0</td>
 * 		<td>~</td>
 * 		<td>s</td>
 * 		<td>s</td>
 * 		<td>s</td>
 * 		<td>s</td>
 * 		<td>s</td>
 * 		<td>W</td>
 * 		<td>W</td>
 * 	</tr>
 * 	<tr>
 * 		<td>1</td>
 * 		<td>~</td>
 * 		<td>~</td>
 * 		<td>s</td>
 * 		<td>s</td>
 * 		<td>s</td>
 * 		<td>s</td>
 * 		<td>W</td>
 * 		<td>W</td>
 *	</tr>
 * 	<tr>
 * 		<td>2</td>
 * 		<td>~</td>
 * 		<td>~</td>
 * 		<td>~</td>
 * 		<td>s</td>
 * 		<td>s</td>
 * 		<td>s</td>
 * 		<td>W</td>
 * 		<td>W</td>
 *	</tr>
 * 	<tr>
 * 		<td>STANDBY</td>
 * 		<td>~</td>
 * 		<td>~</td>
 * 		<td>~</td>
 * 		<td>~</td>
 * 		<td>~</td>
 * 		<td>~</td>
 * 		<td>d</td>
 * 		<td>/ڲ ޲</td>
 * 	</tr>
 * </table>
 *
 * ޲x~Ɉڍsɂ͗p\ȋx~1ݒ肳Ax~ֈڍs
 * ֐Ă΂Ȃ΂Ȃ܂B޲͐銄荞݂܂͑
 * ޲ۂւ̉ŎIɋNオ܂B
 *
 * ̎Ӌ@\ۯ͂̌`Ԑݒɉċx~ɋɗ܂A]܂
 * ꍇAPʕ͐ߓd̂߂ɼт̑̕d͒~œ𑱂
 * Ƃɋ߂ɋx~ɸۯ쓮邱Ƃł܂B
 *
 *
 * \section asfdoc_sam0_system_special_considerations ʂȍl
 *
 * ײނ̊֐̖wǂ޲L̐ƒӎA޲ްĂ
 * QƂĂB
 *
 *
 * \section asfdoc_sam0_system_extra_info ǉ
 *
 * ǉɂĂ\ref asfdoc_sam0_system_extraB͈ȉ܂݂܂B:
 *  - \ref asfdoc_sam0_system_extra_acronyms
 *  - \ref asfdoc_sam0_system_extra_dependencies
 *  - \ref asfdoc_sam0_system_extra_errata
 *  - \ref asfdoc_sam0_system_extra_history
 *
 *
 * \section asfdoc_sam0_system_examples 
 *
 * Ɋ֘ASYSTEMPʕɂĂ\ref asfdoc_sam0_system_module_overview 
 * "ђPʕTv"ňꗗɂ镛PʕQƂĂB
 *
 *
 * \section asfdoc_sam0_system_api_overview APITv
 * @{
 */

/**
 * \brief ޲̓d
 *
 * ޲Ŏgp邩Ȃp\ȓd(VREF)̈ꗗ
 */
enum system_voltage_reference {
	SYSTEM_VOLTAGE_REFERENCE_TEMPSENSE,	/**< xmd */
	SYSTEM_VOLTAGE_REFERENCE_BANDGAP,	/**< ޷ެߓd */
};

/**
 * \brief ޲x~
 *
 * ޲ŗp\ȋx~̈ꗗBex~ŗp\ȸۯ̕\
 * \ref asfdoc_sam0_system_module_overview_sleep_modeŌ邱Ƃł܂B
 */
enum system_sleepmode {
	SYSTEM_SLEEPMODE_IDLE_0,	/**< 0x~ */
	SYSTEM_SLEEPMODE_IDLE_1,	/**< 1x~ */
	SYSTEM_SLEEPMODE_IDLE_2,	/**< 2x~ */
	SYSTEM_SLEEPMODE_STANDBY,	/**< ޲x~ */
};

/**
 * \brief тؾČ
 *
 * \ȼтؾČ̈ꗗ
 */
enum system_reset_cause {
	SYSTEM_RESET_CAUSE_SOFTWARE       = PM_RCAUSE_SYST,		/**< т͍Ōɿĳ ؾĂɂؾĂ܂B */
	SYSTEM_RESET_CAUSE_WDT            = PM_RCAUSE_WDT,		/**< т͍Ōɳޯ ςɂؾĂ܂B */
	SYSTEM_RESET_CAUSE_EXTERNAL_RESET = PM_RCAUSE_EXT,		/**< т͍ŌɊOؾĐLowɈꂽؾĂ܂B */
	SYSTEM_RESET_CAUSE_BOD33          = PM_RCAUSE_BOD33,	/**< т͍ŌBOD33ɂؾĂ܂B */
	SYSTEM_RESET_CAUSE_BOD12          = PM_RCAUSE_BOD12,	/**< т͍ŌBOD12ɂؾĂ܂B */
	SYSTEM_RESET_CAUSE_POR            = PM_RCAUSE_POR,		/**< т͍ŌPDR(dONؾ)ɂؾĂ܂B */
};

/**
 * \name ю
 * @{
 */

/**
 * \brief ޲ʎ[擾
 *
 * ݂޲̎[擾܂B
 *
 * \return 32ޯĐƂ޲ID[
 */
static inline uint32_t system_get_device_id(void)
{
	return DSU->DID.reg;
}

/**
 * @}
 */


/**
 * \name d
 * @{
 */

/**
 * \brief I񂾓d
 *
 * ݂ŗp\ȓdLqłȂ۸ގӋ@\ւ̓͌ɂI񂾓d
 * ܂B
 *
 * \param[in]  vref d
 */
static inline void system_voltage_reference_enable(
		const enum system_voltage_reference vref)
{
	switch (vref) {
		case SYSTEM_VOLTAGE_REFERENCE_TEMPSENSE:
			SYSCTRL->VREF.reg |= SYSCTRL_VREF_TSEN;
			break;

		case SYSTEM_VOLTAGE_REFERENCE_BANDGAP:
			SYSCTRL->VREF.reg |= SYSCTRL_VREF_BGOUTEN;
			break;

		default:
			Assert(false);
			return;
	}
}

/**
 * \brief I񂾓d֎~
 *
 * I񂾓d֎~܂B
 *
 * \param[in]  vref ֎~d
 */
static inline void system_voltage_reference_disable(
		const enum system_voltage_reference vref)
{
	switch (vref) {
		case SYSTEM_VOLTAGE_REFERENCE_TEMPSENSE:
			SYSCTRL->VREF.reg &= ~SYSCTRL_VREF_TSEN;
			break;

		case SYSTEM_VOLTAGE_REFERENCE_BANDGAP:
			SYSCTRL->VREF.reg &= ~SYSCTRL_VREF_BGOUTEN;
			break;

		default:
			Assert(false);
			return;
	}
}

/**
 * @}
 */


/**
 * \name ޲x~
 * @{
 */

/**
 * \brief ޲̋x~ݒ
 *
 * ޲̋x~ݒA`Ԑݒ肵x~͎\ref system_sleep()֐
 * яoňڍs܂B
 *
 * ex~ɑ΂ċx~łǂ̼т֎~邩̊TvɂĂ
 * \ref asfdoc_sam0_system_module_overview_sleep_modeB
 *
 * \param[in]  sleep_mode ̋x~ɑ΂Č`Ԑݒ肷x~
 *
 * \retval STATUS_OK              삪Ɋ
 * \retval STATUS_ERR_INVALID_ARG vx~삪ps
 */
static inline enum status_code system_set_sleepmode(
	const enum system_sleepmode sleep_mode)
{
	switch (sleep_mode) {
		case SYSTEM_SLEEPMODE_IDLE_0:
		case SYSTEM_SLEEPMODE_IDLE_1:
		case SYSTEM_SLEEPMODE_IDLE_2:
			SCB->SCR &= ~SCB_SCR_SLEEPDEEP_Msk;
			PM->SLEEP.reg = sleep_mode;
			break;

		case SYSTEM_SLEEPMODE_STANDBY:
			SCB->SCR |=  SCB_SCR_SLEEPDEEP_Msk;
			break;

		default:
			return STATUS_ERR_INVALID_ARG;
	}

	return STATUS_OK;
}

/**
 * \brief т荞ݑ҂x~ɒu
 *
 * is̑SĂ 邱Ƃۏ؂邽߂޲BSB(ް)
 * ߂ǍɊ荞݂ɂċN܂޲
 * \ref system_set_sleepmodeɂĎw肳ꂽx~֒u߂WFI(荞ݑ
 * )߂s܂B
 */
static inline void system_sleep(void)
{
	__DSB();
	__WFI();
}

/**
 * @}
 */

/**
 * \name ؾĐ
 * @{
 */

/**
 * \brief ޯނ݂邩
 *
 * ޯނޯ (DAP)ɐڑĂ邩ׂ܂B
 *
 * \return ޶ނ݂邩ްْl
 *
 * \retval true  ޯނͼÂɐڑĂ܂B
 * \retval false ޯނͼÂɐڑĂ܂B
 *
 */
static inline bool system_is_debugger_present(void)
{
	return DSU->STATUSB.reg & DSU_STATUSB_DBGPRES;
}

/**
 * \brief MCUؾ
 *
 * RTCASĂ32kHzA(ALWAYSONݒȂ)WDTA(WRTLOCKݒȂ)GCLK
 * AMCUƊ֘AӋ@\ڼ޽ؾĂ܂B
 *
 */
static inline void system_reset(void)
{
	NVIC_SystemReset();
}

/**
 * \brief ؾČԂB
 *
 * Ō̼ ؾĂ̌擾܂B
 *
 * \return Ō̼ ؾĂ̌񋓒l
 */
static inline enum system_reset_cause system_get_reset_cause(void)
{
	return (enum system_reset_cause)PM->RCAUSE.reg;
}

/**
 * @}
 */


/**
 * \name я
 * @{
 */

void system_init(void);

/**
 * @}
 */


/**
 * @}
 */

/**
 * \page asfdoc_sam0_system_extra SYSTEMײޗpǉ
 *
 * \section asfdoc_sam0_system_extra_acronyms 
 * ͂̈Ӑ}ӖƋɂ̒PʕŎgp铪ꗗɂ\łB
 *
 * <table>
 *  <tr>
 *      <th></th>
 *      <th>`</th>
 *  </tr>
 *  <tr>
 *		<td>PM</td>
 *		<td>d͊Ǘ(Power Manager)</td>
 *  </tr>
 *  <tr>
 *		<td>SYSCTRL</td>
 *		<td>ѐ̪(System control interface)</td>
 *  </tr>
 * </table>
 *
 *
 * \section asfdoc_sam0_system_extra_dependencies ˑ
 * ײނ͈ȉ̈ˑ܂B
 *
 *  - Ȃ
 *
 *
 * \section asfdoc_sam0_system_extra_errata Q
 * ײނɊ֘AQ͂܂B
 *
 *
 * \section asfdoc_sam0_system_extra_history Pʕ
 * Pʕ̊Tv͏JPʕɑ΂čsꂽƏC̏ڍׂƋɉ
 * \ŕ\܂B̌ݔł͕\̍ŐVłɑΉ܂B
 *
 * <table>
 *	<tr>
 *		<th>ύXL^</th>
 *	</tr>
 *	<tr>
 *		<td>SAMD21xǉ</td>
 *	</tr>
 *	<tr>
 *		<td>̗OMCUSؾĂ悤ɐV\c system_reset()
 *			ǉ</td>
 *	</tr>
 *	<tr>
 *		<td>޲ID擾V\c system_get_device_id()֐ǉ</td>
 *	</tr>
 *	<tr>
 *		<td>J</td>
 *	</tr>
 * </table>
 *
 * \page asfdoc_sam0_system_document_revision_history 
 *
 * <table>
 *	<tr>
 *		<th></td>
 *		<th>t</td>
 *		<th></td>
 *	</tr>
 *	<tr>
 *		<td>D</td>
 *		<td>2014N2</td>
 *		<td>SAMR21xǉ</td>
 *	</tr>
 *	<tr>
 *		<td>C</td>
 *		<td>2014N1</td>
 *		<td>SAMD21xǉ</td>
 *	</tr>
 *	<tr>
 *		<td>B</td>
 *		<td>2013N6</td>
 *		<td>AC</td>
 *	</tr>
 *	<tr>
 *		<td>A</td>
 *		<td>2013N6</td>
 *		<td>J</td>
 *	</tr>
 * </table>
 */

#ifdef __cplusplus
}
#endif

#endif /* SYSTEM_H_INCLUDED */
