/**
 * \file
 *
 * \brief SAM TC - v/vײޑJn
 *
 * 쌠 (c) 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

/**
 * \page asfdoc_sam0_tc_timer_use_case TCpJn̎ - v
 *
 * ̎gpʂŁATC͈Ɣrv𐶐vƂĎgp܂BĂі
 * ŊLEDݐ؂ւ܂B
 *
 * TCPʕ͎̗lɍ\ݒ肳܂B:
 *
 * - GCLK1(GCLK 32K)ۯ
 * - vł16ޯĕ\
 * - 64̑Ou
 * - GCLKĐݒ芈
 * - ㏸v
 * - ޲ősȂB
 * - g`o͂Ȃ
 * - ߊlȂ
 * - PsȂ
 * - ۓ͂Ȃ
 * - ۊȂ
 * - ېȂ
 * - 0ŌvJn
 * - vTOP2000(4s)ɐݒAĂі߂
 * - 0rƈvl900ɐݒAĂі߂𐶐
 * - 1rƈvl930ɐݒAĂі߂𐶐
 *
 * \section asfdoc_sam0_tc_timer_use_case_setup Jn
 *
 * \subsection asfdoc_sam0_tc_timer_use_case_prereq OKv
 * ̎gpʂɂāAXOSC32K͋GCLK1ۯIʂėp\
 * ɂׂłBAtmelĳgg(ASF:Atmel Software Framework)ŁA
 * <i>conf_clocks.h</i>̕ύXʂčsƂł܂Bۯ`ԐݒɂĂ
 * 葽̏ڍׂɂĂ\ref asfdoc_sam0_system_clock_group " ۯǗ
 * ײ"B
 *
 * \subsection asfdoc_sam0_tc_timer_use_case_setup_code 
 *
 * ̊֐̊Oňȉ剞p ̧قɒǉ܂B:
 * \snippet qs_tc_timer.c module_inst
 *
 * ȉ̌Ăі߂֐ނgp҉pɕ/\t܂B:
 * \snippet qs_tc_timer.c callback_funcs
 *
 * ȉ̍\ݒ躰ނgp҉pɕ/\t܂B:
 * \snippet qs_tc_timer.c setup
 *
 * gp҉p(ʓI\c main()̎n)ɒǉ܂B
 * \snippet qs_tc_timer.c setup_init
 *
 * \subsection asfdoc_sam0_tc_timer_use_case_setup_flow Ƃ̗
 * -# ꂪgpԂTCײނ̏Ԃi[邽߂TCPʕpPʕĳ
 *    ̍\̂쐬܂B
 *    \snippet qs_tc_timer.c module_inst
 *    \note ͒PʕgpĂ茈ĉ͈͊OɂȂׂł͂
 *          ܂Bwǂ̏ꍇł͑SłB
 *
 * -# TCPʕ`Ԑݒ肵܂B
 *  -# ITCӋ@\̌`Ԑݒ𒲐邽߂ɋL邱ƂłTCPʕ
 *     `Ԑݒ\̂쐬܂B
 *     \snippet qs_tc_timer.c setup_config
 *  -# Pʕ̊lTC`Ԑݒ\̂܂B
 *     \snippet qs_tc_timer.c setup_config_defaults
 *     \note ͑SĂ̒lm̊lɏ邱Ƃۏ؂邽߂Ɍ`
 *           ݒ\̂ĝɐ旧ďɎsׂłB
 *
 *  -# GCLKAOuAArْl`Ԑݒ肷邽߂TCݒς
 *     ܂B
 *     \snippet qs_tc_timer.c setup_change_config
 *  -# ]ސݒTCPʕ`Ԑݒ肵܂B
 *     \snippet qs_tc_timer.c setup_set_config
 *  -# vJn邽߂TCPʕ܂B
 *     \snippet qs_tc_timer.c setup_enable
 * -# TCĂі߂`Ԑݒ肵܂B
 *  -# ײނňƔrوv̌Ăі߂֐o^܂B
 *     \snippet qs_tc_timer.c setup_register_callback
 *  -# K؂ȎײނɂČĂ΂悤ɈƔrوv̌Ăі߂
 *     ܂B
 *     \snippet qs_tc_timer.c setup_enable_callback
 *
 *
 * \section asfdoc_sam0_tc_timer_use_case_main gp
 *
 * \subsection asfdoc_sam0_tc_timer_use_case_main_code 
 * ȉ̺ނgp҉pɕ/\t܂B:
 * \snippet qs_tc_timer.c main
 *
 * \subsection asfdoc_sam0_tc_timer_use_case_main_flow Ƃ̗
 * -# v킪sĂԖJԂɓ܂B
 *    \snippet qs_tc_timer.c main_loop
 */


#include <asf.h>
#include <conf_clocks.h>
