/**
 * \file
 *
 * \brief ʂĎgpݸٰށA^Aϸ
 *
 * 쌠 (c) 2012 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef UTILS_COMPILER_H_INCLUDED
#define UTILS_COMPILER_H_INCLUDED

/**
 * \defgroup group_sam0_utils ߲גۑwƺ հèè
 *
 * Atmel SAM޲ɊÂCortex-M0+p߲גۑwƺ հèè
 * ̒Pʕ͈قȂ߲׊Ԃźތ݊ɂ邽߂̗lXȒۑwհèè
 * ܂B
 *
 * @{
 */

#if (defined __ICCARM__)
#  include <intrinsics.h>
#endif

#include <stddef.h>
#include <parts.h>
#include <status_codes.h>
#include <preprocessor.h>
#include <io.h>

#ifndef __ASSEMBLY__

#include <stdio.h>
#include <stdbool.h>
#include <stdint.h>
#include <stdlib.h>

/**
 * \def UNUSED
 * \brief gpҰ܂͒lƂ\a vLB
 */
#define UNUSED(v)		(void)(v)

/**
 * \def barrier
 * \brief ؏
 */
#ifdef __GNUC__
#  define barrier()		asm volatile("" ::: "memory")
#else
#  define barrier()		asm ("")
#endif

/**
 * \brief ׂ߲pragma \a arg𔭍s
 *
 * \param[in]  arg \e \#pragmaɂꂪ悤pragmaw
 *				   (񕶎)
 */
#define COMPILER_PRAGMA(arg)			_Pragma(#arg)

/**
 * \def COMPILER_PACK_SET(alignment)
 * \brief \a alignmentɑ΂Č㑱\lƋp̂̒`ɑ΂őݒ
 */
#define COMPILER_PACK_SET(alignment)	COMPILER_PRAGMA(pack(alignment))

/**
 * \def COMPILER_PACK_RESET()
 * \brief 㑱\lƋp̂̒`ɑ΂ݒ
 */
#define COMPILER_PACK_RESET()			 COMPILER_PRAGMA(pack())


/**
 * \brief 񂳂ꂽEݒ
 */
#if (defined __GNUC__) || (defined __CC_ARM)
#   define COMPILER_ALIGNED(a)			__attribute__((__aligned__(a)))
#elif (defined __ICCARM__)
#   define COMPILER_ALIGNED(a)			COMPILER_PRAGMA(data_alignment = a)
#endif

/**
 * \brief ꐮ񂳂ꂽEݒ
 */
#if (defined __GNUC__) || defined(__CC_ARM)
#define COMPILER_WORD_ALIGNED			__attribute__((__aligned__(4)))
#elif (defined __ICCARM__)
#define COMPILER_WORD_ALIGNED			COMPILER_PRAGMA(data_alignment = 4)
#endif

/**
 * \def __always_inline
 * \brief ֐͏ɲײׂ݉łB
 *
 * ̒L͔IwKײ݉𖳎ĂꂪǂȂɑ傫Ȃ낤Ƃ̊֐
 * ײ݉邱Ƃׂ߲Ɏw܂B
 */
#if defined(__CC_ARM)
#  define __always_inline				__forceinline
#elif (defined __GNUC__)
#  define __always_inline				__attribute__((__always_inline__))
#elif (defined __ICCARM__)
#  define __always_inline				_Pragma("inline=forced")
#endif

/**
 * \def __no_inline
 * \brief ֐͌Ĳײׂ݉ł͂܂B
 *
 * ̒L͔IwKײ݉𖳎ĂꂪǂȂɏȂ낤Ƃ̊֐
 * ײ݉ȂƂׂ߲Ɏw܂B
 */
#if defined(__CC_ARM)
#  define __no_inline					__attribute__((noinline))
#elif (defined __GNUC__)
#  define __no_inline					__attribute__((noinline))
#elif (defined __ICCARM__)
#  define __no_inline					_Pragma("inline=never")
#endif


/** \brief This macro is used to test fatal errors.
 *
 * The macro tests if the expression is false. If it is, a fatal error is
 * detected and the application hangs up. If \c TEST_SUITE_DEFINE_ASSERT_MACRO
 * is defined, a unit test version of the macro is used, to allow execution
 * of further tests after a false expression.
 *
 * \param[in]  expr ]鎮A0
 */
#if defined(_ASSERT_ENABLE_)
#  if defined(TEST_SUITE_DEFINE_ASSERT_MACRO)
#    include "unit_test/suite.h"
#  else
#    undef TEST_SUITE_DEFINE_ASSERT_MACRO
#    define Assert(expr) \
        {\
           if (!(expr)) asm("BKPT #0");\
        }
#  endif
#else
#  define Assert(expr) ((void) 0)
#endif

/* WEAK` */
#if defined   ( __CC_ARM   )
#   define WEAK __attribute__ ((weak))
#elif defined ( __ICCARM__ )
#   define WEAK __weak
#elif defined (  __GNUC__  )
#   define WEAK __attribute__ ((weak))
#endif

/* NO_INIT` */
#if defined   ( __CC_ARM   )
#   define NO_INIT __attribute__((zero_init))
#elif defined ( __ICCARM__ )
#   define NO_INIT __no_init
#elif defined (  __GNUC__  )
#   define NO_INIT __attribute__((section(".no_init")))
#endif

#include "interrupt.h"

/** \name ʏ^
 * @{ */
#ifndef __cplusplus
#  if !defined(__bool_true_false_are_defined)
typedef unsigned char	bool;
#  endif
#endif
typedef uint16_t		le16_t;
typedef uint16_t		be16_t;
typedef uint32_t		le32_t;
typedef uint32_t		be32_t;
typedef uint32_t		iram_size_t;
/** @} */

/** \name ʖWv^
 * @{ */

/** 16ޯċp */
typedef union
{
  int16_t  s16;
  uint16_t u16;
  int8_t   s8[2];
  uint8_t  u8[2];
} Union16;

/** 32ޯċp */
typedef union
{
  int32_t  s32;
  uint32_t u32;
  int16_t  s16[2];
  uint16_t u16[2];
  int8_t   s8[4];
  uint8_t  u8[4];
} Union32;

/** 64ޯċp */
typedef union
{
  int64_t  s64;
  uint64_t u64;
  int32_t  s32[2];
  uint32_t u32[2];
  int16_t  s16[4];
  uint16_t u16[4];
  int8_t   s8[8];
  uint8_t  u8[8];
} Union64;

/** 64,32,16,8ޯĕȂւ߲̋p */
typedef union
{
  int64_t  *s64ptr;
  uint64_t *u64ptr;
  int32_t  *s32ptr;
  uint32_t *u32ptr;
  int16_t  *s16ptr;
  uint16_t *u16ptr;
  int8_t   *s8ptr;
  uint8_t  *u8ptr;
} UnionPtr;

/** volatile 64,32,16,8ޯĕȂւ߲̋p */
typedef union
{
  volatile int64_t  *s64ptr;
  volatile uint64_t *u64ptr;
  volatile int32_t  *s32ptr;
  volatile uint32_t *u32ptr;
  volatile int16_t  *s16ptr;
  volatile uint16_t *u16ptr;
  volatile int8_t   *s8ptr;
  volatile uint8_t  *u8ptr;
} UnionVPtr;

/** constant 64,32,16,8ޯĕȂւ߲̋p */
typedef union
{
  const int64_t  *s64ptr;
  const uint64_t *u64ptr;
  const int32_t  *s32ptr;
  const uint32_t *u32ptr;
  const int16_t  *s16ptr;
  const uint16_t *u16ptr;
  const int8_t   *s8ptr;
  const uint8_t  *u8ptr;
} UnionCPtr;

/** constant volatile 64,32,16,8ޯĕȂւ߲̋p */
typedef union
{
  const volatile int64_t  *s64ptr;
  const volatile uint64_t *u64ptr;
  const volatile int32_t  *s32ptr;
  const volatile uint32_t *u32ptr;
  const volatile int16_t  *s16ptr;
  const volatile uint16_t *u16ptr;
  const volatile int8_t   *s8ptr;
  const volatile uint8_t  *u8ptr;
} UnionCVPtr;

/** 64,32,16,8ޯĕȂւ߲̍\ */
typedef struct
{
  int64_t  *s64ptr;
  uint64_t *u64ptr;
  int32_t  *s32ptr;
  uint32_t *u32ptr;
  int16_t  *s16ptr;
  uint16_t *u16ptr;
  int8_t   *s8ptr;
  uint8_t  *u8ptr;
} StructPtr;

/** volatile 64,32,16,8ޯĕȂւ߲̍\ */
typedef struct
{
  volatile int64_t  *s64ptr;
  volatile uint64_t *u64ptr;
  volatile int32_t  *s32ptr;
  volatile uint32_t *u32ptr;
  volatile int16_t  *s16ptr;
  volatile uint16_t *u16ptr;
  volatile int8_t   *s8ptr;
  volatile uint8_t  *u8ptr;
} StructVPtr;

/** constant 64,32,16,8ޯĕȂւ߲̍\ */
typedef struct
{
  const int64_t  *s64ptr;
  const uint64_t *u64ptr;
  const int32_t  *s32ptr;
  const uint32_t *u32ptr;
  const int16_t  *s16ptr;
  const uint16_t *u16ptr;
  const int8_t   *s8ptr;
  const uint8_t  *u8ptr;
} StructCPtr;

/** constant volatile 64,32,16,8ޯĕȂւ߲̍\ */
typedef struct
{
  const volatile int64_t  *s64ptr;
  const volatile uint64_t *u64ptr;
  const volatile int32_t  *s32ptr;
  const volatile uint32_t *u32ptr;
  const volatile int16_t  *s16ptr;
  const volatile uint16_t *u16ptr;
  const volatile int8_t   *s8ptr;
  const volatile uint8_t  *u8ptr;
} StructCVPtr;

/** @} */

#endif  /* #ifndef __ASSEMBLY__ */

/** \name ʏ萔
 * @{ */
#define DISABLE		0
#define ENABLE		1

#ifndef __cplusplus
#  if !defined(__bool_true_false_are_defined)
#    define false	0
#    define true	1
#  endif
#endif
/** @} */

#ifndef __ASSEMBLY__

/** \name œK
 * @{ */

/**
 * \def likely(exp)
 * \brief \a exptruełB
 */
#if !defined(likely) || defined(__DOXYGEN__)
#   define likely(exp)    (exp)
#endif

/**
 * \def unlikely(exp)
 * \brief \a exptruełȂB
 */
#if !defined(unlikely) || defined(__DOXYGEN__)
#   define unlikely(exp)  (exp)
#endif

/**
 * \def is_constant(exp)
 * \brief 萔lƕ]邩𔻒
 *
 * \param[in]  exp  ꂩ̎
 *
 * \return \a exp萔ȂtrueAȂfalse
 */
#if (defined __GNUC__) || (defined __CC_ARM)
#   define is_constant(exp)       __builtin_constant_p(exp)
#else
#   define is_constant(exp)       (0)
#endif

/** @} */

/** \name ޯė̈揈
 * @{ */

/** \brief ^ꂽޯĎՕɂĎw肳ꂽlޯēǂݍ
 *
 * \param[in]  value ޯĂǂޒl
 * \param[in]  mask  ǂޯĂޯĎՕ
 *
 * \return ޯēǂݍݒl
 */
#define Rd_bits( value, mask)        ((value) & (mask))

/** \brief ^ꂽޯĎՕɂĎw肳ꂽC lvalueޯď
 *
 * \param[in]  lvalue ޯĂC lvalue
 * \param[in]  mask   ޯĂޯĎՕ
 * \param[in]  bits   ޯ
 *
 * \return ꂽޯĂ̌ʒl
 */
#define Wr_bits(lvalue, mask, bits)  ((lvalue) = ((lvalue) & ~(mask)) |\
                                                 ((bits  ) &  (mask)))

/** \brief ^ꂽޯĎՕɂĎw肳ꂽlޯČ
 *
 * \param[in]  value ޯČl
 * \param[in]  mask  ޯĂޯĎՕ
 *
 * \return Œ1̌ޯĂݒȂ\c 1AȂ\c 0
 */
#define Tst_bits( value, mask)  (Rd_bits(value, mask) != 0)

/** \brief ^ꂽޯĎՕɂĎw肳ꂽC lvalueޯĉ
 *
 * \param[in]  lvalue ޯĉC lvalue
 * \param[in]  mask   ޯĂޯĎՕ
 *
 * \return ꂽޯĂʒl
 */
#define Clr_bits(lvalue, mask)  ((lvalue) &= ~(mask))

/** \brief ^ꂽޯĎՕɂĎw肳ꂽC lvalueޯĐݒ
 *
 * \param[in]  lvalue ޯĐݒ肳C lvalue
 * \param[in]  mask   ݒ肳ޯĂޯĎՕ
 *
 * \return ݒ肳ꂽޯĂʒl
 */
#define Set_bits(lvalue, mask)  ((lvalue) |=  (mask))

/** \brief ^ꂽޯĎՕɂĎw肳ꂽC lvalueޯČݐ؂ւ
 *
 * \param[in]  lvalue ޯĐ؂ւC lvalue
 * \param[in]  mask   ؂ւޯĂޯĎՕ
 *
 * \return ؂ւꂽޯĂʒl
 */
#define Tgl_bits(lvalue, mask)  ((lvalue) ^=  (mask))

/** \brief ^ꂽޯĎՕɂĎw肳ꂽlޯė̈ǂݍ
 *
 * \param[in]  value ޯė̈ǂޒl
 * \param[in]  mask  ǂޯė̈ޯĎՕ
 *
 * \return ǂޯė̈
 */
#define Rd_bitfield( value, mask)           (Rd_bits( value, mask) >> ctz(mask))

/** \brief ^ꂽޯĎՕɂĎw肳ꂽC lvalueޯė̈揑
 *
 * \param[in]  lvalue   ޯė̈C lvalue
 * \param[in]  mask     ޯė̈ޯĎՕ
 * \param[in]  bitfield ޯė̈
 *
 * \return ꂽޯė̈ʒl
 */
#define Wr_bitfield(lvalue, mask, bitfield) (Wr_bits(lvalue, mask, (uint32_t)(bitfield) << ctz(mask)))

/** @} */


/*! \name 0ޯČv
 *
 * GCCŁA__builtin_clz__builtin_ctz͒萔(َ߲ɕl)ɓKp
 * 鎞ϸۂ̂悤ɓÂɂ͑Ή鱾ؖ߂̎gpƍœK
 * AႦ΁AÓILԂµ޼ުĂ邽߂ɂ萔
 * Ďgp邱ƂłA萔(َ߲ɖm̒l)ɓKp鎞̑Ή
 * ؖ߂̂悤ɁA͉肭ǂ؂ƍœK܂B
 * ǂclzctz͒萔Ɣ萔̗ɑ΂ĉ\ȍœKꂽۏ؂
 * B
 *
 * @{ */

/** \brief 32ޯĐƌ􂳂^ꂽl̐s0ޯĂv
 *
 * \param[in]  u s0ޯĂvl
 *
 * \return \a uɐs0ޯČv
 */
#if (defined __GNUC__) || (defined __CC_ARM)
#   define clz(u)              __builtin_clz(u)
#else
#   define clz(u)              (((u) == 0)          ? 32 : \
                                ((u) & (1ul << 31)) ?  0 : \
                                ((u) & (1ul << 30)) ?  1 : \
                                ((u) & (1ul << 29)) ?  2 : \
                                ((u) & (1ul << 28)) ?  3 : \
                                ((u) & (1ul << 27)) ?  4 : \
                                ((u) & (1ul << 26)) ?  5 : \
                                ((u) & (1ul << 25)) ?  6 : \
                                ((u) & (1ul << 24)) ?  7 : \
                                ((u) & (1ul << 23)) ?  8 : \
                                ((u) & (1ul << 22)) ?  9 : \
                                ((u) & (1ul << 21)) ? 10 : \
                                ((u) & (1ul << 20)) ? 11 : \
                                ((u) & (1ul << 19)) ? 12 : \
                                ((u) & (1ul << 18)) ? 13 : \
                                ((u) & (1ul << 17)) ? 14 : \
                                ((u) & (1ul << 16)) ? 15 : \
                                ((u) & (1ul << 15)) ? 16 : \
                                ((u) & (1ul << 14)) ? 17 : \
                                ((u) & (1ul << 13)) ? 18 : \
                                ((u) & (1ul << 12)) ? 19 : \
                                ((u) & (1ul << 11)) ? 20 : \
                                ((u) & (1ul << 10)) ? 21 : \
                                ((u) & (1ul <<  9)) ? 22 : \
                                ((u) & (1ul <<  8)) ? 23 : \
                                ((u) & (1ul <<  7)) ? 24 : \
                                ((u) & (1ul <<  6)) ? 25 : \
                                ((u) & (1ul <<  5)) ? 26 : \
                                ((u) & (1ul <<  4)) ? 27 : \
                                ((u) & (1ul <<  3)) ? 28 : \
                                ((u) & (1ul <<  2)) ? 29 : \
                                ((u) & (1ul <<  1)) ? 30 : \
                                31)
#endif

/** \brief 32ޯĐƌ􂳂^ꂽľs0ޯĂv
 *
 * \param[in]  u s0ޯĂvl
 *
 * \return \a uɌs0ޯČv
 */
#if (defined __GNUC__) || (defined __CC_ARM)
#   define ctz(u)              __builtin_ctz(u)
#else
#   define ctz(u)              ((u) & (1ul <<  0) ?  0 : \
                                (u) & (1ul <<  1) ?  1 : \
                                (u) & (1ul <<  2) ?  2 : \
                                (u) & (1ul <<  3) ?  3 : \
                                (u) & (1ul <<  4) ?  4 : \
                                (u) & (1ul <<  5) ?  5 : \
                                (u) & (1ul <<  6) ?  6 : \
                                (u) & (1ul <<  7) ?  7 : \
                                (u) & (1ul <<  8) ?  8 : \
                                (u) & (1ul <<  9) ?  9 : \
                                (u) & (1ul << 10) ? 10 : \
                                (u) & (1ul << 11) ? 11 : \
                                (u) & (1ul << 12) ? 12 : \
                                (u) & (1ul << 13) ? 13 : \
                                (u) & (1ul << 14) ? 14 : \
                                (u) & (1ul << 15) ? 15 : \
                                (u) & (1ul << 16) ? 16 : \
                                (u) & (1ul << 17) ? 17 : \
                                (u) & (1ul << 18) ? 18 : \
                                (u) & (1ul << 19) ? 19 : \
                                (u) & (1ul << 20) ? 20 : \
                                (u) & (1ul << 21) ? 21 : \
                                (u) & (1ul << 22) ? 22 : \
                                (u) & (1ul << 23) ? 23 : \
                                (u) & (1ul << 24) ? 24 : \
                                (u) & (1ul << 25) ? 25 : \
                                (u) & (1ul << 26) ? 26 : \
                                (u) & (1ul << 27) ? 27 : \
                                (u) & (1ul << 28) ? 28 : \
                                (u) & (1ul << 29) ? 29 : \
                                (u) & (1ul << 30) ? 30 : \
                                (u) & (1ul << 31) ? 31 : \
                                32)
#endif

/** @} */


/** \name ޯċt]
 * @{ */

/** \brief \a u8ޯċt]
 *
 * \param[in]  u8 ޯĂt]U8
 *
 * \return ޯĂt]\a u8̌
 */
#define bit_reverse8(u8)    ((U8)(bit_reverse32((U8)(u8)) >> 24))

/** \brief \a u16ޯċt]
 *
 * \param[in]  u16 ޯĂt]U16
 *
 * \return ޯĂt]\a u16̌
 */
#define bit_reverse16(u16)  ((uint16_t)(bit_reverse32((uint16_t)(u16)) >> 16))

/** \brief \a u32ޯċt]
 *
 * \param[in]  u32 ޯĂt]U32
 *
 * \return ޯĂt]\a u32̌
 */
#define bit_reverse32(u32)   __RBIT(u32)

/** \brief \a u64ޯċt]
 *
 * \param[in]  u64 ޯĂt]U64
 *
 * \return ޯĂt]\a u64̌
 */
#define bit_reverse64(u64)  ((uint64_t)(((uint64_t)bit_reverse32((uint64_t)(u64) >> 32)) |\
										((uint64_t)bit_reverse32((uint64_t)(u64)) << 32)))

/** @} */


/** \name 
 * @{ */

/** \brief \a nE\a val̐̐񌟍
 *
 * \param[in]  val ͒l
 * \param[in]  n   E
 *
 * \return  \a val̐\a nEŐ񂳂Ă\c 1AȂ\c 0
 */
#define Test_align(val, n) (!Tst_bits( val, (n) - 1     )   )

/** \brief \a nEɊւ\a val̐̐擾
 *
 * \param[in]  val ͒l
 * \param[in]  n   E
 *
 * \return \a nEɊւ\a val̐̐
 */
#define Get_align(val, n) (  Rd_bits( val, (n) - 1     )   )

/** \brief \a nEɊւ\a lvallvaluë\a algɐݒ
 *
 * \param[in]  lval  olvalue
 * \param[in]  n     E
 * \param[in]  alg   
 *
 * \return \a nEɊւĂ̈̌ʂ\a lval̐Vl\a algɐݒ
 */
#define Set_align(lval, n, alg) (  Wr_bits(lval, (n) - 1, alg)   )

/** \brief \a nEȏ\a val̐𐮗
 *
 * \param[in]  val ͒l
 * \param[in]  n   E
 *
 * \return \a nEȏŖ񂳂ꂽ\a val̐̌ʒl
 */
#define Align_up(  val, n) (((val) + ((n) - 1)) & ~((n) - 1))

/** \brief \a nEȉ\a val̐𐮗
 *
 * \param[in]  val ͒l
 * \param[in]  n   E
 *
 * \return \a nEȉŖ񂳂ꂽ\a val̐̌ʒl
 */
#define Align_down(val, n) ( (val)              & ~((n) - 1))

/** @} */


/*! \name Z
 *
 * clzctzƓlKp܂AGCCͱؖ߂𱸾gݍ
 * ֐abs,min,max񋟂Awǂ̏ꍇłꎩgɂĂ𐶐A
 * ɂ2ϸۂ̑g`܂B:
 *   - 萔(َ߲Ɋm̒l)ɓKpAbs,Min,Max
 *   - 萔(َ߲ɖm̒l)ɓKpabs,min,max
 *
 * @{ */

/** \brief  \a a̐ΒlB
 *
 * \param[in]  a ͒l
 *
 * \return \a a̐Βl
 *
 * \note َ߲Ɋm̒lłgpꍇɂƍœK܂B
 */
#define Abs(a)              (((a) <  0 ) ? -(a) : (a))

/** \brief \a a\a b̍ŏlB
 *
 * \param[in]  a ͒l
 * \param[in]  b ͒l
 *
 * \return \a a\a b̍ŏl
 *
 * \note َ߲Ɋm̒lłgpꍇɂƍœK܂B
 */
#define Min(a, b)           (((a) < (b)) ?  (a) : (b))

/** \brief \a a\a b̍őlB
 *
 * \param[in]  a ͒l
 * \param[in]  b ͒l
 *
 * \return \a a\a b̍ől
 *
 * \note َ߲Ɋm̒lłgpꍇɂƍœK܂B
 */
#define Max(a, b)           (((a) > (b)) ?  (a) : (b))

/** \brief \brief \a a\a b̍ŏlB
 *
 * \param[in]  a ͒l
 * \param[in]  b ͒l
 *
 * \return \a a\a b̍ŏl
 *
 * \note َ߲ɖm̒lłgpꍇɂƍœK܂B
 */
#define min(a, b)   Min(a, b)

/** \brief \a a\a b̍őlB
 *
 * \param[in]  a ͒l
 * \param[in]  b ͒l
 *
 * \return \a a\a b̍ől
 *
 * \note َ߲ɖm̒lłgpꍇɂƍœK܂B
 */
#define max(a, b)   Max(a, b)

/** @} */


/*! \brief ڽ\a addrٰ݌Ăяo
 *
 * ͒Ăяoߺނ𐶐܂B
 *
 * Ⴆ΁A`Long_call(0x80000000)'͂ꂪCPU삩ĂяoꂽꍇUC3
 * ł̿ĳ ؾĂ𐶐܂B
 *
 * \param[in]  addr Ăяoٰ݂̱ڽ
 *
 * \note ʂȏꍇɒߺނƂĎgp邩܂B
 */
#define Long_call(addr)                   ((*(void (*)(void))(addr))())


/*! \name MCUިݏ
 * ARM ިMCUłB
 *
 * @{ */
#define  BE16(x)		Swap16(x)
#define  LE16(x)		(x)

#define  le16_to_cpu(x)	(x)
#define  cpu_to_le16(x)	(x)
#define  LE16_TO_CPU(x)	(x)
#define  CPU_TO_LE16(x)	(x)

#define  be16_to_cpu(x)	Swap16(x)
#define  cpu_to_be16(x)	Swap16(x)
#define  BE16_TO_CPU(x)	Swap16(x)
#define  CPU_TO_BE16(x)	Swap16(x)

#define  le32_to_cpu(x)	(x)
#define  cpu_to_le32(x)	(x)
#define  LE32_TO_CPU(x)	(x)
#define  CPU_TO_LE32(x)	(x)

#define  be32_to_cpu(x)	swap32(x)
#define  cpu_to_be32(x)	swap32(x)
#define  BE32_TO_CPU(x)	swap32(x)
#define  CPU_TO_BE32(x)	swap32(x)
/** @} */


/*! \name ިݕϊ
 *
 * clzctzƓlKp܂AGCC__builtin_bswap_32__builtin
 * _bswap_64͒萔ɓKp鎞ϸۂ̂悤ɓÂɂ2ϸۂ̑g
 * `܂B:
 *   - 萔(َ߲Ɋm̒l)ɓKp邽߂Swap16,Swap32,Swap64
 *   - 萔(َ߲ɖm̒l)ɓKp邽߂swap16,swap32,swap64
 *
 * @{ */

/** \brief \a u16̴ި݂(޲Čɂ)ݐ؂ւ
 *
 * \param[in]  u16 ި݂ݐ؂ւU16
 *
 * \return ި݂ݐ؂ւ\a u16̌ʒl
 *
 * \note َ߲Ɋm̒lłgpꍇɂƍœK܂B
 */
#define Swap16(u16) ((uint16_t)(((uint16_t)(u16) >> 8) |\
                           ((uint16_t)(u16) << 8)))

/** \brief \a u32̴ި݂(޲Čɂ)ݐ؂ւ
 *
 * \param[in]  u32 ި݂ݐ؂ւU32
 *
 * \return ި݂ݐ؂ւ\a u32̌ʒl
 *
 * \note َ߲Ɋm̒lłgpꍇɂƍœK܂B
 */
#define Swap32(u32) ((uint32_t)(((uint32_t)Swap16((uint32_t)(u32) >> 16)) |\
                           ((uint32_t)Swap16((uint32_t)(u32)) << 16)))

/** \brief \a u64̴ި݂(޲Čɂ)ݐ؂ւ
 *
 * \param[in]  u64 ި݂ݐ؂ւU64
 *
 * \return ި݂ݐ؂ւ\a u64̌ʒl
 *
 * \note َ߲Ɋm̒lłgpꍇɂƍœK܂B
 */
#define Swap64(u64) ((uint64_t)(((uint64_t)Swap32((uint64_t)(u64) >> 32)) |\
                           ((uint64_t)Swap32((uint64_t)(u64)) << 32)))

/** \brief \a u16̴ި݂(޲Čɂ)ݐ؂ւ
 *
 * \param[in]  u16 ި݂ݐ؂ւU16
 *
 * \return ި݂ݐ؂ւ\a u16̌ʒl
 *
 * \note َ߲ɖm̒lłgpꍇɂƍœK܂B
 */
#define swap16(u16) Swap16(u16)

/** \brief \a u32̴ި݂(޲Čɂ)ݐ؂ւ
 *
 * \param[in]  u32 ި݂ݐ؂ւU32
 *
 * \return ި݂ݐ؂ւ\a u32̌ʒl
 *
 * \note َ߲ɖm̒lłgpꍇɂƍœK܂B
 */
#if (defined __GNUC__)
#  define swap32(u32) ((uint32_t)__builtin_bswap32((uint32_t)(u32)))
#else
#  define swap32(u32) Swap32(u32)
#endif

/** \brief \a u64̴ި݂(޲Čɂ)ݐ؂ւ
 *
 * \param[in]  u64 ި݂ݐ؂ւU64
 *
 * \return ި݂ݐ؂ւ\a u64̌ʒl
 *
 * \note َ߲ɖm̒lłgpꍇɂƍœK܂B
 */
#if (defined __GNUC__)
#  define swap64(u64) ((uint64_t)__builtin_bswap64((uint64_t)(u64)))
#else
#  define swap64(u64) ((uint64_t)(((uint64_t)swap32((uint64_t)(u64) >> 32)) |\
                         ((uint64_t)swap32((uint64_t)(u64)) << 32)))
#endif

/** @} */


/** \name ړIΏےۉ
 *
 * @{ */

#define _GLOBEXT_			extern		/**< externL׽wq */
#define _CONST_TYPE_		const		/**< const^Cq */
#define _MEM_TYPE_SLOW_					/**< ᑬ،^ */
#define _MEM_TYPE_MEDFAST_				/**< Ȃ荂،^ */
#define _MEM_TYPE_FAST_					/**< ،^ */

#define memcmp_ram2ram		memcmp		/**< RAMRAMւ̖ړIΏۓLmemcmp */
#define memcmp_code2ram		memcmp		/**< RAMNVRAMւ̖ړIΏۓLmemcmp */
#define memcpy_ram2ram		memcpy		/**< RAMRAMւ̖ړIΏۓLmemcpy */
#define memcpy_code2ram		memcpy		/**< RAMNVRAMւ̖ړIΏۓLmemcpy */

/** @} */

/**
 * \brief Zp\f$ \left\lceil \frac{a}{b} \right\rceil \f$vZ
 *
 * \param[in]  a 
 * \param[in]  b ʂ̐
 *
 * \return (\a a / \a b)̍ł߂֊ۂߏグ
 */
#define div_ceil(a, b)      (((a) + (b) - 1) / (b))

#endif  /* #ifndef __ASSEMBLY__ */
#ifdef __ICCARM__
/*! \name ߲ ܰ
 *
 * GCCIAR Embedded Workbenchւ̂̷ܰވڐA
 *
 * @{ */

#define __asm__			asm
#define __inline__		inline
#define __volatile__

/** @} */

#endif

#define FUNC_PTR		void *
/**
 * \def unused
 * \brief gpҰ܂͒lƂ\a vLB
 */
#define unused(v)		do { (void)(v); } while(0)

/* RAMFUNC` */
#if defined   ( __CC_ARM   ) /* Keil uVision 4 */
#   define RAMFUNC __attribute__ ((section(".ramfunc")))
#elif defined ( __ICCARM__ ) /* IAR Ewarm 5.41+ */
#   define RAMFUNC __ramfunc
#elif defined (  __GNUC__  ) /* GCC CS3 2009q3-68 */
#   define RAMFUNC __attribute__ ((section(".ramfunc")))
#endif

/* OPTIMIZE_HIGH` */
#if defined   ( __CC_ARM   ) /* Keil uVision 4 */
#   define OPTIMIZE_HIGH _Pragma("O3")
#elif defined ( __ICCARM__ ) /* IAR Ewarm 5.41+ */
#   define OPTIMIZE_HIGH _Pragma("optimize=high")
#elif defined (  __GNUC__  ) /* GCC CS3 2009q3-68 */
#   define OPTIMIZE_HIGH __attribute__((optimize(s)))
#endif
#define PASS		0
#define FAIL		1
#define LOW			0
#define HIGH		1

typedef int8_t		S8 ;	//!< 8ޯĕt
typedef uint8_t		U8 ;	//!< 8ޯĕȂ
typedef int16_t		S16;	//!< 16ޯĕt
typedef uint16_t	U16;	//!< 16ޯĕȂ
typedef int32_t		S32;	//!< 32ޯĕt
typedef uint32_t	U32;	//!< 32ޯĕȂ
typedef int64_t		S64;	//!< 64ޯĕt
typedef uint64_t	U64;	//!< 64ޯĕȂ
typedef float		F32;	//!< 32ޯĕ_
typedef double		F64;	//!< 64ޯĕ_

#define  MSB(u16)		(((U8  *)&(u16))[1])	//!< \a u16̍ŏ޲
#define  LSB(u16)		(((U8  *)&(u16))[0])	//!< \a u16̍ŉ޲

#define  MSH(u32)		(((U16 *)&(u32))[1])	//!< \a u32̍ŏʔ
#define  LSH(u32)		(((U16 *)&(u32))[0])	//!< \a u32̍ŉʔ
#define  MSB0W(u32)		(((U8  *)&(u32))[3])	//!< \a u32̍ŏʑ1޲
#define  MSB1W(u32)		(((U8  *)&(u32))[2])	//!< \a u32̍ŏʑ2޲
#define  MSB2W(u32)		(((U8  *)&(u32))[1])	//!< \a u32̍ŏʑ3޲
#define  MSB3W(u32)		(((U8  *)&(u32))[0])	//!< \a u32̍ŏʑ4޲
#define  LSB3W(u32)		MSB0W(u32)				//!< \a u32̍ŉʑ4޲
#define  LSB2W(u32)		MSB1W(u32)				//!< \a u32̍ŉʑ3޲
#define  LSB1W(u32)		MSB2W(u32)				//!< \a u32̍ŉʑ2޲
#define  LSB0W(u32)		MSB3W(u32)				//!< \a u32̍ŉʑ1޲

#define  MSW(u64)		(((U32 *)&(u64))[1])	//!< \a u64̍ŏʌ
#define  LSW(u64)		(((U32 *)&(u64))[0])	//!< \a u64̍ŉʌ
#define  MSH0(u64)		(((U16 *)&(u64))[3])	//!< \a u64̍ŏʑ1
#define  MSH1(u64)		(((U16 *)&(u64))[2])	//!< \a u64̍ŏʑ2
#define  MSH2(u64)		(((U16 *)&(u64))[1])	//!< \a u64̍ŏʑ3
#define  MSH3(u64)		(((U16 *)&(u64))[0])	//!< \a u64̍ŏʑ4
#define  LSH3(u64)		MSH0(u64)				//!< \a u64̍ŉʑ4
#define  LSH2(u64)		MSH1(u64)				//!< \a u64̍ŉʑ3
#define  LSH1(u64)		MSH2(u64)				//!< \a u64̍ŉʑ2
#define  LSH0(u64)		MSH3(u64)				//!< \a u64̍ŉʑ1
#define  MSB0D(u64)		(((U8  *)&(u64))[7])	//!< \a u64̍ŏʑ1޲
#define  MSB1D(u64)		(((U8  *)&(u64))[6])	//!< \a u64̍ŏʑ2޲
#define  MSB2D(u64)		(((U8  *)&(u64))[5])	//!< \a u64̍ŏʑ3޲
#define  MSB3D(u64)		(((U8  *)&(u64))[4])	//!< \a u64̍ŏʑ4޲
#define  MSB4D(u64)		(((U8  *)&(u64))[3])	//!< \a u64̍ŏʑ5޲
#define  MSB5D(u64)		(((U8  *)&(u64))[2])	//!< \a u64̍ŏʑ6޲
#define  MSB6D(u64)		(((U8  *)&(u64))[1])	//!< \a u64̍ŏʑ7޲
#define  MSB7D(u64)		(((U8  *)&(u64))[0])	//!< \a u64̍ŏʑ8޲
#define  LSB7D(u64)		MSB0D(u64)				//!< \a u64̍ŉʑ8޲
#define  LSB6D(u64)		MSB1D(u64)				//!< \a u64̍ŉʑ7޲
#define  LSB5D(u64)		MSB2D(u64)				//!< \a u64̍ŉʑ6޲
#define  LSB4D(u64)		MSB3D(u64)				//!< \a u64̍ŉʑ5޲
#define  LSB3D(u64)		MSB4D(u64)				//!< \a u64̍ŉʑ4޲
#define  LSB2D(u64)		MSB5D(u64)				//!< \a u64̍ŉʑ3޲
#define  LSB1D(u64)		MSB6D(u64)				//!< \a u64̍ŉʑ2޲
#define  LSB0D(u64)		MSB7D(u64)				//!< \a u64̍ŉʑ1޲

#define LSB0(u32)		LSB0W(u32)				//!< \a u32̍ŉʑ1޲
#define LSB1(u32)		LSB1W(u32)				//!< \a u32̍ŉʑ2޲
#define LSB2(u32)		LSB2W(u32)				//!< \a u32̍ŉʑ3޲
#define LSB3(u32)		LSB3W(u32)				//!< \a u32̍ŉʑ4޲
#define MSB3(u32)		MSB3W(u32)				//!< \a u32̍ŏʑ4޲
#define MSB2(u32)		MSB2W(u32)				//!< \a u32̍ŏʑ3޲
#define MSB1(u32)		MSB1W(u32)				//!< \a u32̍ŏʑ2޲
#define MSB0(u32)		MSB0W(u32)				//!< \a u32̍ŏʑ1޲

#if defined(__ICCARM__)
#define SHORTENUM           __packed
#elif defined(__GNUC__)
#define SHORTENUM           __attribute__((packed))
#endif

/*  */
#if defined(__ICCARM__)
#define nop()               __no_operation()
#elif defined(__GNUC__)
#define nop()               (__NOP())
#endif

#define FLASH_DECLARE(x)  const x
#define FLASH_EXTERN(x) extern const x
#define PGM_READ_BYTE(x) *(x)
#define PGM_READ_WORD(x) *(x)
#define MEMCPY_ENDIAN memcpy
#define PGM_READ_BLOCK(dst, src, len) memcpy((dst), (src), (len))

/* MAC̗vƉɑ΂ׯL` */
#define CMD_ID_OCTET    (0)

/* CPUި݂ ި݂֒l̕ϊ */
#define CPU_ENDIAN_TO_LE16(x)   (x)
#define CPU_ENDIAN_TO_LE32(x)   (x)
#define CPU_ENDIAN_TO_LE64(x)   (x)

/*  ި݂CPUި݂֒l̕ϊ */
#define LE16_TO_CPU_ENDIAN(x)   (x)
#define LE32_TO_CPU_ENDIAN(x)   (x)
#define LE64_TO_CPU_ENDIAN(x)   (x)

/*  ި݂CPUި݂֒萔̕ϊ */
#define CLE16_TO_CPU_ENDIAN(x)  (x)
#define CLE32_TO_CPU_ENDIAN(x)  (x)
#define CLE64_TO_CPU_ENDIAN(x)  (x)

/* CPUި݂ ި݂֒萔̕ϊ */
#define CCPU_ENDIAN_TO_LE16(x)  (x)
#define CCPU_ENDIAN_TO_LE32(x)  (x)
#define CCPU_ENDIAN_TO_LE64(x)  (x)

#define ADDR_COPY_DST_SRC_16(dst, src)  ((dst) = (src))
#define ADDR_COPY_DST_SRC_64(dst, src)  ((dst) = (src))

/**
 * @brief 64ޯĒl8޲Ĕzɕϊ
 *
 * @param[in]   value 64ޯĒl
 * @param[out]  data  64ޯĒlōXV8޲Ĕzւ̈ʒuwq
 * @ingroup apiPalApi
 */
static inline void convert_64_bit_to_byte_array(uint64_t value, uint8_t *data)
{
	uint8_t index = 0;

	while (index < 8)
	{
		data[index++] = value & 0xFF;
		value = value >> 8;
	}
}

/**
 * @brief 16ޯĒl2޲Ĕzɕϊ
 *
 * @param[in]  value 16ޯĒl
 * @param[out] data  16ޯĒlōXV2޲Ĕzւ̈ʒuwq
 * @ingroup apiPalApi
 */
static inline void convert_16_bit_to_byte_array(uint16_t value, uint8_t *data)
{
    data[0] = value & 0xFF;
    data[1] = (value >> 8) & 0xFF;
}

/* 16ޯĒl2޲Ĕzɕϊ */
static inline void convert_spec_16_bit_to_byte_array(uint16_t value, uint8_t *data)
{
    data[0] = value & 0xFF;
    data[1] = (value >> 8) & 0xFF;
}

/* 16ޯĒl2޲Ĕzɕϊ */
static inline void convert_16_bit_to_byte_address(uint16_t value, uint8_t *data)
{
    data[0] = value & 0xFF;
    data[1] = (value >> 8) & 0xFF;
}

/*
 * @brief 2޲Ĕz16ޯĒlɕϊ
 *
 * @param  data 2޲Ĕzւ̈ʒuwqw
 *
 * @return 16ޯĒl
 * @ingroup apiPalApi
 */
static inline uint16_t convert_byte_array_to_16_bit(uint8_t *data)
{
    return (data[0] | ((uint16_t)data[1] << 8));
}

/* 4޲Ĕz32ޯĒlɕϊ */
static inline uint32_t convert_byte_array_to_32_bit(uint8_t *data)
{
	union
	{
		uint32_t u32;
		uint8_t u8[4];
	}long_addr;
	uint8_t index;
	for (index = 0; index < 4; index++)
	{
		long_addr.u8[index] = *data++;
	}
	return long_addr.u32;
}

/**
 * @brief 8޲Ĕz64ޯĒlɕϊ
 *
 * @param  data 8޲Ĕzւ̈ʒuwqw
 *
 * @return 64ޯĒl
 * @ingroup apiPalApi
 */
static inline uint64_t convert_byte_array_to_64_bit(uint8_t *data)
{
	union
	{
		uint64_t u64;
		uint8_t u8[8];
	} long_addr;

	uint8_t index;

	for (index = 0; index < 8; index++)
	{
		long_addr.u8[index] = *data++;
	}

	return long_addr.u64;
}

/** @} */

#endif /* UTILS_COMPILER_H_INCLUDED */
