/**
 * \file
 *
 * \brief I2Sp\iLq
 *
 * 쌠 (c) 2013 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAMD21_I2S_COMPONENT_
#define _SAMD21_I2S_COMPONENT_

/* ========================================================================== */
/** I2SpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAMD21_I2S IC̪ */
/*@{*/

#define I2S_U2224
#define REV_I2S							0x100

/* -------- I2S_CTRLA : (I2Sψ:0x00) (R/W  8)A -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  SWRST:1;			/*!< ޯ  0: ĳ ؾ */
    uint8_t  ENABLE:1;			/*!< ޯ  1:  */
    uint8_t  CKEN0:1;			/*!< ޯ  2: ۯ0 */
    uint8_t  CKEN1:1;			/*!< ޯ  3: ۯ1 */
    uint8_t  SEREN0:1;			/*!< ޯ  4: 񉻊0 */
    uint8_t  SEREN1:1;			/*!< ޯ  5: 񉻊1 */
    uint8_t  :2;				/*!< ޯ6,7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint8_t  :2;				/*!< ޯ0,1: \ */
    uint8_t  CKEN:2;			/*!< ޯ2,3: ۯx */
    uint8_t  SEREN:2;			/*!< ޯ4,5: 񉻊x */
    uint8_t  :2;				/*!< ޯ6,7: \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} I2S_CTRLA_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define I2S_CTRLA_OFFSET				0x00			/**< \brief (I2S_CTRLA offset)A */
#define I2S_CTRLA_RESETVALUE			0x00			/**< \brief (I2S_CTRLA reset_value)A */

#define I2S_CTRLA_SWRST_Pos				0				/**< \brief (I2S_CTRLA)ĳ ؾ */
#define I2S_CTRLA_SWRST					(0x1u << I2S_CTRLA_SWRST_Pos)
#define I2S_CTRLA_ENABLE_Pos			1				/**< \brief (I2S_CTRLA) */
#define I2S_CTRLA_ENABLE				(0x1u << I2S_CTRLA_ENABLE_Pos)
#define I2S_CTRLA_CKEN0_Pos				2				/**< \brief (I2S_CTRLA)ۯ0 */
#define I2S_CTRLA_CKEN0					(1 << I2S_CTRLA_CKEN0_Pos)
#define I2S_CTRLA_CKEN1_Pos				3				/**< \brief (I2S_CTRLA)ۯ1 */
#define I2S_CTRLA_CKEN1					(1 << I2S_CTRLA_CKEN1_Pos)
#define I2S_CTRLA_CKEN_Pos				2				/**< \brief (I2S_CTRLA)ۯx */
#define I2S_CTRLA_CKEN_Msk				(0x3u << I2S_CTRLA_CKEN_Pos)
#define I2S_CTRLA_CKEN(value)			((I2S_CTRLA_CKEN_Msk & ((value) << I2S_CTRLA_CKEN_Pos)))
#define I2S_CTRLA_SEREN0_Pos			4				/**< \brief (I2S_CTRLA)񉻊0 */
#define I2S_CTRLA_SEREN0				(1 << I2S_CTRLA_SEREN0_Pos)
#define I2S_CTRLA_SEREN1_Pos			5				/**< \brief (I2S_CTRLA)񉻊1 */
#define I2S_CTRLA_SEREN1				(1 << I2S_CTRLA_SEREN1_Pos)
#define I2S_CTRLA_SEREN_Pos				4				/**< \brief (I2S_CTRLA)񉻊x */
#define I2S_CTRLA_SEREN_Msk				(0x3u << I2S_CTRLA_SEREN_Pos)
#define I2S_CTRLA_SEREN(value)			((I2S_CTRLA_SEREN_Msk & ((value) << I2S_CTRLA_SEREN_Pos)))
#define I2S_CTRLA_MASK					0x3Fu			/**< \brief (I2S_CTRLA)Օڼ޽ */

/* -------- I2S_CLKCTRL : (I2Sψ:0x04) (R/W 32)ۯn -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t SLOTSIZE:2;		/*!< ޯ   0,1: ۯĂ̑傫 */
    uint32_t NBSLOTS:3;			/*!< ޯ 2` 4: ڰǓ̽ۯĐ */
    uint32_t FSWIDTH:2;			/*!< ޯ   5,6: ڰѓ */
    uint32_t BITDELAY:1;		/*!< ޯ     7: ڰѓްx */
    uint32_t FSSEL:1;			/*!< ޯ     8: ڰѓI */
    uint32_t :2;				/*!< ޯ 9`10: \ */
    uint32_t FSINV:1;			/*!< ޯ    11: ڰѓ] */
    uint32_t SCKSEL:1;			/*!< ޯ    12: ۯI */
    uint32_t :3;				/*!< ޯ13`15: \ */
    uint32_t MCKSEL:1;			/*!< ޯ    16: ۯI */
    uint32_t :1;				/*!< ޯ    17: \ */
    uint32_t MCKEN:1;			/*!< ޯ    18: ۯ */
    uint32_t MCKDIV:5;			/*!< ޯ19`23: ۯW */
    uint32_t MCKOUTDIV:5;		/*!< ޯ24`28: ۯo͕W */
    uint32_t FSOUTINV:1;		/*!< ޯ    29: ڰѓo͔] */
    uint32_t SCKOUTINV:1;		/*!< ޯ    30: ۯo͔] */
    uint32_t MCKOUTINV:1;		/*!< ޯ    31: ۯo͔] */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} I2S_CLKCTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define I2S_CLKCTRL_OFFSET				0x04			/**< \brief (I2S_CLKCTRL offset)ۯn */
#define I2S_CLKCTRL_RESETVALUE			0x00000000		/**< \brief (I2S_CLKCTRL reset_value)ۯn */

#define I2S_CLKCTRL_SLOTSIZE_Pos		0				/**< \brief (I2S_CLKCTRL)ۯĂ̑傫 */
#define I2S_CLKCTRL_SLOTSIZE_Msk		(0x3u << I2S_CLKCTRL_SLOTSIZE_Pos)
#define I2S_CLKCTRL_SLOTSIZE(value)		((I2S_CLKCTRL_SLOTSIZE_Msk & ((value) << I2S_CLKCTRL_SLOTSIZE_Pos)))
#define   I2S_CLKCTRL_SLOTSIZE_8_Val		0x0u		/**< \brief (I2S_CLKCTRL)ۯnp8ޯ ۯ */
#define   I2S_CLKCTRL_SLOTSIZE_16_Val		0x1u		/**< \brief (I2S_CLKCTRL)ۯnp16ޯ ۯ */
#define   I2S_CLKCTRL_SLOTSIZE_24_Val		0x2u		/**< \brief (I2S_CLKCTRL)ۯnp24ޯ ۯ */
#define   I2S_CLKCTRL_SLOTSIZE_32_Val		0x3u		/**< \brief (I2S_CLKCTRL)ۯnp32ޯ ۯ */
#define I2S_CLKCTRL_SLOTSIZE_8			(I2S_CLKCTRL_SLOTSIZE_8_Val    << I2S_CLKCTRL_SLOTSIZE_Pos)
#define I2S_CLKCTRL_SLOTSIZE_16			(I2S_CLKCTRL_SLOTSIZE_16_Val   << I2S_CLKCTRL_SLOTSIZE_Pos)
#define I2S_CLKCTRL_SLOTSIZE_24			(I2S_CLKCTRL_SLOTSIZE_24_Val   << I2S_CLKCTRL_SLOTSIZE_Pos)
#define I2S_CLKCTRL_SLOTSIZE_32			(I2S_CLKCTRL_SLOTSIZE_32_Val   << I2S_CLKCTRL_SLOTSIZE_Pos)
#define I2S_CLKCTRL_NBSLOTS_Pos			2				/**< \brief (I2S_CLKCTRL)ڰǓ̽ۯĐ */
#define I2S_CLKCTRL_NBSLOTS_Msk			(0x7u << I2S_CLKCTRL_NBSLOTS_Pos)
#define I2S_CLKCTRL_NBSLOTS(value)		((I2S_CLKCTRL_NBSLOTS_Msk & ((value) << I2S_CLKCTRL_NBSLOTS_Pos)))
#define I2S_CLKCTRL_FSWIDTH_Pos			5				/**< \brief (I2S_CLKCTRL)ڰѓ */
#define I2S_CLKCTRL_FSWIDTH_Msk			(0x3u << I2S_CLKCTRL_FSWIDTH_Pos)
#define I2S_CLKCTRL_FSWIDTH(value)		((I2S_CLKCTRL_FSWIDTH_Msk & ((value) << I2S_CLKCTRL_FSWIDTH_Pos)))
#define   I2S_CLKCTRL_FSWIDTH_SLOT_Val		0x0u		/**< \brief (I2S_CLKCTRL)ڰѓٽ1ۯĕ(I2SKɑ΂) */
#define   I2S_CLKCTRL_FSWIDTH_HALF_Val		0x1u		/**< \brief (I2S_CLKCTRL)ڰѓٽ1/2ڰѕ */
#define   I2S_CLKCTRL_FSWIDTH_BIT_Val		0x2u		/**< \brief (I2S_CLKCTRL)ڰѓٽ1ޯĕ */
#define   I2S_CLKCTRL_FSWIDTH_BURST_Val		0x3u		/**< \brief (I2S_CLKCTRL)ۯnް]vꂽɂް̎斈1ޯĕڰѓٽWœ܂B */
#define I2S_CLKCTRL_FSWIDTH_SLOT		(I2S_CLKCTRL_FSWIDTH_SLOT_Val  << I2S_CLKCTRL_FSWIDTH_Pos)
#define I2S_CLKCTRL_FSWIDTH_HALF		(I2S_CLKCTRL_FSWIDTH_HALF_Val  << I2S_CLKCTRL_FSWIDTH_Pos)
#define I2S_CLKCTRL_FSWIDTH_BIT			(I2S_CLKCTRL_FSWIDTH_BIT_Val   << I2S_CLKCTRL_FSWIDTH_Pos)
#define I2S_CLKCTRL_FSWIDTH_BURST		(I2S_CLKCTRL_FSWIDTH_BURST_Val << I2S_CLKCTRL_FSWIDTH_Pos)
#define I2S_CLKCTRL_BITDELAY_Pos		7				/**< \brief (I2S_CLKCTRL)ڰѓްx */
#define I2S_CLKCTRL_BITDELAY			(0x1u << I2S_CLKCTRL_BITDELAY_Pos)
#define   I2S_CLKCTRL_BITDELAY_LJ_Val		0x0u		/**< \brief (I2S_CLKCTRL)(0ޯĒx) */
#define   I2S_CLKCTRL_BITDELAY_I2S_Val		0x1u		/**< \brief (I2S_CLKCTRL)I2S(1ޯĒx) */
#define I2S_CLKCTRL_BITDELAY_LJ			(I2S_CLKCTRL_BITDELAY_LJ_Val   << I2S_CLKCTRL_BITDELAY_Pos)
#define I2S_CLKCTRL_BITDELAY_I2S		(I2S_CLKCTRL_BITDELAY_I2S_Val  << I2S_CLKCTRL_BITDELAY_Pos)
#define I2S_CLKCTRL_FSSEL_Pos			8				/**< \brief (I2S_CLKCTRL)ڰѓI */
#define I2S_CLKCTRL_FSSEL				(0x1u << I2S_CLKCTRL_FSSEL_Pos)
#define   I2S_CLKCTRL_FSSEL_SCKDIV_Val		0x0u		/**< \brief (I2S_CLKCTRL)ۯnڰѓnƂĎgp܂B */
#define   I2S_CLKCTRL_FSSEL_FSPIN_Val		0x1u		/**< \brief (I2S_CLKCTRL)FSn݂ڰѓnƂĎgp܂B */
#define I2S_CLKCTRL_FSSEL_SCKDIV		(I2S_CLKCTRL_FSSEL_SCKDIV_Val  << I2S_CLKCTRL_FSSEL_Pos)
#define I2S_CLKCTRL_FSSEL_FSPIN			(I2S_CLKCTRL_FSSEL_FSPIN_Val   << I2S_CLKCTRL_FSSEL_Pos)
#define I2S_CLKCTRL_FSINV_Pos			11				/**< \brief (I2S_CLKCTRL)ڰѓ] */
#define I2S_CLKCTRL_FSINV				(0x1u << I2S_CLKCTRL_FSINV_Pos)
#define I2S_CLKCTRL_SCKSEL_Pos			12				/**< \brief (I2S_CLKCTRL)ۯI */
#define I2S_CLKCTRL_SCKSEL				(0x1u << I2S_CLKCTRL_SCKSEL_Pos)
#define   I2S_CLKCTRL_SCKSEL_MCKDIV_Val		0x0u		/**< \brief (I2S_CLKCTRL)ۯnڰѓnƂĎgp܂B */
#define   I2S_CLKCTRL_SCKSEL_SCKPIN_Val		0x1u		/**< \brief (I2S_CLKCTRL)SCKn݂͒ۯnƂĎgp܂B */
#define I2S_CLKCTRL_SCKSEL_MCKDIV		(I2S_CLKCTRL_SCKSEL_MCKDIV_Val << I2S_CLKCTRL_SCKSEL_Pos)
#define I2S_CLKCTRL_SCKSEL_SCKPIN		(I2S_CLKCTRL_SCKSEL_SCKPIN_Val << I2S_CLKCTRL_SCKSEL_Pos)
#define I2S_CLKCTRL_MCKSEL_Pos			16				/**< \brief (I2S_CLKCTRL)ۯI */
#define I2S_CLKCTRL_MCKSEL				(0x1u << I2S_CLKCTRL_MCKSEL_Pos)
#define   I2S_CLKCTRL_MCKSEL_GCLK_Val		0x0u		/**< \brief (I2S_CLKCTRL)clk_gen_n͎ۯnƂĎgp܂B */
#define   I2S_CLKCTRL_MCKSEL_MCKPIN_Val		0x1u		/**< \brief (I2S_CLKCTRL)MCKn݂͎ۯnƂĎgp܂B */
#define I2S_CLKCTRL_MCKSEL_GCLK			(I2S_CLKCTRL_MCKSEL_GCLK_Val   << I2S_CLKCTRL_MCKSEL_Pos)
#define I2S_CLKCTRL_MCKSEL_MCKPIN		(I2S_CLKCTRL_MCKSEL_MCKPIN_Val << I2S_CLKCTRL_MCKSEL_Pos)
#define I2S_CLKCTRL_MCKEN_Pos			18				/**< \brief (I2S_CLKCTRL)ۯ */
#define I2S_CLKCTRL_MCKEN				(0x1u << I2S_CLKCTRL_MCKEN_Pos)
#define I2S_CLKCTRL_MCKDIV_Pos			19				/**< \brief (I2S_CLKCTRL)ۯW */
#define I2S_CLKCTRL_MCKDIV_Msk			(0x1Fu << I2S_CLKCTRL_MCKDIV_Pos)
#define I2S_CLKCTRL_MCKDIV(value)		((I2S_CLKCTRL_MCKDIV_Msk & ((value) << I2S_CLKCTRL_MCKDIV_Pos)))
#define I2S_CLKCTRL_MCKOUTDIV_Pos		24				/**< \brief (I2S_CLKCTRL)ۯo͕W */
#define I2S_CLKCTRL_MCKOUTDIV_Msk		(0x1Fu << I2S_CLKCTRL_MCKOUTDIV_Pos)
#define I2S_CLKCTRL_MCKOUTDIV(value)	((I2S_CLKCTRL_MCKOUTDIV_Msk & ((value) << I2S_CLKCTRL_MCKOUTDIV_Pos)))
#define I2S_CLKCTRL_FSOUTINV_Pos		29				/**< \brief (I2S_CLKCTRL)ڰѓo͔] */
#define I2S_CLKCTRL_FSOUTINV			(0x1u << I2S_CLKCTRL_FSOUTINV_Pos)
#define I2S_CLKCTRL_SCKOUTINV_Pos		30				/**< \brief (I2S_CLKCTRL)ۯo͔] */
#define I2S_CLKCTRL_SCKOUTINV			(0x1u << I2S_CLKCTRL_SCKOUTINV_Pos)
#define I2S_CLKCTRL_MCKOUTINV_Pos		31				/**< \brief (I2S_CLKCTRL)ۯo͔] */
#define I2S_CLKCTRL_MCKOUTINV			(0x1u << I2S_CLKCTRL_MCKOUTINV_Pos)
#define I2S_CLKCTRL_MASK				0xFFFD19FFu		/**< \brief (I2S_CLKCTRL)Օڼ޽ */

/* -------- I2S_INTENCLR : (I2Sψ:0x0C) (R/W 16)荞݋ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t RXRDY0:1;			/*!< ޯ    0: M0荞݋ */
    uint16_t RXRDY1:1;			/*!< ޯ    1: M1荞݋ */
    uint16_t :2;				/*!< ޯ  2,3: \ */
    uint16_t RXOR0:1;			/*!< ޯ    4: Mް0荞݋ */
    uint16_t RXOR1:1;			/*!< ޯ    5: Mް1荞݋ */
    uint16_t :2;				/*!< ޯ  6,7: \ */
    uint16_t TXRDY0:1;			/*!< ޯ    8: M0荞݋  */
    uint16_t TXRDY1:1;			/*!< ޯ    9: M1荞݋ */
    uint16_t :2;				/*!< ޯ10,11: \ */
    uint16_t TXUR0:1;			/*!< ޯ   12: Mް0荞݋ */
    uint16_t TXUR1:1;			/*!< ޯ   13: Mް1荞݋ */
    uint16_t :2;				/*!< ޯ14,15: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint16_t RXRDY:2;			/*!< ޯ 0, 1: Mx荞݋ */
    uint16_t :2;				/*!< ޯ 2, 3: \ */
    uint16_t RXOR:2;			/*!< ޯ 4, 5: Mްx荞݋ */
    uint16_t :2;				/*!< ޯ 6, 7: \ */
    uint16_t TXRDY:2;			/*!< ޯ 8, 9: Mx荞݋ */
    uint16_t :2;				/*!< ޯ10,11: \ */
    uint16_t TXUR:2;			/*!< ޯ12,13: Mްx荞݋ */
    uint16_t :2;				/*!< ޯ14,15: \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} I2S_INTENCLR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define I2S_INTENCLR_OFFSET				0x0C			/**< \brief (I2S_INTENCLR offset)荞݋ */
#define I2S_INTENCLR_RESETVALUE			0x0000			/**< \brief (I2S_INTENCLR reset_value)荞݋ */

#define I2S_INTENCLR_RXRDY0_Pos			0				/**< \brief (I2S_INTENCLR)M0荞݋ */
#define I2S_INTENCLR_RXRDY0				(1 << I2S_INTENCLR_RXRDY0_Pos)
#define I2S_INTENCLR_RXRDY1_Pos			1				/**< \brief (I2S_INTENCLR)M1荞݋ */
#define I2S_INTENCLR_RXRDY1				(1 << I2S_INTENCLR_RXRDY1_Pos)
#define I2S_INTENCLR_RXRDY_Pos			0				/**< \brief (I2S_INTENCLR)Mx荞݋ */
#define I2S_INTENCLR_RXRDY_Msk			(0x3u << I2S_INTENCLR_RXRDY_Pos)
#define I2S_INTENCLR_RXRDY(value)		((I2S_INTENCLR_RXRDY_Msk & ((value) << I2S_INTENCLR_RXRDY_Pos)))
#define I2S_INTENCLR_RXOR0_Pos			4				/**< \brief (I2S_INTENCLR)Mް0荞݋ */
#define I2S_INTENCLR_RXOR0				(1 << I2S_INTENCLR_RXOR0_Pos)
#define I2S_INTENCLR_RXOR1_Pos			5				/**< \brief (I2S_INTENCLR)Mް1荞݋ */
#define I2S_INTENCLR_RXOR1				(1 << I2S_INTENCLR_RXOR1_Pos)
#define I2S_INTENCLR_RXOR_Pos			4				/**< \brief (I2S_INTENCLR)Mްx荞݋ */
#define I2S_INTENCLR_RXOR_Msk			(0x3u << I2S_INTENCLR_RXOR_Pos)
#define I2S_INTENCLR_RXOR(value)		((I2S_INTENCLR_RXOR_Msk & ((value) << I2S_INTENCLR_RXOR_Pos)))
#define I2S_INTENCLR_TXRDY0_Pos			8				/**< \brief (I2S_INTENCLR)M0荞݋ */
#define I2S_INTENCLR_TXRDY0				(1 << I2S_INTENCLR_TXRDY0_Pos)
#define I2S_INTENCLR_TXRDY1_Pos			9				/**< \brief (I2S_INTENCLR)M1荞݋ */
#define I2S_INTENCLR_TXRDY1				(1 << I2S_INTENCLR_TXRDY1_Pos)
#define I2S_INTENCLR_TXRDY_Pos			8				/**< \brief (I2S_INTENCLR)Mx荞݋ */
#define I2S_INTENCLR_TXRDY_Msk			(0x3u << I2S_INTENCLR_TXRDY_Pos)
#define I2S_INTENCLR_TXRDY(value)		((I2S_INTENCLR_TXRDY_Msk & ((value) << I2S_INTENCLR_TXRDY_Pos)))
#define I2S_INTENCLR_TXUR0_Pos			12				/**< \brief (I2S_INTENCLR)Mް0荞݋ */
#define I2S_INTENCLR_TXUR0				(1 << I2S_INTENCLR_TXUR0_Pos)
#define I2S_INTENCLR_TXUR1_Pos			13				/**< \brief (I2S_INTENCLR)Mް1荞݋ */
#define I2S_INTENCLR_TXUR1				(1 << I2S_INTENCLR_TXUR1_Pos)
#define I2S_INTENCLR_TXUR_Pos			12				/**< \brief (I2S_INTENCLR)Mްx荞݋ */
#define I2S_INTENCLR_TXUR_Msk			(0x3u << I2S_INTENCLR_TXUR_Pos)
#define I2S_INTENCLR_TXUR(value)		((I2S_INTENCLR_TXUR_Msk & ((value) << I2S_INTENCLR_TXUR_Pos)))
#define I2S_INTENCLR_MASK				0x3333u			/**< \brief (I2S_INTENCLR)Օڼ޽ */

/* -------- I2S_INTENSET : (I2Sψ:0x10) (R/W 16)荞݋ݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t RXRDY0:1;			/*!< ޯ    0: M0荞݋ */
    uint16_t RXRDY1:1;			/*!< ޯ    1: M1荞݋ */
    uint16_t :2;				/*!< ޯ  2,3: \ */
    uint16_t RXOR0:1;			/*!< ޯ    4: Mް0荞݋ */
    uint16_t RXOR1:1;			/*!< ޯ    5: Mް1荞݋ */
    uint16_t :2;				/*!< ޯ  6,7: \ */
    uint16_t TXRDY0:1;			/*!< ޯ    8: M0荞݋ */
    uint16_t TXRDY1:1;			/*!< ޯ    9: M1荞݋ */
    uint16_t :2;				/*!< ޯ10,11: \ */
    uint16_t TXUR0:1;			/*!< ޯ   12: Mް0荞݋ */
    uint16_t TXUR1:1;			/*!< ޯ   13: Mް1荞݋ */
    uint16_t :2;				/*!< ޯ14,15: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint16_t RXRDY:2;			/*!< ޯ 0, 1: Mx荞݋ */
    uint16_t :2;				/*!< ޯ 2, 3: \ */
    uint16_t RXOR:2;			/*!< ޯ 4, 5: Mްx荞݋ */
    uint16_t :2;				/*!< ޯ 6, 7: \ */
    uint16_t TXRDY:2;			/*!< ޯ 8, 9: Mx荞݋ */
    uint16_t :2;				/*!< ޯ10,11: \ */
    uint16_t TXUR:2;			/*!< ޯ12,13: Mްx荞݋ */
    uint16_t :2;				/*!< ޯ14,15: \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} I2S_INTENSET_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define I2S_INTENSET_OFFSET				0x10			/**< \brief (I2S_INTENSET offset)荞݋ݒ */
#define I2S_INTENSET_RESETVALUE			0x0000			/**< \brief (I2S_INTENSET reset_value)荞݋ݒ */

#define I2S_INTENSET_RXRDY0_Pos			0				/**< \brief (I2S_INTENSET)M0荞݋ */
#define I2S_INTENSET_RXRDY0				(1 << I2S_INTENSET_RXRDY0_Pos)
#define I2S_INTENSET_RXRDY1_Pos			1				/**< \brief (I2S_INTENSET)M1荞݋ */
#define I2S_INTENSET_RXRDY1				(1 << I2S_INTENSET_RXRDY1_Pos)
#define I2S_INTENSET_RXRDY_Pos			0				/**< \brief (I2S_INTENSET)Mx荞݋ */
#define I2S_INTENSET_RXRDY_Msk			(0x3u << I2S_INTENSET_RXRDY_Pos)
#define I2S_INTENSET_RXRDY(value)		((I2S_INTENSET_RXRDY_Msk & ((value) << I2S_INTENSET_RXRDY_Pos)))
#define I2S_INTENSET_RXOR0_Pos			4				/**< \brief (I2S_INTENSET)Mް0荞݋ */
#define I2S_INTENSET_RXOR0				(1 << I2S_INTENSET_RXOR0_Pos)
#define I2S_INTENSET_RXOR1_Pos			5				/**< \brief (I2S_INTENSET)Mް1荞݋ */
#define I2S_INTENSET_RXOR1				(1 << I2S_INTENSET_RXOR1_Pos)
#define I2S_INTENSET_RXOR_Pos			4				/**< \brief (I2S_INTENSET)Mްx荞݋ */
#define I2S_INTENSET_RXOR_Msk			(0x3u << I2S_INTENSET_RXOR_Pos)
#define I2S_INTENSET_RXOR(value)		((I2S_INTENSET_RXOR_Msk & ((value) << I2S_INTENSET_RXOR_Pos)))
#define I2S_INTENSET_TXRDY0_Pos			8				/**< \brief (I2S_INTENSET)M0荞݋ */
#define I2S_INTENSET_TXRDY0				(1 << I2S_INTENSET_TXRDY0_Pos)
#define I2S_INTENSET_TXRDY1_Pos			9				/**< \brief (I2S_INTENSET)M1荞݋ */
#define I2S_INTENSET_TXRDY1				(1 << I2S_INTENSET_TXRDY1_Pos)
#define I2S_INTENSET_TXRDY_Pos			8				/**< \brief (I2S_INTENSET)Mx荞݋ */
#define I2S_INTENSET_TXRDY_Msk			(0x3u << I2S_INTENSET_TXRDY_Pos)
#define I2S_INTENSET_TXRDY(value)		((I2S_INTENSET_TXRDY_Msk & ((value) << I2S_INTENSET_TXRDY_Pos)))
#define I2S_INTENSET_TXUR0_Pos			12				/**< \brief (I2S_INTENSET)Mް0荞݋ */
#define I2S_INTENSET_TXUR0				(1 << I2S_INTENSET_TXUR0_Pos)
#define I2S_INTENSET_TXUR1_Pos			13				/**< \brief (I2S_INTENSET)Mް1荞݋ */
#define I2S_INTENSET_TXUR1				(1 << I2S_INTENSET_TXUR1_Pos)
#define I2S_INTENSET_TXUR_Pos			12				/**< \brief (I2S_INTENSET)Mްx荞݋ */
#define I2S_INTENSET_TXUR_Msk			(0x3u << I2S_INTENSET_TXUR_Pos)
#define I2S_INTENSET_TXUR(value)		((I2S_INTENSET_TXUR_Msk & ((value) << I2S_INTENSET_TXUR_Pos)))
#define I2S_INTENSET_MASK				0x3333u			/**< \brief (I2S_INTENSET)Օڼ޽ */

/* -------- I2S_INTFLAG : (I2Sψ:0x14) (R/W 16)荞׸ޏ/ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t RXRDY0:1;			/*!< ޯ    0: M0 */
    uint16_t RXRDY1:1;			/*!< ޯ    1: M1 */
    uint16_t :2;				/*!< ޯ  2,3: \ */
    uint16_t RXOR0:1;			/*!< ޯ    4: Mް0 */
    uint16_t RXOR1:1;			/*!< ޯ    5: Mް1 */
    uint16_t :2;				/*!< ޯ  6,7: \ */
    uint16_t TXRDY0:1;			/*!< ޯ    8: M0 */
    uint16_t TXRDY1:1;			/*!< ޯ    9: M1 */
    uint16_t :2;				/*!< ޯ10,11: \ */
    uint16_t TXUR0:1;			/*!< ޯ   12: Mް0 */
    uint16_t TXUR1:1;			/*!< ޯ   13: Mް1 */
    uint16_t :2;				/*!< ޯ14,15: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint16_t RXRDY:2;			/*!< ޯ 0, 1: Mx */
    uint16_t :2;				/*!< ޯ 2, 3: \ */
    uint16_t RXOR:2;			/*!< ޯ 4, 5: Mްx */
    uint16_t :2;				/*!< ޯ 6, 7: \ */
    uint16_t TXRDY:2;			/*!< ޯ 8, 9: Mx */
    uint16_t :2;				/*!< ޯ10,11: \ */
    uint16_t TXUR:2;			/*!< ޯ12,13: Mްx */
    uint16_t :2;				/*!< ޯ14,15: \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} I2S_INTFLAG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define I2S_INTFLAG_OFFSET				0x14			/**< \brief (I2S_INTFLAG offset)荞׸ޏ/ */
#define I2S_INTFLAG_RESETVALUE			0x0000			/**< \brief (I2S_INTFLAG reset_value)荞׸ޏ/ */

#define I2S_INTFLAG_RXRDY0_Pos			0				/**< \brief (I2S_INTFLAG)M0 */
#define I2S_INTFLAG_RXRDY0				(1 << I2S_INTFLAG_RXRDY0_Pos)
#define I2S_INTFLAG_RXRDY1_Pos			1				/**< \brief (I2S_INTFLAG)M1 */
#define I2S_INTFLAG_RXRDY1				(1 << I2S_INTFLAG_RXRDY1_Pos)
#define I2S_INTFLAG_RXRDY_Pos			0				/**< \brief (I2S_INTFLAG)Mx */
#define I2S_INTFLAG_RXRDY_Msk			(0x3u << I2S_INTFLAG_RXRDY_Pos)
#define I2S_INTFLAG_RXRDY(value)		((I2S_INTFLAG_RXRDY_Msk & ((value) << I2S_INTFLAG_RXRDY_Pos)))
#define I2S_INTFLAG_RXOR0_Pos			4				/**< \brief (I2S_INTFLAG)Mް0 */
#define I2S_INTFLAG_RXOR0				(1 << I2S_INTFLAG_RXOR0_Pos)
#define I2S_INTFLAG_RXOR1_Pos			5				/**< \brief (I2S_INTFLAG)Mް1 */
#define I2S_INTFLAG_RXOR1				(1 << I2S_INTFLAG_RXOR1_Pos)
#define I2S_INTFLAG_RXOR_Pos			4				/**< \brief (I2S_INTFLAG)Mްx */
#define I2S_INTFLAG_RXOR_Msk			(0x3u << I2S_INTFLAG_RXOR_Pos)
#define I2S_INTFLAG_RXOR(value)			((I2S_INTFLAG_RXOR_Msk & ((value) << I2S_INTFLAG_RXOR_Pos)))
#define I2S_INTFLAG_TXRDY0_Pos			8				/**< \brief (I2S_INTFLAG)M0 */
#define I2S_INTFLAG_TXRDY0				(1 << I2S_INTFLAG_TXRDY0_Pos)
#define I2S_INTFLAG_TXRDY1_Pos			9				/**< \brief (I2S_INTFLAG)M1 */
#define I2S_INTFLAG_TXRDY1				(1 << I2S_INTFLAG_TXRDY1_Pos)
#define I2S_INTFLAG_TXRDY_Pos			8				/**< \brief (I2S_INTFLAG)Mx */
#define I2S_INTFLAG_TXRDY_Msk			(0x3u << I2S_INTFLAG_TXRDY_Pos)
#define I2S_INTFLAG_TXRDY(value)		((I2S_INTFLAG_TXRDY_Msk & ((value) << I2S_INTFLAG_TXRDY_Pos)))
#define I2S_INTFLAG_TXUR0_Pos			12				/**< \brief (I2S_INTFLAG)Mް0 */
#define I2S_INTFLAG_TXUR0				(1 << I2S_INTFLAG_TXUR0_Pos)
#define I2S_INTFLAG_TXUR1_Pos			13				/**< \brief (I2S_INTFLAG)Mް1 */
#define I2S_INTFLAG_TXUR1				(1 << I2S_INTFLAG_TXUR1_Pos)
#define I2S_INTFLAG_TXUR_Pos			12				/**< \brief (I2S_INTFLAG)Mްx */
#define I2S_INTFLAG_TXUR_Msk			(0x3u << I2S_INTFLAG_TXUR_Pos)
#define I2S_INTFLAG_TXUR(value)			((I2S_INTFLAG_TXUR_Msk & ((value) << I2S_INTFLAG_TXUR_Pos)))
#define I2S_INTFLAG_MASK				0x3333u			/**< \brief (I2S_INTFLAG)Օڼ޽ */

/* -------- I2S_SYNCBUSY : (I2Sψ:0x18) (R/  16) -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t SWRST:1;			/*!< ޯ     0: ĳ ؾē */
    uint16_t ENABLE:1;			/*!< ޯ     1:  */
    uint16_t CKEN0:1;			/*!< ޯ     2: ۯ0 */
    uint16_t CKEN1:1;			/*!< ޯ     3: ۯ1 */
    uint16_t SEREN0:1;			/*!< ޯ     4: 񉻊0 */
    uint16_t SEREN1:1;			/*!< ޯ     5: 񉻊1 */
    uint16_t :2;				/*!< ޯ 6` 7: \ */
    uint16_t DATA0:1;			/*!< ޯ     8: ް0 */
    uint16_t DATA1:1;			/*!< ޯ     9: ް1 */
    uint16_t :6;				/*!< ޯ10`15: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint16_t :2;				/*!< ޯ 0` 1: \ */
    uint16_t CKEN:2;			/*!< ޯ 2` 3: ۯx */
    uint16_t SEREN:2;			/*!< ޯ 4` 5: 񉻊x */
    uint16_t :2;				/*!< ޯ 6` 7: \ */
    uint16_t DATA:2;			/*!< ޯ 8` 9: ްx */
    uint16_t :6;				/*!< ޯ10`15: \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} I2S_SYNCBUSY_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define I2S_SYNCBUSY_OFFSET				0x18			/**< \brief (I2S_SYNCBUSY offset) */
#define I2S_SYNCBUSY_RESETVALUE			0x0000			/**< \brief (I2S_SYNCBUSY reset_value) */

#define I2S_SYNCBUSY_SWRST_Pos			0				/**< \brief (I2S_SYNCBUSY)ĳ ؾē */
#define I2S_SYNCBUSY_SWRST				(0x1u << I2S_SYNCBUSY_SWRST_Pos)
#define I2S_SYNCBUSY_ENABLE_Pos			1				/**< \brief (I2S_SYNCBUSY) */
#define I2S_SYNCBUSY_ENABLE				(0x1u << I2S_SYNCBUSY_ENABLE_Pos)
#define I2S_SYNCBUSY_CKEN0_Pos			2				/**< \brief (I2S_SYNCBUSY)ۯ0 */
#define I2S_SYNCBUSY_CKEN0				(1 << I2S_SYNCBUSY_CKEN0_Pos)
#define I2S_SYNCBUSY_CKEN1_Pos			3				/**< \brief (I2S_SYNCBUSY)ۯ1 */
#define I2S_SYNCBUSY_CKEN1				(1 << I2S_SYNCBUSY_CKEN1_Pos)
#define I2S_SYNCBUSY_CKEN_Pos			2				/**< \brief (I2S_SYNCBUSY)ۯx */
#define I2S_SYNCBUSY_CKEN_Msk			(0x3u << I2S_SYNCBUSY_CKEN_Pos)
#define I2S_SYNCBUSY_CKEN(value)		((I2S_SYNCBUSY_CKEN_Msk & ((value) << I2S_SYNCBUSY_CKEN_Pos)))
#define I2S_SYNCBUSY_SEREN0_Pos			4				/**< \brief (I2S_SYNCBUSY)񉻊0 */
#define I2S_SYNCBUSY_SEREN0				(1 << I2S_SYNCBUSY_SEREN0_Pos)
#define I2S_SYNCBUSY_SEREN1_Pos			5				/**< \brief (I2S_SYNCBUSY)񉻊1 */
#define I2S_SYNCBUSY_SEREN1				(1 << I2S_SYNCBUSY_SEREN1_Pos)
#define I2S_SYNCBUSY_SEREN_Pos			4				/**< \brief (I2S_SYNCBUSY)񉻊x */
#define I2S_SYNCBUSY_SEREN_Msk			(0x3u << I2S_SYNCBUSY_SEREN_Pos)
#define I2S_SYNCBUSY_SEREN(value)		((I2S_SYNCBUSY_SEREN_Msk & ((value) << I2S_SYNCBUSY_SEREN_Pos)))
#define I2S_SYNCBUSY_DATA0_Pos			8				/**< \brief (I2S_SYNCBUSY)ް0 */
#define I2S_SYNCBUSY_DATA0				(1 << I2S_SYNCBUSY_DATA0_Pos)
#define I2S_SYNCBUSY_DATA1_Pos			9				/**< \brief (I2S_SYNCBUSY)ް1 */
#define I2S_SYNCBUSY_DATA1				(1 << I2S_SYNCBUSY_DATA1_Pos)
#define I2S_SYNCBUSY_DATA_Pos			8				/**< \brief (I2S_SYNCBUSY)ްx */
#define I2S_SYNCBUSY_DATA_Msk			(0x3u << I2S_SYNCBUSY_DATA_Pos)
#define I2S_SYNCBUSY_DATA(value)		((I2S_SYNCBUSY_DATA_Msk & ((value) << I2S_SYNCBUSY_DATA_Pos)))
#define I2S_SYNCBUSY_MASK				0x033Fu			/**< \brief (I2S_SYNCBUSY)Օڼ޽ */

/* -------- I2S_SERCTRL : (I2Sψ:0x20) (R/W 32)񉻊n -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t SERMODE:2;			/*!< ޯ   0,1: 񉻊퓮 */
    uint32_t TXDEFAULT:2;		/*!< ޯ   2,3: ۯċ֎~ */
    uint32_t TXSAME:1;			/*!< ޯ     4: ްݎްM */
    uint32_t CLKSEL:1;			/*!< ޯ     5: ۯI */
    uint32_t :1;				/*!< ޯ     6: \ */
    uint32_t SLOTADJ:1;			/*!< ޯ     7: ް ۯ ̫ϰĕ␳ */
    uint32_t DATASIZE:3;		/*!< ޯ  8,10: ް̑傫 */
    uint32_t :1;				/*!< ޯ    11: \ */
    uint32_t WORDADJ:1;			/*!< ޯ    12: ް̫ϯĕ␳ */
    uint32_t EXTEND:2;			/*!< ޯ 13,14: ް ̫ϯ ޯĊg */
    uint32_t BITREV:1;			/*!< ޯ    15: ް ̫ϯ ޯċt] */
    uint32_t SLOTDIS0:1;		/*!< ޯ    16: ̒񉻊ɑ΂Ľۯ0֎~ */
    uint32_t SLOTDIS1:1;		/*!< ޯ    17: ̒񉻊ɑ΂Ľۯ1֎~ */
    uint32_t SLOTDIS2:1;		/*!< ޯ    18: ̒񉻊ɑ΂Ľۯ2֎~ */
    uint32_t SLOTDIS3:1;		/*!< ޯ    19: ̒񉻊ɑ΂Ľۯ3֎~ */
    uint32_t SLOTDIS4:1;		/*!< ޯ    20: ̒񉻊ɑ΂Ľۯ4֎~ */
    uint32_t SLOTDIS5:1;		/*!< ޯ    21: ̒񉻊ɑ΂Ľۯ5֎~ */
    uint32_t SLOTDIS6:1;		/*!< ޯ    22: ̒񉻊ɑ΂Ľۯ6֎~ */
    uint32_t SLOTDIS7:1;		/*!< ޯ    23: ̒񉻊ɑ΂Ľۯ7֎~ */
    uint32_t MONO:1;			/*!< ޯ    24: Pꓮ */
    uint32_t DMA:1;				/*!< ޯ    25: P܂͕DMA */
    uint32_t RXLOOP:1;			/*!< ޯ    26: ԂH */
    uint32_t :5;				/*!< ޯ27`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint32_t :16;				/*!< ޯ 0`15: \ */
    uint32_t SLOTDIS:8;			/*!< ޯ16`23: ̒񉻊ɑ΂Ľۯx֎~ */
    uint32_t :8;				/*!< ޯ24`31: \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} I2S_SERCTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define I2S_SERCTRL_OFFSET				0x20			/**< \brief (I2S_SERCTRL offset)񉻊n */
#define I2S_SERCTRL_RESETVALUE			0x00000000		/**< \brief (I2S_SERCTRL reset_value)񉻊n */

#define I2S_SERCTRL_SERMODE_Pos			0				/**< \brief (I2S_SERCTRL)񉻊퓮 */
#define I2S_SERCTRL_SERMODE_Msk			(0x3u << I2S_SERCTRL_SERMODE_Pos)
#define I2S_SERCTRL_SERMODE(value)		((I2S_SERCTRL_SERMODE_Msk & ((value) << I2S_SERCTRL_SERMODE_Pos)))
#define   I2S_SERCTRL_SERMODE_RX_Val		0x0u		/**< \brief (I2S_SERCTRL)M */
#define   I2S_SERCTRL_SERMODE_TX_Val		0x1u		/**< \brief (I2S_SERCTRL)M */
#define   I2S_SERCTRL_SERMODE_PDM2_Val		0x2u		/**< \brief (I2S_SERCTRL)eۯ[1PDMްM */
#define I2S_SERCTRL_SERMODE_RX			(I2S_SERCTRL_SERMODE_RX_Val		<< I2S_SERCTRL_SERMODE_Pos)
#define I2S_SERCTRL_SERMODE_TX			(I2S_SERCTRL_SERMODE_TX_Val		<< I2S_SERCTRL_SERMODE_Pos)
#define I2S_SERCTRL_SERMODE_PDM2		(I2S_SERCTRL_SERMODE_PDM2_Val	<< I2S_SERCTRL_SERMODE_Pos)
#define I2S_SERCTRL_TXDEFAULT_Pos		2				/**< \brief (I2S_SERCTRL)ۯċ֎~ */
#define I2S_SERCTRL_TXDEFAULT_Msk		(0x3u << I2S_SERCTRL_TXDEFAULT_Pos)
#define I2S_SERCTRL_TXDEFAULT(value)	((I2S_SERCTRL_TXDEFAULT_Msk & ((value) << I2S_SERCTRL_TXDEFAULT_Pos)))
#define   I2S_SERCTRL_TXDEFAULT_ZERO_Val	0x0u		/**< \brief (I2S_SERCTRL)o͊l0 */
#define   I2S_SERCTRL_TXDEFAULT_ONE_Val		0x1u		/**< \brief (I2S_SERCTRL)o͊l1 */
#define   I2S_SERCTRL_TXDEFAULT_HIZ_Val		0x3u		/**< \brief (I2S_SERCTRL)o͊lHi-Z */
#define I2S_SERCTRL_TXDEFAULT_ZERO		(I2S_SERCTRL_TXDEFAULT_ZERO_Val	<< I2S_SERCTRL_TXDEFAULT_Pos)
#define I2S_SERCTRL_TXDEFAULT_ONE		(I2S_SERCTRL_TXDEFAULT_ONE_Val	<< I2S_SERCTRL_TXDEFAULT_Pos)
#define I2S_SERCTRL_TXDEFAULT_HIZ		(I2S_SERCTRL_TXDEFAULT_HIZ_Val	<< I2S_SERCTRL_TXDEFAULT_Pos)
#define I2S_SERCTRL_TXSAME_Pos			4				/**< \brief (I2S_SERCTRL)ްݎްM */
#define I2S_SERCTRL_TXSAME				(0x1u << I2S_SERCTRL_TXSAME_Pos)
#define   I2S_SERCTRL_TXSAME_ZERO_Val		0x0u		/**< \brief (I2S_SERCTRL)ް݂̏ꍇ0ް𑗐M */
#define   I2S_SERCTRL_TXSAME_SAME_Val		0x1u		/**< \brief (I2S_SERCTRL)ް݂̏ꍇɍŌް𑗐M */
#define I2S_SERCTRL_TXSAME_ZERO			(I2S_SERCTRL_TXSAME_ZERO_Val << I2S_SERCTRL_TXSAME_Pos)
#define I2S_SERCTRL_TXSAME_SAME			(I2S_SERCTRL_TXSAME_SAME_Val << I2S_SERCTRL_TXSAME_Pos)
#define I2S_SERCTRL_CLKSEL_Pos			5				/**< \brief (I2S_SERCTRL)ۯI */
#define I2S_SERCTRL_CLKSEL				(0x1u << I2S_SERCTRL_CLKSEL_Pos)
#define   I2S_SERCTRL_CLKSEL_CLK0_Val		0x0u		/**< \brief (I2S_SERCTRL)ۯ0gp */
#define   I2S_SERCTRL_CLKSEL_CLK1_Val		0x1u		/**< \brief (I2S_SERCTRL)ۯ1gp */
#define I2S_SERCTRL_CLKSEL_CLK0			(I2S_SERCTRL_CLKSEL_CLK0_Val << I2S_SERCTRL_CLKSEL_Pos)
#define I2S_SERCTRL_CLKSEL_CLK1			(I2S_SERCTRL_CLKSEL_CLK1_Val << I2S_SERCTRL_CLKSEL_Pos)
#define I2S_SERCTRL_SLOTADJ_Pos			7				/**< \brief (I2S_SERCTRL)ް ۯ ̫ϰĕ␳ */
#define I2S_SERCTRL_SLOTADJ				(0x1u << I2S_SERCTRL_SLOTADJ_Pos)
#define   I2S_SERCTRL_SLOTADJ_RIGHT_Val		0x0u		/**< \brief (I2S_SERCTRL)ްͽۯĂŉE܂B */
#define   I2S_SERCTRL_SLOTADJ_LEFT_Val		0x1u		/**< \brief (I2S_SERCTRL)ްͽۯĂō܂B */
#define I2S_SERCTRL_SLOTADJ_RIGHT		(I2S_SERCTRL_SLOTADJ_RIGHT_Val	<< I2S_SERCTRL_SLOTADJ_Pos)
#define I2S_SERCTRL_SLOTADJ_LEFT		(I2S_SERCTRL_SLOTADJ_LEFT_Val	<< I2S_SERCTRL_SLOTADJ_Pos)
#define I2S_SERCTRL_DATASIZE_Pos		8				/**< \brief (I2S_SERCTRL)ް̑傫 */
#define I2S_SERCTRL_DATASIZE_Msk		(0x7u << I2S_SERCTRL_DATASIZE_Pos)
#define I2S_SERCTRL_DATASIZE(value)		((I2S_SERCTRL_DATASIZE_Msk & ((value) << I2S_SERCTRL_DATASIZE_Pos)))
#define   I2S_SERCTRL_DATASIZE_32_Val		0x0u		/**< \brief (I2S_SERCTRL)32ޯ */
#define   I2S_SERCTRL_DATASIZE_24_Val		0x1u		/**< \brief (I2S_SERCTRL)24ޯ */
#define   I2S_SERCTRL_DATASIZE_20_Val		0x2u		/**< \brief (I2S_SERCTRL)20ޯ */
#define   I2S_SERCTRL_DATASIZE_18_Val		0x3u		/**< \brief (I2S_SERCTRL)18ޯ */
#define   I2S_SERCTRL_DATASIZE_16_Val		0x4u		/**< \brief (I2S_SERCTRL)16ޯ */
#define   I2S_SERCTRL_DATASIZE_16C_Val		0x5u		/**< \brief (I2S_SERCTRL)16ޯ ߸ ڵ */
#define   I2S_SERCTRL_DATASIZE_8_Val		0x6u		/**< \brief (I2S_SERCTRL)8ޯ */
#define   I2S_SERCTRL_DATASIZE_8C_Val		0x7u		/**< \brief (I2S_SERCTRL)8ޯ ߸ ڵ */
#define I2S_SERCTRL_DATASIZE_32			(I2S_SERCTRL_DATASIZE_32_Val	<< I2S_SERCTRL_DATASIZE_Pos)
#define I2S_SERCTRL_DATASIZE_24			(I2S_SERCTRL_DATASIZE_24_Val	<< I2S_SERCTRL_DATASIZE_Pos)
#define I2S_SERCTRL_DATASIZE_20			(I2S_SERCTRL_DATASIZE_20_Val	<< I2S_SERCTRL_DATASIZE_Pos)
#define I2S_SERCTRL_DATASIZE_18			(I2S_SERCTRL_DATASIZE_18_Val	<< I2S_SERCTRL_DATASIZE_Pos)
#define I2S_SERCTRL_DATASIZE_16			(I2S_SERCTRL_DATASIZE_16_Val	<< I2S_SERCTRL_DATASIZE_Pos)
#define I2S_SERCTRL_DATASIZE_16C		(I2S_SERCTRL_DATASIZE_16C_Val	<< I2S_SERCTRL_DATASIZE_Pos)
#define I2S_SERCTRL_DATASIZE_8			(I2S_SERCTRL_DATASIZE_8_Val		<< I2S_SERCTRL_DATASIZE_Pos)
#define I2S_SERCTRL_DATASIZE_8C			(I2S_SERCTRL_DATASIZE_8C_Val	<< I2S_SERCTRL_DATASIZE_Pos)
#define I2S_SERCTRL_WORDADJ_Pos			12				/**< \brief (I2S_SERCTRL)ް̫ϯĕ␳ */
#define I2S_SERCTRL_WORDADJ				(0x1u << I2S_SERCTRL_WORDADJ_Pos)
#define   I2S_SERCTRL_WORDADJ_RIGHT_Val		0x0u		/**< \brief (I2S_SERCTRL)ް͌ŉE܂B */
#define   I2S_SERCTRL_WORDADJ_LEFT_Val		0x1u		/**< \brief (I2S_SERCTRL)ް͌ō܂B */
#define I2S_SERCTRL_WORDADJ_RIGHT		(I2S_SERCTRL_WORDADJ_RIGHT_Val	<< I2S_SERCTRL_WORDADJ_Pos)
#define I2S_SERCTRL_WORDADJ_LEFT		(I2S_SERCTRL_WORDADJ_LEFT_Val	<< I2S_SERCTRL_WORDADJ_Pos)
#define I2S_SERCTRL_EXTEND_Pos			13				/**< \brief (I2S_SERCTRL)ް ̫ϯ ޯĊg */
#define I2S_SERCTRL_EXTEND_Msk			(0x3u << I2S_SERCTRL_EXTEND_Pos)
#define I2S_SERCTRL_EXTEND(value)		((I2S_SERCTRL_EXTEND_Msk & ((value) << I2S_SERCTRL_EXTEND_Pos)))
#define   I2S_SERCTRL_EXTEND_ZERO_Val		0x0u		/**< \brief (I2S_SERCTRL)0Ŋg */
#define   I2S_SERCTRL_EXTEND_ONE_Val		0x1u		/**< \brief (I2S_SERCTRL)1Ŋg */
#define   I2S_SERCTRL_EXTEND_MSBIT_Val		0x2u		/**< \brief (I2S_SERCTRL)ŏޯĂŊg */
#define   I2S_SERCTRL_EXTEND_LSBIT_Val		0x3u		/**< \brief (I2S_SERCTRL)ŉޯĂŊg */
#define I2S_SERCTRL_EXTEND_ZERO			(I2S_SERCTRL_EXTEND_ZERO_Val	<< I2S_SERCTRL_EXTEND_Pos)
#define I2S_SERCTRL_EXTEND_ONE			(I2S_SERCTRL_EXTEND_ONE_Val		<< I2S_SERCTRL_EXTEND_Pos)
#define I2S_SERCTRL_EXTEND_MSBIT		(I2S_SERCTRL_EXTEND_MSBIT_Val	<< I2S_SERCTRL_EXTEND_Pos)
#define I2S_SERCTRL_EXTEND_LSBIT		(I2S_SERCTRL_EXTEND_LSBIT_Val	<< I2S_SERCTRL_EXTEND_Pos)
#define I2S_SERCTRL_BITREV_Pos			15				/**< \brief (I2S_SERCTRL)ް ̫ϯ ޯċt] */
#define I2S_SERCTRL_BITREV				(0x1u << I2S_SERCTRL_BITREV_Pos)
#define   I2S_SERCTRL_BITREV_MSBIT_Val		0x0u		/**< \brief (I2S_SERCTRL)ŏޯ(MSB)ɓ](I2SKɑ΂) */
#define   I2S_SERCTRL_BITREV_LSBIT_Val		0x1u		/**< \brief (I2S_SERCTRL)ŉޯ(LSB)ɓ] */
#define I2S_SERCTRL_BITREV_MSBIT		(I2S_SERCTRL_BITREV_MSBIT_Val << I2S_SERCTRL_BITREV_Pos)
#define I2S_SERCTRL_BITREV_LSBIT		(I2S_SERCTRL_BITREV_LSBIT_Val << I2S_SERCTRL_BITREV_Pos)
#define I2S_SERCTRL_SLOTDIS0_Pos		16				/**< \brief (I2S_SERCTRL)̒񉻊ɑ΂Ľۯ0֎~ */
#define I2S_SERCTRL_SLOTDIS0			(1 << I2S_SERCTRL_SLOTDIS0_Pos)
#define I2S_SERCTRL_SLOTDIS1_Pos		17				/**< \brief (I2S_SERCTRL)̒񉻊ɑ΂Ľۯ1֎~ */
#define I2S_SERCTRL_SLOTDIS1			(1 << I2S_SERCTRL_SLOTDIS1_Pos)
#define I2S_SERCTRL_SLOTDIS2_Pos		18				/**< \brief (I2S_SERCTRL)̒񉻊ɑ΂Ľۯ2֎~ */
#define I2S_SERCTRL_SLOTDIS2			(1 << I2S_SERCTRL_SLOTDIS2_Pos)
#define I2S_SERCTRL_SLOTDIS3_Pos		19				/**< \brief (I2S_SERCTRL)̒񉻊ɑ΂Ľۯ3֎~ */
#define I2S_SERCTRL_SLOTDIS3			(1 << I2S_SERCTRL_SLOTDIS3_Pos)
#define I2S_SERCTRL_SLOTDIS4_Pos		20				/**< \brief (I2S_SERCTRL)̒񉻊ɑ΂Ľۯ4֎~ */
#define I2S_SERCTRL_SLOTDIS4			(1 << I2S_SERCTRL_SLOTDIS4_Pos)
#define I2S_SERCTRL_SLOTDIS5_Pos		21				/**< \brief (I2S_SERCTRL)̒񉻊ɑ΂Ľۯ5֎~ */
#define I2S_SERCTRL_SLOTDIS5			(1 << I2S_SERCTRL_SLOTDIS5_Pos)
#define I2S_SERCTRL_SLOTDIS6_Pos		22				/**< \brief (I2S_SERCTRL)̒񉻊ɑ΂Ľۯ6֎~ */
#define I2S_SERCTRL_SLOTDIS6			(1 << I2S_SERCTRL_SLOTDIS6_Pos)
#define I2S_SERCTRL_SLOTDIS7_Pos		23				/**< \brief (I2S_SERCTRL)̒񉻊ɑ΂Ľۯ7֎~ */
#define I2S_SERCTRL_SLOTDIS7			(1 << I2S_SERCTRL_SLOTDIS7_Pos)
#define I2S_SERCTRL_SLOTDIS_Pos			16				/**< \brief (I2S_SERCTRL)̒񉻊ɑ΂Ľۯx֎~ */
#define I2S_SERCTRL_SLOTDIS_Msk			(0xFFu << I2S_SERCTRL_SLOTDIS_Pos)
#define I2S_SERCTRL_SLOTDIS(value)		((I2S_SERCTRL_SLOTDIS_Msk & ((value) << I2S_SERCTRL_SLOTDIS_Pos)))
#define I2S_SERCTRL_MONO_Pos			24				/**< \brief (I2S_SERCTRL)Pꓮ */
#define I2S_SERCTRL_MONO				(0x1u << I2S_SERCTRL_MONO_Pos)
#define   I2S_SERCTRL_MONO_STEREO_Val		0x0u		/**< \brief (I2S_SERCTRL)W */
#define   I2S_SERCTRL_MONO_MONO_Val			0x1u		/**< \brief (I2S_SERCTRL)ق͉Eقɏd܂B */
#define I2S_SERCTRL_MONO_STEREO			(I2S_SERCTRL_MONO_STEREO_Val	<< I2S_SERCTRL_MONO_Pos)
#define I2S_SERCTRL_MONO_MONO			(I2S_SERCTRL_MONO_MONO_Val		<< I2S_SERCTRL_MONO_Pos)
#define I2S_SERCTRL_DMA_Pos				25				/**< \brief (I2S_SERCTRL)P܂͕DMA */
#define I2S_SERCTRL_DMA					(0x1u << I2S_SERCTRL_DMA_Pos)
#define   I2S_SERCTRL_DMA_SINGLE_Val		0x0u		/**< \brief (I2S_SERCTRL)PDMA */
#define   I2S_SERCTRL_DMA_MULTIPLE_Val		0x1u		/**< \brief (I2S_SERCTRL)ް ٖ1DMA */
#define I2S_SERCTRL_DMA_SINGLE			(I2S_SERCTRL_DMA_SINGLE_Val		<< I2S_SERCTRL_DMA_Pos)
#define I2S_SERCTRL_DMA_MULTIPLE		(I2S_SERCTRL_DMA_MULTIPLE_Val	<< I2S_SERCTRL_DMA_Pos)
#define I2S_SERCTRL_RXLOOP_Pos			26				/**< \brief (I2S_SERCTRL)ԂH */
#define I2S_SERCTRL_RXLOOP				(0x1u << I2S_SERCTRL_RXLOOP_Pos)
#define I2S_SERCTRL_MASK				0x07FFF7BFu		/**< \brief (I2S_SERCTRL)Օڼ޽ */

/* -------- I2S_DATA : (I2Sψ:0x30) (R/W 32)ްn -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t DATA:32;			/*!< ޯ0`31: ̎ް */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} I2S_DATA_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define I2S_DATA_OFFSET					0x30			/**< \brief (I2S_DATA offset)ްn */
#define I2S_DATA_RESETVALUE				0x00000000		/**< \brief (I2S_DATA reset_value)ްn */

#define I2S_DATA_DATA_Pos				0				/**< \brief (I2S_DATA)̎ް*/
#define I2S_DATA_DATA_Msk				(0xFFFFFFFFu << I2S_DATA_DATA_Pos)
#define I2S_DATA_DATA(value)			((I2S_DATA_DATA_Msk & ((value) << I2S_DATA_DATA_Pos)))
#define I2S_DATA_MASK					0xFFFFFFFFu		/**< \brief (I2S_DATA)Օڼ޽ */

/** \brief I2Sʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  __IO I2S_CTRLA_Type		CTRLA;			/**< \briefψ:0x00 (R/W  8)A */
	   RoReg8				Reserved1[0x3];
  __IO I2S_CLKCTRL_Type		CLKCTRL[2];		/**< \briefψ:0x04 (R/W 32)ۯn */
  __IO I2S_INTENCLR_Type	INTENCLR;		/**< \briefψ:0x0C (R/W 16)荞݋ */
	   RoReg8				Reserved2[0x2];
  __IO I2S_INTENSET_Type	INTENSET;		/**< \briefψ:0x10 (R/W 16)荞݋ݒ */
	   RoReg8				Reserved3[0x2];
  __IO I2S_INTFLAG_Type		INTFLAG;		/**< \briefψ:0x14 (R/W 16)荞׸ޏ/ */
	   RoReg8				Reserved4[0x2];
  __I  I2S_SYNCBUSY_Type	SYNCBUSY;		/**< \briefψ:0x18 (R/  16) */
	   RoReg8				Reserved5[0x6];
  __IO I2S_SERCTRL_Type		SERCTRL[2];		/**< \briefψ:0x20 (R/W 32)񉻊n [SER_NUM] */
	   RoReg8				Reserved6[0x8];
  __IO I2S_DATA_Type		DATA[2];		/**< \briefψ:0x30 (R/W 32)ްn [SER_NUM] */
} I2s;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAMD21_I2S_COMPONENT_ */
