/**
 * \file
 *
 * \brief MTBp\iLq
 *
 * 쌠 (c) 2013 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAMD21_MTB_COMPONENT_
#define _SAMD21_MTB_COMPONENT_

/* ========================================================================== */
/** MTBpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAMD21_MTB Cortex-M0+ ǐՊɏՕ */
/*@{*/

#define MTB_U2002
#define REV_MTB						0x100

/* -------- MTB_POSITION : (MTBψ:0x000) (R/W 32)MTBʒu -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t :2;				/*!< ޯ0` 1: \ */
    uint32_t WRAP:1;			/*!< ޯ    2: ʒuwqlۂ */
    uint32_t POINTER:29;		/*!< ޯ3`31: ǐ߹Ĉʒuʒuwq */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} MTB_POSITION_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define MTB_POSITION_OFFSET			0x000			/**< \brief (MTB_POSITION offset)MTBʒu */

#define MTB_POSITION_WRAP_Pos		2				/**< \brief (MTB_POSITION)ʒuwqlۂ */
#define MTB_POSITION_WRAP			(0x1u << MTB_POSITION_WRAP_Pos)
#define MTB_POSITION_POINTER_Pos	3				/**< \brief (MTB_POSITION)ǐ߹Ĉʒuʒuwq */
#define MTB_POSITION_POINTER_Msk	(0x1FFFFFFFu << MTB_POSITION_POINTER_Pos)
#define MTB_POSITION_POINTER(value)	((MTB_POSITION_POINTER_Msk & ((value) << MTB_POSITION_POINTER_Pos)))
#define MTB_POSITION_MASK			0xFFFFFFFCu		/**< \brief (MTB_POSITION)Օڼ޽ */

/* -------- MTB_MASTER : (MTBψ:0x004) (R/W 32)MTB匠 -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t MASK:5;			/*!< ޯ 0` 4: SRAM̒ǐՊɏՕ̍ől */
    uint32_t TSTARTEN:1;		/*!< ޯ     5: ǐՊJn͋ */
    uint32_t TSTOPEN:1;			/*!< ޯ     6: ǐՒ~͋ */
    uint32_t SFRWPRIV:1;		/*!< ޯ     7: @\ڼ޽ݓ */
    uint32_t RAMPRIV:1;			/*!< ޯ     8: SRAM */
    uint32_t HALTREQ:1;			/*!< ޯ     9: ~v */
    uint32_t :21;				/*!< ޯ10`30: \ */
    uint32_t EN:1;				/*!< ޯ    31: ǐՋ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} MTB_MASTER_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define MTB_MASTER_OFFSET			0x004			/**< \brief (MTB_MASTER offset)MTB匠 */
#define MTB_MASTER_RESETVALUE		0x00000000		/**< \brief (MTB_MASTER reset_value)MTB匠 */

#define MTB_MASTER_MASK_Pos			0				/**< \brief (MTB_MASTER)SRAM̒ǐՊɏՕ̍ől */
#define MTB_MASTER_MASK_Msk			(0x1Fu << MTB_MASTER_MASK_Pos)
#define MTB_MASTER_MASK(value)		((MTB_MASTER_MASK_Msk & ((value) << MTB_MASTER_MASK_Pos)))
#define MTB_MASTER_TSTARTEN_Pos		5				/**< \brief (MTB_MASTER)ǐՊJn͋ */
#define MTB_MASTER_TSTARTEN			(0x1u << MTB_MASTER_TSTARTEN_Pos)
#define MTB_MASTER_TSTOPEN_Pos		6				/**< \brief (MTB_MASTER)ǐՒ~͋ */
#define MTB_MASTER_TSTOPEN			(0x1u << MTB_MASTER_TSTOPEN_Pos)
#define MTB_MASTER_SFRWPRIV_Pos		7				/**< \brief (MTB_MASTER)@\ڼ޽ݓ */
#define MTB_MASTER_SFRWPRIV			(0x1u << MTB_MASTER_SFRWPRIV_Pos)
#define MTB_MASTER_RAMPRIV_Pos		8				/**< \brief (MTB_MASTER)SRAM */
#define MTB_MASTER_RAMPRIV			(0x1u << MTB_MASTER_RAMPRIV_Pos)
#define MTB_MASTER_HALTREQ_Pos		9				/**< \brief (MTB_MASTER)~v */
#define MTB_MASTER_HALTREQ			(0x1u << MTB_MASTER_HALTREQ_Pos)
#define MTB_MASTER_EN_Pos			31				/**< \brief (MTB_MASTER)ǐՋ */
#define MTB_MASTER_EN				(0x1u << MTB_MASTER_EN_Pos)
#define MTB_MASTER_MASK_			0x800003FFu		/**< \brief (MTB_MASTER)Օڼ޽ */

/* -------- MTB_FLOW : (MTBψ:0x008) (R/W 32)MTB -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t AUTOSTOP:1;		/*!< ޯ    0: ~ǐ */
    uint32_t AUTOHALT:1;		/*!< ޯ    1: ~v */
    uint32_t :1;				/*!< ޯ    2: \ */
    uint32_t WATERMARK:29;		/*!< ޯ3`31: l */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} MTB_FLOW_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define MTB_FLOW_OFFSET				0x008			/**< \brief (MTB_FLOW offset)MTB */
#define MTB_FLOW_RESETVALUE			0x00000000		/**< \brief (MTB_FLOW reset_value)MTB */

#define MTB_FLOW_AUTOSTOP_Pos		0				/**< \brief (MTB_FLOW)~ǐ */
#define MTB_FLOW_AUTOSTOP			(0x1u << MTB_FLOW_AUTOSTOP_Pos)
#define MTB_FLOW_AUTOHALT_Pos		1				/**< \brief (MTB_FLOW)~v */
#define MTB_FLOW_AUTOHALT			(0x1u << MTB_FLOW_AUTOHALT_Pos)
#define MTB_FLOW_WATERMARK_Pos		3				/**< \brief (MTB_FLOW)l */
#define MTB_FLOW_WATERMARK_Msk		(0x1FFFFFFFu << MTB_FLOW_WATERMARK_Pos)
#define MTB_FLOW_WATERMARK(value)	((MTB_FLOW_WATERMARK_Msk & ((value) << MTB_FLOW_WATERMARK_Pos)))
#define MTB_FLOW_MASK				0xFFFFFFFBu		/**< \brief (MTB_FLOW)Օڼ޽ */

/* -------- MTB_BASE : (MTBψ:0x00C) (R/  32)MTB -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} MTB_BASE_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define MTB_BASE_OFFSET				0x00C			/**< \brief (MTB_BASE offset)MTB */
#define MTB_BASE_MASK				0xFFFFFFFFu		/**< \brief (MTB_BASE)Օڼ޽ */

/* -------- MTB_ITCTRL : (MTBψ:0xF00) (R/W 32)MTB쐧 -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} MTB_ITCTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define MTB_ITCTRL_OFFSET			0xF00			/**< \brief (MTB_ITCTRL offset)MTB쐧 */
#define MTB_ITCTRL_MASK				0xFFFFFFFFu		/**< \brief (MTB_ITCTRL)Օڼ޽ */

/* -------- MTB_CLAIMSET : (MTBψ:0xFA0) (R/W 32)MTBݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} MTB_CLAIMSET_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define MTB_CLAIMSET_OFFSET			0xFA0			/**< \brief (MTB_CLAIMSET offset)MTBݒ */
#define MTB_CLAIMSET_MASK			0xFFFFFFFFu		/**< \brief (MTB_CLAIMSET)Օڼ޽ */

/* -------- MTB_CLAIMCLR : (MTBψ:0xFA4) (R/W 32)MTB -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} MTB_CLAIMCLR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define MTB_CLAIMCLR_OFFSET			0xFA4			/**< \brief (MTB_CLAIMCLR offset)MTB */
#define MTB_CLAIMCLR_MASK			0xFFFFFFFFu		/**< \brief (MTB_CLAIMCLR)Օڼ޽ */

/* -------- MTB_LOCKACCESS : (MTBψ:0xFB0) (R/W 32)MTB{ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} MTB_LOCKACCESS_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define MTB_LOCKACCESS_OFFSET		0xFB0			/**< \brief (MTB_LOCKACCESS offset)MTB{ */
#define MTB_LOCKACCESS_MASK			0xFFFFFFFFu		/**< \brief (MTB_LOCKACCESS)Օڼ޽ */

/* -------- MTB_LOCKSTATUS : (MTBψ:0xFB4) (R/  32)MTB{ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} MTB_LOCKSTATUS_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define MTB_LOCKSTATUS_OFFSET		0xFB4			/**< \brief (MTB_LOCKSTATUS offset)MTB{ */
#define MTB_LOCKSTATUS_MASK			0xFFFFFFFFu		/**< \brief (MTB_LOCKSTATUS)Օڼ޽ */

/* -------- MTB_AUTHSTATUS : (MTBψ:0xFB8) (R/  32)MTBF؏ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} MTB_AUTHSTATUS_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define MTB_AUTHSTATUS_OFFSET		0xFB8			/**< \brief (MTB_AUTHSTATUS offset)MTBF؏ */
#define MTB_AUTHSTATUS_MASK			0xFFFFFFFFu		/**< \brief (MTB_AUTHSTATUS)Օڼ޽ */

/* -------- MTB_DEVARCH : (MTBψ:0xFBC) (R/  32)MTB޲{\ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} MTB_DEVARCH_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define MTB_DEVARCH_OFFSET			0xFBC			/**< \brief (MTB_DEVARCH offset)MTB޲{\ */
#define MTB_DEVARCH_MASK			0xFFFFFFFFu		/**< \brief (MTB_DEVARCH)Օڼ޽ */

/* -------- MTB_DEVID : (MTBψ:0xFC8) (R/  32)MTB޲`Ԑݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} MTB_DEVID_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define MTB_DEVID_OFFSET			0xFC8			/**< \brief (MTB_DEVID offset)MTB޲`Ԑݒ */
#define MTB_DEVID_MASK				0xFFFFFFFFu		/**< \brief (MTB_DEVID)Օڼ޽ */

/* -------- MTB_DEVTYPE : (MTBψ:0xFCC) (R/  32)MTB޲^ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} MTB_DEVTYPE_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define MTB_DEVTYPE_OFFSET			0xFCC			/**< \brief (MTB_DEVTYPE offset)MTB޲^ */
#define MTB_DEVTYPE_MASK			0xFFFFFFFFu		/**< \brief (MTB_DEVTYPE)Օڼ޽ */

/* -------- MTB_PID4 : (MTBψ:0xFD0) (R/  32)CoreSight -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} MTB_PID4_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define MTB_PID4_OFFSET				0xFD0			/**< \brief (MTB_PID4 offset)CoreSight */
#define MTB_PID4_MASK				0xFFFFFFFFu		/**< \brief (MTB_PID4)Օڼ޽ */

/* -------- MTB_PID5 : (MTBψ:0xFD4) (R/  32)CoreSight -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} MTB_PID5_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define MTB_PID5_OFFSET				0xFD4			/**< \brief (MTB_PID5 offset)CoreSight */
#define MTB_PID5_MASK				0xFFFFFFFFu		/**< \brief (MTB_PID5)Օڼ޽ */

/* -------- MTB_PID6 : (MTBψ:0xFD8) (R/  32)CoreSight -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} MTB_PID6_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define MTB_PID6_OFFSET				0xFD8			/**< \brief (MTB_PID6 offset)CoreSight */
#define MTB_PID6_MASK				0xFFFFFFFFu		/**< \brief (MTB_PID6)Օڼ޽ */

/* -------- MTB_PID7 : (MTBψ:0xFDC) (R/  32)CoreSight -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} MTB_PID7_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define MTB_PID7_OFFSET				0xFDC			/**< \brief (MTB_PID7 offset)CoreSight */
#define MTB_PID7_MASK				0xFFFFFFFFu		/**< \brief (MTB_PID7)Օڼ޽ */

/* -------- MTB_PID0 : (MTBψ:0xFE0) (R/  32)CoreSight -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} MTB_PID0_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define MTB_PID0_OFFSET				0xFE0			/**< \brief (MTB_PID0 offset)CoreSight */
#define MTB_PID0_MASK				0xFFFFFFFFu		/**< \brief (MTB_PID0)Օڼ޽ */

/* -------- MTB_PID1 : (MTBψ:0xFE4) (R/  32)CoreSight -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} MTB_PID1_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define MTB_PID1_OFFSET				0xFE4			/**< \brief (MTB_PID1 offset)CoreSight */
#define MTB_PID1_MASK				0xFFFFFFFFu		/**< \brief (MTB_PID1)Օڼ޽ */

/* -------- MTB_PID2 : (MTBψ:0xFE8) (R/  32)CoreSight -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} MTB_PID2_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define MTB_PID2_OFFSET				0xFE8			/**< \brief (MTB_PID2 offset)CoreSight */
#define MTB_PID2_MASK				0xFFFFFFFFu		/**< \brief (MTB_PID2)Օڼ޽ */

/* -------- MTB_PID3 : (MTBψ:0xFEC) (R/  32)CoreSight -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} MTB_PID3_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define MTB_PID3_OFFSET				0xFEC			/**< \brief (MTB_PID3 offset)CoreSight */
#define MTB_PID3_MASK				0xFFFFFFFFu		/**< \brief (MTB_PID3)Օڼ޽ */

/* -------- MTB_CID0 : (MTBψ:0xFF0) (R/  32)CoreSight -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} MTB_CID0_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define MTB_CID0_OFFSET				0xFF0			/**< \brief (MTB_CID0 offset)CoreSight */
#define MTB_CID0_MASK				0xFFFFFFFFu		/**< \brief (MTB_CID0)Օڼ޽ */

/* -------- MTB_CID1 : (MTBψ:0xFF4) (R/  32)CoreSight -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} MTB_CID1_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define MTB_CID1_OFFSET				0xFF4			/**< \brief (MTB_CID1 offset)CoreSight */
#define MTB_CID1_MASK				0xFFFFFFFFu		/**< \brief (MTB_CID1)Օڼ޽ */

/* -------- MTB_CID2 : (MTBψ:0xFF8) (R/  32)CoreSight -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} MTB_CID2_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define MTB_CID2_OFFSET				0xFF8			/**< \brief (MTB_CID2 offset)CoreSight */
#define MTB_CID2_MASK				0xFFFFFFFFu		/**< \brief (MTB_CID2)Օڼ޽ */

/* -------- MTB_CID3 : (MTBψ:0xFFC) (R/  32)CoreSight -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} MTB_CID3_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define MTB_CID3_OFFSET				0xFFC			/**< \brief (MTB_CID3 offset)CoreSight */
#define MTB_CID3_MASK				0xFFFFFFFFu		/**< \brief (MTB_CID3)Օڼ޽ */

/** \brief MTBʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  __IO MTB_POSITION_Type	POSITION;		/**< \briefψ:0x000 (R/W 32)MTBʒu */
  __IO MTB_MASTER_Type		MASTER;			/**< \briefψ:0x004 (R/W 32)MTB匠 */
  __IO MTB_FLOW_Type		FLOW;			/**< \briefψ:0x008 (R/W 32)MTB */
  __I  MTB_BASE_Type		BASE;			/**< \briefψ:0x00C (R/  32)MTB */
	   RoReg8				Reserved1[0xEF0];
  __IO MTB_ITCTRL_Type		ITCTRL;			/**< \briefψ:0xF00 (R/W 32)MTB쐧 */
	   RoReg8				Reserved2[0x9C];
  __IO MTB_CLAIMSET_Type	CLAIMSET;		/**< \briefψ:0xFA0 (R/W 32)MTBݒ */
  __IO MTB_CLAIMCLR_Type	CLAIMCLR;		/**< \briefψ:0xFA4 (R/W 32)MTB */
	   RoReg8				Reserved3[0x8];
  __IO MTB_LOCKACCESS_Type	LOCKACCESS;		/**< \briefψ:0xFB0 (R/W 32)MTB{ */
  __I  MTB_LOCKSTATUS_Type	LOCKSTATUS;		/**< \briefψ:0xFB4 (R/  32)MTB{ */
  __I  MTB_AUTHSTATUS_Type	AUTHSTATUS;		/**< \briefψ:0xFB8 (R/  32)MTBF؏ */
  __I  MTB_DEVARCH_Type		DEVARCH;		/**< \briefψ:0xFBC (R/  32)MTB޲{\ */
	   RoReg8				Reserved4[0x8];
  __I  MTB_DEVID_Type		DEVID;			/**< \briefψ:0xFC8 (R/  32)MTB޲`Ԑݒ */
  __I  MTB_DEVTYPE_Type		DEVTYPE;		/**< \briefψ:0xFCC (R/  32)MTB޲^ */
  __I  MTB_PID4_Type		PID4;			/**< \briefψ:0xFD0 (R/  32)CoreSight */
  __I  MTB_PID5_Type		PID5;			/**< \briefψ:0xFD4 (R/  32)CoreSight */
  __I  MTB_PID6_Type		PID6;			/**< \briefψ:0xFD8 (R/  32)CoreSight */
  __I  MTB_PID7_Type		PID7;			/**< \briefψ:0xFDC (R/  32)CoreSight */
  __I  MTB_PID0_Type		PID0;			/**< \briefψ:0xFE0 (R/  32)CoreSight */
  __I  MTB_PID1_Type		PID1;			/**< \briefψ:0xFE4 (R/  32)CoreSight */
  __I  MTB_PID2_Type		PID2;			/**< \briefψ:0xFE8 (R/  32)CoreSight */
  __I  MTB_PID3_Type		PID3;			/**< \briefψ:0xFEC (R/  32)CoreSight */
  __I  MTB_CID0_Type		CID0;			/**< \briefψ:0xFF0 (R/  32)CoreSight */
  __I  MTB_CID1_Type		CID1;			/**< \briefψ:0xFF4 (R/  32)CoreSight */
  __I  MTB_CID2_Type		CID2;			/**< \briefψ:0xFF8 (R/  32)CoreSight */
  __I  MTB_CID3_Type		CID3;			/**< \briefψ:0xFFC (R/  32)CoreSight */
} Mtb;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAMD21_MTB_COMPONENT_ */
