/**
 * \file
 *
 * \brief SYSCTRLp\iLq
 *
 * 쌠 (c) 2013 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAMD21_SYSCTRL_COMPONENT_
#define _SAMD21_SYSCTRL_COMPONENT_

/* ========================================================================== */
/** SYSCTRLpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAMD21_SYSCTRL ѐ */
/*@{*/

#define SYSCTRL_U2100
#define REV_SYSCTRL							0x201

/* -------- SYSCTRL_INTENCLR : (SYSCTRLψ:0x00) (R/W 32)荞݋ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t XOSCRDY:1;			/*!< ޯ     0: XOSC荞݋ */
    uint32_t XOSC32KRDY:1;		/*!< ޯ     1: XOSC32K荞݋ */
    uint32_t OSC32KRDY:1;		/*!< ޯ     2: OSC32K荞݋ */
    uint32_t OSC8MRDY:1;		/*!< ޯ     3: OSC8M荞݋ */
    uint32_t DFLLRDY:1;			/*!< ޯ     4: DFLL荞݋ */
    uint32_t DFLLOOB:1;			/*!< ޯ     5: DFLLEO荞݋ */
    uint32_t DFLLLCKF:1;		/*!< ޯ     6: DFLLŒ艻荞݋ */
    uint32_t DFLLLCKC:1;		/*!< ޯ     7: DFLLaŒ艻荞݋ */
    uint32_t DFLLRCS:1;			/*!< ޯ     8: DFLLۯ~荞݋ */
    uint32_t BOD33RDY:1;		/*!< ޯ     9: BOD33荞݋ */
    uint32_t BOD33DET:1;		/*!< ޯ    10: BOD33o荞݋ */
    uint32_t B33SRDY:1;			/*!< ޯ    11: BOD33荞݋ */
    uint32_t :3;				/*!< ޯ12`14: \ */
    uint32_t DPLLLCKR:1;		/*!< ޯ    15: DPLL㏸Œ艻荞݋ */
    uint32_t DPLLLCKF:1;		/*!< ޯ    16: DPLL~Œ艻荞݋ */
    uint32_t DPLLLTO:1;			/*!< ޯ    17: DPLLŒ艻Ԓߊ荞݋ */
    uint32_t :14;				/*!< ޯ18`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_INTENCLR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_INTENCLR_OFFSET				0x00			/**< \brief (SYSCTRL_INTENCLR offset)荞݋ */
#define SYSCTRL_INTENCLR_RESETVALUE			0x00000000		/**< \brief (SYSCTRL_INTENCLR reset_value)荞݋ */

#define SYSCTRL_INTENCLR_XOSCRDY_Pos		0				/**< \brief (SYSCTRL_INTENCLR)XOSC荞݋ */
#define SYSCTRL_INTENCLR_XOSCRDY			(0x1u << SYSCTRL_INTENCLR_XOSCRDY_Pos)
#define SYSCTRL_INTENCLR_XOSC32KRDY_Pos		1				/**< \brief (SYSCTRL_INTENCLR)XOSC32K荞݋ */
#define SYSCTRL_INTENCLR_XOSC32KRDY			(0x1u << SYSCTRL_INTENCLR_XOSC32KRDY_Pos)
#define SYSCTRL_INTENCLR_OSC32KRDY_Pos		2				/**< \brief (SYSCTRL_INTENCLR)OSC32K荞݋ */
#define SYSCTRL_INTENCLR_OSC32KRDY			(0x1u << SYSCTRL_INTENCLR_OSC32KRDY_Pos)
#define SYSCTRL_INTENCLR_OSC8MRDY_Pos		3				/**< \brief (SYSCTRL_INTENCLR)OSC8M荞݋ */
#define SYSCTRL_INTENCLR_OSC8MRDY			(0x1u << SYSCTRL_INTENCLR_OSC8MRDY_Pos)
#define SYSCTRL_INTENCLR_DFLLRDY_Pos		4				/**< \brief (SYSCTRL_INTENCLR)DFLL荞݋ */
#define SYSCTRL_INTENCLR_DFLLRDY			(0x1u << SYSCTRL_INTENCLR_DFLLRDY_Pos)
#define SYSCTRL_INTENCLR_DFLLOOB_Pos		5				/**< \brief (SYSCTRL_INTENCLR)DFLLEO荞݋ */
#define SYSCTRL_INTENCLR_DFLLOOB			(0x1u << SYSCTRL_INTENCLR_DFLLOOB_Pos)
#define SYSCTRL_INTENCLR_DFLLLCKF_Pos		6				/**< \brief (SYSCTRL_INTENCLR)DFLLŒ艻荞݋ */
#define SYSCTRL_INTENCLR_DFLLLCKF			(0x1u << SYSCTRL_INTENCLR_DFLLLCKF_Pos)
#define SYSCTRL_INTENCLR_DFLLLCKC_Pos		7				/**< \brief (SYSCTRL_INTENCLR)DFLLaŒ艻荞݋ */
#define SYSCTRL_INTENCLR_DFLLLCKC			(0x1u << SYSCTRL_INTENCLR_DFLLLCKC_Pos)
#define SYSCTRL_INTENCLR_DFLLRCS_Pos		8				/**< \brief (SYSCTRL_INTENCLR)DFLLۯ~荞݋ */
#define SYSCTRL_INTENCLR_DFLLRCS			(0x1u << SYSCTRL_INTENCLR_DFLLRCS_Pos)
#define SYSCTRL_INTENCLR_BOD33RDY_Pos		9				/**< \brief (SYSCTRL_INTENCLR)BOD33荞݋ */
#define SYSCTRL_INTENCLR_BOD33RDY			(0x1u << SYSCTRL_INTENCLR_BOD33RDY_Pos)
#define SYSCTRL_INTENCLR_BOD33DET_Pos		10				/**< \brief (SYSCTRL_INTENCLR)BOD33o荞݋ */
#define SYSCTRL_INTENCLR_BOD33DET			(0x1u << SYSCTRL_INTENCLR_BOD33DET_Pos)
#define SYSCTRL_INTENCLR_B33SRDY_Pos		11				/**< \brief (SYSCTRL_INTENCLR)BOD33荞݋ */
#define SYSCTRL_INTENCLR_B33SRDY			(0x1u << SYSCTRL_INTENCLR_B33SRDY_Pos)
#define SYSCTRL_INTENCLR_DPLLLCKR_Pos		15				/**< \brief (SYSCTRL_INTENCLR)DPLL㏸Œ艻荞݋ */
#define SYSCTRL_INTENCLR_DPLLLCKR			(0x1u << SYSCTRL_INTENCLR_DPLLLCKR_Pos)
#define SYSCTRL_INTENCLR_DPLLLCKF_Pos		16				/**< \brief (SYSCTRL_INTENCLR)DPLL~Œ艻荞݋ */
#define SYSCTRL_INTENCLR_DPLLLCKF			(0x1u << SYSCTRL_INTENCLR_DPLLLCKF_Pos)
#define SYSCTRL_INTENCLR_DPLLLTO_Pos		17				/**< \brief (SYSCTRL_INTENCLR)DPLLŒ艻Ԓߊ荞݋ */
#define SYSCTRL_INTENCLR_DPLLLTO			(0x1u << SYSCTRL_INTENCLR_DPLLLTO_Pos)
#define SYSCTRL_INTENCLR_MASK				0x00038FFFu		/**< \brief (SYSCTRL_INTENCLR)Օڼ޽ */

/* -------- SYSCTRL_INTENSET : (SYSCTRLψ:0x04) (R/W 32)荞݋ݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t XOSCRDY:1;			/*!< ޯ     0: XOSC荞݋ */
    uint32_t XOSC32KRDY:1;		/*!< ޯ     1: XOSC32K荞݋ */
    uint32_t OSC32KRDY:1;		/*!< ޯ     2: OSC32K荞݋ */
    uint32_t OSC8MRDY:1;		/*!< ޯ     3: OSC8M荞݋ */
    uint32_t DFLLRDY:1;			/*!< ޯ     4: DFLL荞݋ */
    uint32_t DFLLOOB:1;			/*!< ޯ     5: DFLLEO荞݋ */
    uint32_t DFLLLCKF:1;		/*!< ޯ     6: DFLLŒ艻荞݋ */
    uint32_t DFLLLCKC:1;		/*!< ޯ     7: DFLLaŒ艻荞݋ */
    uint32_t DFLLRCS:1;			/*!< ޯ     8: DFLLۯ~荞݋ */
    uint32_t BOD33RDY:1;		/*!< ޯ     9: BOD33荞݋ */
    uint32_t BOD33DET:1;		/*!< ޯ    10: BOD33o荞݋ */
    uint32_t B33SRDY:1;			/*!< ޯ    11: BOD33荞݋ */
    uint32_t :3;				/*!< ޯ12`14: \ */
    uint32_t DPLLLCKR:1;		/*!< ޯ    15: DPLL㏸Œ艻荞݋ */
    uint32_t DPLLLCKF:1;		/*!< ޯ    16: DPLL~Œ艻荞݋ */
    uint32_t DPLLLTO:1;			/*!< ޯ    17: DPLLŒ艻Ԓߊ荞݋ */
    uint32_t :14;				/*!< ޯ18`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_INTENSET_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_INTENSET_OFFSET				0x04			/**< \brief (SYSCTRL_INTENSET offset)荞݋ݒ */
#define SYSCTRL_INTENSET_RESETVALUE			0x00000000		/**< \brief (SYSCTRL_INTENSET reset_value)荞݋ݒ */

#define SYSCTRL_INTENSET_XOSCRDY_Pos		0				/**< \brief (SYSCTRL_INTENSET)XOSC荞݋ */
#define SYSCTRL_INTENSET_XOSCRDY			(0x1u << SYSCTRL_INTENSET_XOSCRDY_Pos)
#define SYSCTRL_INTENSET_XOSC32KRDY_Pos		1				/**< \brief (SYSCTRL_INTENSET)XOSC32K荞݋ */
#define SYSCTRL_INTENSET_XOSC32KRDY			(0x1u << SYSCTRL_INTENSET_XOSC32KRDY_Pos)
#define SYSCTRL_INTENSET_OSC32KRDY_Pos		2				/**< \brief (SYSCTRL_INTENSET)OSC32K荞݋ */
#define SYSCTRL_INTENSET_OSC32KRDY			(0x1u << SYSCTRL_INTENSET_OSC32KRDY_Pos)
#define SYSCTRL_INTENSET_OSC8MRDY_Pos		3				/**< \brief (SYSCTRL_INTENSET)OSC8M荞݋ */
#define SYSCTRL_INTENSET_OSC8MRDY			(0x1u << SYSCTRL_INTENSET_OSC8MRDY_Pos)
#define SYSCTRL_INTENSET_DFLLRDY_Pos		4				/**< \brief (SYSCTRL_INTENSET)DFLL荞݋ */
#define SYSCTRL_INTENSET_DFLLRDY			(0x1u << SYSCTRL_INTENSET_DFLLRDY_Pos)
#define SYSCTRL_INTENSET_DFLLOOB_Pos		5				/**< \brief (SYSCTRL_INTENSET)DFLLEO荞݋ */
#define SYSCTRL_INTENSET_DFLLOOB			(0x1u << SYSCTRL_INTENSET_DFLLOOB_Pos)
#define SYSCTRL_INTENSET_DFLLLCKF_Pos		6				/**< \brief (SYSCTRL_INTENSET)DFLLŒ艻荞݋ */
#define SYSCTRL_INTENSET_DFLLLCKF			(0x1u << SYSCTRL_INTENSET_DFLLLCKF_Pos)
#define SYSCTRL_INTENSET_DFLLLCKC_Pos		7				/**< \brief (SYSCTRL_INTENSET)DFLLaŒ艻荞݋ */
#define SYSCTRL_INTENSET_DFLLLCKC			(0x1u << SYSCTRL_INTENSET_DFLLLCKC_Pos)
#define SYSCTRL_INTENSET_DFLLRCS_Pos		8				/**< \brief (SYSCTRL_INTENSET)DFLLۯ~荞݋ */
#define SYSCTRL_INTENSET_DFLLRCS			(0x1u << SYSCTRL_INTENSET_DFLLRCS_Pos)
#define SYSCTRL_INTENSET_BOD33RDY_Pos		9				/**< \brief (SYSCTRL_INTENSET)BOD33荞݋ */
#define SYSCTRL_INTENSET_BOD33RDY			(0x1u << SYSCTRL_INTENSET_BOD33RDY_Pos)
#define SYSCTRL_INTENSET_BOD33DET_Pos		10				/**< \brief (SYSCTRL_INTENSET)BOD33o荞݋ */
#define SYSCTRL_INTENSET_BOD33DET			(0x1u << SYSCTRL_INTENSET_BOD33DET_Pos)
#define SYSCTRL_INTENSET_B33SRDY_Pos		11				/**< \brief (SYSCTRL_INTENSET)BOD33荞݋ */
#define SYSCTRL_INTENSET_B33SRDY			(0x1u << SYSCTRL_INTENSET_B33SRDY_Pos)
#define SYSCTRL_INTENSET_DPLLLCKR_Pos		15				/**< \brief (SYSCTRL_INTENSET)DPLL㏸Œ艻荞݋ */
#define SYSCTRL_INTENSET_DPLLLCKR			(0x1u << SYSCTRL_INTENSET_DPLLLCKR_Pos)
#define SYSCTRL_INTENSET_DPLLLCKF_Pos		16				/**< \brief (SYSCTRL_INTENSET)DPLL~Œ艻荞݋ */
#define SYSCTRL_INTENSET_DPLLLCKF			(0x1u << SYSCTRL_INTENSET_DPLLLCKF_Pos)
#define SYSCTRL_INTENSET_DPLLLTO_Pos		17				/**< \brief (SYSCTRL_INTENSET)DPLLŒ艻Ԓߊ荞݋ */
#define SYSCTRL_INTENSET_DPLLLTO			(0x1u << SYSCTRL_INTENSET_DPLLLTO_Pos)
#define SYSCTRL_INTENSET_MASK				0x00038FFFu		/**< \brief (SYSCTRL_INTENSET)Օڼ޽ */

/* -------- SYSCTRL_INTFLAG : (SYSCTRLψ:0x08) (R/W 32)荞׸ޏ/ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t XOSCRDY:1;			/*!< ޯ     0: XOSC */
    uint32_t XOSC32KRDY:1;		/*!< ޯ     1: XOSC32K */
    uint32_t OSC32KRDY:1;		/*!< ޯ     2: OSC32K */
    uint32_t OSC8MRDY:1;		/*!< ޯ     3: OSC8M */
    uint32_t DFLLRDY:1;			/*!< ޯ     4: DFLL */
    uint32_t DFLLOOB:1;			/*!< ޯ     5: DFLLEO */
    uint32_t DFLLLCKF:1;		/*!< ޯ     6: DFLLŒ艻 */
    uint32_t DFLLLCKC:1;		/*!< ޯ     7: DFLLaŒ艻 */
    uint32_t DFLLRCS:1;			/*!< ޯ     8: DFLLۯ~ */
    uint32_t BOD33RDY:1;		/*!< ޯ     9: BOD33 */
    uint32_t BOD33DET:1;		/*!< ޯ    10: BOD33o */
    uint32_t B33SRDY:1;			/*!< ޯ    11: BOD33 */
    uint32_t :3;				/*!< ޯ12`14: \ */
    uint32_t DPLLLCKR:1;		/*!< ޯ    15: DPLL㏸Œ艻 */
    uint32_t DPLLLCKF:1;		/*!< ޯ    16: DPLL~Œ艻 */
    uint32_t DPLLLTO:1;			/*!< ޯ    17: DPLLŒ艻Ԓ */
    uint32_t :14;				/*!< ޯ18`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_INTFLAG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_INTFLAG_OFFSET				0x08			/**< \brief (SYSCTRL_INTFLAG offset)荞׸ޏ/ */
#define SYSCTRL_INTFLAG_RESETVALUE			0x00000000		/**< \brief (SYSCTRL_INTFLAG reset_value)荞׸ޏ/ */

#define SYSCTRL_INTFLAG_XOSCRDY_Pos			0				/**< \brief (SYSCTRL_INTFLAG)XOSC */
#define SYSCTRL_INTFLAG_XOSCRDY				(0x1u << SYSCTRL_INTFLAG_XOSCRDY_Pos)
#define SYSCTRL_INTFLAG_XOSC32KRDY_Pos		1				/**< \brief (SYSCTRL_INTFLAG)XOSC32K */
#define SYSCTRL_INTFLAG_XOSC32KRDY			(0x1u << SYSCTRL_INTFLAG_XOSC32KRDY_Pos)
#define SYSCTRL_INTFLAG_OSC32KRDY_Pos		2				/**< \brief (SYSCTRL_INTFLAG)OSC32K */
#define SYSCTRL_INTFLAG_OSC32KRDY			(0x1u << SYSCTRL_INTFLAG_OSC32KRDY_Pos)
#define SYSCTRL_INTFLAG_OSC8MRDY_Pos		3				/**< \brief (SYSCTRL_INTFLAG)OSC8M */
#define SYSCTRL_INTFLAG_OSC8MRDY			(0x1u << SYSCTRL_INTFLAG_OSC8MRDY_Pos)
#define SYSCTRL_INTFLAG_DFLLRDY_Pos			4				/**< \brief (SYSCTRL_INTFLAG)DFLL */
#define SYSCTRL_INTFLAG_DFLLRDY				(0x1u << SYSCTRL_INTFLAG_DFLLRDY_Pos)
#define SYSCTRL_INTFLAG_DFLLOOB_Pos			5				/**< \brief (SYSCTRL_INTFLAG)DFLLEO */
#define SYSCTRL_INTFLAG_DFLLOOB				(0x1u << SYSCTRL_INTFLAG_DFLLOOB_Pos)
#define SYSCTRL_INTFLAG_DFLLLCKF_Pos		6				/**< \brief (SYSCTRL_INTFLAG)DFLLŒ艻 */
#define SYSCTRL_INTFLAG_DFLLLCKF			(0x1u << SYSCTRL_INTFLAG_DFLLLCKF_Pos)
#define SYSCTRL_INTFLAG_DFLLLCKC_Pos		7				/**< \brief (SYSCTRL_INTFLAG)DFLLaŒ艻 */
#define SYSCTRL_INTFLAG_DFLLLCKC			(0x1u << SYSCTRL_INTFLAG_DFLLLCKC_Pos)
#define SYSCTRL_INTFLAG_DFLLRCS_Pos			8				/**< \brief (SYSCTRL_INTFLAG)DFLLۯ~ */
#define SYSCTRL_INTFLAG_DFLLRCS				(0x1u << SYSCTRL_INTFLAG_DFLLRCS_Pos)
#define SYSCTRL_INTFLAG_BOD33RDY_Pos		9				/**< \brief (SYSCTRL_INTFLAG)BOD33 */
#define SYSCTRL_INTFLAG_BOD33RDY			(0x1u << SYSCTRL_INTFLAG_BOD33RDY_Pos)
#define SYSCTRL_INTFLAG_BOD33DET_Pos		10				/**< \brief (SYSCTRL_INTFLAG)BOD33o */
#define SYSCTRL_INTFLAG_BOD33DET			(0x1u << SYSCTRL_INTFLAG_BOD33DET_Pos)
#define SYSCTRL_INTFLAG_B33SRDY_Pos			11				/**< \brief (SYSCTRL_INTFLAG)BOD33 */
#define SYSCTRL_INTFLAG_B33SRDY				(0x1u << SYSCTRL_INTFLAG_B33SRDY_Pos)
#define SYSCTRL_INTFLAG_DPLLLCKR_Pos		15				/**< \brief (SYSCTRL_INTFLAG)DPLL㏸Œ艻 */
#define SYSCTRL_INTFLAG_DPLLLCKR			(0x1u << SYSCTRL_INTFLAG_DPLLLCKR_Pos)
#define SYSCTRL_INTFLAG_DPLLLCKF_Pos		16				/**< \brief (SYSCTRL_INTFLAG)DPLL~Œ艻 */
#define SYSCTRL_INTFLAG_DPLLLCKF			(0x1u << SYSCTRL_INTFLAG_DPLLLCKF_Pos)
#define SYSCTRL_INTFLAG_DPLLLTO_Pos			17				/**< \brief (SYSCTRL_INTFLAG)DPLLŒ艻Ԓ */
#define SYSCTRL_INTFLAG_DPLLLTO				(0x1u << SYSCTRL_INTFLAG_DPLLLTO_Pos)
#define SYSCTRL_INTFLAG_MASK				0x00038FFFu		/**< \brief (SYSCTRL_INTFLAG)Օڼ޽ */

/* -------- SYSCTRL_PCLKSR : (SYSCTRLψ:0x0C) (R/  32)d͂Ƹۯ̏ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t XOSCRDY:1;			/*!< ޯ     0: XOSC */
    uint32_t XOSC32KRDY:1;		/*!< ޯ     1: XOSC32K */
    uint32_t OSC32KRDY:1;		/*!< ޯ     2: OSC32K */
    uint32_t OSC8MRDY:1;		/*!< ޯ     3: OSC8M */
    uint32_t DFLLRDY:1;			/*!< ޯ     4: DFLL */
    uint32_t DFLLOOB:1;			/*!< ޯ     5: DFLLEO */
    uint32_t DFLLLCKF:1;		/*!< ޯ     6: DFLLŒ艻 */
    uint32_t DFLLLCKC:1;		/*!< ޯ     7: DFLLaŒ艻 */
    uint32_t DFLLRCS:1;			/*!< ޯ     8: DFLLۯ~ */
    uint32_t BOD33RDY:1;		/*!< ޯ     9: BOD33 */
    uint32_t BOD33DET:1;		/*!< ޯ    10: BOD33o */
    uint32_t B33SRDY:1;			/*!< ޯ    11: BOD33 */
    uint32_t :3;				/*!< ޯ12`14: \ */
    uint32_t DPLLLCKR:1;		/*!< ޯ    15: DPLL㏸Œ艻 */
    uint32_t DPLLLCKF:1;		/*!< ޯ    16: DPLL~Œ艻 */
    uint32_t DPLLLTO:1;			/*!< ޯ    17: DPLLŒ艻Ԓ */
    uint32_t :14;				/*!< ޯ18`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_PCLKSR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_PCLKSR_OFFSET				0x0C			/**< \brief (SYSCTRL_PCLKSR offset)d͂Ƹۯ̏ */
#define SYSCTRL_PCLKSR_RESETVALUE			0x00000000		/**< \brief (SYSCTRL_PCLKSR reset_value)d͂Ƹۯ̏ */

#define SYSCTRL_PCLKSR_XOSCRDY_Pos			0				/**< \brief (SYSCTRL_PCLKSR)XOSC */
#define SYSCTRL_PCLKSR_XOSCRDY				(0x1u << SYSCTRL_PCLKSR_XOSCRDY_Pos)
#define SYSCTRL_PCLKSR_XOSC32KRDY_Pos		1				/**< \brief (SYSCTRL_PCLKSR)XOSC32K */
#define SYSCTRL_PCLKSR_XOSC32KRDY			(0x1u << SYSCTRL_PCLKSR_XOSC32KRDY_Pos)
#define SYSCTRL_PCLKSR_OSC32KRDY_Pos		2				/**< \brief (SYSCTRL_PCLKSR)OSC32K */
#define SYSCTRL_PCLKSR_OSC32KRDY			(0x1u << SYSCTRL_PCLKSR_OSC32KRDY_Pos)
#define SYSCTRL_PCLKSR_OSC8MRDY_Pos			3				/**< \brief (SYSCTRL_PCLKSR)OSC8M */
#define SYSCTRL_PCLKSR_OSC8MRDY				(0x1u << SYSCTRL_PCLKSR_OSC8MRDY_Pos)
#define SYSCTRL_PCLKSR_DFLLRDY_Pos			4				/**< \brief (SYSCTRL_PCLKSR)DFLL */
#define SYSCTRL_PCLKSR_DFLLRDY				(0x1u << SYSCTRL_PCLKSR_DFLLRDY_Pos)
#define SYSCTRL_PCLKSR_DFLLOOB_Pos			5				/**< \brief (SYSCTRL_PCLKSR)DFLLEO */
#define SYSCTRL_PCLKSR_DFLLOOB				(0x1u << SYSCTRL_PCLKSR_DFLLOOB_Pos)
#define SYSCTRL_PCLKSR_DFLLLCKF_Pos			6				/**< \brief (SYSCTRL_PCLKSR)DFLLŒ艻 */
#define SYSCTRL_PCLKSR_DFLLLCKF				(0x1u << SYSCTRL_PCLKSR_DFLLLCKF_Pos)
#define SYSCTRL_PCLKSR_DFLLLCKC_Pos			7				/**< \brief (SYSCTRL_PCLKSR)DFLLaŒ艻 */
#define SYSCTRL_PCLKSR_DFLLLCKC				(0x1u << SYSCTRL_PCLKSR_DFLLLCKC_Pos)
#define SYSCTRL_PCLKSR_DFLLRCS_Pos			8				/**< \brief (SYSCTRL_PCLKSR)DFLLۯ~ */
#define SYSCTRL_PCLKSR_DFLLRCS				(0x1u << SYSCTRL_PCLKSR_DFLLRCS_Pos)
#define SYSCTRL_PCLKSR_BOD33RDY_Pos			9				/**< \brief (SYSCTRL_PCLKSR)BOD33 */
#define SYSCTRL_PCLKSR_BOD33RDY				(0x1u << SYSCTRL_PCLKSR_BOD33RDY_Pos)
#define SYSCTRL_PCLKSR_BOD33DET_Pos			10				/**< \brief (SYSCTRL_PCLKSR)BOD33o */
#define SYSCTRL_PCLKSR_BOD33DET				(0x1u << SYSCTRL_PCLKSR_BOD33DET_Pos)
#define SYSCTRL_PCLKSR_B33SRDY_Pos			11				/**< \brief (SYSCTRL_PCLKSR)BOD33 */
#define SYSCTRL_PCLKSR_B33SRDY				(0x1u << SYSCTRL_PCLKSR_B33SRDY_Pos)
#define SYSCTRL_PCLKSR_DPLLLCKR_Pos			15				/**< \brief (SYSCTRL_PCLKSR)DPLL㏸Œ艻 */
#define SYSCTRL_PCLKSR_DPLLLCKR				(0x1u << SYSCTRL_PCLKSR_DPLLLCKR_Pos)
#define SYSCTRL_PCLKSR_DPLLLCKF_Pos			16				/**< \brief (SYSCTRL_PCLKSR)DPLL~Œ艻 */
#define SYSCTRL_PCLKSR_DPLLLCKF				(0x1u << SYSCTRL_PCLKSR_DPLLLCKF_Pos)
#define SYSCTRL_PCLKSR_DPLLLTO_Pos			17				/**< \brief (SYSCTRL_PCLKSR)DPLLŒ艻Ԓ */
#define SYSCTRL_PCLKSR_DPLLLTO				(0x1u << SYSCTRL_PCLKSR_DPLLLTO_Pos)
#define SYSCTRL_PCLKSR_MASK					0x00038FFFu		/**< \brief (SYSCTRL_PCLKSR)Օڼ޽ */

/* -------- SYSCTRL_XOSC : (SYSCTRLψ:0x10) (R/W 16)OprؽٗpU(XOSC) -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t :1;				/*!< ޯ     0: \ */
    uint16_t ENABLE:1;			/*!< ޯ     1: U틖 */
    uint16_t XTALEN:1;			/*!< ޯ     2: ؽٗpU틖 */
    uint16_t :3;				/*!< ޯ 3` 5: \ */
    uint16_t RUNSTDBY:1;		/*!< ޯ     6: ޲ős */
    uint16_t ONDEMAND:1;		/*!< ޯ     7: ^ */
    uint16_t GAIN:3;			/*!< ޯ 8`10: U험 */
    uint16_t AMPGC:1;			/*!< ޯ    11: U */
    uint16_t STARTUP:4;			/*!< ޯ12`15: n */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_XOSC_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_XOSC_OFFSET					0x10			/**< \brief (SYSCTRL_XOSC offset)OprؽٗpU(XOSC) */
#define SYSCTRL_XOSC_RESETVALUE				0x0080			/**< \brief (SYSCTRL_XOSC reset_value)OprؽٗpU(XOSC) */

#define SYSCTRL_XOSC_ENABLE_Pos				1				/**< \brief (SYSCTRL_XOSC)U틖 */
#define SYSCTRL_XOSC_ENABLE					(0x1u << SYSCTRL_XOSC_ENABLE_Pos)
#define SYSCTRL_XOSC_XTALEN_Pos				2				/**< \brief (SYSCTRL_XOSC)ؽٗpU틖 */
#define SYSCTRL_XOSC_XTALEN					(0x1u << SYSCTRL_XOSC_XTALEN_Pos)
#define SYSCTRL_XOSC_RUNSTDBY_Pos			6				/**< \brief (SYSCTRL_XOSC)޲ős */
#define SYSCTRL_XOSC_RUNSTDBY				(0x1u << SYSCTRL_XOSC_RUNSTDBY_Pos)
#define SYSCTRL_XOSC_ONDEMAND_Pos			7				/**< \brief (SYSCTRL_XOSC)^ */
#define SYSCTRL_XOSC_ONDEMAND				(0x1u << SYSCTRL_XOSC_ONDEMAND_Pos)
#define SYSCTRL_XOSC_GAIN_Pos				8				/**< \brief (SYSCTRL_XOSC)U험 */
#define SYSCTRL_XOSC_GAIN_Msk				(0x7u << SYSCTRL_XOSC_GAIN_Pos)
#define SYSCTRL_XOSC_GAIN(value)			((SYSCTRL_XOSC_GAIN_Msk & ((value) << SYSCTRL_XOSC_GAIN_Pos)))
#define   SYSCTRL_XOSC_GAIN_0_Val				0x0u			/**< \brief (SYSCTRL_XOSC)2MHz */
#define   SYSCTRL_XOSC_GAIN_1_Val				0x1u			/**< \brief (SYSCTRL_XOSC)4MHz */
#define   SYSCTRL_XOSC_GAIN_2_Val				0x2u			/**< \brief (SYSCTRL_XOSC)8MHz */
#define   SYSCTRL_XOSC_GAIN_3_Val				0x3u			/**< \brief (SYSCTRL_XOSC)16MHz */
#define   SYSCTRL_XOSC_GAIN_4_Val				0x4u			/**< \brief (SYSCTRL_XOSC)30MHz */
#define SYSCTRL_XOSC_GAIN_0					(SYSCTRL_XOSC_GAIN_0_Val << SYSCTRL_XOSC_GAIN_Pos)
#define SYSCTRL_XOSC_GAIN_1					(SYSCTRL_XOSC_GAIN_1_Val << SYSCTRL_XOSC_GAIN_Pos)
#define SYSCTRL_XOSC_GAIN_2					(SYSCTRL_XOSC_GAIN_2_Val << SYSCTRL_XOSC_GAIN_Pos)
#define SYSCTRL_XOSC_GAIN_3					(SYSCTRL_XOSC_GAIN_3_Val << SYSCTRL_XOSC_GAIN_Pos)
#define SYSCTRL_XOSC_GAIN_4					(SYSCTRL_XOSC_GAIN_4_Val << SYSCTRL_XOSC_GAIN_Pos)
#define SYSCTRL_XOSC_AMPGC_Pos				11				/**< \brief (SYSCTRL_XOSC)U */
#define SYSCTRL_XOSC_AMPGC					(0x1u << SYSCTRL_XOSC_AMPGC_Pos)
#define SYSCTRL_XOSC_STARTUP_Pos			 12				/**< \brief (SYSCTRL_XOSC)n */
#define SYSCTRL_XOSC_STARTUP_Msk			(0xFu << SYSCTRL_XOSC_STARTUP_Pos)
#define SYSCTRL_XOSC_STARTUP(value)			((SYSCTRL_XOSC_STARTUP_Msk & ((value) << SYSCTRL_XOSC_STARTUP_Pos)))
#define SYSCTRL_XOSC_MASK					0xFFC6u			/**< \brief (SYSCTRL_XOSC)Օڼ޽ */

/* -------- SYSCTRL_XOSC32K : (SYSCTRLψ:0x14) (R/W 16)32kHzOؽٗpU(XOSC32K) -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t :1;				/*!< ޯ     0: \ */
    uint16_t ENABLE:1;			/*!< ޯ     1: U틖 */
    uint16_t XTALEN:1;			/*!< ޯ     2: ؽٗpU틖 */
    uint16_t EN32K:1;			/*!< ޯ     3: 32kHzo͋ */
    uint16_t EN1K:1;			/*!< ޯ     4: 1kHzo͋ */
    uint16_t AAMPEN:1;			/*!< ޯ     5: U䋖 */
    uint16_t RUNSTDBY:1;		/*!< ޯ     6: ޲ős */
    uint16_t ONDEMAND:1;		/*!< ޯ     7: ^ */
    uint16_t STARTUP:3;			/*!< ޯ 8`10: Un */
    uint16_t :1;				/*!< ޯ    11: \ */
    uint16_t WRTLOCK:1;			/*!< ޯ    12: ݎ{ */
    uint16_t :3;				/*!< ޯ13`15: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_XOSC32K_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_XOSC32K_OFFSET				0x14			/**< \brief (SYSCTRL_XOSC32K offset)32kHzOؽٗpU(XOSC32K) */
#define SYSCTRL_XOSC32K_RESETVALUE			0x0080			/**< \brief (SYSCTRL_XOSC32K reset_value)32kHzOؽٗpU(XOSC32K) */

#define SYSCTRL_XOSC32K_ENABLE_Pos			1				/**< \brief (SYSCTRL_XOSC32K)U틖 */
#define SYSCTRL_XOSC32K_ENABLE				(0x1u << SYSCTRL_XOSC32K_ENABLE_Pos)
#define SYSCTRL_XOSC32K_XTALEN_Pos			2				/**< \brief (SYSCTRL_XOSC32K)ؽٗpU틖 */
#define SYSCTRL_XOSC32K_XTALEN				(0x1u << SYSCTRL_XOSC32K_XTALEN_Pos)
#define SYSCTRL_XOSC32K_EN32K_Pos			3				/**< \brief (SYSCTRL_XOSC32K)32kHzo͋ */
#define SYSCTRL_XOSC32K_EN32K				(0x1u << SYSCTRL_XOSC32K_EN32K_Pos)
#define SYSCTRL_XOSC32K_EN1K_Pos			4				/**< \brief (SYSCTRL_XOSC32K)1kHzo͋ */
#define SYSCTRL_XOSC32K_EN1K				(0x1u << SYSCTRL_XOSC32K_EN1K_Pos)
#define SYSCTRL_XOSC32K_AAMPEN_Pos			5				/**< \brief (SYSCTRL_XOSC32K)U䋖 */
#define SYSCTRL_XOSC32K_AAMPEN				(0x1u << SYSCTRL_XOSC32K_AAMPEN_Pos)
#define SYSCTRL_XOSC32K_RUNSTDBY_Pos		6				/**< \brief (SYSCTRL_XOSC32K)޲ős */
#define SYSCTRL_XOSC32K_RUNSTDBY			(0x1u << SYSCTRL_XOSC32K_RUNSTDBY_Pos)
#define SYSCTRL_XOSC32K_ONDEMAND_Pos		7				/**< \brief (SYSCTRL_XOSC32K)^ */
#define SYSCTRL_XOSC32K_ONDEMAND			(0x1u << SYSCTRL_XOSC32K_ONDEMAND_Pos)
#define SYSCTRL_XOSC32K_STARTUP_Pos			8				/**< \brief (SYSCTRL_XOSC32K)Un */
#define SYSCTRL_XOSC32K_STARTUP_Msk			(0x7u << SYSCTRL_XOSC32K_STARTUP_Pos)
#define SYSCTRL_XOSC32K_STARTUP(value)		((SYSCTRL_XOSC32K_STARTUP_Msk & ((value) << SYSCTRL_XOSC32K_STARTUP_Pos)))
#define SYSCTRL_XOSC32K_WRTLOCK_Pos			12				/**< \brief (SYSCTRL_XOSC32K)ݎ{ */
#define SYSCTRL_XOSC32K_WRTLOCK				(0x1u << SYSCTRL_XOSC32K_WRTLOCK_Pos)
#define SYSCTRL_XOSC32K_MASK				0x17FEu			/**< \brief (SYSCTRL_XOSC32K)Օڼ޽ */

/* -------- SYSCTRL_OSC32K : (SYSCTRLψ:0x18) (R/W 32)32kHzU(OSC32K) -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t :1;				/*!< ޯ     0: \ */
    uint32_t ENABLE:1;			/*!< ޯ     1: U틖 */
    uint32_t EN32K:1;			/*!< ޯ     2: 32kHzo͋ */
    uint32_t EN1K:1;			/*!< ޯ     3: 1kHzo͋ */
    uint32_t :2;				/*!< ޯ 4` 5: \ */
    uint32_t RUNSTDBY:1;		/*!< ޯ     6: ޲ős */
    uint32_t ONDEMAND:1;		/*!< ޯ     7: ^ */
    uint32_t STARTUP:3;			/*!< ޯ 8`10: Un */
    uint32_t :1;				/*!< ޯ    11: \ */
    uint32_t WRTLOCK:1;			/*!< ޯ    12: ݎ{ */
    uint32_t :3;				/*!< ޯ13`15: \ */
    uint32_t CALIB:7;			/*!< ޯ16`22: UZ */
    uint32_t :9;				/*!< ޯ23`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_OSC32K_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_OSC32K_OFFSET				0x18			/**< \brief (SYSCTRL_OSC32K offset)32kHzU(OSC32K) */
#define SYSCTRL_OSC32K_RESETVALUE			0x003F0080		/**< \brief (SYSCTRL_OSC32K reset_value)32kHzU(OSC32K) */

#define SYSCTRL_OSC32K_ENABLE_Pos			1				/**< \brief (SYSCTRL_OSC32K)U틖 */
#define SYSCTRL_OSC32K_ENABLE				(0x1u << SYSCTRL_OSC32K_ENABLE_Pos)
#define SYSCTRL_OSC32K_EN32K_Pos			2				/**< \brief (SYSCTRL_OSC32K)32kHzo͋ */
#define SYSCTRL_OSC32K_EN32K				(0x1u << SYSCTRL_OSC32K_EN32K_Pos)
#define SYSCTRL_OSC32K_EN1K_Pos				3				/**< \brief (SYSCTRL_OSC32K)1kHzo͋ */
#define SYSCTRL_OSC32K_EN1K					(0x1u << SYSCTRL_OSC32K_EN1K_Pos)
#define SYSCTRL_OSC32K_RUNSTDBY_Pos			6				/**< \brief (SYSCTRL_OSC32K)޲ős */
#define SYSCTRL_OSC32K_RUNSTDBY				(0x1u << SYSCTRL_OSC32K_RUNSTDBY_Pos)
#define SYSCTRL_OSC32K_ONDEMAND_Pos			7				/**< \brief (SYSCTRL_OSC32K)^ */
#define SYSCTRL_OSC32K_ONDEMAND				(0x1u << SYSCTRL_OSC32K_ONDEMAND_Pos)
#define SYSCTRL_OSC32K_STARTUP_Pos			8				/**< \brief (SYSCTRL_OSC32K)Un */
#define SYSCTRL_OSC32K_STARTUP_Msk			(0x7u << SYSCTRL_OSC32K_STARTUP_Pos)
#define SYSCTRL_OSC32K_STARTUP(value)		((SYSCTRL_OSC32K_STARTUP_Msk & ((value) << SYSCTRL_OSC32K_STARTUP_Pos)))
#define SYSCTRL_OSC32K_WRTLOCK_Pos			12				/**< \brief (SYSCTRL_OSC32K)ݎ{ */
#define SYSCTRL_OSC32K_WRTLOCK				(0x1u << SYSCTRL_OSC32K_WRTLOCK_Pos)
#define SYSCTRL_OSC32K_CALIB_Pos			16				/**< \brief (SYSCTRL_OSC32K)UZ */
#define SYSCTRL_OSC32K_CALIB_Msk			(0x7Fu << SYSCTRL_OSC32K_CALIB_Pos)
#define SYSCTRL_OSC32K_CALIB(value)			((SYSCTRL_OSC32K_CALIB_Msk & ((value) << SYSCTRL_OSC32K_CALIB_Pos)))
#define SYSCTRL_OSC32K_MASK					0x007F17CEu		/**< \brief (SYSCTRL_OSC32K)Օڼ޽ */

/* -------- SYSCTRL_OSCULP32K : (SYSCTRLψ:0x1C) (R/W  8)32kHzd͓U(OSCULP32K) -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  CALIB:5;			/*!< ޯ0`4: UZ */
    uint8_t  :2;				/*!< ޯ5`6: \ */
    uint8_t  WRTLOCK:1;			/*!< ޯ   7: ݎ{ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_OSCULP32K_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_OSCULP32K_OFFSET			0x1C			/**< \brief (SYSCTRL_OSCULP32K offset)32kHzd͓U(OSCULP32K) */
#define SYSCTRL_OSCULP32K_RESETVALUE		0x1F			/**< \brief (SYSCTRL_OSCULP32K reset_value)32kHzd͓U(OSCULP32K) */

#define SYSCTRL_OSCULP32K_CALIB_Pos			0				/**< \brief (SYSCTRL_OSCULP32K)UZ */
#define SYSCTRL_OSCULP32K_CALIB_Msk			(0x1Fu << SYSCTRL_OSCULP32K_CALIB_Pos)
#define SYSCTRL_OSCULP32K_CALIB(value)		((SYSCTRL_OSCULP32K_CALIB_Msk & ((value) << SYSCTRL_OSCULP32K_CALIB_Pos)))
#define SYSCTRL_OSCULP32K_WRTLOCK_Pos		7				/**< \brief (SYSCTRL_OSCULP32K)ݎ{ */
#define SYSCTRL_OSCULP32K_WRTLOCK			(0x1u << SYSCTRL_OSCULP32K_WRTLOCK_Pos)
#define SYSCTRL_OSCULP32K_MASK				0x9Fu			/**< \brief (SYSCTRL_OSCULP32K)Օڼ޽ */

/* -------- SYSCTRL_OSC8M : (SYSCTRLψ:0x20) (R/W 32)8MHzU(OSC8M)A -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t :1;				/*!< ޯ     0: \ */
    uint32_t ENABLE:1;			/*!< ޯ     1: U틖 */
    uint32_t :4;				/*!< ޯ 2` 5: \ */
    uint32_t RUNSTDBY:1;		/*!< ޯ     6: ޲ős */
    uint32_t ONDEMAND:1;		/*!< ޯ     7: ^ */
    uint32_t PRESC:2;			/*!< ޯ 8` 9: UOu */
    uint32_t :6;				/*!< ޯ10`15: \ */
    uint32_t CALIB:12;			/*!< ޯ16`27: UZ */
    uint32_t :2;				/*!< ޯ28`29: \ */
    uint32_t FRANGE:2;			/*!< ޯ30`31: Ug͈ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_OSC8M_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_OSC8M_OFFSET				0x20			/**< \brief (SYSCTRL_OSC8M offset)8MHzU(OSC8M)A */
#define SYSCTRL_OSC8M_RESETVALUE			0x87070382		/**< \brief (SYSCTRL_OSC8M reset_value)8MHzU(OSC8M)A */

#define SYSCTRL_OSC8M_ENABLE_Pos			1				/**< \brief (SYSCTRL_OSC8M)U틖 */
#define SYSCTRL_OSC8M_ENABLE				(0x1u << SYSCTRL_OSC8M_ENABLE_Pos)
#define SYSCTRL_OSC8M_RUNSTDBY_Pos			6				/**< \brief (SYSCTRL_OSC8M)޲ős */
#define SYSCTRL_OSC8M_RUNSTDBY				(0x1u << SYSCTRL_OSC8M_RUNSTDBY_Pos)
#define SYSCTRL_OSC8M_ONDEMAND_Pos			7				/**< \brief (SYSCTRL_OSC8M)^ */
#define SYSCTRL_OSC8M_ONDEMAND				(0x1u << SYSCTRL_OSC8M_ONDEMAND_Pos)
#define SYSCTRL_OSC8M_PRESC_Pos				8				/**< \brief (SYSCTRL_OSC8M)UOu */
#define SYSCTRL_OSC8M_PRESC_Msk				(0x3u << SYSCTRL_OSC8M_PRESC_Pos)
#define SYSCTRL_OSC8M_PRESC(value)			((SYSCTRL_OSC8M_PRESC_Msk & ((value) << SYSCTRL_OSC8M_PRESC_Pos)))
#define   SYSCTRL_OSC8M_PRESC_0_Val			0x0u			/**< \brief (SYSCTRL_OSC8M)1 */
#define   SYSCTRL_OSC8M_PRESC_1_Val			0x1u			/**< \brief (SYSCTRL_OSC8M)2 */
#define   SYSCTRL_OSC8M_PRESC_2_Val			0x2u			/**< \brief (SYSCTRL_OSC8M)4 */
#define   SYSCTRL_OSC8M_PRESC_3_Val			0x3u			/**< \brief (SYSCTRL_OSC8M)8 */
#define SYSCTRL_OSC8M_PRESC_0				(SYSCTRL_OSC8M_PRESC_0_Val << SYSCTRL_OSC8M_PRESC_Pos)
#define SYSCTRL_OSC8M_PRESC_1				(SYSCTRL_OSC8M_PRESC_1_Val << SYSCTRL_OSC8M_PRESC_Pos)
#define SYSCTRL_OSC8M_PRESC_2				(SYSCTRL_OSC8M_PRESC_2_Val << SYSCTRL_OSC8M_PRESC_Pos)
#define SYSCTRL_OSC8M_PRESC_3				(SYSCTRL_OSC8M_PRESC_3_Val << SYSCTRL_OSC8M_PRESC_Pos)
#define SYSCTRL_OSC8M_CALIB_Pos				16				/**< \brief (SYSCTRL_OSC8M)UZ */
#define SYSCTRL_OSC8M_CALIB_Msk				(0xFFFu << SYSCTRL_OSC8M_CALIB_Pos)
#define SYSCTRL_OSC8M_CALIB(value)			((SYSCTRL_OSC8M_CALIB_Msk & ((value) << SYSCTRL_OSC8M_CALIB_Pos)))
#define SYSCTRL_OSC8M_FRANGE_Pos			 30				/**< \brief (SYSCTRL_OSC8M)Ug͈ */
#define SYSCTRL_OSC8M_FRANGE_Msk			(0x3u << SYSCTRL_OSC8M_FRANGE_Pos)
#define SYSCTRL_OSC8M_FRANGE(value)			((SYSCTRL_OSC8M_FRANGE_Msk & ((value) << SYSCTRL_OSC8M_FRANGE_Pos)))
#define   SYSCTRL_OSC8M_FRANGE_0_Val		0x0u			/**< \brief (SYSCTRL_OSC8M)4`6MHz */
#define   SYSCTRL_OSC8M_FRANGE_1_Val		0x1u			/**< \brief (SYSCTRL_OSC8M)6`8MHz */
#define   SYSCTRL_OSC8M_FRANGE_2_Val		0x2u			/**< \brief (SYSCTRL_OSC8M)8`11MHz */
#define   SYSCTRL_OSC8M_FRANGE_3_Val		0x3u			/**< \brief (SYSCTRL_OSC8M)11`15MHz */
#define SYSCTRL_OSC8M_FRANGE_0				(SYSCTRL_OSC8M_FRANGE_0_Val << SYSCTRL_OSC8M_FRANGE_Pos)
#define SYSCTRL_OSC8M_FRANGE_1				(SYSCTRL_OSC8M_FRANGE_1_Val << SYSCTRL_OSC8M_FRANGE_Pos)
#define SYSCTRL_OSC8M_FRANGE_2				(SYSCTRL_OSC8M_FRANGE_2_Val << SYSCTRL_OSC8M_FRANGE_Pos)
#define SYSCTRL_OSC8M_FRANGE_3				(SYSCTRL_OSC8M_FRANGE_3_Val << SYSCTRL_OSC8M_FRANGE_Pos)
#define SYSCTRL_OSC8M_MASK					0xCFFF03C2u		/**< \brief (SYSCTRL_OSC8M)Օڼ޽ */

/* -------- SYSCTRL_DFLLCTRL : (SYSCTRLψ:0x24) (R/W 16)DFLL48M -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t :1;				/*!< ޯ     0: \ */
    uint16_t ENABLE:1;			/*!< ޯ     1: DFLL */
    uint16_t MODE:1;			/*!< ޯ     2: `ԑI */
    uint16_t STABLE:1;			/*!< ޯ     3: DFLLg */
    uint16_t LLAW:1;			/*!< ޯ     4: NŒ艻 */
    uint16_t USBCRM:1;			/*!< ޯ     5: USBۯ */
    uint16_t RUNSTDBY:1;		/*!< ޯ     6: ޲ős */
    uint16_t ONDEMAND:1;		/*!< ޯ     7: ^ */
    uint16_t CCDIS:1;			/*!< ޯ     8: p֎~ */
    uint16_t QLDIS:1;			/*!< ޯ     9: vŒ艻֎~ */
    uint16_t BPLCKC:1;			/*!< ޯ    10: aŒ艻I */
    uint16_t WAITLOCK:1;		/*!< ޯ    11: Œ艻ҋ@ */
    uint16_t :4;				/*!< ޯ12`15: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_DFLLCTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_DFLLCTRL_OFFSET				0x24			/**< \brief (SYSCTRL_DFLLCTRL offset)DFLL48M */
#define SYSCTRL_DFLLCTRL_RESETVALUE			0x0080			/**< \brief (SYSCTRL_DFLLCTRL reset_value)DFLL48M */

#define SYSCTRL_DFLLCTRL_ENABLE_Pos			1				/**< \brief (SYSCTRL_DFLLCTRL)DFLL */
#define SYSCTRL_DFLLCTRL_ENABLE				(0x1u << SYSCTRL_DFLLCTRL_ENABLE_Pos)
#define SYSCTRL_DFLLCTRL_MODE_Pos			2				/**< \brief (SYSCTRL_DFLLCTRL)`ԑI */
#define SYSCTRL_DFLLCTRL_MODE				(0x1u << SYSCTRL_DFLLCTRL_MODE_Pos)
#define SYSCTRL_DFLLCTRL_STABLE_Pos			3				/**< \brief (SYSCTRL_DFLLCTRL)DFLLg */
#define SYSCTRL_DFLLCTRL_STABLE				(0x1u << SYSCTRL_DFLLCTRL_STABLE_Pos)
#define SYSCTRL_DFLLCTRL_LLAW_Pos			4				/**< \brief (SYSCTRL_DFLLCTRL)NŒ艻*/
#define SYSCTRL_DFLLCTRL_LLAW				(0x1u << SYSCTRL_DFLLCTRL_LLAW_Pos)
#define SYSCTRL_DFLLCTRL_USBCRM_Pos			5				/**< \brief (SYSCTRL_DFLLCTRL)USBۯ */
#define SYSCTRL_DFLLCTRL_USBCRM				(0x1u << SYSCTRL_DFLLCTRL_USBCRM_Pos)
#define SYSCTRL_DFLLCTRL_RUNSTDBY_Pos		6				/**< \brief (SYSCTRL_DFLLCTRL)޲ős */
#define SYSCTRL_DFLLCTRL_RUNSTDBY			(0x1u << SYSCTRL_DFLLCTRL_RUNSTDBY_Pos)
#define SYSCTRL_DFLLCTRL_ONDEMAND_Pos		7				/**< \brief (SYSCTRL_DFLLCTRL)^ */
#define SYSCTRL_DFLLCTRL_ONDEMAND			(0x1u << SYSCTRL_DFLLCTRL_ONDEMAND_Pos)
#define SYSCTRL_DFLLCTRL_CCDIS_Pos			8				/**< \brief (SYSCTRL_DFLLCTRL)p֎~ */
#define SYSCTRL_DFLLCTRL_CCDIS				(0x1u << SYSCTRL_DFLLCTRL_CCDIS_Pos)
#define SYSCTRL_DFLLCTRL_QLDIS_Pos			9				/**< \brief (SYSCTRL_DFLLCTRL)vŒ艻֎~ */
#define SYSCTRL_DFLLCTRL_QLDIS				(0x1u << SYSCTRL_DFLLCTRL_QLDIS_Pos)
#define SYSCTRL_DFLLCTRL_BPLCKC_Pos			10				/**< \brief (SYSCTRL_DFLLCTRL)aŒ艻I */
#define SYSCTRL_DFLLCTRL_BPLCKC				(0x1u << SYSCTRL_DFLLCTRL_BPLCKC_Pos)
#define SYSCTRL_DFLLCTRL_WAITLOCK_Pos		11				/**< \brief (SYSCTRL_DFLLCTRL)Œ艻ҋ@ */
#define SYSCTRL_DFLLCTRL_WAITLOCK			(0x1u << SYSCTRL_DFLLCTRL_WAITLOCK_Pos)
#define SYSCTRL_DFLLCTRL_MASK				0x0FFEu			/**< \brief (SYSCTRL_DFLLCTRL)Օڼ޽ */

/* -------- SYSCTRL_DFLLVAL : (SYSCTRLψ:0x28) (R/W 32)DFLL48Ml -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t FINE:10;			/*!< ޯ 0` 9: l */
    uint32_t COARSE:6;			/*!< ޯ10`15: al */
    uint32_t DIFF:16;			/*!< ޯ16`31: { */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_DFLLVAL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_DFLLVAL_OFFSET				0x28			/**< \brief (SYSCTRL_DFLLVAL offset)DFLL48Ml */
#define SYSCTRL_DFLLVAL_RESETVALUE			0x00000000		/**< \brief (SYSCTRL_DFLLVAL reset_value)DFLL48Ml */

#define SYSCTRL_DFLLVAL_FINE_Pos			 0				/**< \brief (SYSCTRL_DFLLVAL)l */
#define SYSCTRL_DFLLVAL_FINE_Msk			(0x3FFu << SYSCTRL_DFLLVAL_FINE_Pos)
#define SYSCTRL_DFLLVAL_FINE(value)			((SYSCTRL_DFLLVAL_FINE_Msk & ((value) << SYSCTRL_DFLLVAL_FINE_Pos)))
#define SYSCTRL_DFLLVAL_COARSE_Pos			10				/**< \brief (SYSCTRL_DFLLVAL)al */
#define SYSCTRL_DFLLVAL_COARSE_Msk			(0x3Fu << SYSCTRL_DFLLVAL_COARSE_Pos)
#define SYSCTRL_DFLLVAL_COARSE(value)		((SYSCTRL_DFLLVAL_COARSE_Msk & ((value) << SYSCTRL_DFLLVAL_COARSE_Pos)))
#define SYSCTRL_DFLLVAL_DIFF_Pos			 16				/**< \brief (SYSCTRL_DFLLVAL){ */
#define SYSCTRL_DFLLVAL_DIFF_Msk			(0xFFFFu << SYSCTRL_DFLLVAL_DIFF_Pos)
#define SYSCTRL_DFLLVAL_DIFF(value)			((SYSCTRL_DFLLVAL_DIFF_Msk & ((value) << SYSCTRL_DFLLVAL_DIFF_Pos)))
#define SYSCTRL_DFLLVAL_MASK				0xFFFFFFFFu		/**< \brief (SYSCTRL_DFLLVAL)Օڼ޽ */

/* -------- SYSCTRL_DFLLMUL : (SYSCTRLψ:0x2C) (R/W 32)DFLL48M{ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t MUL:16;			/*!< ޯ 0`15: DFLL{ */
    uint32_t FSTEP:10;			/*!< ޯ16`25: őiK */
    uint32_t CSTEP:6;			/*!< ޯ26`31: aőiK */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_DFLLMUL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_DFLLMUL_OFFSET				0x2C			/**< \brief (SYSCTRL_DFLLMUL offset)DFLL48M{ */
#define SYSCTRL_DFLLMUL_RESETVALUE			0x00000000		/**< \brief (SYSCTRL_DFLLMUL reset_value)DFLL48M{ */

#define SYSCTRL_DFLLMUL_MUL_Pos				0				/**< \brief (SYSCTRL_DFLLMUL)DFLL{ */
#define SYSCTRL_DFLLMUL_MUL_Msk				(0xFFFFu << SYSCTRL_DFLLMUL_MUL_Pos)
#define SYSCTRL_DFLLMUL_MUL(value)			((SYSCTRL_DFLLMUL_MUL_Msk & ((value) << SYSCTRL_DFLLMUL_MUL_Pos)))
#define SYSCTRL_DFLLMUL_FSTEP_Pos			16				/**< \brief (SYSCTRL_DFLLMUL)őiK */
#define SYSCTRL_DFLLMUL_FSTEP_Msk			(0x3FFu << SYSCTRL_DFLLMUL_FSTEP_Pos)
#define SYSCTRL_DFLLMUL_FSTEP(value)		((SYSCTRL_DFLLMUL_FSTEP_Msk & ((value) << SYSCTRL_DFLLMUL_FSTEP_Pos)))
#define SYSCTRL_DFLLMUL_CSTEP_Pos			26				/**< \brief (SYSCTRL_DFLLMUL)aőiK */
#define SYSCTRL_DFLLMUL_CSTEP_Msk			(0x3Fu << SYSCTRL_DFLLMUL_CSTEP_Pos)
#define SYSCTRL_DFLLMUL_CSTEP(value)		((SYSCTRL_DFLLMUL_CSTEP_Msk & ((value) << SYSCTRL_DFLLMUL_CSTEP_Pos)))
#define SYSCTRL_DFLLMUL_MASK				0xFFFFFFFFu		/**< \brief (SYSCTRL_DFLLMUL)Օڼ޽ */

/* -------- SYSCTRL_DFLLSYNC : (SYSCTRLψ:0x30) (R/W  8)DFLL48M -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  :7;				/*!< ޯ0`6: \ */
    uint8_t  READREQ:1;			/*!< ޯ   7: ǂݍݗv */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_DFLLSYNC_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_DFLLSYNC_OFFSET				0x30			/**< \brief (SYSCTRL_DFLLSYNC offset)DFLL48M */
#define SYSCTRL_DFLLSYNC_RESETVALUE			0x00			/**< \brief (SYSCTRL_DFLLSYNC reset_value)DFLL48M */

#define SYSCTRL_DFLLSYNC_READREQ_Pos		7				/**< \brief (SYSCTRL_DFLLSYNC)ǂݍݗv */
#define SYSCTRL_DFLLSYNC_READREQ			(0x1u << SYSCTRL_DFLLSYNC_READREQ_Pos)
#define SYSCTRL_DFLLSYNC_MASK				0x80u			/**< \brief (SYSCTRL_DFLLSYNC)Օڼ޽ */

/* -------- SYSCTRL_BOD33 : (SYSCTRLψ:0x34) (R/W 32)3.3Vdo(BOD33) -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t :1;				/*!< ޯ     0: \ */
    uint32_t ENABLE:1;			/*!< ޯ     1:  */
    uint32_t HYST:1;			/*!< ޯ     2: ˽ؼ */
    uint32_t ACTION:2;			/*!< ޯ 3` 4: BOD33 */
    uint32_t :1;				/*!< ޯ     5: \ */
    uint32_t RUNSTDBY:1;		/*!< ޯ     6: ޲ős */
    uint32_t :1;				/*!< ޯ     7: \ */
    uint32_t MODE:1;			/*!< ޯ     8: ` */
    uint32_t CEN:1;				/*!< ޯ     9: ۯ */
    uint32_t :2;				/*!< ޯ10`11: \ */
    uint32_t PSEL:4;			/*!< ޯ12`15: OuI */
    uint32_t LEVEL:6;			/*!< ޯ16`21: BOD33臒l */
    uint32_t :10;				/*!< ޯ22`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_BOD33_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_BOD33_OFFSET				0x34			/**< \brief (SYSCTRL_BOD33 offset)3.3Vdo(BOD33) */
#define SYSCTRL_BOD33_RESETVALUE			0x00000000		/**< \brief (SYSCTRL_BOD33 reset_value)3.3Vdo(BOD33) */

#define SYSCTRL_BOD33_ENABLE_Pos			1				/**< \brief (SYSCTRL_BOD33) */
#define SYSCTRL_BOD33_ENABLE				(0x1u << SYSCTRL_BOD33_ENABLE_Pos)
#define SYSCTRL_BOD33_HYST_Pos				2				/**< \brief (SYSCTRL_BOD33)˽ؼ */
#define SYSCTRL_BOD33_HYST					(0x1u << SYSCTRL_BOD33_HYST_Pos)
#define SYSCTRL_BOD33_ACTION_Pos			3				/**< \brief (SYSCTRL_BOD33)BOD33 */
#define SYSCTRL_BOD33_ACTION_Msk			(0x3u << SYSCTRL_BOD33_ACTION_Pos)
#define SYSCTRL_BOD33_ACTION(value)			((SYSCTRL_BOD33_ACTION_Msk & ((value) << SYSCTRL_BOD33_ACTION_Pos)))
#define   SYSCTRL_BOD33_ACTION_NONE_Val			0x0u			/**< \brief (SYSCTRL_BOD33)Ȃ */
#define   SYSCTRL_BOD33_ACTION_RESET_Val		0x1u			/**< \brief (SYSCTRL_BOD33)BOD33ؾĂ𐶐 */
#define   SYSCTRL_BOD33_ACTION_INTERRUPT_Val	0x2u			/**< \brief (SYSCTRL_BOD33)BOD33͊荞݂𐶐 */
#define SYSCTRL_BOD33_ACTION_NONE			(SYSCTRL_BOD33_ACTION_NONE_Val		<< SYSCTRL_BOD33_ACTION_Pos)
#define SYSCTRL_BOD33_ACTION_RESET			(SYSCTRL_BOD33_ACTION_RESET_Val		<< SYSCTRL_BOD33_ACTION_Pos)
#define SYSCTRL_BOD33_ACTION_INTERRUPT		(SYSCTRL_BOD33_ACTION_INTERRUPT_Val	<< SYSCTRL_BOD33_ACTION_Pos)
#define SYSCTRL_BOD33_RUNSTDBY_Pos			6				/**< \brief (SYSCTRL_BOD33)޲ős */
#define SYSCTRL_BOD33_RUNSTDBY				(0x1u << SYSCTRL_BOD33_RUNSTDBY_Pos)
#define SYSCTRL_BOD33_MODE_Pos				8				/**< \brief (SYSCTRL_BOD33)` */
#define SYSCTRL_BOD33_MODE					(0x1u << SYSCTRL_BOD33_MODE_Pos)
#define SYSCTRL_BOD33_CEN_Pos				9				/**< \brief (SYSCTRL_BOD33)ۯ */
#define SYSCTRL_BOD33_CEN					(0x1u << SYSCTRL_BOD33_CEN_Pos)
#define SYSCTRL_BOD33_PSEL_Pos				12				/**< \brief (SYSCTRL_BOD33)OuI */
#define SYSCTRL_BOD33_PSEL_Msk				(0xFu << SYSCTRL_BOD33_PSEL_Pos)
#define SYSCTRL_BOD33_PSEL(value)			((SYSCTRL_BOD33_PSEL_Msk & ((value) << SYSCTRL_BOD33_PSEL_Pos)))
#define   SYSCTRL_BOD33_PSEL_DIV2_Val			0x0u			/**< \brief (SYSCTRL_BOD33)2 */
#define   SYSCTRL_BOD33_PSEL_DIV4_Val			0x1u			/**< \brief (SYSCTRL_BOD33)4 */
#define   SYSCTRL_BOD33_PSEL_DIV8_Val			0x2u			/**< \brief (SYSCTRL_BOD33)8 */
#define   SYSCTRL_BOD33_PSEL_DIV16_Val			0x0x3u			/**< \brief (SYSCTRL_BOD33)16 */
#define   SYSCTRL_BOD33_PSEL_DIV32_Val			0x0x4u			/**< \brief (SYSCTRL_BOD33)32 */
#define   SYSCTRL_BOD33_PSEL_DIV64_Val			0x0x5u			/**< \brief (SYSCTRL_BOD33)64 */
#define   SYSCTRL_BOD33_PSEL_DIV128_Val			0x6u			/**< \brief (SYSCTRL_BOD33)128 */
#define   SYSCTRL_BOD33_PSEL_DIV256_Val			0x7u			/**< \brief (SYSCTRL_BOD33)256 */
#define   SYSCTRL_BOD33_PSEL_DIV512_Val			0x8u			/**< \brief (SYSCTRL_BOD33)512 */
#define   SYSCTRL_BOD33_PSEL_DIV1K_Val			0x0x9u			/**< \brief (SYSCTRL_BOD33)1024 */
#define   SYSCTRL_BOD33_PSEL_DIV2K_Val			0x0xAu			/**< \brief (SYSCTRL_BOD33)2048 */
#define   SYSCTRL_BOD33_PSEL_DIV4K_Val			0x0xBu			/**< \brief (SYSCTRL_BOD33)4096 */
#define   SYSCTRL_BOD33_PSEL_DIV8K_Val			0x0xCu			/**< \brief (SYSCTRL_BOD33)8192 */
#define   SYSCTRL_BOD33_PSEL_DIV16K_Val			0xDu			/**< \brief (SYSCTRL_BOD33)16384 */
#define   SYSCTRL_BOD33_PSEL_DIV32K_Val			0xEu			/**< \brief (SYSCTRL_BOD33)32768 */
#define   SYSCTRL_BOD33_PSEL_DIV64K_Val			0xFu			/**< \brief (SYSCTRL_BOD33)65536 */
#define SYSCTRL_BOD33_PSEL_DIV2				(SYSCTRL_BOD33_PSEL_DIV2_Val	<< SYSCTRL_BOD33_PSEL_Pos)
#define SYSCTRL_BOD33_PSEL_DIV4				(SYSCTRL_BOD33_PSEL_DIV4_Val	<< SYSCTRL_BOD33_PSEL_Pos)
#define SYSCTRL_BOD33_PSEL_DIV8				(SYSCTRL_BOD33_PSEL_DIV8_Val	<< SYSCTRL_BOD33_PSEL_Pos)
#define SYSCTRL_BOD33_PSEL_DIV16			(SYSCTRL_BOD33_PSEL_DIV16_Val	<< SYSCTRL_BOD33_PSEL_Pos)
#define SYSCTRL_BOD33_PSEL_DIV32			(SYSCTRL_BOD33_PSEL_DIV32_Val	<< SYSCTRL_BOD33_PSEL_Pos)
#define SYSCTRL_BOD33_PSEL_DIV64			(SYSCTRL_BOD33_PSEL_DIV64_Val	<< SYSCTRL_BOD33_PSEL_Pos)
#define SYSCTRL_BOD33_PSEL_DIV128			(SYSCTRL_BOD33_PSEL_DIV128_Val	<< SYSCTRL_BOD33_PSEL_Pos)
#define SYSCTRL_BOD33_PSEL_DIV256			(SYSCTRL_BOD33_PSEL_DIV256_Val	<< SYSCTRL_BOD33_PSEL_Pos)
#define SYSCTRL_BOD33_PSEL_DIV512			(SYSCTRL_BOD33_PSEL_DIV512_Val	<< SYSCTRL_BOD33_PSEL_Pos)
#define SYSCTRL_BOD33_PSEL_DIV1K			(SYSCTRL_BOD33_PSEL_DIV1K_Val	<< SYSCTRL_BOD33_PSEL_Pos)
#define SYSCTRL_BOD33_PSEL_DIV2K			(SYSCTRL_BOD33_PSEL_DIV2K_Val	<< SYSCTRL_BOD33_PSEL_Pos)
#define SYSCTRL_BOD33_PSEL_DIV4K			(SYSCTRL_BOD33_PSEL_DIV4K_Val	<< SYSCTRL_BOD33_PSEL_Pos)
#define SYSCTRL_BOD33_PSEL_DIV8K			(SYSCTRL_BOD33_PSEL_DIV8K_Val	<< SYSCTRL_BOD33_PSEL_Pos)
#define SYSCTRL_BOD33_PSEL_DIV16K			(SYSCTRL_BOD33_PSEL_DIV16K_Val	<< SYSCTRL_BOD33_PSEL_Pos)
#define SYSCTRL_BOD33_PSEL_DIV32K			(SYSCTRL_BOD33_PSEL_DIV32K_Val	<< SYSCTRL_BOD33_PSEL_Pos)
#define SYSCTRL_BOD33_PSEL_DIV64K			(SYSCTRL_BOD33_PSEL_DIV64K_Val	<< SYSCTRL_BOD33_PSEL_Pos)
#define SYSCTRL_BOD33_LEVEL_Pos				16				/**< \brief (SYSCTRL_BOD33)BOD33臒l */
#define SYSCTRL_BOD33_LEVEL_Msk				(0x3Fu << SYSCTRL_BOD33_LEVEL_Pos)
#define SYSCTRL_BOD33_LEVEL(value)			((SYSCTRL_BOD33_LEVEL_Msk & ((value) << SYSCTRL_BOD33_LEVEL_Pos)))
#define SYSCTRL_BOD33_MASK					0x003FF35Eu		/**< \brief (SYSCTRL_BOD33)Օڼ޽ */

/* -------- SYSCTRL_VREF : (SYSCTRLψ:0x40) (R/W 32)d(VREF) -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t :1;				/*!< ޯ     0: \ */
    uint32_t TSEN:1;			/*!< ޯ     1: xm틖 */
    uint32_t BGOUTEN:1;			/*!< ޯ     2: ޷ެߏo͋ */
    uint32_t :13;				/*!< ޯ 3`15: \ */
    uint32_t CALIB:11;			/*!< ޯ16`26: ޷ެߓdZ */
    uint32_t :5;				/*!< ޯ27`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_VREF_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_VREF_OFFSET					0x40			/**< \brief (SYSCTRL_VREF offset)d(VREF) */
#define SYSCTRL_VREF_RESETVALUE				0x00000000		/**< \brief (SYSCTRL_VREF reset_value)d(VREF) */

#define SYSCTRL_VREF_TSEN_Pos				1				/**< \brief (SYSCTRL_VREF)xm틖 */
#define SYSCTRL_VREF_TSEN					(0x1u << SYSCTRL_VREF_TSEN_Pos)
#define SYSCTRL_VREF_BGOUTEN_Pos			 2				/**< \brief (SYSCTRL_VREF)޷ެߏo͋ */
#define SYSCTRL_VREF_BGOUTEN				(0x1u << SYSCTRL_VREF_BGOUTEN_Pos)
#define SYSCTRL_VREF_CALIB_Pos				16				/**< \brief (SYSCTRL_VREF)޷ެߓdZ */
#define SYSCTRL_VREF_CALIB_Msk				(0x7FFu << SYSCTRL_VREF_CALIB_Pos)
#define SYSCTRL_VREF_CALIB(value)			 ((SYSCTRL_VREF_CALIB_Msk & ((value) << SYSCTRL_VREF_CALIB_Pos)))
#define SYSCTRL_VREF_MASK					0x07FF0006u		/**< \brief (SYSCTRL_VREF)Օڼ޽ */

/* -------- SYSCTRL_DPLLCTRLA : (SYSCTRLψ:0x44) (R/W  8)DPLLA -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  :1;				/*!< ޯ    0: \ */
    uint8_t  ENABLE:1;			/*!< ޯ    1: DPLL */
    uint8_t  :4;				/*!< ޯ2` 5: \ */
    uint8_t  RUNSTDBY:1;		/*!< ޯ    6: ޲ős */
    uint8_t  ONDEMAND:1;		/*!< ޯ    7: ^ۯ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_DPLLCTRLA_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_DPLLCTRLA_OFFSET			0x44			/**< \brief (SYSCTRL_DPLLCTRLA offset)DPLLA */
#define SYSCTRL_DPLLCTRLA_RESETVALUE		0x80			/**< \brief (SYSCTRL_DPLLCTRLA reset_value)DPLLA */

#define SYSCTRL_DPLLCTRLA_ENABLE_Pos		1				/**< \brief (SYSCTRL_DPLLCTRLA)DPLL */
#define SYSCTRL_DPLLCTRLA_ENABLE			(0x1u << SYSCTRL_DPLLCTRLA_ENABLE_Pos)
#define SYSCTRL_DPLLCTRLA_RUNSTDBY_Pos		6				/**< \brief (SYSCTRL_DPLLCTRLA)޲ős */
#define SYSCTRL_DPLLCTRLA_RUNSTDBY			(0x1u << SYSCTRL_DPLLCTRLA_RUNSTDBY_Pos)
#define SYSCTRL_DPLLCTRLA_ONDEMAND_Pos		7				/**< \brief (SYSCTRL_DPLLCTRLA)^ۯ */
#define SYSCTRL_DPLLCTRLA_ONDEMAND			(0x1u << SYSCTRL_DPLLCTRLA_ONDEMAND_Pos)
#define SYSCTRL_DPLLCTRLA_MASK				0xC2u			/**< \brief (SYSCTRL_DPLLCTRLA)Օڼ޽ */

/* -------- SYSCTRL_DPLLRATIO : (SYSCTRLψ:0x48) (R/W 32)DPLL䗦 -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t LDR:12;			/*!< ޯ 0`11: H */
    uint32_t :4;				/*!< ޯ12`15: \ */
    uint32_t LDRFRAC:4;			/*!< ޯ16`19: H䏬 */
    uint32_t :12;				/*!< ޯ20`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_DPLLRATIO_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_DPLLRATIO_OFFSET			0x48			/**< \brief (SYSCTRL_DPLLRATIO offset)DPLL䗦 */
#define SYSCTRL_DPLLRATIO_RESETVALUE		0x00000000		/**< \brief (SYSCTRL_DPLLRATIO reset_value)DPLL䗦 */

#define SYSCTRL_DPLLRATIO_LDR_Pos			0				/**< \brief (SYSCTRL_DPLLRATIO)H */
#define SYSCTRL_DPLLRATIO_LDR_Msk			(0xFFFu << SYSCTRL_DPLLRATIO_LDR_Pos)
#define SYSCTRL_DPLLRATIO_LDR(value)		((SYSCTRL_DPLLRATIO_LDR_Msk & ((value) << SYSCTRL_DPLLRATIO_LDR_Pos)))
#define SYSCTRL_DPLLRATIO_LDRFRAC_Pos		16				/**< \brief (SYSCTRL_DPLLRATIO)H䏬 */
#define SYSCTRL_DPLLRATIO_LDRFRAC_Msk		(0xFu << SYSCTRL_DPLLRATIO_LDRFRAC_Pos)
#define SYSCTRL_DPLLRATIO_LDRFRAC(value)	((SYSCTRL_DPLLRATIO_LDRFRAC_Msk & ((value) << SYSCTRL_DPLLRATIO_LDRFRAC_Pos)))
#define SYSCTRL_DPLLRATIO_MASK				0x000F0FFFu		/**< \brief (SYSCTRL_DPLLRATIO)Օڼ޽ */

/* -------- SYSCTRL_DPLLCTRLB : (SYSCTRLψ:0x4C) (R/W 32)DPLLB -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t FILTER:2;			/*!< ޯ 0` 1: ϕhgI */
    uint32_t LPEN:1;			/*!< ޯ     2: d͋ */
    uint32_t WUF:1;				/*!< ޯ     3: N */
    uint32_t REFCLK:2;			/*!< ޯ 4` 5: ۯI */
    uint32_t :2;				/*!< ޯ 6` 7: \ */
    uint32_t LTIME:3;			/*!< ޯ 8`10: Œ艻 */
    uint32_t :1;				/*!< ޯ    11: \ */
    uint32_t LBYPASS:1;			/*!< ޯ    12: Œ艻I */
    uint32_t :3;				/*!< ޯ13`15: \ */
    uint32_t DIV:11;			/*!< ޯ16`26: ۯ */
    uint32_t :5;				/*!< ޯ27`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_DPLLCTRLB_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_DPLLCTRLB_OFFSET			0x4C			/**< \brief (SYSCTRL_DPLLCTRLB offset)DPLLB */
#define SYSCTRL_DPLLCTRLB_RESETVALUE		0x00000000		/**< \brief (SYSCTRL_DPLLCTRLB reset_value)DPLLB */

#define SYSCTRL_DPLLCTRLB_FILTER_Pos		0				/**< \brief (SYSCTRL_DPLLCTRLB)ϕhgI */
#define SYSCTRL_DPLLCTRLB_FILTER_Msk		(0x3u << SYSCTRL_DPLLCTRLB_FILTER_Pos)
#define SYSCTRL_DPLLCTRLB_FILTER(value)		((SYSCTRL_DPLLCTRLB_FILTER_Msk & ((value) << SYSCTRL_DPLLCTRLB_FILTER_Pos)))
#define   SYSCTRL_DPLLCTRLB_FILTER_DEFAULT_Val	0x0u			/**< \brief (SYSCTRL_DPLLCTRLB)hg퓮 */
#define   SYSCTRL_DPLLCTRLB_FILTER_LBFILT_Val	0x1u			/**< \brief (SYSCTRL_DPLLCTRLB)шhg */
#define   SYSCTRL_DPLLCTRLB_FILTER_HBFILT_Val	0x2u			/**< \brief (SYSCTRL_DPLLCTRLB)шhg */
#define   SYSCTRL_DPLLCTRLB_FILTER_HDFILT_Val	0x3u			/**< \brief (SYSCTRL_DPLLCTRLB)hg */
#define SYSCTRL_DPLLCTRLB_FILTER_DEFAULT	(SYSCTRL_DPLLCTRLB_FILTER_DEFAULT_Val	<< SYSCTRL_DPLLCTRLB_FILTER_Pos)
#define SYSCTRL_DPLLCTRLB_FILTER_LBFILT		(SYSCTRL_DPLLCTRLB_FILTER_LBFILT_Val	<< SYSCTRL_DPLLCTRLB_FILTER_Pos)
#define SYSCTRL_DPLLCTRLB_FILTER_HBFILT		(SYSCTRL_DPLLCTRLB_FILTER_HBFILT_Val	<< SYSCTRL_DPLLCTRLB_FILTER_Pos)
#define SYSCTRL_DPLLCTRLB_FILTER_HDFILT		(SYSCTRL_DPLLCTRLB_FILTER_HDFILT_Val	<< SYSCTRL_DPLLCTRLB_FILTER_Pos)
#define SYSCTRL_DPLLCTRLB_LPEN_Pos			2				/**< \brief (SYSCTRL_DPLLCTRLB)d͋ */
#define SYSCTRL_DPLLCTRLB_LPEN				(0x1u << SYSCTRL_DPLLCTRLB_LPEN_Pos)
#define SYSCTRL_DPLLCTRLB_WUF_Pos			3				/**< \brief (SYSCTRL_DPLLCTRLB)N */
#define SYSCTRL_DPLLCTRLB_WUF				(0x1u << SYSCTRL_DPLLCTRLB_WUF_Pos)
#define SYSCTRL_DPLLCTRLB_REFCLK_Pos		4				/**< \brief (SYSCTRL_DPLLCTRLB)ۯI */
#define SYSCTRL_DPLLCTRLB_REFCLK_Msk		(0x3u << SYSCTRL_DPLLCTRLB_REFCLK_Pos)
#define SYSCTRL_DPLLCTRLB_REFCLK(value)		((SYSCTRL_DPLLCTRLB_REFCLK_Msk & ((value) << SYSCTRL_DPLLCTRLB_REFCLK_Pos)))
#define   SYSCTRL_DPLLCTRLB_REFCLK_REF0_Val		0x0u			/**< \brief (SYSCTRL_DPLLCTRLB)CLK_DPLL_REF0ۯ */
#define   SYSCTRL_DPLLCTRLB_REFCLK_REF1_Val		0x1u			/**< \brief (SYSCTRL_DPLLCTRLB)CLK_DPLL_REF1ۯ */
#define   SYSCTRL_DPLLCTRLB_REFCLK_GCLK_Val		0x2u			/**< \brief (SYSCTRL_DPLLCTRLB)GCLK_DPLLۯ */
#define   SYSCTRL_DPLLCTRLB_REFCLK_3_Val		0x3u			/**< \brief (SYSCTRL_DPLLCTRLB)\ */
#define SYSCTRL_DPLLCTRLB_REFCLK_REF0		(SYSCTRL_DPLLCTRLB_REFCLK_REF0_Val	<< SYSCTRL_DPLLCTRLB_REFCLK_Pos)
#define SYSCTRL_DPLLCTRLB_REFCLK_REF1		(SYSCTRL_DPLLCTRLB_REFCLK_REF1_Val	<< SYSCTRL_DPLLCTRLB_REFCLK_Pos)
#define SYSCTRL_DPLLCTRLB_REFCLK_GCLK		(SYSCTRL_DPLLCTRLB_REFCLK_GCLK_Val	<< SYSCTRL_DPLLCTRLB_REFCLK_Pos)
#define SYSCTRL_DPLLCTRLB_REFCLK_3			(SYSCTRL_DPLLCTRLB_REFCLK_3_Val		<< SYSCTRL_DPLLCTRLB_REFCLK_Pos)
#define SYSCTRL_DPLLCTRLB_LTIME_Pos			8				/**< \brief (SYSCTRL_DPLLCTRLB)Œ艻 */
#define SYSCTRL_DPLLCTRLB_LTIME_Msk			(0x7u << SYSCTRL_DPLLCTRLB_LTIME_Pos)
#define SYSCTRL_DPLLCTRLB_LTIME(value)		((SYSCTRL_DPLLCTRLB_LTIME_Msk & ((value) << SYSCTRL_DPLLCTRLB_LTIME_Pos)))
#define   SYSCTRL_DPLLCTRLB_LTIME_0_Val			0x0u			/**< \brief (SYSCTRL_DPLLCTRLB)AԂȂ */
#define   SYSCTRL_DPLLCTRLB_LTIME_1_Val			0x1u			/**< \brief (SYSCTRL_DPLLCTRLB)\ */
#define   SYSCTRL_DPLLCTRLB_LTIME_2_Val			0x2u			/**< \brief (SYSCTRL_DPLLCTRLB)\ */
#define   SYSCTRL_DPLLCTRLB_LTIME_3_Val			0x3u			/**< \brief (SYSCTRL_DPLLCTRLB)\ */
#define   SYSCTRL_DPLLCTRLB_LTIME_4_Val			0x4u			/**< \brief (SYSCTRL_DPLLCTRLB)8MSA8msȓɌŒ艻ȂꍇɎԒ */
#define   SYSCTRL_DPLLCTRLB_LTIME_5_Val			0x5u			/**< \brief (SYSCTRL_DPLLCTRLB)9MSA9msȓɌŒ艻ȂꍇɎԒ */
#define   SYSCTRL_DPLLCTRLB_LTIME_6_Val			0x6u			/**< \brief (SYSCTRL_DPLLCTRLB)10MSA10msȓɌŒ艻ȂꍇɎԒ */
#define   SYSCTRL_DPLLCTRLB_LTIME_7_Val			0x7u			/**< \brief (SYSCTRL_DPLLCTRLB)11MSA11msȓɌŒ艻ȂꍇɎԒ */
#define SYSCTRL_DPLLCTRLB_LTIME_0			(SYSCTRL_DPLLCTRLB_LTIME_0_Val << SYSCTRL_DPLLCTRLB_LTIME_Pos)
#define SYSCTRL_DPLLCTRLB_LTIME_1			(SYSCTRL_DPLLCTRLB_LTIME_1_Val << SYSCTRL_DPLLCTRLB_LTIME_Pos)
#define SYSCTRL_DPLLCTRLB_LTIME_2			(SYSCTRL_DPLLCTRLB_LTIME_2_Val << SYSCTRL_DPLLCTRLB_LTIME_Pos)
#define SYSCTRL_DPLLCTRLB_LTIME_3			(SYSCTRL_DPLLCTRLB_LTIME_3_Val << SYSCTRL_DPLLCTRLB_LTIME_Pos)
#define SYSCTRL_DPLLCTRLB_LTIME_4			(SYSCTRL_DPLLCTRLB_LTIME_4_Val << SYSCTRL_DPLLCTRLB_LTIME_Pos)
#define SYSCTRL_DPLLCTRLB_LTIME_5			(SYSCTRL_DPLLCTRLB_LTIME_5_Val << SYSCTRL_DPLLCTRLB_LTIME_Pos)
#define SYSCTRL_DPLLCTRLB_LTIME_6			(SYSCTRL_DPLLCTRLB_LTIME_6_Val << SYSCTRL_DPLLCTRLB_LTIME_Pos)
#define SYSCTRL_DPLLCTRLB_LTIME_7			(SYSCTRL_DPLLCTRLB_LTIME_7_Val << SYSCTRL_DPLLCTRLB_LTIME_Pos)
#define SYSCTRL_DPLLCTRLB_LBYPASS_Pos		12				/**< \brief (SYSCTRL_DPLLCTRLB)Œ艻I */
#define SYSCTRL_DPLLCTRLB_LBYPASS			(0x1u << SYSCTRL_DPLLCTRLB_LBYPASS_Pos)
#define SYSCTRL_DPLLCTRLB_DIV_Pos			16				/**< \brief (SYSCTRL_DPLLCTRLB)ۯ */
#define SYSCTRL_DPLLCTRLB_DIV_Msk			(0x7FFu << SYSCTRL_DPLLCTRLB_DIV_Pos)
#define SYSCTRL_DPLLCTRLB_DIV(value)		((SYSCTRL_DPLLCTRLB_DIV_Msk & ((value) << SYSCTRL_DPLLCTRLB_DIV_Pos)))
#define SYSCTRL_DPLLCTRLB_MASK				0x07FF173Fu		/**< \brief (SYSCTRL_DPLLCTRLB)Օڼ޽ */

/* -------- SYSCTRL_DPLLSTATUS : (SYSCTRLψ:0x50) (R/   8)DPLL -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  LOCK:1;			/*!< ޯ   0: DPLLŒ艻 */
    uint8_t  CLKRDY:1;			/*!< ޯ   1: o͸ۯ */
    uint8_t  ENABLE:1;			/*!< ޯ   2: DPLL */
    uint8_t  DIV:1;				/*!< ޯ   3: 틖 */
    uint8_t  :4;				/*!< ޯ4`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_DPLLSTATUS_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_DPLLSTATUS_OFFSET			0x50			/**< \brief (SYSCTRL_DPLLSTATUS offset)DPLL */
#define SYSCTRL_DPLLSTATUS_RESETVALUE		0x00			/**< \brief (SYSCTRL_DPLLSTATUS reset_value)DPLL */

#define SYSCTRL_DPLLSTATUS_LOCK_Pos			0				/**< \brief (SYSCTRL_DPLLSTATUS)DPLLŒ艻 */
#define SYSCTRL_DPLLSTATUS_LOCK				(0x1u << SYSCTRL_DPLLSTATUS_LOCK_Pos)
#define SYSCTRL_DPLLSTATUS_CLKRDY_Pos		1				/**< \brief (SYSCTRL_DPLLSTATUS)o͸ۯ */
#define SYSCTRL_DPLLSTATUS_CLKRDY			(0x1u << SYSCTRL_DPLLSTATUS_CLKRDY_Pos)
#define SYSCTRL_DPLLSTATUS_ENABLE_Pos		2				/**< \brief (SYSCTRL_DPLLSTATUS)DPLL */
#define SYSCTRL_DPLLSTATUS_ENABLE			(0x1u << SYSCTRL_DPLLSTATUS_ENABLE_Pos)
#define SYSCTRL_DPLLSTATUS_DIV_Pos			3				/**< \brief (SYSCTRL_DPLLSTATUS)틖 */
#define SYSCTRL_DPLLSTATUS_DIV				(0x1u << SYSCTRL_DPLLSTATUS_DIV_Pos)
#define SYSCTRL_DPLLSTATUS_MASK				0x0Fu			/**< \brief (SYSCTRL_DPLLSTATUS)Օڼ޽ */

/** \brief SYSCTRLʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  __IO SYSCTRL_INTENCLR_Type	INTENCLR;		/**< \briefψ:0x00 (R/W 32)荞݋ */
  __IO SYSCTRL_INTENSET_Type	INTENSET;		/**< \briefψ:0x04 (R/W 32)荞݋ݒ */
  __IO SYSCTRL_INTFLAG_Type		INTFLAG;		/**< \briefψ:0x08 (R/W 32)荞׸ޏ/ */
  __I  SYSCTRL_PCLKSR_Type		PCLKSR;			/**< \briefψ:0x0C (R/  32)d͂Ƹۯ̏ */
  __IO SYSCTRL_XOSC_Type		XOSC;			/**< \briefψ:0x10 (R/W 16)OprؽٗpU(XOSC) */
	   RoReg8					Reserved1[0x2];
  __IO SYSCTRL_XOSC32K_Type		XOSC32K;		/**< \briefψ:0x14 (R/W 16)32kHzOؽٗpU(XOSC32K) */
	   RoReg8					Reserved2[0x2];
  __IO SYSCTRL_OSC32K_Type		OSC32K;			/**< \briefψ:0x18 (R/W 32)32kHzU(OSC32K) */
  __IO SYSCTRL_OSCULP32K_Type	OSCULP32K;		/**< \briefψ:0x1C (R/W  8)32kHzd͓U(OSCULP32K) */
	   RoReg8					Reserved3[0x3];
  __IO SYSCTRL_OSC8M_Type		OSC8M;			/**< \briefψ:0x20 (R/W 32)8MHzU(OSC8M)A */
  __IO SYSCTRL_DFLLCTRL_Type	DFLLCTRL;		/**< \briefψ:0x24 (R/W 16)DFLL48M */
	   RoReg8					Reserved4[0x2];
  __IO SYSCTRL_DFLLVAL_Type		DFLLVAL;		/**< \briefψ:0x28 (R/W 32)DFLL48Ml */
  __IO SYSCTRL_DFLLMUL_Type		DFLLMUL;		/**< \briefψ:0x2C (R/W 32)DFLL48M{ */
  __IO SYSCTRL_DFLLSYNC_Type	DFLLSYNC;		/**< \briefψ:0x30 (R/W  8)DFLL48M */
	   RoReg8					Reserved5[0x3];
  __IO SYSCTRL_BOD33_Type		BOD33;			/**< \briefψ:0x34 (R/W 32)3.3Vdo(BOD33) */
	   RoReg8					Reserved6[0x8];
  __IO SYSCTRL_VREF_Type		VREF;			/**< \briefψ:0x40 (R/W 32)d(VREF) */
  __IO SYSCTRL_DPLLCTRLA_Type	DPLLCTRLA;		/**< \briefψ:0x44 (R/W  8)DPLLA */
	   RoReg8					Reserved7[0x3];
  __IO SYSCTRL_DPLLRATIO_Type	DPLLRATIO;		/**< \briefψ:0x48 (R/W 32)DPLL䗦 */
  __IO SYSCTRL_DPLLCTRLB_Type	DPLLCTRLB;		/**< \briefψ:0x4C (R/W 32)DPLLB */
  __I  SYSCTRL_DPLLSTATUS_Type	DPLLSTATUS;		/**< \briefψ:0x50 (R/   8)DPLL */
} Sysctrl;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAMD21_SYSCTRL_COMPONENT_ */
