/**
 * \file
 *
 * \brief USBp\iLq
 *
 * 쌠 (c) 2013 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAMD21_USB_COMPONENT_
#define _SAMD21_USB_COMPONENT_

/* ========================================================================== */
/** USBpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAMD21_USB ŉ޽ */
/*@{*/

#define USB_U2222
#define REV_USB									0x100

/* -------- USB_CTRLA : (USBψ:0x000) (R/W  8)A -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  SWRST:1;				/*!< ޯ   0: ĳ ؾ */
    uint8_t  ENABLE:1;				/*!< ޯ   1:  */
    uint8_t  RUNSTDBY:1;			/*!< ޯ   2: ޲ős */
    uint8_t  :4;					/*!< ޯ3`6: \ */
    uint8_t  MODE:1;				/*!< ޯ   7: ` */
  } bit;							/*!< ޯ Ɏgp\ */
  uint8_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_CTRLA_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_CTRLA_OFFSET						0x000			/**< \brief (USB_CTRLA offset)A */
#define USB_CTRLA_RESETVALUE					0x00			/**< \brief (USB_CTRLA reset_value)A */

#define USB_CTRLA_SWRST_Pos						0				/**< \brief (USB_CTRLA)ĳ ؾ */
#define USB_CTRLA_SWRST							(0x1u << USB_CTRLA_SWRST_Pos)
#define USB_CTRLA_ENABLE_Pos					1				/**< \brief (USB_CTRLA) */
#define USB_CTRLA_ENABLE						(0x1u << USB_CTRLA_ENABLE_Pos)
#define USB_CTRLA_RUNSTDBY_Pos					2				/**< \brief (USB_CTRLA)޲ős */
#define USB_CTRLA_RUNSTDBY						(0x1u << USB_CTRLA_RUNSTDBY_Pos)
#define USB_CTRLA_MODE_Pos						7				/**< \brief (USB_CTRLA)` */
#define USB_CTRLA_MODE							(0x1u << USB_CTRLA_MODE_Pos)
#define   USB_CTRLA_MODE_DEVICE_Val					0x0u		/**< \brief (USB_CTRLA)u */
#define   USB_CTRLA_MODE_HOST_Val					0x1u		/**< \brief (USB_CTRLA)νē */
#define USB_CTRLA_MODE_DEVICE					(USB_CTRLA_MODE_DEVICE_Val	<< USB_CTRLA_MODE_Pos)
#define USB_CTRLA_MODE_HOST						(USB_CTRLA_MODE_HOST_Val	<< USB_CTRLA_MODE_Pos)
#define USB_CTRLA_MASK							0x87u			/**< \brief (USB_CTRLA)Օڼ޽ */

/* -------- USB_SYNCBUSY : (USBψ:0x002) (R/   8)Z -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  SWRST:1;				/*!< ޯ   0: ĳ ؾēZ */
    uint8_t  ENABLE:1;				/*!< ޯ   1: Z */
    uint8_t  :6;					/*!< ޯ2`7: \ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint8_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_SYNCBUSY_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_SYNCBUSY_OFFSET						0x002			/**< \brief (USB_SYNCBUSY offset)Z */
#define USB_SYNCBUSY_RESETVALUE					0x00			/**< \brief (USB_SYNCBUSY reset_value)Z */

#define USB_SYNCBUSY_SWRST_Pos					0				/**< \brief (USB_SYNCBUSY)ĳ ؾēZ */
#define USB_SYNCBUSY_SWRST						(0x1u << USB_SYNCBUSY_SWRST_Pos)
#define USB_SYNCBUSY_ENABLE_Pos					1				/**< \brief (USB_SYNCBUSY)Z */
#define USB_SYNCBUSY_ENABLE						(0x1u << USB_SYNCBUSY_ENABLE_Pos)
#define USB_SYNCBUSY_MASK						0x03u			/**< \brief (USB_SYNCBUSY)Օڼ޽ */

/* -------- USB_DEVICE_CTRLB : (USBψ:0x008) (R/W 16) DEVICE uB -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t DETACH:1;				/*!< ޯ     0: O */
    uint16_t UPRSM:1;				/*!< ޯ     1: ĊJ */
    uint16_t SPDCONF:2;				/*!< ޯ 2` 3: x`Ԑݒ */
    uint16_t NREPLY:1;				/*!< ޯ     4:  */
    uint16_t TSTJ:1;				/*!< ޯ     5: J */
    uint16_t TSTK:1;				/*!< ޯ     6: K */
    uint16_t TSTPCKT:1;				/*!< ޯ     7: ߹ē */
    uint16_t OPMODE2:1;				/*!< ޯ     8: 蓮` */
    uint16_t GNAK:1;				/*!< ޯ     9: SNAK */
    uint16_t LPMHDSK:2;				/*!< ޯ10`11: ڑd͊Ǘ޼ */
    uint16_t :4;					/*!< ޯ12`15: \ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint16_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_DEVICE_CTRLB_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_DEVICE_CTRLB_OFFSET					0x008			/**< \brief (USB_DEVICE_CTRLB offset)uB */
#define USB_DEVICE_CTRLB_RESETVALUE				0x0001			/**< \brief (USB_DEVICE_CTRLB reset_value)uB */

#define USB_DEVICE_CTRLB_DETACH_Pos				0				/**< \brief (USB_DEVICE_CTRLB)O */
#define USB_DEVICE_CTRLB_DETACH					(0x1u << USB_DEVICE_CTRLB_DETACH_Pos)
#define USB_DEVICE_CTRLB_UPRSM_Pos				1				/**< \brief (USB_DEVICE_CTRLB)ĊJ */
#define USB_DEVICE_CTRLB_UPRSM					(0x1u << USB_DEVICE_CTRLB_UPRSM_Pos)
#define USB_DEVICE_CTRLB_SPDCONF_Pos			2				/**< \brief (USB_DEVICE_CTRLB)x`Ԑݒ */
#define USB_DEVICE_CTRLB_SPDCONF_Msk			(0x3u << USB_DEVICE_CTRLB_SPDCONF_Pos)
#define USB_DEVICE_CTRLB_SPDCONF(value)			((USB_DEVICE_CTRLB_SPDCONF_Msk & ((value) << USB_DEVICE_CTRLB_SPDCONF_Pos)))
#define   USB_DEVICE_CTRLB_SPDCONF_0_Val			0x0u		/**< \brief (USB_DEVICE_CTRLB)FS  :S */
#define   USB_DEVICE_CTRLB_SPDCONF_1_Val			0x1u		/**< \brief (USB_DEVICE_CTRLB)LS  :ᑬ */
#define   USB_DEVICE_CTRLB_SPDCONF_2_Val			0x2u		/**< \brief (USB_DEVICE_CTRLB)HS  :\ */
#define   USB_DEVICE_CTRLB_SPDCONF_3_Val			0x3u		/**< \brief (USB_DEVICE_CTRLB)HSTM:(pɍ십) */
#define USB_DEVICE_CTRLB_SPDCONF_0				(USB_DEVICE_CTRLB_SPDCONF_0_Val << USB_DEVICE_CTRLB_SPDCONF_Pos)
#define USB_DEVICE_CTRLB_SPDCONF_1				(USB_DEVICE_CTRLB_SPDCONF_1_Val << USB_DEVICE_CTRLB_SPDCONF_Pos)
#define USB_DEVICE_CTRLB_SPDCONF_2				(USB_DEVICE_CTRLB_SPDCONF_2_Val << USB_DEVICE_CTRLB_SPDCONF_Pos)
#define USB_DEVICE_CTRLB_SPDCONF_3				(USB_DEVICE_CTRLB_SPDCONF_3_Val << USB_DEVICE_CTRLB_SPDCONF_Pos)
#define USB_DEVICE_CTRLB_NREPLY_Pos				4				/**< \brief (USB_DEVICE_CTRLB) */
#define USB_DEVICE_CTRLB_NREPLY					(0x1u << USB_DEVICE_CTRLB_NREPLY_Pos)
#define USB_DEVICE_CTRLB_TSTJ_Pos				5				/**< \brief (USB_DEVICE_CTRLB)J */
#define USB_DEVICE_CTRLB_TSTJ					(0x1u << USB_DEVICE_CTRLB_TSTJ_Pos)
#define USB_DEVICE_CTRLB_TSTK_Pos				6				/**< \brief (USB_DEVICE_CTRLB)K */
#define USB_DEVICE_CTRLB_TSTK					(0x1u << USB_DEVICE_CTRLB_TSTK_Pos)
#define USB_DEVICE_CTRLB_TSTPCKT_Pos			7				/**< \brief (USB_DEVICE_CTRLB)߹ē */
#define USB_DEVICE_CTRLB_TSTPCKT				(0x1u << USB_DEVICE_CTRLB_TSTPCKT_Pos)
#define USB_DEVICE_CTRLB_OPMODE2_Pos			8				/**< \brief (USB_DEVICE_CTRLB)蓮` */
#define USB_DEVICE_CTRLB_OPMODE2				(0x1u << USB_DEVICE_CTRLB_OPMODE2_Pos)
#define USB_DEVICE_CTRLB_GNAK_Pos				9				/**< \brief (USB_DEVICE_CTRLB)SNAK */
#define USB_DEVICE_CTRLB_GNAK					(0x1u << USB_DEVICE_CTRLB_GNAK_Pos)
#define USB_DEVICE_CTRLB_LPMHDSK_Pos			10				/**< \brief (USB_DEVICE_CTRLB)ڑd͊Ǘ޼ */
#define USB_DEVICE_CTRLB_LPMHDSK_Msk			(0x3u << USB_DEVICE_CTRLB_LPMHDSK_Pos)
#define USB_DEVICE_CTRLB_LPMHDSK(value)			((USB_DEVICE_CTRLB_LPMHDSK_Msk & ((value) << USB_DEVICE_CTRLB_LPMHDSK_Pos)))
#define   USB_DEVICE_CTRLB_LPMHDSK_NO_Val			0x0u		/**< \brief (USB_DEVICE_CTRLB)޼ȂALPMxȂ */
#define   USB_DEVICE_CTRLB_LPMHDSK_ACK_Val			0x1u		/**< \brief (USB_DEVICE_CTRLB)ACK */
#define   USB_DEVICE_CTRLB_LPMHDSK_NYET_Val			0x2u		/**< \brief (USB_DEVICE_CTRLB)NYET */
#define   USB_DEVICE_CTRLB_LPMHDSK_STALL_Val		0x3u		/**< \brief (USB_DEVICE_CTRLB)STALL */
#define USB_DEVICE_CTRLB_LPMHDSK_NO				(USB_DEVICE_CTRLB_LPMHDSK_NO_Val	<< USB_DEVICE_CTRLB_LPMHDSK_Pos)
#define USB_DEVICE_CTRLB_LPMHDSK_ACK			(USB_DEVICE_CTRLB_LPMHDSK_ACK_Val	<< USB_DEVICE_CTRLB_LPMHDSK_Pos)
#define USB_DEVICE_CTRLB_LPMHDSK_NYET			(USB_DEVICE_CTRLB_LPMHDSK_NYET_Val	<< USB_DEVICE_CTRLB_LPMHDSK_Pos)
#define USB_DEVICE_CTRLB_LPMHDSK_STALL			(USB_DEVICE_CTRLB_LPMHDSK_STALL_Val	<< USB_DEVICE_CTRLB_LPMHDSK_Pos)
#define USB_DEVICE_CTRLB_MASK					0x0FFFu			/**< \brief (USB_DEVICE_CTRLB)Օڼ޽ */

/* -------- USB_HOST_CTRLB : (USBψ:0x008) (R/W 16) HOST νĐB -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t :1;					/*!< ޯ     0: \ */
    uint16_t RESUME:1;				/*!< ޯ     1: USBĊJo */
    uint16_t SPDCONF:2;				/*!< ޯ 2` 3: νėpx`Ԑݒ */
    uint16_t :1;					/*!< ޯ     4: \ */
    uint16_t TSTJ:1;				/*!< ޯ     5: J */
    uint16_t TSTK:1;				/*!< ޯ     6: K */
    uint16_t :1;					/*!< ޯ     7: \ */
    uint16_t SOFE:1;				/*!< ޯ     8: ڰъJn */
    uint16_t BUSRESET:1;			/*!< ޯ     9: USBؾđo */
    uint16_t VBUSOK:1;				/*!< ޯ    10: VBUSOK */
    uint16_t L1RESUME:1;			/*!< ޯ    11: LIĊJo */
    uint16_t :4;					/*!< ޯ12`15: \ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint16_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_HOST_CTRLB_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_HOST_CTRLB_OFFSET					0x008			/**< \brief (USB_HOST_CTRLB offset)νĐB */
#define USB_HOST_CTRLB_RESETVALUE				0x0000			/**< \brief (USB_HOST_CTRLB reset_value)νĐB */

#define USB_HOST_CTRLB_RESUME_Pos				1				/**< \brief (USB_HOST_CTRLB)USBĊJo */
#define USB_HOST_CTRLB_RESUME					(0x1u << USB_HOST_CTRLB_RESUME_Pos)
#define USB_HOST_CTRLB_SPDCONF_Pos				2				/**< \brief (USB_HOST_CTRLB)νėpx`Ԑݒ */
#define USB_HOST_CTRLB_SPDCONF_Msk				(0x3u << USB_HOST_CTRLB_SPDCONF_Pos)
#define USB_HOST_CTRLB_SPDCONF(value			((USB_HOST_CTRLB_SPDCONF_Msk & ((value) << USB_HOST_CTRLB_SPDCONF_Pos)))
#define   USB_HOST_CTRLB_SPDCONF_0_Val				0x0u		/**< \brief (USB_HOST_CTRLB)W:νĂ͑SŊJnĉӋ@\\͂Ȃ΍ɐ؂ւ邽߂ɍؾĂs */
#define   USB_HOST_CTRLB_SPDCONF_1_Val				0x1u		/**< \brief (USB_HOST_CTRLB)\ */
#define   USB_HOST_CTRLB_SPDCONF_2_Val				0x2u		/**< \brief (USB_HOST_CTRLB)\ */
#define   USB_HOST_CTRLB_SPDCONF_3_Val				0x3u		/**< \brief (USB_HOST_CTRLB)S:νĂ͎Ӌ@\x\͂łSɗ܂܂BUTMIł֘A */
#define USB_HOST_CTRLB_SPDCONF_0				(USB_HOST_CTRLB_SPDCONF_0_Val << USB_HOST_CTRLB_SPDCONF_Pos)
#define USB_HOST_CTRLB_SPDCONF_1				(USB_HOST_CTRLB_SPDCONF_1_Val << USB_HOST_CTRLB_SPDCONF_Pos)
#define USB_HOST_CTRLB_SPDCONF_2				(USB_HOST_CTRLB_SPDCONF_2_Val << USB_HOST_CTRLB_SPDCONF_Pos)
#define USB_HOST_CTRLB_SPDCONF_3				(USB_HOST_CTRLB_SPDCONF_3_Val << USB_HOST_CTRLB_SPDCONF_Pos)
#define USB_HOST_CTRLB_TSTJ_Pos					5				/**< \brief (USB_HOST_CTRLB)J */
#define USB_HOST_CTRLB_TSTJ						(0x1u << USB_HOST_CTRLB_TSTJ_Pos)
#define USB_HOST_CTRLB_TSTK_Pos					6				/**< \brief (USB_HOST_CTRLB)K */
#define USB_HOST_CTRLB_TSTK						(0x1u << USB_HOST_CTRLB_TSTK_Pos)
#define USB_HOST_CTRLB_SOFE_Pos					8				/**< \brief (USB_HOST_CTRLB)ڰъJn */
#define USB_HOST_CTRLB_SOFE						(0x1u << USB_HOST_CTRLB_SOFE_Pos)
#define USB_HOST_CTRLB_BUSRESET_Pos				9				/**< \brief (USB_HOST_CTRLB)USBؾđo */
#define USB_HOST_CTRLB_BUSRESET					(0x1u << USB_HOST_CTRLB_BUSRESET_Pos)
#define USB_HOST_CTRLB_VBUSOK_Pos				10				/**< \brief (USB_HOST_CTRLB)VBUSOK */
#define USB_HOST_CTRLB_VBUSOK					(0x1u << USB_HOST_CTRLB_VBUSOK_Pos)
#define USB_HOST_CTRLB_L1RESUME_Pos				11				/**< \brief (USB_HOST_CTRLB)LIĊJo */
#define USB_HOST_CTRLB_L1RESUME					(0x1u << USB_HOST_CTRLB_L1RESUME_Pos)
#define USB_HOST_CTRLB_MASK						0x0F6Eu			/**< \brief (USB_HOST_CTRLB)Օڼ޽ */

/* -------- USB_DEVICE_DADD : (USBψ:0x00A) (R/W  8) DEVICE DEVICEuڽ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  DADD:7;				/*!< ޯ0`6: uڽ */
    uint8_t  ADDEN:1;				/*!< ޯ   7: uڽuڽ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint8_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_DEVICE_DADD_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_DEVICE_DADD_OFFSET					0x00A			/**< \brief (USB_DEVICE_DADD offset)DEVICE uڽ */
#define USB_DEVICE_DADD_RESETVALUE				0x00			/**< \brief (USB_DEVICE_DADD reset_value)DEVICE uڽ */

#define USB_DEVICE_DADD_DADD_Pos				0				/**< \brief (USB_DEVICE_DADD)uڽ */
#define USB_DEVICE_DADD_DADD_Msk				(0x7Fu << USB_DEVICE_DADD_DADD_Pos)
#define USB_DEVICE_DADD_DADD(value)				((USB_DEVICE_DADD_DADD_Msk & ((value) << USB_DEVICE_DADD_DADD_Pos)))
#define USB_DEVICE_DADD_ADDEN_Pos				7				/**< \brief (USB_DEVICE_DADD)uڽuڽ */
#define USB_DEVICE_DADD_ADDEN					(0x1u << USB_DEVICE_DADD_ADDEN_Pos)
#define USB_DEVICE_DADD_MASK					0xFFu			/**< \brief (USB_DEVICE_DADD)Օڼ޽ */

/* -------- USB_HOST_HSOFC : (USBψ:0x00A) (R/W  8) HOST HOSTν ڰъJn -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  FLENC:4;				/*!< ޯ0`3: ڰђ */
    uint8_t  :3;					/*!< ޯ4`6: \ */
    uint8_t  FLENCE:1;				/*!< ޯ   7: ڰђ䋖 */
  } bit;							/*!< ޯ Ɏgp\ */
  uint8_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_HOST_HSOFC_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_HOST_HSOFC_OFFSET					0x00A			/**< \brief (USB_HOST_HSOFC offset)HOST ν ڰъJn */
#define USB_HOST_HSOFC_RESETVALUE				0x00			/**< \brief (USB_HOST_HSOFC reset_value)HOST ν ڰъJn */

#define USB_HOST_HSOFC_FLENC_Pos				0				/**< \brief (USB_HOST_HSOFC)ڰђ */
#define USB_HOST_HSOFC_FLENC_Msk				(0xFu << USB_HOST_HSOFC_FLENC_Pos)
#define USB_HOST_HSOFC_FLENC(value)				((USB_HOST_HSOFC_FLENC_Msk & ((value) << USB_HOST_HSOFC_FLENC_Pos)))
#define USB_HOST_HSOFC_FLENCE_Pos				7				/**< \brief (USB_HOST_HSOFC)ڰђ䋖 */
#define USB_HOST_HSOFC_FLENCE					(0x1u << USB_HOST_HSOFC_FLENCE_Pos)
#define USB_HOST_HSOFC_MASK						0x8Fu			/**< \brief (USB_HOST_HSOFC)Օڼ޽ */

/* -------- USB_DEVICE_STATUS : (USBψ:0x00C) (R/   8) DEVICE u -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  :2;					/*!< ޯ0`1: \ */
    uint8_t  SPEED:2;				/*!< ޯ2`3: x */
    uint8_t  :2;					/*!< ޯ4`5: \ */
    uint8_t  LINESTATE:2;			/*!< ޯ6`7: USB󋵏 */
  } bit;							/*!< ޯ Ɏgp\ */
  uint8_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_DEVICE_STATUS_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_DEVICE_STATUS_OFFSET				0x00C			/**< \brief (USB_DEVICE_STATUS offset)u */
#define USB_DEVICE_STATUS_RESETVALUE			0x40			/**< \brief (USB_DEVICE_STATUS reset_value)u */

#define USB_DEVICE_STATUS_SPEED_Pos				2				/**< \brief (USB_DEVICE_STATUS)x */
#define USB_DEVICE_STATUS_SPEED_Msk				(0x3u << USB_DEVICE_STATUS_SPEED_Pos)
#define USB_DEVICE_STATUS_SPEED(value)			((USB_DEVICE_STATUS_SPEED_Msk & ((value) << USB_DEVICE_STATUS_SPEED_Pos)))
#define   USB_DEVICE_STATUS_SPEED_0_Val				0x0u		/**< \brief (USB_DEVICE_STATUS)S */
#define   USB_DEVICE_STATUS_SPEED_1_Val				0x1u		/**< \brief (USB_DEVICE_STATUS) */
#define   USB_DEVICE_STATUS_SPEED_2_Val				0x2u		/**< \brief (USB_DEVICE_STATUS)ᑬ */
#define USB_DEVICE_STATUS_SPEED_0				(USB_DEVICE_STATUS_SPEED_0_Val << USB_DEVICE_STATUS_SPEED_Pos)
#define USB_DEVICE_STATUS_SPEED_1				(USB_DEVICE_STATUS_SPEED_1_Val << USB_DEVICE_STATUS_SPEED_Pos)
#define USB_DEVICE_STATUS_SPEED_2				(USB_DEVICE_STATUS_SPEED_2_Val << USB_DEVICE_STATUS_SPEED_Pos)
#define USB_DEVICE_STATUS_LINESTATE_Pos			6				/**< \brief (USB_DEVICE_STATUS)USB󋵏 */
#define USB_DEVICE_STATUS_LINESTATE_Msk			(0x3u << USB_DEVICE_STATUS_LINESTATE_Pos)
#define USB_DEVICE_STATUS_LINESTATE(value)		((USB_DEVICE_STATUS_LINESTATE_Msk & ((value) << USB_DEVICE_STATUS_LINESTATE_Pos)))
#define   USB_DEVICE_STATUS_LINESTATE_0_Val			0x0u		/**< \brief (USB_DEVICE_STATUS)SE0/RESET */
#define   USB_DEVICE_STATUS_LINESTATE_1_Val			0x1u		/**< \brief (USB_DEVICE_STATUS)FS-J܂LS-K */
#define   USB_DEVICE_STATUS_LINESTATE_2_Val			0x2u		/**< \brief (USB_DEVICE_STATUS)FS-K܂LS-J */
#define USB_DEVICE_STATUS_LINESTATE_0			(USB_DEVICE_STATUS_LINESTATE_0_Val << USB_DEVICE_STATUS_LINESTATE_Pos)
#define USB_DEVICE_STATUS_LINESTATE_1			(USB_DEVICE_STATUS_LINESTATE_1_Val << USB_DEVICE_STATUS_LINESTATE_Pos)
#define USB_DEVICE_STATUS_LINESTATE_2			(USB_DEVICE_STATUS_LINESTATE_2_Val << USB_DEVICE_STATUS_LINESTATE_Pos)
#define USB_DEVICE_STATUS_MASK					0xCCu			/**< \brief (USB_DEVICE_STATUS)Օڼ޽ */

/* -------- USB_HOST_STATUS : (USBψ:0x00C) (R/W  8) HOSTνď -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  :2;					/*!< ޯ0`1: \ */
    uint8_t  SPEED:2;				/*!< ޯ2`3: x */
    uint8_t  :2;					/*!< ޯ4`5: \ */
    uint8_t  LINESTATE:2;			/*!< ޯ6`7: USB󋵏 */
  } bit;							/*!< ޯ Ɏgp\ */
  uint8_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_HOST_STATUS_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_HOST_STATUS_OFFSET					0x00C			/**< \brief (USB_HOST_STATUS offset)νď */
#define USB_HOST_STATUS_RESETVALUE				0x00			/**< \brief (USB_HOST_STATUS reset_value)νď */

#define USB_HOST_STATUS_SPEED_Pos				2				/**< \brief (USB_HOST_STATUS)x */
#define USB_HOST_STATUS_SPEED_Msk				(0x3u << USB_HOST_STATUS_SPEED_Pos)
#define USB_HOST_STATUS_SPEED(value)			((USB_HOST_STATUS_SPEED_Msk & ((value) << USB_HOST_STATUS_SPEED_Pos)))
#define USB_HOST_STATUS_LINESTATE_Pos			6				/**< \brief (USB_HOST_STATUS)USB󋵏 */
#define USB_HOST_STATUS_LINESTATE_Msk			(0x3u << USB_HOST_STATUS_LINESTATE_Pos)
#define USB_HOST_STATUS_LINESTATE(value)		((USB_HOST_STATUS_LINESTATE_Msk & ((value) << USB_HOST_STATUS_LINESTATE_Pos)))
#define USB_HOST_STATUS_MASK					0xCCu			/**< \brief (USB_HOST_STATUS)Օڼ޽ */

/* -------- USB_FSMSTATUS : (USBψ:0x00D) (R/   8)Lԋ@\ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  FSMSTATE:6;			/*!< ޯ0`5: ڍ׏ԋ@\ */
    uint8_t  :2;					/*!< ޯ6`7: \ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint8_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_FSMSTATUS_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_FSMSTATUS_OFFSET					0x00D			/**< \brief (USB_FSMSTATUS offset)Lԋ@\ */
#define USB_FSMSTATUS_RESETVALUE				0x01			/**< \brief (USB_FSMSTATUS reset_value)Lԋ@\ */

#define USB_FSMSTATUS_FSMSTATE_Pos				0				/**< \brief (USB_FSMSTATUS)ڍ׏ԋ@\ */
#define USB_FSMSTATUS_FSMSTATE_Msk				(0x3Fu << USB_FSMSTATUS_FSMSTATE_Pos)
#define USB_FSMSTATUS_FSMSTATE(value)			((USB_FSMSTATUS_FSMSTATE_Msk & ((value) << USB_FSMSTATUS_FSMSTATE_Pos)))
#define   USB_FSMSTATUS_FSMSTATE_1_Val				0x1u		/**< \brief (USB_FSMSTATUS)OFF(L3)AdOFFAؒfA֎~ԂɑΉ */
#define   USB_FSMSTATUS_FSMSTATE_2_Val				0x2u		/**< \brief (USB_FSMSTATUS)ON(L0)AقƊ̏ԂɑΉ */
#define   USB_FSMSTATUS_FSMSTATE_4_Val				0x4u		/**< \brief (USB_FSMSTATUS)SUSPEND(L2) */
#define   USB_FSMSTATUS_FSMSTATE_8_Val				0x8u		/**< \brief (USB_FSMSTATUS)SLEEP(L1) */
#define   USB_FSMSTATUS_FSMSTATE_16_Val				0x10u		/**< \brief (USB_FSMSTATUS)DNRESUMEAĊJ */
#define   USB_FSMSTATUS_FSMSTATE_32_Val				0x20u		/**< \brief (USB_FSMSTATUS)UPRESUMEAĊJ */
#define   USB_FSMSTATUS_FSMSTATE_64_Val				0x40u		/**< \brief (USB_FSMSTATUS)RESETAUSBؾ */
#define USB_FSMSTATUS_FSMSTATE_1				(USB_FSMSTATUS_FSMSTATE_1_Val	<< USB_FSMSTATUS_FSMSTATE_Pos)
#define USB_FSMSTATUS_FSMSTATE_2				(USB_FSMSTATUS_FSMSTATE_2_Val	<< USB_FSMSTATUS_FSMSTATE_Pos)
#define USB_FSMSTATUS_FSMSTATE_4				(USB_FSMSTATUS_FSMSTATE_4_Val	<< USB_FSMSTATUS_FSMSTATE_Pos)
#define USB_FSMSTATUS_FSMSTATE_8				(USB_FSMSTATUS_FSMSTATE_8_Val	<< USB_FSMSTATUS_FSMSTATE_Pos)
#define USB_FSMSTATUS_FSMSTATE_16				(USB_FSMSTATUS_FSMSTATE_16_Val	<< USB_FSMSTATUS_FSMSTATE_Pos)
#define USB_FSMSTATUS_FSMSTATE_32				(USB_FSMSTATUS_FSMSTATE_32_Val	<< USB_FSMSTATUS_FSMSTATE_Pos)
#define USB_FSMSTATUS_FSMSTATE_64				(USB_FSMSTATUS_FSMSTATE_64_Val	<< USB_FSMSTATUS_FSMSTATE_Pos)
#define USB_FSMSTATUS_MASK						0x3Fu			/**< \brief (USB_FSMSTATUS)Օڼ޽ */

/* -------- USB_DEVICE_FNUM : (USBψ:0x010) (R/  16) DEVICE uڰєԍ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t MFNUM:3;				/*!< ޯ0` 2: ϲ ڰєԍ */
    uint16_t FNUM:11;				/*!< ޯ3`13: ڰєԍ */
    uint16_t :1;					/*!< ޯ   14: \ */
    uint16_t FNCERR:1;				/*!< ޯ   15: ڰєԍCRC */
  } bit;							/*!< ޯ Ɏgp\ */
  uint16_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_DEVICE_FNUM_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_DEVICE_FNUM_OFFSET					0x010			/**< \brief (USB_DEVICE_FNUM offset)uڰєԍ */
#define USB_DEVICE_FNUM_RESETVALUE				0x0000			/**< \brief (USB_DEVICE_FNUM reset_value)uڰєԍ */

#define USB_DEVICE_FNUM_MFNUM_Pos				0				/**< \brief (USB_DEVICE_FNUM)ϲ ڰєԍ */
#define USB_DEVICE_FNUM_MFNUM_Msk				(0x7u << USB_DEVICE_FNUM_MFNUM_Pos)
#define USB_DEVICE_FNUM_MFNUM(value)			((USB_DEVICE_FNUM_MFNUM_Msk & ((value) << USB_DEVICE_FNUM_MFNUM_Pos)))
#define USB_DEVICE_FNUM_FNUM_Pos				3				/**< \brief (USB_DEVICE_FNUM)ڰєԍ */
#define USB_DEVICE_FNUM_FNUM_Msk				(0x7FFu << USB_DEVICE_FNUM_FNUM_Pos)
#define USB_DEVICE_FNUM_FNUM(value)				((USB_DEVICE_FNUM_FNUM_Msk & ((value) << USB_DEVICE_FNUM_FNUM_Pos)))
#define USB_DEVICE_FNUM_FNCERR_Pos				15				/**< \brief (USB_DEVICE_FNUM)ڰєԍCRC */
#define USB_DEVICE_FNUM_FNCERR					(0x1u << USB_DEVICE_FNUM_FNCERR_Pos)
#define USB_DEVICE_FNUM_MASK					0xBFFFu			/**< \brief (USB_DEVICE_FNUM)Օڼ޽ */

/* -------- USB_HOST_FNUM : (USBψ:0x010) (R/W 16) HOST ν ڰєԍ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t MFNUM:3;				/*!< ޯ 0` 2: ϲ ڰєԍ */
    uint16_t FNUM:11;				/*!< ޯ 3`13: ڰєԍ */
    uint16_t :2;					/*!< ޯ14`15: \ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint16_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_HOST_FNUM_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_HOST_FNUM_OFFSET					0x010			/**< \brief (USB_HOST_FNUM offset)ν ڰєԍ */
#define USB_HOST_FNUM_RESETVALUE				0x0000			/**< \brief (USB_HOST_FNUM reset_value)ν ڰєԍ */

#define USB_HOST_FNUM_MFNUM_Pos					0				/**< \brief (USB_HOST_FNUM)ϲ ڰєԍ */
#define USB_HOST_FNUM_MFNUM_Msk					(0x7u << USB_HOST_FNUM_MFNUM_Pos)
#define USB_HOST_FNUM_MFNUM(value)				((USB_HOST_FNUM_MFNUM_Msk & ((value) << USB_HOST_FNUM_MFNUM_Pos)))
#define USB_HOST_FNUM_FNUM_Pos					3				/**< \brief (USB_HOST_FNUM)ڰєԍ */
#define USB_HOST_FNUM_FNUM_Msk					(0x7FFu << USB_HOST_FNUM_FNUM_Pos)
#define USB_HOST_FNUM_FNUM(value)				((USB_HOST_FNUM_FNUM_Msk & ((value) << USB_HOST_FNUM_FNUM_Pos)))
#define USB_HOST_FNUM_MASK						0x3FFFu			/**< \brief (USB_HOST_FNUM)Օڼ޽ */

/* -------- USB_HOST_FLENHIGH : (USBψ:0x012) (R/   8) HOST ν ڰђ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  FLENHIGH:8;			/*!< ޯ0` 7: ڰђ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint8_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_HOST_FLENHIGH_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_HOST_FLENHIGH_OFFSET				0x012			/**< \brief (USB_HOST_FLENHIGH offset)ν ڰђ */
#define USB_HOST_FLENHIGH_RESETVALUE			0x00			/**< \brief (USB_HOST_FLENHIGH reset_value)ν ڰђ */

#define USB_HOST_FLENHIGH_FLENHIGH_Pos			0				/**< \brief (USB_HOST_FLENHIGH)ڰђ */
#define USB_HOST_FLENHIGH_FLENHIGH_Msk			(0xFFu << USB_HOST_FLENHIGH_FLENHIGH_Pos)
#define USB_HOST_FLENHIGH_FLENHIGH(value)		((USB_HOST_FLENHIGH_FLENHIGH_Msk & ((value) << USB_HOST_FLENHIGH_FLENHIGH_Pos)))
#define USB_HOST_FLENHIGH_MASK					0xFFu			/**< \brief (USB_HOST_FLENHIGH)Օڼ޽ */

/* -------- USB_DEVICE_INTENCLR : (USBψ:0x014) (R/W 16) DEVICE u荞݋ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t SUSPEND:1;				/*!< ޯ     0: x~荞݋ */
    uint16_t MSOF:1;				/*!< ޯ     1: ϲ ڰъJn荞݋ */
    uint16_t SOF:1;					/*!< ޯ     2: ڰъJn荞݋ */
    uint16_t EORST:1;				/*!< ޯ     3: ؾďI荞݋ */
    uint16_t WAKEUP:1;				/*!< ޯ     4: N荞݋ */
    uint16_t EORSM:1;				/*!< ޯ     5: ĊJI荞݋ */
    uint16_t UPRSM:1;				/*!< ޯ     6: ĊJ荞݋ */
    uint16_t RAMACER:1;				/*!< ޯ     7: RAM荞݋					*/
    uint16_t LPMNYET:1;				/*!< ޯ     8: ڑd͊ǗȂ荞݋ */
    uint16_t LPMSUSP:1;				/*!< ޯ     9: ڑd͊Ǘx~荞݋ */
    uint16_t :6;					/*!< ޯ10`15: \ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint16_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_DEVICE_INTENCLR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_DEVICE_INTENCLR_OFFSET				0x014			/**< \brief (USB_DEVICE_INTENCLR offset)u荞݋ */
#define USB_DEVICE_INTENCLR_RESETVALUE			0x0000			/**< \brief (USB_DEVICE_INTENCLR reset_value)u荞݋ */

#define USB_DEVICE_INTENCLR_SUSPEND_Pos			0				/**< \brief (USB_DEVICE_INTENCLR)x~荞݋ */
#define USB_DEVICE_INTENCLR_SUSPEND				(0x1u << USB_DEVICE_INTENCLR_SUSPEND_Pos)
#define USB_DEVICE_INTENCLR_MSOF_Pos			1				/**< \brief (USB_DEVICE_INTENCLR)ϲ ڰъJn荞݋ */
#define USB_DEVICE_INTENCLR_MSOF				(0x1u << USB_DEVICE_INTENCLR_MSOF_Pos)
#define USB_DEVICE_INTENCLR_SOF_Pos				2				/**< \brief (USB_DEVICE_INTENCLR)ڰъJn荞݋ */
#define USB_DEVICE_INTENCLR_SOF					(0x1u << USB_DEVICE_INTENCLR_SOF_Pos)
#define USB_DEVICE_INTENCLR_EORST_Pos			3				/**< \brief (USB_DEVICE_INTENCLR)ؾďI荞݋ */
#define USB_DEVICE_INTENCLR_EORST				(0x1u << USB_DEVICE_INTENCLR_EORST_Pos)
#define USB_DEVICE_INTENCLR_WAKEUP_Pos			4				/**< \brief (USB_DEVICE_INTENCLR)N荞݋ */
#define USB_DEVICE_INTENCLR_WAKEUP				(0x1u << USB_DEVICE_INTENCLR_WAKEUP_Pos)
#define USB_DEVICE_INTENCLR_EORSM_Pos			5				/**< \brief (USB_DEVICE_INTENCLR)ĊJI荞݋ */
#define USB_DEVICE_INTENCLR_EORSM				(0x1u << USB_DEVICE_INTENCLR_EORSM_Pos)
#define USB_DEVICE_INTENCLR_UPRSM_Pos			6				/**< \brief (USB_DEVICE_INTENCLR)ĊJ荞݋ */
#define USB_DEVICE_INTENCLR_UPRSM				(0x1u << USB_DEVICE_INTENCLR_UPRSM_Pos)
#define USB_DEVICE_INTENCLR_RAMACER_Pos			7				/**< \brief (USB_DEVICE_INTENCLR)RAM荞݋ */
#define USB_DEVICE_INTENCLR_RAMACER				(0x1u << USB_DEVICE_INTENCLR_RAMACER_Pos)
#define USB_DEVICE_INTENCLR_LPMNYET_Pos			8				/**< \brief (USB_DEVICE_INTENCLR)ڑd͊ǗȂ荞݋ */
#define USB_DEVICE_INTENCLR_LPMNYET				(0x1u << USB_DEVICE_INTENCLR_LPMNYET_Pos)
#define USB_DEVICE_INTENCLR_LPMSUSP_Pos			9				/**< \brief (USB_DEVICE_INTENCLR)ڑd͊Ǘx~荞݋ */
#define USB_DEVICE_INTENCLR_LPMSUSP				(0x1u << USB_DEVICE_INTENCLR_LPMSUSP_Pos)
#define USB_DEVICE_INTENCLR_MASK				0x03FFu			/**< \brief (USB_DEVICE_INTENCLR)Օڼ޽ */

/* -------- USB_HOST_INTENCLR : (USBψ:0x014) (R/W 16) HOST νĊ荞݋ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t :2;					/*!< ޯ 0` 1: \ */
    uint16_t HSOF:1;				/*!< ޯ     2:ν ڰъJn荞݋֎~ */
    uint16_t RST:1;					/*!< ޯ     3: ޽ ؾĊ荞݋֎~ */
    uint16_t WAKEUP:1;				/*!< ޯ     4: N荞݋֎~ */
    uint16_t DNRSM:1;				/*!< ޯ     5: uւ̉ꊄ荞݋֎~ */
    uint16_t UPRSM:1;				/*!< ޯ     6: ȕĊJ荞݋֎~ */
    uint16_t RAMACER:1;				/*!< ޯ     7: RAM荞݋֎~ */
    uint16_t DCONN:1;				/*!< ޯ     8: uڑ荞݋֎~ */
    uint16_t DDISC:1;				/*!< ޯ     9: uؒf荞݋֎~ */
    uint16_t :6;					/*!< ޯ10`15: \ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint16_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_HOST_INTENCLR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_HOST_INTENCLR_OFFSET				0x014			/**< \brief (USB_HOST_INTENCLR offset)νĊ荞݋ */
#define USB_HOST_INTENCLR_RESETVALUE			0x0000			/**< \brief (USB_HOST_INTENCLR reset_value)νĊ荞݋ */

#define USB_HOST_INTENCLR_HSOF_Pos				2				/**< \brief (USB_HOST_INTENCLR)ν ڰъJn荞݋֎~ */
#define USB_HOST_INTENCLR_HSOF					(0x1u << USB_HOST_INTENCLR_HSOF_Pos)
#define USB_HOST_INTENCLR_RST_Pos				3				/**< \brief (USB_HOST_INTENCLR)޽ ؾĊ荞݋֎~ */
#define USB_HOST_INTENCLR_RST					(0x1u << USB_HOST_INTENCLR_RST_Pos)
#define USB_HOST_INTENCLR_WAKEUP_Pos				4				/**< \brief (USB_HOST_INTENCLR)N荞݋֎~ */
#define USB_HOST_INTENCLR_WAKEUP				(0x1u << USB_HOST_INTENCLR_WAKEUP_Pos)
#define USB_HOST_INTENCLR_DNRSM_Pos				5				/**< \brief (USB_HOST_INTENCLR)uւ̉ꊄ荞݋֎~ */
#define USB_HOST_INTENCLR_DNRSM					(0x1u << USB_HOST_INTENCLR_DNRSM_Pos)
#define USB_HOST_INTENCLR_UPRSM_Pos				6				/**< \brief (USB_HOST_INTENCLR)ȕĊJ荞݋֎~ */
#define USB_HOST_INTENCLR_UPRSM					(0x1u << USB_HOST_INTENCLR_UPRSM_Pos)
#define USB_HOST_INTENCLR_RAMACER_Pos			7				/**< \brief (USB_HOST_INTENCLR)RAM荞݋֎~ */
#define USB_HOST_INTENCLR_RAMACER				(0x1u << USB_HOST_INTENCLR_RAMACER_Pos)
#define USB_HOST_INTENCLR_DCONN_Pos				8				/**< \brief (USB_HOST_INTENCLR)uڑ荞݋֎~ */
#define USB_HOST_INTENCLR_DCONN					(0x1u << USB_HOST_INTENCLR_DCONN_Pos)
#define USB_HOST_INTENCLR_DDISC_Pos				9				/**< \brief (USB_HOST_INTENCLR)uؒf荞݋֎~ */
#define USB_HOST_INTENCLR_DDISC					(0x1u << USB_HOST_INTENCLR_DDISC_Pos)
#define USB_HOST_INTENCLR_MASK					0x03FCu			/**< \brief (USB_HOST_INTENCLR)Օڼ޽ */

/* -------- USB_DEVICE_INTENSET : (USBψ:0x018) (R/W 16) DEVICE u荞݋ݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t SUSPEND:1;				/*!< ޯ     0: x~荞݋ */
    uint16_t MSOF:1;				/*!< ޯ     1: ϲ ڰъJn荞݋ */
    uint16_t SOF:1;					/*!< ޯ     2: ڰъJn荞݋ */
    uint16_t EORST:1;				/*!< ޯ     3: ؾďI荞݋ */
    uint16_t WAKEUP:1;				/*!< ޯ     4: N荞݋ */
    uint16_t EORSM:1;				/*!< ޯ     5: ĊJI荞݋ */
    uint16_t UPRSM:1;				/*!< ޯ     6: ĊJ荞݋ */
    uint16_t RAMACER:1;				/*!< ޯ     7: RAM荞݋ */
    uint16_t LPMNYET:1;				/*!< ޯ     8: ڑd͊ǗȂ荞݋ */
    uint16_t LPMSUSP:1;				/*!< ޯ     9: ڑd͊Ǘx~荞݋ */
    uint16_t :6;					/*!< ޯ10`15: \ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint16_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_DEVICE_INTENSET_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_DEVICE_INTENSET_OFFSET				0x018			/**< \brief (USB_DEVICE_INTENSET offset)u荞݋ݒ */
#define USB_DEVICE_INTENSET_RESETVALUE			0x0000			/**< \brief (USB_DEVICE_INTENSET reset_value)u荞݋ݒ */

#define USB_DEVICE_INTENSET_SUSPEND_Pos			0				/**< \brief (USB_DEVICE_INTENSET)x~荞݋ */
#define USB_DEVICE_INTENSET_SUSPEND				(0x1u << USB_DEVICE_INTENSET_SUSPEND_Pos)
#define USB_DEVICE_INTENSET_MSOF_Pos			1				/**< \brief (USB_DEVICE_INTENSET)ϲ ڰъJn荞݋ */
#define USB_DEVICE_INTENSET_MSOF				(0x1u << USB_DEVICE_INTENSET_MSOF_Pos)
#define USB_DEVICE_INTENSET_SOF_Pos				2				/**< \brief (USB_DEVICE_INTENSET)ڰъJn荞݋ */
#define USB_DEVICE_INTENSET_SOF					(0x1u << USB_DEVICE_INTENSET_SOF_Pos)
#define USB_DEVICE_INTENSET_EORST_Pos			3				/**< \brief (USB_DEVICE_INTENSET)ؾďI荞݋ */
#define USB_DEVICE_INTENSET_EORST				(0x1u << USB_DEVICE_INTENSET_EORST_Pos)
#define USB_DEVICE_INTENSET_WAKEUP_Pos			4				/**< \brief (USB_DEVICE_INTENSET)N荞݋ */
#define USB_DEVICE_INTENSET_WAKEUP				(0x1u << USB_DEVICE_INTENSET_WAKEUP_Pos)
#define USB_DEVICE_INTENSET_EORSM_Pos			5				/**< \brief (USB_DEVICE_INTENSET)ĊJI荞݋ */
#define USB_DEVICE_INTENSET_EORSM				(0x1u << USB_DEVICE_INTENSET_EORSM_Pos)
#define USB_DEVICE_INTENSET_UPRSM_Pos			6				/**< \brief (USB_DEVICE_INTENSET)ĊJ荞݋ */
#define USB_DEVICE_INTENSET_UPRSM				(0x1u << USB_DEVICE_INTENSET_UPRSM_Pos)
#define USB_DEVICE_INTENSET_RAMACER_Pos			7				/**< \brief (USB_DEVICE_INTENSET)RAM荞݋ */
#define USB_DEVICE_INTENSET_RAMACER				(0x1u << USB_DEVICE_INTENSET_RAMACER_Pos)
#define USB_DEVICE_INTENSET_LPMNYET_Pos			8				/**< \brief (USB_DEVICE_INTENSET)ڑd͊ǗȂ荞݋ */
#define USB_DEVICE_INTENSET_LPMNYET				(0x1u << USB_DEVICE_INTENSET_LPMNYET_Pos)
#define USB_DEVICE_INTENSET_LPMSUSP_Pos			9				/**< \brief (USB_DEVICE_INTENSET)ڑd͊Ǘx~荞݋ */
#define USB_DEVICE_INTENSET_LPMSUSP				(0x1u << USB_DEVICE_INTENSET_LPMSUSP_Pos)
#define USB_DEVICE_INTENSET_MASK				0x03FFu			/**< \brief (USB_DEVICE_INTENSET)Օڼ޽ */

/* -------- USB_HOST_INTENSET : (USBψ:0x018) (R/W 16) HOST νĊ荞݋ݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t :2;					/*!< ޯ 0` 1: \ */
    uint16_t HSOF:1;				/*!< ޯ     2: ν ڰъJn荞݋ */
    uint16_t RST:1;					/*!< ޯ     3: ޽ ؾĊ荞݋ */
    uint16_t WAKEUP:1;				/*!< ޯ     4: N荞݋ */
    uint16_t DNRSM:1;				/*!< ޯ     5: uւ̉ꊄ荞݋ */
    uint16_t UPRSM:1;				/*!< ޯ     6: ȕĊJ荞݋ */
    uint16_t RAMACER:1;				/*!< ޯ     7: RAM荞݋ */
    uint16_t DCONN:1;				/*!< ޯ     8: ڑd͊Ǘ荞݋ */
    uint16_t DDISC:1;				/*!< ޯ     9: uؒf荞݋ */
    uint16_t :6;					/*!< ޯ10`15: \ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint16_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_HOST_INTENSET_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_HOST_INTENSET_OFFSET				0x018			/**< \brief (USB_HOST_INTENSET offset)νĊ荞݋ݒ */
#define USB_HOST_INTENSET_RESETVALUE			0x0000			/**< \brief (USB_HOST_INTENSET reset_value)νĊ荞݋ݒ */

#define USB_HOST_INTENSET_HSOF_Pos				2				/**< \brief (USB_HOST_INTENSET)ν ڰъJn荞݋ */
#define USB_HOST_INTENSET_HSOF					(0x1u << USB_HOST_INTENSET_HSOF_Pos)
#define USB_HOST_INTENSET_RST_Pos				3				/**< \brief (USB_HOST_INTENSET)޽ ؾĊ荞݋ */
#define USB_HOST_INTENSET_RST					(0x1u << USB_HOST_INTENSET_RST_Pos)
#define USB_HOST_INTENSET_WAKEUP_Pos			4				/**< \brief (USB_HOST_INTENSET)N荞݋ */
#define USB_HOST_INTENSET_WAKEUP				(0x1u << USB_HOST_INTENSET_WAKEUP_Pos)
#define USB_HOST_INTENSET_DNRSM_Pos				5				/**< \brief (USB_HOST_INTENSET)uւ̉ꊄ荞݋ */
#define USB_HOST_INTENSET_DNRSM					(0x1u << USB_HOST_INTENSET_DNRSM_Pos)
#define USB_HOST_INTENSET_UPRSM_Pos				6				/**< \brief (USB_HOST_INTENSET)ȕĊJ荞݋ */
#define USB_HOST_INTENSET_UPRSM					(0x1u << USB_HOST_INTENSET_UPRSM_Pos)
#define USB_HOST_INTENSET_RAMACER_Pos			7				/**< \brief (USB_HOST_INTENSET)RAM荞݋ */
#define USB_HOST_INTENSET_RAMACER				(0x1u << USB_HOST_INTENSET_RAMACER_Pos)
#define USB_HOST_INTENSET_DCONN_Pos				8				/**< \brief (USB_HOST_INTENSET)ڑd͊Ǘ荞݋ */
#define USB_HOST_INTENSET_DCONN					(0x1u << USB_HOST_INTENSET_DCONN_Pos)
#define USB_HOST_INTENSET_DDISC_Pos				9				/**< \brief (USB_HOST_INTENSET)uؒf荞݋ */
#define USB_HOST_INTENSET_DDISC					(0x1u << USB_HOST_INTENSET_DDISC_Pos)
#define USB_HOST_INTENSET_MASK					0x03FCu			/**< \brief (USB_HOST_INTENSET)Օڼ޽ */

/* -------- USB_DEVICE_INTFLAG : (USBψ:0x01C) (R/W 16) DEVICE u荞׸ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t SUSPEND:1;				/*!< ޯ     0: x~ */
    uint16_t MSOF:1;				/*!< ޯ     1: łϲ ڰъJn */
    uint16_t SOF:1;					/*!< ޯ     2: ڰъJn */
    uint16_t EORST:1;				/*!< ޯ     3: ؾďI */
    uint16_t WAKEUP:1;				/*!< ޯ     4: N */
    uint16_t EORSM:1;				/*!< ޯ     5: ĊJI */
    uint16_t UPRSM:1;				/*!< ޯ     6: ĊJ */
    uint16_t RAMACER:1;				/*!< ޯ     7: RAM */
    uint16_t LPMNYET:1;				/*!< ޯ     8: ڑd͊ǗȂ */
    uint16_t LPMSUSP:1;				/*!< ޯ     9: ڑd͊Ǘx~ */
    uint16_t :6;					/*!< ޯ10`15: \ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint16_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_DEVICE_INTFLAG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_DEVICE_INTFLAG_OFFSET				0x01C			/**< \brief (USB_DEVICE_INTFLAG offset)u荞׸ */
#define USB_DEVICE_INTFLAG_RESETVALUE			0x0000			/**< \brief (USB_DEVICE_INTFLAG reset_value)u荞׸ */

#define USB_DEVICE_INTFLAG_SUSPEND_Pos			0				/**< \brief (USB_DEVICE_INTFLAG)x~ */
#define USB_DEVICE_INTFLAG_SUSPEND				(0x1u << USB_DEVICE_INTFLAG_SUSPEND_Pos)
#define USB_DEVICE_INTFLAG_MSOF_Pos				1				/**< \brief (USB_DEVICE_INTFLAG)łϲ ڰъJn */
#define USB_DEVICE_INTFLAG_MSOF					(0x1u << USB_DEVICE_INTFLAG_MSOF_Pos)
#define USB_DEVICE_INTFLAG_SOF_Pos				2				/**< \brief (USB_DEVICE_INTFLAG)ڰъJn */
#define USB_DEVICE_INTFLAG_SOF					(0x1u << USB_DEVICE_INTFLAG_SOF_Pos)
#define USB_DEVICE_INTFLAG_EORST_Pos			3				/**< \brief (USB_DEVICE_INTFLAG)ؾďI */
#define USB_DEVICE_INTFLAG_EORST				(0x1u << USB_DEVICE_INTFLAG_EORST_Pos)
#define USB_DEVICE_INTFLAG_WAKEUP_Pos			4				/**< \brief (USB_DEVICE_INTFLAG)N */
#define USB_DEVICE_INTFLAG_WAKEUP				(0x1u << USB_DEVICE_INTFLAG_WAKEUP_Pos)
#define USB_DEVICE_INTFLAG_EORSM_Pos			5				/**< \brief (USB_DEVICE_INTFLAG)ĊJI */
#define USB_DEVICE_INTFLAG_EORSM				(0x1u << USB_DEVICE_INTFLAG_EORSM_Pos)
#define USB_DEVICE_INTFLAG_UPRSM_Pos			6				/**< \brief (USB_DEVICE_INTFLAG)ĊJ */
#define USB_DEVICE_INTFLAG_UPRSM				(0x1u << USB_DEVICE_INTFLAG_UPRSM_Pos)
#define USB_DEVICE_INTFLAG_RAMACER_Pos			7				/**< \brief (USB_DEVICE_INTFLAG)RAM */
#define USB_DEVICE_INTFLAG_RAMACER				(0x1u << USB_DEVICE_INTFLAG_RAMACER_Pos)
#define USB_DEVICE_INTFLAG_LPMNYET_Pos			8				/**< \brief (USB_DEVICE_INTFLAG)ڑd͊ǗȂ */
#define USB_DEVICE_INTFLAG_LPMNYET				(0x1u << USB_DEVICE_INTFLAG_LPMNYET_Pos)
#define USB_DEVICE_INTFLAG_LPMSUSP_Pos			9				/**< \brief (USB_DEVICE_INTFLAG)ڑd͊Ǘx~ */
#define USB_DEVICE_INTFLAG_LPMSUSP				(0x1u << USB_DEVICE_INTFLAG_LPMSUSP_Pos)
#define USB_DEVICE_INTFLAG_MASK					0x03FFu			/**< \brief (USB_DEVICE_INTFLAG)Օڼ޽ */

/* -------- USB_HOST_INTFLAG : (USBψ:0x01C) (R/W 16) HOST νĊ荞׸ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t :2;					/*!< ޯ 0` 1: \ */
    uint16_t HSOF:1;				/*!< ޯ     2: ν ڰъJn */
    uint16_t RST:1;					/*!< ޯ     3: ޽ ؾ */
    uint16_t WAKEUP:1;				/*!< ޯ     4: N */
    uint16_t DNRSM:1;				/*!< ޯ     5:  */
    uint16_t UPRSM:1;				/*!< ޯ     6: ȕĊJ */
    uint16_t RAMACER:1;				/*!< ޯ     7: RAM */
    uint16_t DCONN:1;				/*!< ޯ     8: uڑ */
    uint16_t DDISC:1;				/*!< ޯ     9: uؒf */
    uint16_t :6;					/*!< ޯ10`15: \ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint16_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_HOST_INTFLAG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_HOST_INTFLAG_OFFSET					0x01C			/**< \brief (USB_HOST_INTFLAG offset)νĊ荞׸ */
#define USB_HOST_INTFLAG_RESETVALUE				0x0000			/**< \brief (USB_HOST_INTFLAG reset_value)νĊ荞׸ */

#define USB_HOST_INTFLAG_HSOF_Pos				2				/**< \brief (USB_HOST_INTFLAG)ν ڰъJn */
#define USB_HOST_INTFLAG_HSOF					(0x1u << USB_HOST_INTFLAG_HSOF_Pos)
#define USB_HOST_INTFLAG_RST_Pos				3				/**< \brief (USB_HOST_INTFLAG)޽ ؾ */
#define USB_HOST_INTFLAG_RST					(0x1u << USB_HOST_INTFLAG_RST_Pos)
#define USB_HOST_INTFLAG_WAKEUP_Pos				4				/**< \brief (USB_HOST_INTFLAG)N */
#define USB_HOST_INTFLAG_WAKEUP					(0x1u << USB_HOST_INTFLAG_WAKEUP_Pos)
#define USB_HOST_INTFLAG_DNRSM_Pos				5				/**< \brief (USB_HOST_INTFLAG) */
#define USB_HOST_INTFLAG_DNRSM					(0x1u << USB_HOST_INTFLAG_DNRSM_Pos)
#define USB_HOST_INTFLAG_UPRSM_Pos				6				/**< \brief (USB_HOST_INTFLAG)ȕĊJ */
#define USB_HOST_INTFLAG_UPRSM					(0x1u << USB_HOST_INTFLAG_UPRSM_Pos)
#define USB_HOST_INTFLAG_RAMACER_Pos			7				/**< \brief (USB_HOST_INTFLAG)RAM */
#define USB_HOST_INTFLAG_RAMACER				(0x1u << USB_HOST_INTFLAG_RAMACER_Pos)
#define USB_HOST_INTFLAG_DCONN_Pos				8				/**< \brief (USB_HOST_INTFLAG)uڑ */
#define USB_HOST_INTFLAG_DCONN					(0x1u << USB_HOST_INTFLAG_DCONN_Pos)
#define USB_HOST_INTFLAG_DDISC_Pos				9				/**< \brief (USB_HOST_INTFLAG)uؒf */
#define USB_HOST_INTFLAG_DDISC					(0x1u << USB_HOST_INTFLAG_DDISC_Pos)
#define USB_HOST_INTFLAG_MASK					0x03FCu			/**< \brief (USB_HOST_INTFLAG)Օڼ޽ */

/* -------- USB_DEVICE_EPINTSMRY : (USBψ:0x020) (R/  16) DEVICE u߲Ċ荞ݗv -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t EPINT0:1;				/*!< ޯ    0: ߲0荞 */
    uint16_t EPINT1:1;				/*!< ޯ    1: ߲1荞 */
    uint16_t EPINT2:1;				/*!< ޯ    2: ߲2荞 */
    uint16_t EPINT3:1;				/*!< ޯ    3: ߲3荞 */
    uint16_t EPINT4:1;				/*!< ޯ    4: ߲4荞 */
    uint16_t EPINT5:1;				/*!< ޯ    5: ߲5荞 */
    uint16_t EPINT6:1;				/*!< ޯ    6: ߲6荞 */
    uint16_t EPINT7:1;				/*!< ޯ    7: ߲7荞 */
    uint16_t :8;					/*!< ޯ8`15: \ */
  } bit;							/*!< ޯ Ɏgp\ */
  struct {
    uint16_t EPINT:8;				/*!< ޯ 0` 7 ߲x荞 */
    uint16_t :8;					/*!< ޯ 8`15 \ */
  } vec;							/*!< ޸ Ɏgp\ */
  uint16_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_DEVICE_EPINTSMRY_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_DEVICE_EPINTSMRY_OFFSET				0x020			/**< \brief (USB_DEVICE_EPINTSMRY offset)u߲Ċ荞ݗv */
#define USB_DEVICE_EPINTSMRY_RESETVALUE			0x0000			/**< \brief (USB_DEVICE_EPINTSMRY reset_value)u߲Ċ荞ݗv */

#define USB_DEVICE_EPINTSMRY_EPINT0_Pos			0				/**< \brief (USB_DEVICE_EPINTSMRY)߲0荞 */
#define USB_DEVICE_EPINTSMRY_EPINT0				(1 << USB_DEVICE_EPINTSMRY_EPINT0_Pos)
#define USB_DEVICE_EPINTSMRY_EPINT1_Pos			1				/**< \brief (USB_DEVICE_EPINTSMRY)߲1荞 */
#define USB_DEVICE_EPINTSMRY_EPINT1				(1 << USB_DEVICE_EPINTSMRY_EPINT1_Pos)
#define USB_DEVICE_EPINTSMRY_EPINT2_Pos			2				/**< \brief (USB_DEVICE_EPINTSMRY)߲2荞 */
#define USB_DEVICE_EPINTSMRY_EPINT2				(1 << USB_DEVICE_EPINTSMRY_EPINT2_Pos)
#define USB_DEVICE_EPINTSMRY_EPINT3_Pos			3				/**< \brief (USB_DEVICE_EPINTSMRY)߲3荞 */
#define USB_DEVICE_EPINTSMRY_EPINT3				(1 << USB_DEVICE_EPINTSMRY_EPINT3_Pos)
#define USB_DEVICE_EPINTSMRY_EPINT4_Pos			4				/**< \brief (USB_DEVICE_EPINTSMRY)߲4荞 */
#define USB_DEVICE_EPINTSMRY_EPINT4				(1 << USB_DEVICE_EPINTSMRY_EPINT4_Pos)
#define USB_DEVICE_EPINTSMRY_EPINT5_Pos			5				/**< \brief (USB_DEVICE_EPINTSMRY)߲5荞 */
#define USB_DEVICE_EPINTSMRY_EPINT5				(1 << USB_DEVICE_EPINTSMRY_EPINT5_Pos)
#define USB_DEVICE_EPINTSMRY_EPINT6_Pos			6				/**< \brief (USB_DEVICE_EPINTSMRY)߲6荞 */
#define USB_DEVICE_EPINTSMRY_EPINT6				(1 << USB_DEVICE_EPINTSMRY_EPINT6_Pos)
#define USB_DEVICE_EPINTSMRY_EPINT7_Pos			7				/**< \brief (USB_DEVICE_EPINTSMRY)߲7荞 */
#define USB_DEVICE_EPINTSMRY_EPINT7				(1 << USB_DEVICE_EPINTSMRY_EPINT7_Pos)
#define USB_DEVICE_EPINTSMRY_EPINT_Pos			0				/**< \brief (USB_DEVICE_EPINTSMRY)߲x荞 */
#define USB_DEVICE_EPINTSMRY_EPINT_Msk			(0xFFu << USB_DEVICE_EPINTSMRY_EPINT_Pos)
#define USB_DEVICE_EPINTSMRY_EPINT(value)		((USB_DEVICE_EPINTSMRY_EPINT_Msk & ((value) << USB_DEVICE_EPINTSMRY_EPINT_Pos)))
#define USB_DEVICE_EPINTSMRY_MASK				0x00FFu			/**< \brief (USB_DEVICE_EPINTSMRY)Օڼ޽ */

/* -------- USB_HOST_PINTSMRY : (USBψ:0x020) (R/  16) HOST ν ߲ߊ荞ݗv -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t EPINT0:1;				/*!< ޯ    0:  ߲0荞 */
    uint16_t EPINT1:1;				/*!< ޯ    1:  ߲1荞 */
    uint16_t EPINT2:1;				/*!< ޯ    2:  ߲2荞 */
    uint16_t EPINT3:1;				/*!< ޯ    3:  ߲3荞 */
    uint16_t EPINT4:1;				/*!< ޯ    4:  ߲4荞 */
    uint16_t EPINT5:1;				/*!< ޯ    5:  ߲5荞 */
    uint16_t EPINT6:1;				/*!< ޯ    6:  ߲6荞 */
    uint16_t EPINT7:1;				/*!< ޯ    7:  ߲7荞 */
    uint16_t :8;					/*!< ޯ8`15: \ */
  } bit;							/*!< ޯ Ɏgp\ */
  struct {
    uint16_t EPINT:8;				/*!< ޯ 0` 7  ߲x荞 */
    uint16_t :8;					/*!< ޯ 8`15 \ */
  } vec;							/*!< ޸ Ɏgp\ */
  uint16_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_HOST_PINTSMRY_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_HOST_PINTSMRY_OFFSET				0x020			/**< \brief (USB_HOST_PINTSMRY offset)ν ߲ߊ荞ݗv */
#define USB_HOST_PINTSMRY_RESETVALUE			0x0000			/**< \brief (USB_HOST_PINTSMRY reset_value)ν ߲ߊ荞ݗv */

#define USB_HOST_PINTSMRY_EPINT0_Pos			0				/**< \brief (USB_HOST_PINTSMRY)߲0荞 */
#define USB_HOST_PINTSMRY_EPINT0				(1 << USB_HOST_PINTSMRY_EPINT0_Pos)
#define USB_HOST_PINTSMRY_EPINT1_Pos			1				/**< \brief (USB_HOST_PINTSMRY)߲1荞 */
#define USB_HOST_PINTSMRY_EPINT1				(1 << USB_HOST_PINTSMRY_EPINT1_Pos)
#define USB_HOST_PINTSMRY_EPINT2_Pos			2				/**< \brief (USB_HOST_PINTSMRY)߲2荞 */
#define USB_HOST_PINTSMRY_EPINT2				(1 << USB_HOST_PINTSMRY_EPINT2_Pos)
#define USB_HOST_PINTSMRY_EPINT3_Pos			3				/**< \brief (USB_HOST_PINTSMRY)߲3荞 */
#define USB_HOST_PINTSMRY_EPINT3				(1 << USB_HOST_PINTSMRY_EPINT3_Pos)
#define USB_HOST_PINTSMRY_EPINT4_Pos			4				/**< \brief (USB_HOST_PINTSMRY)߲4荞 */
#define USB_HOST_PINTSMRY_EPINT4				(1 << USB_HOST_PINTSMRY_EPINT4_Pos)
#define USB_HOST_PINTSMRY_EPINT5_Pos			5				/**< \brief (USB_HOST_PINTSMRY)߲5荞 */
#define USB_HOST_PINTSMRY_EPINT5				(1 << USB_HOST_PINTSMRY_EPINT5_Pos)
#define USB_HOST_PINTSMRY_EPINT6_Pos			6				/**< \brief (USB_HOST_PINTSMRY)߲6荞 */
#define USB_HOST_PINTSMRY_EPINT6				(1 << USB_HOST_PINTSMRY_EPINT6_Pos)
#define USB_HOST_PINTSMRY_EPINT7_Pos			7				/**< \brief (USB_HOST_PINTSMRY)߲7荞 */
#define USB_HOST_PINTSMRY_EPINT7				(1 << USB_HOST_PINTSMRY_EPINT7_Pos)
#define USB_HOST_PINTSMRY_EPINT_Pos				0				/**< \brief (USB_HOST_PINTSMRY)߲x荞 */
#define USB_HOST_PINTSMRY_EPINT_Msk				(0xFFu << USB_HOST_PINTSMRY_EPINT_Pos)
#define USB_HOST_PINTSMRY_EPINT(value)			((USB_HOST_PINTSMRY_EPINT_Msk & ((value) << USB_HOST_PINTSMRY_EPINT_Pos)))
#define USB_HOST_PINTSMRY_MASK					0x00FFu			/**< \brief (USB_HOST_PINTSMRY)Օڼ޽ */

/* -------- USB_DESCADD : (USBψ:0x024) (R/W 32)Lqqڽ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t DESCADD:32;			/*!< ޯ0`31: Lqqڽl */
  } bit;							/*!< ޯ Ɏgp\ */
  uint32_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_DESCADD_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_DESCADD_OFFSET						0x024			/**< \brief (USB_DESCADD offset)Lqqڽ */
#define USB_DESCADD_RESETVALUE					0x00000000		/**< \brief (USB_DESCADD reset_value)Lqqڽ */

#define USB_DESCADD_DESCADD_Pos					0				/**< \brief (USB_DESCADD)Lqqڽl */
#define USB_DESCADD_DESCADD_Msk					(0xFFFFFFFFu << USB_DESCADD_DESCADD_Pos)
#define USB_DESCADD_DESCADD(value)				((USB_DESCADD_DESCADD_Msk & ((value) << USB_DESCADD_DESCADD_Pos)))
#define USB_DESCADD_MASK						0xFFFFFFFFu		/**< \brief (USB_DESCADD)Օڼ޽ */

/* -------- USB_PADCAL : (USBψ:0x028) (R/W 16)USB߯ލZ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t TRANSP:5;				/*!< ޯ 0` 4: USB߯ޕϊPZ */
    uint16_t :1;					/*!< ޯ     5: \ */
    uint16_t TRANSN:5;				/*!< ޯ 6`10: USB߯ޕϊNZ */
    uint16_t :1;					/*!< ޯ    11: \ */
    uint16_t TRIM:3;				/*!< ޯ12`14: USB߯ޒZ */
    uint16_t :1;					/*!< ޯ    15: \ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint16_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_PADCAL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_PADCAL_OFFSET						0x028			/**< \brief (USB_PADCAL offset)USB߯ލZ */
#define USB_PADCAL_RESETVALUE					0x0000			/**< \brief (USB_PADCAL reset_value)USB߯ލZ */

#define USB_PADCAL_TRANSP_Pos					0				/**< \brief (USB_PADCAL)USB߯ޕϊPZ */
#define USB_PADCAL_TRANSP_Msk					(0x1Fu << USB_PADCAL_TRANSP_Pos)
#define USB_PADCAL_TRANSP(value)				((USB_PADCAL_TRANSP_Msk & ((value) << USB_PADCAL_TRANSP_Pos)))
#define USB_PADCAL_TRANSN_Pos					6				/**< \brief (USB_PADCAL)USB߯ޕϊNZ */
#define USB_PADCAL_TRANSN_Msk					(0x1Fu << USB_PADCAL_TRANSN_Pos)
#define USB_PADCAL_TRANSN(value)				((USB_PADCAL_TRANSN_Msk & ((value) << USB_PADCAL_TRANSN_Pos)))
#define USB_PADCAL_TRIM_Pos						12				/**< \brief (USB_PADCAL)USB߯ޒZ */
#define USB_PADCAL_TRIM_Msk						(0x7u << USB_PADCAL_TRIM_Pos)
#define USB_PADCAL_TRIM(value)					((USB_PADCAL_TRIM_Msk & ((value) << USB_PADCAL_TRIM_Pos)))
#define USB_PADCAL_MASK							0x77DFu			/**< \brief (USB_PADCAL)Օڼ޽ */

/* -------- USB_DEVICE_EPCFG : (USBψ:0x100) (R/W  8) DEVICE DEVICE_ENDPOINT߲Č`Ԑݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  EPTYPE0:3;				/*!< ޯ0`2: ߲Č^0 */
    uint8_t  :1;					/*!< ޯ   3: \ */
    uint8_t  EPTYPE1:3;				/*!< ޯ4`6: ߲Č^1 */
    uint8_t  NYETDIS:1;				/*!< ޯ   7: NYETʕ[֎~ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint8_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_DEVICE_EPCFG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_DEVICE_EPCFG_OFFSET					0x100			/**< \brief (USB_DEVICE_EPCFG offset DEVICE_ENDPOINT߲Č`Ԑݒ */
#define USB_DEVICE_EPCFG_RESETVALUE				0x00			/**< \brief (USB_DEVICE_EPCFG reset_value)DEVICE_ENDPOINT߲Č`Ԑݒ */

#define USB_DEVICE_EPCFG_EPTYPE0_Pos			0				/**< \brief (USB_DEVICE_EPCFG)߲Č^0 */
#define USB_DEVICE_EPCFG_EPTYPE0_Msk			(0x7u << USB_DEVICE_EPCFG_EPTYPE0_Pos)
#define USB_DEVICE_EPCFG_EPTYPE0(value)			((USB_DEVICE_EPCFG_EPTYPE0_Msk & ((value) << USB_DEVICE_EPCFG_EPTYPE0_Pos)))
#define USB_DEVICE_EPCFG_EPTYPE1_Pos			4				/**< \brief (USB_DEVICE_EPCFG)߲Č^1 */
#define USB_DEVICE_EPCFG_EPTYPE1_Msk			(0x7u << USB_DEVICE_EPCFG_EPTYPE1_Pos)
#define USB_DEVICE_EPCFG_EPTYPE1(value)			((USB_DEVICE_EPCFG_EPTYPE1_Msk & ((value) << USB_DEVICE_EPCFG_EPTYPE1_Pos)))
#define USB_DEVICE_EPCFG_NYETDIS_Pos			7				/**< \brief (USB_DEVICE_EPCFG)NYETʕ[֎~ */
#define USB_DEVICE_EPCFG_NYETDIS				(0x1u << USB_DEVICE_EPCFG_NYETDIS_Pos)
#define USB_DEVICE_EPCFG_MASK					0xF7u			/**< \brief (USB_DEVICE_EPCFG)Օڼ޽ */

/* -------- USB_HOST_PCFG : (USBψ:0x100) (R/W  8) HOST HOST_PIPE߲Č`Ԑݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  PTOKEN:2;				/*!< ޯ0`1: ߲ߒʕ[ */
    uint8_t  BK:1;					/*!< ޯ   2: ߲ ݸ */
    uint8_t  PTYPE:3;				/*!< ޯ3`5: ߲ߌ^ */
    uint8_t  :2;					/*!< ޯ6`7: \ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint8_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_HOST_PCFG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_HOST_PCFG_OFFSET					0x100			/**< \brief (USB_HOST_PCFG offset)HOST_PIPE߲Č`Ԑݒ */
#define USB_HOST_PCFG_RESETVALUE				0x00			/**< \brief (USB_HOST_PCFG reset_value)HOST_PIPE߲Č`Ԑݒ */

#define USB_HOST_PCFG_PTOKEN_Pos				0				/**< \brief (USB_HOST_PCFG)߲ߒʕ[ */
#define USB_HOST_PCFG_PTOKEN_Msk				(0x3u << USB_HOST_PCFG_PTOKEN_Pos)
#define USB_HOST_PCFG_PTOKEN(value)				((USB_HOST_PCFG_PTOKEN_Msk & ((value) << USB_HOST_PCFG_PTOKEN_Pos)))
#define USB_HOST_PCFG_BK_Pos					2				/**< \brief (USB_HOST_PCFG)߲ ݸ */
#define USB_HOST_PCFG_BK						(0x1u << USB_HOST_PCFG_BK_Pos)
#define USB_HOST_PCFG_PTYPE_Pos					3				/**< \brief (USB_HOST_PCFG)߲ߌ^ */
#define USB_HOST_PCFG_PTYPE_Msk					(0x7u << USB_HOST_PCFG_PTYPE_Pos)
#define USB_HOST_PCFG_PTYPE(value)				((USB_HOST_PCFG_PTYPE_Msk & ((value) << USB_HOST_PCFG_PTYPE_Pos)))
#define USB_HOST_PCFG_MASK						0x3Fu			/**< \brief (USB_HOST_PCFG)Օڼ޽ */

/* -------- USB_HOST_BINTERVAL : (USBψ:0x103) (R/W  8) HOST HOST_PIPE߲߂޽ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  BITINTERVAL:8;		/*!< ޯ0`7: ޯĊԊu */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} USB_HOST_BINTERVAL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_HOST_BINTERVAL_OFFSET					0x103			/**< \brief (USB_HOST_BINTERVAL offset)HOST_PIPE߲߂޽ */
#define USB_HOST_BINTERVAL_RESETVALUE				0x00			/**< \brief (USB_HOST_BINTERVAL reset_value)HOST_PIPE߲߂޽ */

#define USB_HOST_BINTERVAL_BITINTERVAL_Pos			0				/**< \brief (USB_HOST_BINTERVAL)ޯĊԊu */
#define USB_HOST_BINTERVAL_BITINTERVAL_Msk			(0xFFu << USB_HOST_BINTERVAL_BITINTERVAL_Pos)
#define USB_HOST_BINTERVAL_BITINTERVAL(value)		((USB_HOST_BINTERVAL_BITINTERVAL_Msk & ((value) << USB_HOST_BINTERVAL_BITINTERVAL_Pos)))
#define USB_HOST_BINTERVAL_MASK						0xFFu			/**< \brief (USB_HOST_BINTERVAL)Օڼ޽ */

/* -------- USB_DEVICE_EPSTATUSCLR : (USBψ:0x104) ( /W  8) DEVICE DEVICE_ENDPOINT߲ ߲ߏԉ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  DTGLOUT:1;				/*!< ޯ   0: ްݐ؂ւOUT */
    uint8_t  DTGLIN:1;				/*!< ޯ   1: ްݐ؂ւIN */
    uint8_t  CURBK:1;				/*!< ޯ   2: ݸ */
    uint8_t  :1;					/*!< ޯ   3: \ */
    uint8_t  STALLRQ:2;				/*!< ޯ4`5: ~v */
    uint8_t  BK0RDY:1;				/*!< ޯ   6: ݸ0 */
    uint8_t  BK1RDY:1;				/*!< ޯ   7: ݸ1 */
  } bit;							/*!< ޯ Ɏgp\ */
  uint8_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_DEVICE_EPSTATUSCLR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_DEVICE_EPSTATUSCLR_OFFSET				0x104			/**< \brief (USB_DEVICE_EPSTATUSCLR offset)DEVICE_ENDPOINT߲ ߲ߏԉ */
#define USB_DEVICE_EPSTATUSCLR_RESETVALUE			0x00			/**< \brief (USB_DEVICE_EPSTATUSCLR reset_value)DEVICE_ENDPOINT߲ ߲ߏԉ */

#define USB_DEVICE_EPSTATUSCLR_DTGLOUT_Pos			0				/**< \brief (USB_DEVICE_EPSTATUSCLR)ްݐ؂ւOUT */
#define USB_DEVICE_EPSTATUSCLR_DTGLOUT				(0x1u << USB_DEVICE_EPSTATUSCLR_DTGLOUT_Pos)
#define USB_DEVICE_EPSTATUSCLR_DTGLIN_Pos			1				/**< \brief (USB_DEVICE_EPSTATUSCLR)ްݐ؂ւIN */
#define USB_DEVICE_EPSTATUSCLR_DTGLIN				(0x1u << USB_DEVICE_EPSTATUSCLR_DTGLIN_Pos)
#define USB_DEVICE_EPSTATUSCLR_CURBK_Pos			2				/**< \brief (USB_DEVICE_EPSTATUSCLR)ݸ */
#define USB_DEVICE_EPSTATUSCLR_CURBK				(0x1u << USB_DEVICE_EPSTATUSCLR_CURBK_Pos)
#define USB_DEVICE_EPSTATUSCLR_STALLRQ_Pos			4				/**< \brief (USB_DEVICE_EPSTATUSCLR)~v */
#define USB_DEVICE_EPSTATUSCLR_STALLRQ_Msk			(0x3u << USB_DEVICE_EPSTATUSCLR_STALLRQ_Pos)
#define USB_DEVICE_EPSTATUSCLR_STALLRQ(value)		((USB_DEVICE_EPSTATUSCLR_STALLRQ_Msk & ((value) << USB_DEVICE_EPSTATUSCLR_STALLRQ_Pos)))
#define USB_DEVICE_EPSTATUSCLR_BK0RDY_Pos			6				/**< \brief (USB_DEVICE_EPSTATUSCLR)ݸ0 */
#define USB_DEVICE_EPSTATUSCLR_BK0RDY				(0x1u << USB_DEVICE_EPSTATUSCLR_BK0RDY_Pos)
#define USB_DEVICE_EPSTATUSCLR_BK1RDY_Pos			7				/**< \brief (USB_DEVICE_EPSTATUSCLR)ݸ1 */
#define USB_DEVICE_EPSTATUSCLR_BK1RDY				(0x1u << USB_DEVICE_EPSTATUSCLR_BK1RDY_Pos)
#define USB_DEVICE_EPSTATUSCLR_MASK					0xF7u			/**< \brief (USB_DEVICE_EPSTATUSCLR)Օڼ޽ */

/* -------- USB_HOST_PSTATUSCLR : (USBψ:0x104) ( /W  8) HOST HOST_PIPE߲ ߲ߏԉ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  DTGL:1;				/*!< ޯ0: ްݐ؂ւ */
    uint8_t  :1;					/*!< ޯ1: \ */
    uint8_t  CURBK:1;				/*!< ޯ2: ݸ */
    uint8_t  :1;					/*!< ޯ3: \ */
    uint8_t  PFREEZE:1;				/*!< ޯ4: ߲ߓ */
    uint8_t  :1;					/*!< ޯ5: \ */
    uint8_t  BK0RDY:1;				/*!< ޯ6: ݸ0 */
    uint8_t  BK1RDY:1;				/*!< ޯ7: ݸ1 */
  } bit;							/*!< ޯ Ɏgp\ */
  uint8_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_HOST_PSTATUSCLR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_HOST_PSTATUSCLR_OFFSET					0x104			/**< \brief (USB_HOST_PSTATUSCLR offset)HOST_PIPE߲ ߲ߏԉ */
#define USB_HOST_PSTATUSCLR_RESETVALUE				0x00			/**< \brief (USB_HOST_PSTATUSCLR reset_value)HOST_PIPE߲ ߲ߏԉ */

#define USB_HOST_PSTATUSCLR_DTGL_Pos				0				/**< \brief (USB_HOST_PSTATUSCLR)ްݐ؂ւ */
#define USB_HOST_PSTATUSCLR_DTGL					(0x1u << USB_HOST_PSTATUSCLR_DTGL_Pos)
#define USB_HOST_PSTATUSCLR_CURBK_Pos				2				/**< \brief (USB_HOST_PSTATUSCLR)ݸ */
#define USB_HOST_PSTATUSCLR_CURBK					(0x1u << USB_HOST_PSTATUSCLR_CURBK_Pos)
#define USB_HOST_PSTATUSCLR_PFREEZE_Pos				4				/**< \brief (USB_HOST_PSTATUSCLR)߲ߓ */
#define USB_HOST_PSTATUSCLR_PFREEZE					(0x1u << USB_HOST_PSTATUSCLR_PFREEZE_Pos)
#define USB_HOST_PSTATUSCLR_BK0RDY_Pos				6				/**< \brief (USB_HOST_PSTATUSCLR)ݸ0 */
#define USB_HOST_PSTATUSCLR_BK0RDY					(0x1u << USB_HOST_PSTATUSCLR_BK0RDY_Pos)
#define USB_HOST_PSTATUSCLR_BK1RDY_Pos				7				/**< \brief (USB_HOST_PSTATUSCLR)ݸ1 */
#define USB_HOST_PSTATUSCLR_BK1RDY					(0x1u << USB_HOST_PSTATUSCLR_BK1RDY_Pos)
#define USB_HOST_PSTATUSCLR_MASK					0xD5u			/**< \brief (USB_HOST_PSTATUSCLR)Օڼ޽ */

/* -------- USB_DEVICE_EPSTATUSSET : (USBψ:0x105) ( /W  8) DEVICE DEVICE_ENDPOINT߲ ߲ߏԐݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  DTGLOUT:1;				/*!< ޯ   0: ްݐ؂ւOUTݒ */
    uint8_t  DTGLIN:1;				/*!< ޯ   1: ްݐ؂ւINݒ */
    uint8_t  CURBK:1;				/*!< ޯ   2: ݸݒ */
    uint8_t  :1;					/*!< ޯ   3: \ */
    uint8_t  STALLRQ:2;				/*!< ޯ4`5: ~vݒ */
    uint8_t  BK0RDY:1;				/*!< ޯ   6: ݸ0ݒ */
    uint8_t  BK1RDY:1;				/*!< ޯ   7: ݸ1ݒ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint8_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_DEVICE_EPSTATUSSET_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_DEVICE_EPSTATUSSET_OFFSET				0x105			/**< \brief (USB_DEVICE_EPSTATUSSET offset)DEVICE_ENDPOINT߲ ߲ߏԐݒ */
#define USB_DEVICE_EPSTATUSSET_RESETVALUE			0x00			/**< \brief (USB_DEVICE_EPSTATUSSET reset_value)DEVICE_ENDPOINT߲ ߲ߏԐݒ */

#define USB_DEVICE_EPSTATUSSET_DTGLOUT_Pos			0				/**< \brief (USB_DEVICE_EPSTATUSSET)ްݐ؂ւOUTݒ */
#define USB_DEVICE_EPSTATUSSET_DTGLOUT				(0x1u << USB_DEVICE_EPSTATUSSET_DTGLOUT_Pos)
#define USB_DEVICE_EPSTATUSSET_DTGLIN_Pos			1				/**< \brief (USB_DEVICE_EPSTATUSSET)ްݐ؂ւINݒ */
#define USB_DEVICE_EPSTATUSSET_DTGLIN				(0x1u << USB_DEVICE_EPSTATUSSET_DTGLIN_Pos)
#define USB_DEVICE_EPSTATUSSET_CURBK_Pos			2				/**< \brief (USB_DEVICE_EPSTATUSSET)ݸݒ */
#define USB_DEVICE_EPSTATUSSET_CURBK				(0x1u << USB_DEVICE_EPSTATUSSET_CURBK_Pos)
#define USB_DEVICE_EPSTATUSSET_STALLRQ_Pos			4				/**< \brief (USB_DEVICE_EPSTATUSSET)~vݒ */
#define USB_DEVICE_EPSTATUSSET_STALLRQ_Msk			(0x3u << USB_DEVICE_EPSTATUSSET_STALLRQ_Pos)
#define USB_DEVICE_EPSTATUSSET_STALLRQ(value)		((USB_DEVICE_EPSTATUSSET_STALLRQ_Msk & ((value) << USB_DEVICE_EPSTATUSSET_STALLRQ_Pos)))
#define USB_DEVICE_EPSTATUSSET_BK0RDY_Pos			6				/**< \brief (USB_DEVICE_EPSTATUSSET)ݸ0ݒ */
#define USB_DEVICE_EPSTATUSSET_BK0RDY				(0x1u << USB_DEVICE_EPSTATUSSET_BK0RDY_Pos)
#define USB_DEVICE_EPSTATUSSET_BK1RDY_Pos			7				/**< \brief (USB_DEVICE_EPSTATUSSET)ݸ1ݒ */
#define USB_DEVICE_EPSTATUSSET_BK1RDY				(0x1u << USB_DEVICE_EPSTATUSSET_BK1RDY_Pos)
#define USB_DEVICE_EPSTATUSSET_MASK					0xF7u			/**< \brief (USB_DEVICE_EPSTATUSSET)Օڼ޽ */

/* -------- USB_HOST_PSTATUSSET : (USBψ:0x105) ( /W  8) HOST HOST_PIPE߲ ߲ߏԐݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  DTGL:1;				/*!< ޯ0: ްݐ؂ւݒ */
    uint8_t  :1;					/*!< ޯ1: \ */
    uint8_t  CURBK:1;				/*!< ޯ2: ݸݒ */
    uint8_t  :1;					/*!< ޯ3: \ */
    uint8_t  PFREEZE:1;				/*!< ޯ4: ߲ߓݒ */
    uint8_t  :1;					/*!< ޯ5: \ */
    uint8_t  BK0RDY:1;				/*!< ޯ6: ݸ0ݒ */
    uint8_t  BK1RDY:1;				/*!< ޯ7: ݸ1ݒ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint8_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_HOST_PSTATUSSET_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_HOST_PSTATUSSET_OFFSET					0x105			/**< \brief (USB_HOST_PSTATUSSET offset)HOST_PIPE߲ ߲ߏԐݒ */
#define USB_HOST_PSTATUSSET_RESETVALUE				0x00			/**< \brief (USB_HOST_PSTATUSSET reset_value)HOST_PIPE߲ ߲ߏԐݒ */

#define USB_HOST_PSTATUSSET_DTGL_Pos				0				/**< \brief (USB_HOST_PSTATUSSET)ްݐ؂ւݒ */
#define USB_HOST_PSTATUSSET_DTGL					(0x1u << USB_HOST_PSTATUSSET_DTGL_Pos)
#define USB_HOST_PSTATUSSET_CURBK_Pos				2				/**< \brief (USB_HOST_PSTATUSSET)ݸݒ */
#define USB_HOST_PSTATUSSET_CURBK					(0x1u << USB_HOST_PSTATUSSET_CURBK_Pos)
#define USB_HOST_PSTATUSSET_PFREEZE_Pos				4				/**< \brief (USB_HOST_PSTATUSSET)߲ߓݒ */
#define USB_HOST_PSTATUSSET_PFREEZE					(0x1u << USB_HOST_PSTATUSSET_PFREEZE_Pos)
#define USB_HOST_PSTATUSSET_BK0RDY_Pos				6				/**< \brief (USB_HOST_PSTATUSSET)ݸ0ݒ */
#define USB_HOST_PSTATUSSET_BK0RDY					(0x1u << USB_HOST_PSTATUSSET_BK0RDY_Pos)
#define USB_HOST_PSTATUSSET_BK1RDY_Pos				7				/**< \brief (USB_HOST_PSTATUSSET)ݸ1ݒ */
#define USB_HOST_PSTATUSSET_BK1RDY					(0x1u << USB_HOST_PSTATUSSET_BK1RDY_Pos)
#define USB_HOST_PSTATUSSET_MASK					0xD5u			/**< \brief (USB_HOST_PSTATUSSET)Օڼ޽ */

/* -------- USB_DEVICE_EPSTATUS : (USBψ:0x106) (R/   8) DEVICE DEVICE_ENDPOINT߲ ߲ߏ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  DTGLOUT:1;				/*!< ޯ   0: ްݐ؂ւOUT */
    uint8_t  DTGLIN:1;				/*!< ޯ   1: ްݐ؂ւIN */
    uint8_t  CURBK:1;				/*!< ޯ   2: ݸ */
    uint8_t  :1;					/*!< ޯ   3: \ */
    uint8_t  STALLRQ:2;				/*!< ޯ4`5: ~v */
    uint8_t  BK0RDY:1;				/*!< ޯ   6: ݸ0 */
    uint8_t  BK1RDY:1;				/*!< ޯ   7: ݸ1 */
  } bit;							/*!< ޯ Ɏgp\ */
  uint8_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_DEVICE_EPSTATUS_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_DEVICE_EPSTATUS_OFFSET					0x106			/**< \brief (USB_DEVICE_EPSTATUS offset)DEVICE_ENDPOINT߲ ߲ߏ */
#define USB_DEVICE_EPSTATUS_RESETVALUE				0x00			/**< \brief (USB_DEVICE_EPSTATUS reset_value)DEVICE_ENDPOINT߲ ߲ߏ */

#define USB_DEVICE_EPSTATUS_DTGLOUT_Pos				0				/**< \brief (USB_DEVICE_EPSTATUS)ްݐ؂ւOUT */
#define USB_DEVICE_EPSTATUS_DTGLOUT					(0x1u << USB_DEVICE_EPSTATUS_DTGLOUT_Pos)
#define USB_DEVICE_EPSTATUS_DTGLIN_Pos				1				/**< \brief (USB_DEVICE_EPSTATUS)ްݐ؂ւIN */
#define USB_DEVICE_EPSTATUS_DTGLIN					(0x1u << USB_DEVICE_EPSTATUS_DTGLIN_Pos)
#define USB_DEVICE_EPSTATUS_CURBK_Pos				2				/**< \brief (USB_DEVICE_EPSTATUS)ݸ */
#define USB_DEVICE_EPSTATUS_CURBK					(0x1u << USB_DEVICE_EPSTATUS_CURBK_Pos)
#define USB_DEVICE_EPSTATUS_STALLRQ_Pos				4				/**< \brief (USB_DEVICE_EPSTATUS)~v */
#define USB_DEVICE_EPSTATUS_STALLRQ_Msk				(0x3u << USB_DEVICE_EPSTATUS_STALLRQ_Pos)
#define USB_DEVICE_EPSTATUS_STALLRQ(value)			((USB_DEVICE_EPSTATUS_STALLRQ_Msk & ((value) << USB_DEVICE_EPSTATUS_STALLRQ_Pos)))
#define USB_DEVICE_EPSTATUS_BK0RDY_Pos				6				/**< \brief (USB_DEVICE_EPSTATUS)ݸ0 */
#define USB_DEVICE_EPSTATUS_BK0RDY					(0x1u << USB_DEVICE_EPSTATUS_BK0RDY_Pos)
#define USB_DEVICE_EPSTATUS_BK1RDY_Pos				7				/**< \brief (USB_DEVICE_EPSTATUS)ݸ1 */
#define USB_DEVICE_EPSTATUS_BK1RDY					(0x1u << USB_DEVICE_EPSTATUS_BK1RDY_Pos)
#define USB_DEVICE_EPSTATUS_MASK					0xF7u			/**< \brief (USB_DEVICE_EPSTATUS)Օڼ޽ */

/* -------- USB_HOST_PSTATUS : (USBψ:0x106) (R/   8) HOST HOST_PIPE߲ ߲ߏ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  DTGL:1;				/*!< ޯ0: ްݐ؂ւ */
    uint8_t  :1;					/*!< ޯ1: \ */
    uint8_t  CURBK:1;				/*!< ޯ2: ݸ */
    uint8_t  :1;					/*!< ޯ3: \ */
    uint8_t  PFREEZE:1;				/*!< ޯ4: ߲ߓ */
    uint8_t  :1;					/*!< ޯ5: \ */
    uint8_t  BK0RDY:1;				/*!< ޯ6: ݸ0 */
    uint8_t  BK1RDY:1;				/*!< ޯ7: ݸ1 */
  } bit;							/*!< ޯ Ɏgp\ */
  uint8_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_HOST_PSTATUS_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_HOST_PSTATUS_OFFSET						0x106			/**< \brief (USB_HOST_PSTATUS offset)HOST_PIPE߲ ߲ߏ */
#define USB_HOST_PSTATUS_RESETVALUE					0x00			/**< \brief (USB_HOST_PSTATUS reset_value)HOST_PIPE߲ ߲ߏ */

#define USB_HOST_PSTATUS_DTGL_Pos					0				/**< \brief (USB_HOST_PSTATUS)ްݐ؂ւ */
#define USB_HOST_PSTATUS_DTGL						(0x1u << USB_HOST_PSTATUS_DTGL_Pos)
#define USB_HOST_PSTATUS_CURBK_Pos					2				/**< \brief (USB_HOST_PSTATUS)ݸ */
#define USB_HOST_PSTATUS_CURBK						(0x1u << USB_HOST_PSTATUS_CURBK_Pos)
#define USB_HOST_PSTATUS_PFREEZE_Pos				4				/**< \brief (USB_HOST_PSTATUS)߲ߓ */
#define USB_HOST_PSTATUS_PFREEZE					(0x1u << USB_HOST_PSTATUS_PFREEZE_Pos)
#define USB_HOST_PSTATUS_BK0RDY_Pos					6				/**< \brief (USB_HOST_PSTATUS)ݸ0 */
#define USB_HOST_PSTATUS_BK0RDY						(0x1u << USB_HOST_PSTATUS_BK0RDY_Pos)
#define USB_HOST_PSTATUS_BK1RDY_Pos					7				/**< \brief (USB_HOST_PSTATUS)ݸ1 */
#define USB_HOST_PSTATUS_BK1RDY						(0x1u << USB_HOST_PSTATUS_BK1RDY_Pos)
#define USB_HOST_PSTATUS_MASK						0xD5u			/**< \brief (USB_HOST_PSTATUS)Օڼ޽ */

/* -------- USB_DEVICE_EPINTFLAG : (USBψ:0x107) (R/W  8) DEVICE DEVICE_ENDPOINT߲Ċ荞׸ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  TRCPT:2;				/*!< ޯ0`1: ]0/1 */
    uint8_t  TRFAIL:2;				/*!< ޯ2`3: ُ0/1 */
    uint8_t  RXSTP:1;				/*!< ޯ   4: SETUPM */
    uint8_t  STALL:2;				/*!< ޯ5`6: ~IN/OUT */
    uint8_t  :1;					/*!< ޯ   7: \ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint8_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_DEVICE_EPINTFLAG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_DEVICE_EPINTFLAG_OFFSET					0x107			/**< \brief (USB_DEVICE_EPINTFLAG offset)DEVICE_ENDPOINT߲Ċ荞׸ */
#define USB_DEVICE_EPINTFLAG_RESETVALUE				0x00			/**< \brief (USB_DEVICE_EPINTFLAG reset_value)DEVICE_ENDPOINT߲Ċ荞׸ */

#define USB_DEVICE_EPINTFLAG_TRCPT_Pos				0				/**< \brief (USB_DEVICE_EPINTFLAG)]0/1 */
#define USB_DEVICE_EPINTFLAG_TRCPT_Msk				(0x3u << USB_DEVICE_EPINTFLAG_TRCPT_Pos)
#define USB_DEVICE_EPINTFLAG_TRCPT(value)			((USB_DEVICE_EPINTFLAG_TRCPT_Msk & ((value) << USB_DEVICE_EPINTFLAG_TRCPT_Pos)))
#define USB_DEVICE_EPINTFLAG_TRFAIL_Pos				2				/**< \brief (USB_DEVICE_EPINTFLAG)ُ0/1 */
#define USB_DEVICE_EPINTFLAG_TRFAIL_Msk				(0x3u << USB_DEVICE_EPINTFLAG_TRFAIL_Pos)
#define USB_DEVICE_EPINTFLAG_TRFAIL(value)			((USB_DEVICE_EPINTFLAG_TRFAIL_Msk & ((value) << USB_DEVICE_EPINTFLAG_TRFAIL_Pos)))
#define USB_DEVICE_EPINTFLAG_RXSTP_Pos				4				/**< \brief (USB_DEVICE_EPINTFLAG)SETUPM */
#define USB_DEVICE_EPINTFLAG_RXSTP					(0x1u << USB_DEVICE_EPINTFLAG_RXSTP_Pos)
#define USB_DEVICE_EPINTFLAG_STALL_Pos				5				/**< \brief (USB_DEVICE_EPINTFLAG)~IN/OUT */
#define USB_DEVICE_EPINTFLAG_STALL_Msk				(0x3u << USB_DEVICE_EPINTFLAG_STALL_Pos)
#define USB_DEVICE_EPINTFLAG_STALL(value)			((USB_DEVICE_EPINTFLAG_STALL_Msk & ((value) << USB_DEVICE_EPINTFLAG_STALL_Pos)))
#define USB_DEVICE_EPINTFLAG_MASK					0x7Fu			/**< \brief (USB_DEVICE_EPINTFLAG)Օڼ޽ */

/* -------- USB_HOST_PINTFLAG : (USBψ:0x107) (R/W  8) HOST HOST_PIPE߲ߊ荞׸ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  TRCPT:2;				/*!< ޯ0`1: ]0/1荞׸ */
    uint8_t  TRFAIL:1;				/*!< ޯ   2: ُ튄荞׸ */
    uint8_t  PERR:1;				/*!< ޯ   3: ߲߈ُ튄荞׸ */
    uint8_t  TXSTP:1;				/*!< ޯ   4: SETUPM荞׸ */
    uint8_t  STALL:1;				/*!< ޯ   5: ~荞׸ */
    uint8_t  :2;					/*!< ޯ6`7: \ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint8_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_HOST_PINTFLAG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_HOST_PINTFLAG_OFFSET					0x107			/**< \brief (USB_HOST_PINTFLAG offset)HOST_PIPE߲ߊ荞׸ */
#define USB_HOST_PINTFLAG_RESETVALUE				0x00			/**< \brief (USB_HOST_PINTFLAG reset_value)HOST_PIPE߲ߊ荞׸ */

#define USB_HOST_PINTFLAG_TRCPT_Pos					0				/**< \brief (USB_HOST_PINTFLAG)]0/1荞׸ */
#define USB_HOST_PINTFLAG_TRCPT_Msk					(0x3u << USB_HOST_PINTFLAG_TRCPT_Pos)
#define USB_HOST_PINTFLAG_TRCPT(value)				((USB_HOST_PINTFLAG_TRCPT_Msk & ((value) << USB_HOST_PINTFLAG_TRCPT_Pos)))
#define USB_HOST_PINTFLAG_TRFAIL_Pos				2				/**< \brief (USB_HOST_PINTFLAG)ُ튄荞׸ */
#define USB_HOST_PINTFLAG_TRFAIL					(0x1u << USB_HOST_PINTFLAG_TRFAIL_Pos)
#define USB_HOST_PINTFLAG_PERR_Pos					3				/**< \brief (USB_HOST_PINTFLAG)߲߈ُ튄荞׸ */
#define USB_HOST_PINTFLAG_PERR						(0x1u << USB_HOST_PINTFLAG_PERR_Pos)
#define USB_HOST_PINTFLAG_TXSTP_Pos					4				/**< \brief (USB_HOST_PINTFLAG)SETUPM荞׸ */
#define USB_HOST_PINTFLAG_TXSTP						(0x1u << USB_HOST_PINTFLAG_TXSTP_Pos)
#define USB_HOST_PINTFLAG_STALL_Pos					5				/**< \brief (USB_HOST_PINTFLAG)~荞׸ */
#define USB_HOST_PINTFLAG_STALL						(0x1u << USB_HOST_PINTFLAG_STALL_Pos)
#define USB_HOST_PINTFLAG_MASK						0x3Fu			/**< \brief (USB_HOST_PINTFLAG)Օڼ޽ */

/* -------- USB_DEVICE_EPINTENCLR : (USBψ:0x108) (R/W  8) DEVICE DEVICE_ENDPOINT߲Ċ荞݉׸ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  TRCPT:2;				/*!< ޯ0`1: ]0/1荞݋֎~ */
    uint8_t  TRFAIL:2;				/*!< ޯ2`3: ُ0/1荞݋֎~ */
    uint8_t  RXSTP:1;				/*!< ޯ   4: SETUPM荞݋֎~ */
    uint8_t  STALL:2;				/*!< ޯ5`6: ~IN/OUT荞݋֎~ */
    uint8_t  :1;					/*!< ޯ   7: \ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint8_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_DEVICE_EPINTENCLR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_DEVICE_EPINTENCLR_OFFSET				0x108			/**< \brief (USB_DEVICE_EPINTENCLR offset)DEVICE_ENDPOINT߲Ċ荞݉׸ */
#define USB_DEVICE_EPINTENCLR_RESETVALUE			0x00			/**< \brief (USB_DEVICE_EPINTENCLR reset_value)DEVICE_ENDPOINT߲Ċ荞݉׸ */

#define USB_DEVICE_EPINTENCLR_TRCPT_Pos				0				/**< \brief (USB_DEVICE_EPINTENCLR)]0/1荞݋֎~ */
#define USB_DEVICE_EPINTENCLR_TRCPT_Msk				(0x3u << USB_DEVICE_EPINTENCLR_TRCPT_Pos)
#define USB_DEVICE_EPINTENCLR_TRCPT(value)			((USB_DEVICE_EPINTENCLR_TRCPT_Msk & ((value) << USB_DEVICE_EPINTENCLR_TRCPT_Pos)))
#define USB_DEVICE_EPINTENCLR_TRFAIL_Pos			2				/**< \brief (USB_DEVICE_EPINTENCLR)ُ0/1荞݋֎~ */
#define USB_DEVICE_EPINTENCLR_TRFAIL_Msk			(0x3u << USB_DEVICE_EPINTENCLR_TRFAIL_Pos)
#define USB_DEVICE_EPINTENCLR_TRFAIL(value)			((USB_DEVICE_EPINTENCLR_TRFAIL_Msk & ((value) << USB_DEVICE_EPINTENCLR_TRFAIL_Pos)))
#define USB_DEVICE_EPINTENCLR_RXSTP_Pos				4				/**< \brief (USB_DEVICE_EPINTENCLR)SETUPM荞݋֎~ */
#define USB_DEVICE_EPINTENCLR_RXSTP					(0x1u << USB_DEVICE_EPINTENCLR_RXSTP_Pos)
#define USB_DEVICE_EPINTENCLR_STALL_Pos				5				/**< \brief (USB_DEVICE_EPINTENCLR)~IN/OUT荞݋֎~ */
#define USB_DEVICE_EPINTENCLR_STALL_Msk				(0x3u << USB_DEVICE_EPINTENCLR_STALL_Pos)
#define USB_DEVICE_EPINTENCLR_STALL(value)			((USB_DEVICE_EPINTENCLR_STALL_Msk & ((value) << USB_DEVICE_EPINTENCLR_STALL_Pos)))
#define USB_DEVICE_EPINTENCLR_MASK					0x7Fu			/**< \brief (USB_DEVICE_EPINTENCLR)Օڼ޽ */

/* -------- USB_HOST_PINTENCLR : (USBψ:0x108) (R/W  8) HOST HOST_PIPE߲ߊ荞׸މ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  TRCPT:2;				/*!< ޯ0`1: ]0/1֎~ */
    uint8_t  TRFAIL:1;				/*!< ޯ   2: ُ튄荞݋֎~ */
    uint8_t  PERR:1;				/*!< ޯ   3: ߲߈ُ튄荞݋֎~ */
    uint8_t  TXSTP:1;				/*!< ޯ   4: SETUPM荞݋֎~ */
    uint8_t  STALL:1;				/*!< ޯ   5: ~荞݋֎~ */
    uint8_t  :2;					/*!< ޯ6`7: \ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint8_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_HOST_PINTENCLR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_HOST_PINTENCLR_OFFSET					0x108			/**< \brief (USB_HOST_PINTENCLR offset)HOST_PIPE߲ߊ荞׸މ */
#define USB_HOST_PINTENCLR_RESETVALUE				0x00			/**< \brief (USB_HOST_PINTENCLR reset_value)HOST_PIPE߲ߊ荞׸މ */

#define USB_HOST_PINTENCLR_TRCPT_Pos				0				/**< \brief (USB_HOST_PINTENCLR)]0/1֎~ */
#define USB_HOST_PINTENCLR_TRCPT_Msk				(0x3u << USB_HOST_PINTENCLR_TRCPT_Pos)
#define USB_HOST_PINTENCLR_TRCPT(value)				((USB_HOST_PINTENCLR_TRCPT_Msk & ((value) << USB_HOST_PINTENCLR_TRCPT_Pos)))
#define USB_HOST_PINTENCLR_TRFAIL_Pos				2				/**< \brief (USB_HOST_PINTENCLR)ُ튄荞݋֎~ */
#define USB_HOST_PINTENCLR_TRFAIL					(0x1u << USB_HOST_PINTENCLR_TRFAIL_Pos)
#define USB_HOST_PINTENCLR_PERR_Pos					3				/**< \brief (USB_HOST_PINTENCLR)߲߈ُ튄荞݋֎~ */
#define USB_HOST_PINTENCLR_PERR						(0x1u << USB_HOST_PINTENCLR_PERR_Pos)
#define USB_HOST_PINTENCLR_TXSTP_Pos				4				/**< \brief (USB_HOST_PINTENCLR)SETUPM荞݋֎~ */
#define USB_HOST_PINTENCLR_TXSTP					(0x1u << USB_HOST_PINTENCLR_TXSTP_Pos)
#define USB_HOST_PINTENCLR_STALL_Pos				5				/**< \brief (USB_HOST_PINTENCLR)~荞݋֎~ */
#define USB_HOST_PINTENCLR_STALL					(0x1u << USB_HOST_PINTENCLR_STALL_Pos)
#define USB_HOST_PINTENCLR_MASK						0x3Fu			/**< \brief (USB_HOST_PINTENCLR)Օڼ޽ */

/* -------- USB_DEVICE_EPINTENSET : (USBψ:0x109) (R/W  8) DEVICE DEVICE_ENDPOINT߲Ċ荞ݐݒ׸ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  TRCPT:2;				/*!< ޯ0`1: ]0/1荞݋ */
    uint8_t  TRFAIL:2;				/*!< ޯ2`3: ُ0/1荞݋ */
    uint8_t  RXSTP:1;				/*!< ޯ   4: SETUPM荞݋ */
    uint8_t  STALL:2;				/*!< ޯ5`6: ~IN/OUT荞݋ */
    uint8_t  :1;					/*!< ޯ   7: \ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint8_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_DEVICE_EPINTENSET_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_DEVICE_EPINTENSET_OFFSET				0x109			/**< \brief (USB_DEVICE_EPINTENSET offset)DEVICE_ENDPOINT߲Ċ荞ݐݒ׸ */
#define USB_DEVICE_EPINTENSET_RESETVALUE			0x00			/**< \brief (USB_DEVICE_EPINTENSET reset_value)DEVICE_ENDPOINT߲Ċ荞ݐݒ׸ */

#define USB_DEVICE_EPINTENSET_TRCPT_Pos				0				/**< \brief (USB_DEVICE_EPINTENSET)]0/1荞݋ */
#define USB_DEVICE_EPINTENSET_TRCPT_Msk				(0x3u << USB_DEVICE_EPINTENSET_TRCPT_Pos)
#define USB_DEVICE_EPINTENSET_TRCPT(value)			((USB_DEVICE_EPINTENSET_TRCPT_Msk & ((value) << USB_DEVICE_EPINTENSET_TRCPT_Pos)))
#define USB_DEVICE_EPINTENSET_TRFAIL_Pos			2				/**< \brief (USB_DEVICE_EPINTENSET)ُ0/1荞݋ */
#define USB_DEVICE_EPINTENSET_TRFAIL_Msk			(0x3u << USB_DEVICE_EPINTENSET_TRFAIL_Pos)
#define USB_DEVICE_EPINTENSET_TRFAIL(value)			((USB_DEVICE_EPINTENSET_TRFAIL_Msk & ((value) << USB_DEVICE_EPINTENSET_TRFAIL_Pos)))
#define USB_DEVICE_EPINTENSET_RXSTP_Pos				4				/**< \brief (USB_DEVICE_EPINTENSET)SETUPM荞݋ */
#define USB_DEVICE_EPINTENSET_RXSTP					(0x1u << USB_DEVICE_EPINTENSET_RXSTP_Pos)
#define USB_DEVICE_EPINTENSET_STALL_Pos				5				/**< \brief (USB_DEVICE_EPINTENSET)~IN/OUT荞݋ */
#define USB_DEVICE_EPINTENSET_STALL_Msk				(0x3u << USB_DEVICE_EPINTENSET_STALL_Pos)
#define USB_DEVICE_EPINTENSET_STALL(value)			((USB_DEVICE_EPINTENSET_STALL_Msk & ((value) << USB_DEVICE_EPINTENSET_STALL_Pos)))
#define USB_DEVICE_EPINTENSET_MASK					0x7Fu			/**< \brief (USB_DEVICE_EPINTENSET)Օڼ޽ */

/* -------- USB_HOST_PINTENSET : (USBψ:0x109) (R/W  8) HOST HOST_PIPE߲ߊ荞׸ސݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  TRCPT0:1;				/*!< ޯ   0: ]0荞݋ */
    uint8_t  TRCPT1:1;				/*!< ޯ   1: ]1荞݋ */
    uint8_t  TRFAIL:1;				/*!< ޯ   2: ُ튄荞݋ */
    uint8_t  PERR:1;				/*!< ޯ   3: ߲߈ُ튄荞݋ */
    uint8_t  TXSTP:1;				/*!< ޯ   4: SETUPM荞݋ */
    uint8_t  STALL:1;				/*!< ޯ   5: ~荞݋ */
    uint8_t  :2;					/*!< ޯ6`7: \ */
  } bit;							/*!< ޯ Ɏgp\ */
  struct {
    uint8_t  TRCPT:2;				/*!< ޯ 0` 1 ]x荞݋ */
    uint8_t  :6;					/*!< ޯ 2` 7 \ */
  } vec;							/*!< ޸ Ɏgp\ */
  uint8_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_HOST_PINTENSET_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_HOST_PINTENSET_OFFSET					0x109			/**< \brief (USB_HOST_PINTENSET offset)HOST_PIPE߲ߊ荞׸ސݒ */
#define USB_HOST_PINTENSET_RESETVALUE				0x00			/**< \brief (USB_HOST_PINTENSET reset_value)HOST_PIPE߲ߊ荞׸ސݒ */

#define USB_HOST_PINTENSET_TRCPT0_Pos				0				/**< \brief (USB_HOST_PINTENSET)]0荞݋ */
#define USB_HOST_PINTENSET_TRCPT0					(1 << USB_HOST_PINTENSET_TRCPT0_Pos)
#define USB_HOST_PINTENSET_TRCPT1_Pos				1				/**< \brief (USB_HOST_PINTENSET)]1荞݋ */
#define USB_HOST_PINTENSET_TRCPT1					(1 << USB_HOST_PINTENSET_TRCPT1_Pos)
#define USB_HOST_PINTENSET_TRCPT_Pos				0				/**< \brief (USB_HOST_PINTENSET)]x荞݋ */
#define USB_HOST_PINTENSET_TRCPT_Msk				(0x3u << USB_HOST_PINTENSET_TRCPT_Pos)
#define USB_HOST_PINTENSET_TRCPT(value)				((USB_HOST_PINTENSET_TRCPT_Msk & ((value) << USB_HOST_PINTENSET_TRCPT_Pos)))
#define USB_HOST_PINTENSET_TRFAIL_Pos				2				/**< \brief (USB_HOST_PINTENSET)ُ튄荞݋ */
#define USB_HOST_PINTENSET_TRFAIL					(0x1u << USB_HOST_PINTENSET_TRFAIL_Pos)
#define USB_HOST_PINTENSET_PERR_Pos					3				/**< \brief (USB_HOST_PINTENSET)߲߈ُ튄荞݋ */
#define USB_HOST_PINTENSET_PERR						(0x1u << USB_HOST_PINTENSET_PERR_Pos)
#define USB_HOST_PINTENSET_TXSTP_Pos				4				/**< \brief (USB_HOST_PINTENSET)SETUPM荞݋ */
#define USB_HOST_PINTENSET_TXSTP					(0x1u << USB_HOST_PINTENSET_TXSTP_Pos)
#define USB_HOST_PINTENSET_STALL_Pos				5				/**< \brief (USB_HOST_PINTENSET)~荞݋ */
#define USB_HOST_PINTENSET_STALL					(0x1u << USB_HOST_PINTENSET_STALL_Pos)
#define USB_HOST_PINTENSET_MASK						0x3Fu			/**< \brief (USB_HOST_PINTENSET)Օڼ޽ */

/* -------- USB_DEVICE_ADDR : (USBψ:0x000) (R/W 32) DEVICE DEVICE_DESC_BANK߲ ݸAްɏՕ̱ڽ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t ADDR:32;				/*!< ޯ0`31: ްɏՕ̱ڽ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint32_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_DEVICE_ADDR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_DEVICE_ADDR_OFFSET						0x000			/**< \brief (USB_DEVICE_ADDR offset)DEVICE_DESC_BANK߲ ݸAްɏՕ̱ڽ */

#define USB_DEVICE_ADDR_ADDR_Pos					0				/**< \brief (USB_DEVICE_ADDR)ްɏՕ̱ڽ */
#define USB_DEVICE_ADDR_ADDR_Msk					(0xFFFFFFFFu << USB_DEVICE_ADDR_ADDR_Pos)
#define USB_DEVICE_ADDR_ADDR(value)					((USB_DEVICE_ADDR_ADDR_Msk & ((value) << USB_DEVICE_ADDR_ADDR_Pos)))
#define USB_DEVICE_ADDR_MASK						0xFFFFFFFFu		/**< \brief (USB_DEVICE_ADDR)Օڼ޽ */

/* -------- USB_HOST_ADDR : (USBψ:0x000) (R/W 32) HOST HOST_DESC_BANKν ݸAްɏՕ̱ڽ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t ADDR:32;				/*!< ޯ0`31: ްɏՕ̱ڽ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint32_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_HOST_ADDR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_HOST_ADDR_OFFSET						0x000			/**< \brief (USB_HOST_ADDR offset)HOST_DESC_BANKν ݸAްɏՕ̱ڽ */

#define USB_HOST_ADDR_ADDR_Pos						0				/**< \brief (USB_HOST_ADDR)ްɏՕ̱ڽ */
#define USB_HOST_ADDR_ADDR_Msk						(0xFFFFFFFFu << USB_HOST_ADDR_ADDR_Pos)
#define USB_HOST_ADDR_ADDR(value)					((USB_HOST_ADDR_ADDR_Msk & ((value) << USB_HOST_ADDR_ADDR_Pos)))
#define USB_HOST_ADDR_MASK							0xFFFFFFFFu		/**< \brief (USB_HOST_ADDR)Օڼ޽ */

/* -------- USB_DEVICE_PCKSIZE : (USBψ:0x004) (R/W 32) DEVICE DEVICE_DESC_BANK߲ ݸA߹Ă̑傫 -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t BYTE_COUNT:14;			/*!< ޯ 0`13: ޲Čv */
    uint32_t MULTI_PACKET_SIZE:14;	/*!< ޯ14`27: ߹IN.܂OUT̑傫 */
    uint32_t SIZE:3;				/*!< ޯ28`30: ߲Ă̑傫 */
    uint32_t AUTO_ZLP:1;			/*!< ޯ    31: 0߹ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint32_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_DEVICE_PCKSIZE_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_DEVICE_PCKSIZE_OFFSET					0x004			/**< \brief (USB_DEVICE_PCKSIZE offset)DEVICE_DESC_BANK߲ ݸA߹Ă̑傫 */

#define USB_DEVICE_PCKSIZE_BYTE_COUNT_Pos			0				/**< \brief (USB_DEVICE_PCKSIZE)޲Čv */
#define USB_DEVICE_PCKSIZE_BYTE_COUNT_Msk			(0x3FFFu << USB_DEVICE_PCKSIZE_BYTE_COUNT_Pos)
#define USB_DEVICE_PCKSIZE_BYTE_COUNT(value)		((USB_DEVICE_PCKSIZE_BYTE_COUNT_Msk & ((value) << USB_DEVICE_PCKSIZE_BYTE_COUNT_Pos)))
#define USB_DEVICE_PCKSIZE_MULTI_PACKET_SIZE_Pos	14				/**< \brief (USB_DEVICE_PCKSIZE)߹IN.܂OUT̑傫 */
#define USB_DEVICE_PCKSIZE_MULTI_PACKET_SIZE_Msk	(0x3FFFu << USB_DEVICE_PCKSIZE_MULTI_PACKET_SIZE_Pos)
#define USB_DEVICE_PCKSIZE_MULTI_PACKET_SIZE(value)	((USB_DEVICE_PCKSIZE_MULTI_PACKET_SIZE_Msk & ((value) << USB_DEVICE_PCKSIZE_MULTI_PACKET_SIZE_Pos)))
#define USB_DEVICE_PCKSIZE_SIZE_Pos					28				/**< \brief (USB_DEVICE_PCKSIZE)߲Ă̑傫 */
#define USB_DEVICE_PCKSIZE_SIZE_Msk					(0x7u << USB_DEVICE_PCKSIZE_SIZE_Pos)
#define USB_DEVICE_PCKSIZE_SIZE(value)				((USB_DEVICE_PCKSIZE_SIZE_Msk & ((value) << USB_DEVICE_PCKSIZE_SIZE_Pos)))
#define USB_DEVICE_PCKSIZE_AUTO_ZLP_Pos				31				/**< \brief (USB_DEVICE_PCKSIZE)0߹ */
#define USB_DEVICE_PCKSIZE_AUTO_ZLP					(0x1u << USB_DEVICE_PCKSIZE_AUTO_ZLP_Pos)
#define USB_DEVICE_PCKSIZE_MASK						0xFFFFFFFFu		/**< \brief (USB_DEVICE_PCKSIZE)Օڼ޽ */

/* -------- USB_HOST_PCKSIZE : (USBψ:0x004) (R/W 32) HOST HOST_DESC_BANKν ݸA߹Ă̑傫 -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t BYTE_COUNT:14;			/*!< ޯ 0`13: ޲Čv */
    uint32_t MULTI_PACKET_SIZE:14;	/*!< ޯ14`27: ߹IN.܂OUT̑傫 */
    uint32_t SIZE:3;				/*!< ޯ28`30: ߲߂̑傫 */
    uint32_t AUTO_ZLP:1;			/*!< ޯ    31: 0߹ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint32_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_HOST_PCKSIZE_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_HOST_PCKSIZE_OFFSET						0x004			/**< \brief (USB_HOST_PCKSIZE offset)HOST_DESC_BANKν ݸA߹Ă̑傫 */

#define USB_HOST_PCKSIZE_BYTE_COUNT_Pos				0				/**< \brief (USB_HOST_PCKSIZE)޲Čv */
#define USB_HOST_PCKSIZE_BYTE_COUNT_Msk				(0x3FFFu << USB_HOST_PCKSIZE_BYTE_COUNT_Pos)
#define USB_HOST_PCKSIZE_BYTE_COUNT(value)			((USB_HOST_PCKSIZE_BYTE_COUNT_Msk & ((value) << USB_HOST_PCKSIZE_BYTE_COUNT_Pos)))
#define USB_HOST_PCKSIZE_MULTI_PACKET_SIZE_Pos		14				/**< \brief (USB_HOST_PCKSIZE)߹IN.܂OUT̑傫 */
#define USB_HOST_PCKSIZE_MULTI_PACKET_SIZE_Msk		(0x3FFFu << USB_HOST_PCKSIZE_MULTI_PACKET_SIZE_Pos)
#define USB_HOST_PCKSIZE_MULTI_PACKET_SIZE(value)	((USB_HOST_PCKSIZE_MULTI_PACKET_SIZE_Msk & ((value) << USB_HOST_PCKSIZE_MULTI_PACKET_SIZE_Pos)))
#define USB_HOST_PCKSIZE_SIZE_Pos					28				/**< \brief (USB_HOST_PCKSIZE)߲߂̑傫 */
#define USB_HOST_PCKSIZE_SIZE_Msk					(0x7u << USB_HOST_PCKSIZE_SIZE_Pos)
#define USB_HOST_PCKSIZE_SIZE(value)				((USB_HOST_PCKSIZE_SIZE_Msk & ((value) << USB_HOST_PCKSIZE_SIZE_Pos)))
#define USB_HOST_PCKSIZE_AUTO_ZLP_Pos				31				/**< \brief (USB_HOST_PCKSIZE)0߹ */
#define USB_HOST_PCKSIZE_AUTO_ZLP					(0x1u << USB_HOST_PCKSIZE_AUTO_ZLP_Pos)
#define USB_HOST_PCKSIZE_MASK						0xFFFFFFFFu		/**< \brief (USB_HOST_PCKSIZE)Օڼ޽ */

/* -------- USB_DEVICE_EXTREG : (USBψ:0x008) (R/W 16) DEVICE DEVICE_DESC_BANK߲ ݸAg -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t SUBPID:4;				/*!< ޯ0` 3: gʕ[SUBPID̈摗o */
    uint16_t VARIABLE:11;			/*!< ޯ4`14: gʕ[ŕϐ̈摗o */
    uint16_t :1;					/*!< ޯ   15: \ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint16_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_DEVICE_EXTREG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_DEVICE_EXTREG_OFFSET					0x008			/**< \brief (USB_DEVICE_EXTREG offset)DEVICE_DESC_BANK߲ ݸAg */

#define USB_DEVICE_EXTREG_SUBPID_Pos				0				/**< \brief (USB_DEVICE_EXTREG)gʕ[SUBPID̈摗o */
#define USB_DEVICE_EXTREG_SUBPID_Msk				(0xFu << USB_DEVICE_EXTREG_SUBPID_Pos)
#define USB_DEVICE_EXTREG_SUBPID(value)				((USB_DEVICE_EXTREG_SUBPID_Msk & ((value) << USB_DEVICE_EXTREG_SUBPID_Pos)))
#define USB_DEVICE_EXTREG_VARIABLE_Pos				4				/**< \brief (USB_DEVICE_EXTREG)gʕ[ŕϐ̈摗o */
#define USB_DEVICE_EXTREG_VARIABLE_Msk				(0x7FFu << USB_DEVICE_EXTREG_VARIABLE_Pos)
#define USB_DEVICE_EXTREG_VARIABLE(value)			((USB_DEVICE_EXTREG_VARIABLE_Msk & ((value) << USB_DEVICE_EXTREG_VARIABLE_Pos)))
#define USB_DEVICE_EXTREG_MASK						0x7FFFu			/**< \brief (USB_DEVICE_EXTREG)Օڼ޽ */

/* -------- USB_HOST_EXTREG : (USBψ:0x008) (R/W 16) HOST HOST_DESC_BANKν ݸAg -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t SUBPID:4;				/*!< ޯ0` 3: gʕ[SUBPID̈摗o */
    uint16_t VARIABLE:11;			/*!< ޯ4`14: gʕ[ŕϐ̈摗o */
    uint16_t :1;					/*!< ޯ   15: \ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint16_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_HOST_EXTREG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_HOST_EXTREG_OFFSET						0x008			/**< \brief (USB_HOST_EXTREG offset)HOST_DESC_BANKν ݸAg */

#define USB_HOST_EXTREG_SUBPID_Pos					0				/**< \brief (USB_HOST_EXTREG)gʕ[SUBPID̈摗o */
#define USB_HOST_EXTREG_SUBPID_Msk					(0xFu << USB_HOST_EXTREG_SUBPID_Pos)
#define USB_HOST_EXTREG_SUBPID(value)				((USB_HOST_EXTREG_SUBPID_Msk & ((value) << USB_HOST_EXTREG_SUBPID_Pos)))
#define USB_HOST_EXTREG_VARIABLE_Pos				4				/**< \brief (USB_HOST_EXTREG)gʕ[ŕϐ̈摗o */
#define USB_HOST_EXTREG_VARIABLE_Msk				(0x7FFu << USB_HOST_EXTREG_VARIABLE_Pos)
#define USB_HOST_EXTREG_VARIABLE(value)				((USB_HOST_EXTREG_VARIABLE_Msk & ((value) << USB_HOST_EXTREG_VARIABLE_Pos)))
#define USB_HOST_EXTREG_MASK						0x7FFFu			/**< \brief (USB_HOST_EXTREG)Օڼ޽ */

/* -------- USB_DEVICE_STATUS_BK : (USBψ:0x00A) (R/W  8) DEVICE DEVICE_DESC_BANK߲ ݸAݸ̏ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  CRCERR:1;				/*!< ޯ   0: CRC */
    uint8_t  ERRORFLOW:1;			/*!< ޯ   1: ُ */
    uint8_t  :6;					/*!< ޯ2`7: \ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint8_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_DEVICE_STATUS_BK_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_DEVICE_STATUS_BK_OFFSET					0x00A			/**< \brief (USB_DEVICE_STATUS_BK offset)DEVICE_DESC_BANK߲ ݸAݸ̏ */

#define USB_DEVICE_STATUS_BK_CRCERR_Pos				0				/**< \brief (USB_DEVICE_STATUS_BK)CRC */
#define USB_DEVICE_STATUS_BK_CRCERR					(0x1u << USB_DEVICE_STATUS_BK_CRCERR_Pos)
#define USB_DEVICE_STATUS_BK_ERRORFLOW_Pos			1				/**< \brief (USB_DEVICE_STATUS_BK)ُ */
#define USB_DEVICE_STATUS_BK_ERRORFLOW				(0x1u << USB_DEVICE_STATUS_BK_ERRORFLOW_Pos)
#define USB_DEVICE_STATUS_BK_MASK					0x03u			/**< \brief (USB_DEVICE_STATUS_BK)Օڼ޽ */

/* -------- USB_HOST_STATUS_BK : (USBψ:0x00A) (R/W  8) HOST HOST_DESC_BANKν ݸAݸ̏ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  CRCERR:1;				/*!< ޯ   0: CRC */
    uint8_t  ERRORFLOW:1;			/*!< ޯ   1: ُ */
    uint8_t  :6;					/*!< ޯ2`7: \ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint8_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_HOST_STATUS_BK_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_HOST_STATUS_BK_OFFSET					0x00A			/**< \brief (USB_HOST_STATUS_BK offset)HOST_DESC_BANKν ݸAݸ̏ */

#define USB_HOST_STATUS_BK_CRCERR_Pos				0				/**< \brief (USB_HOST_STATUS_BK)CRC */
#define USB_HOST_STATUS_BK_CRCERR					(0x1u << USB_HOST_STATUS_BK_CRCERR_Pos)
#define USB_HOST_STATUS_BK_ERRORFLOW_Pos			1				/**< \brief (USB_HOST_STATUS_BK)ُ */
#define USB_HOST_STATUS_BK_ERRORFLOW				(0x1u << USB_HOST_STATUS_BK_ERRORFLOW_Pos)
#define USB_HOST_STATUS_BK_MASK						0x03u			/**< \brief (USB_HOST_STATUS_BK)Օڼ޽ */

/* -------- USB_HOST_CTRL_PIPE : (USBψ:0x00C) (R/W 16) HOST HOST_DESC_BANKν ݸAνĐ߲-------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t PDADDR:7;				/*!< ޯ 0` 6: ߲ߑuڽ */
    uint16_t :1;					/*!< ޯ     7: \ */
    uint16_t PEPNUM:4;				/*!< ޯ 8`11: ߲ ߲Ĕԍ */
    uint16_t PERMAX:4;				/*!< ޯ12`15: ߲߈ُőԍ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint16_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_HOST_CTRL_PIPE_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_HOST_CTRL_PIPE_OFFSET					0x00C			/**< \brief (USB_HOST_CTRL_PIPE offset)HOST_DESC_BANKν ݸAνĐ߲*/
#define USB_HOST_CTRL_PIPE_RESETVALUE				0x0000			/**< \brief (USB_HOST_CTRL_PIPE reset_value)HOST_DESC_BANKν ݸAνĐ߲*/

#define USB_HOST_CTRL_PIPE_PDADDR_Pos				0				/**< \brief (USB_HOST_CTRL_PIPE)߲ߑuڽ */
#define USB_HOST_CTRL_PIPE_PDADDR_Msk				(0x7Fu << USB_HOST_CTRL_PIPE_PDADDR_Pos)
#define USB_HOST_CTRL_PIPE_PDADDR(value)			((USB_HOST_CTRL_PIPE_PDADDR_Msk & ((value) << USB_HOST_CTRL_PIPE_PDADDR_Pos)))
#define USB_HOST_CTRL_PIPE_PEPNUM_Pos				8				/**< \brief (USB_HOST_CTRL_PIPE)߲ ߲Ĕԍ */
#define USB_HOST_CTRL_PIPE_PEPNUM_Msk				(0xFu << USB_HOST_CTRL_PIPE_PEPNUM_Pos)
#define USB_HOST_CTRL_PIPE_PEPNUM(value)			((USB_HOST_CTRL_PIPE_PEPNUM_Msk & ((value) << USB_HOST_CTRL_PIPE_PEPNUM_Pos)))
#define USB_HOST_CTRL_PIPE_PERMAX_Pos				12				/**< \brief (USB_HOST_CTRL_PIPE)߲߈ُőԍ */
#define USB_HOST_CTRL_PIPE_PERMAX_Msk				(0xFu << USB_HOST_CTRL_PIPE_PERMAX_Pos)
#define USB_HOST_CTRL_PIPE_PERMAX(value)			((USB_HOST_CTRL_PIPE_PERMAX_Msk & ((value) << USB_HOST_CTRL_PIPE_PERMAX_Pos)))
#define USB_HOST_CTRL_PIPE_MASK						0xFF7Fu			/**< \brief (USB_HOST_CTRL_PIPE)Օڼ޽ */

/* -------- USB_HOST_STATUS_PIPE : (USBψ:0x00E) (R/W 16) HOST HOST_DESC_BANKν ݸAνď߲-------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t DTGLER:1;				/*!< ޯ    0: ްݐ؂ւُ */
    uint16_t DAPIDER:1;				/*!< ޯ    1: ްPIDُ */
    uint16_t PIDER:1;				/*!< ޯ    2: PIDُ */
    uint16_t TOUTER:1;				/*!< ޯ    3: Ԓ߈ُ */
    uint16_t CRC16ER:1;				/*!< ޯ    4: CRC16ُ */
    uint16_t ERCNT:3;				/*!< ޯ5` 7: ߲߈ُv */
    uint16_t :8;					/*!< ޯ8`15: \ */
  } bit;							/*!< ޯ Ɏgp\ */
  uint16_t reg;						/*!< ڼ޽ Ɏgp^ */
} USB_HOST_STATUS_PIPE_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define USB_HOST_STATUS_PIPE_OFFSET					0x00E			/**< \brief (USB_HOST_STATUS_PIPE offset)HOST_DESC_BANKν ݸAνď߲*/

#define USB_HOST_STATUS_PIPE_DTGLER_Pos				0				/**< \brief (USB_HOST_STATUS_PIPE)ްݐ؂ւُ */
#define USB_HOST_STATUS_PIPE_DTGLER					(0x1u << USB_HOST_STATUS_PIPE_DTGLER_Pos)
#define USB_HOST_STATUS_PIPE_DAPIDER_Pos			1				/**< \brief (USB_HOST_STATUS_PIPE)ްPIDُ */
#define USB_HOST_STATUS_PIPE_DAPIDER				(0x1u << USB_HOST_STATUS_PIPE_DAPIDER_Pos)
#define USB_HOST_STATUS_PIPE_PIDER_Pos				2				/**< \brief (USB_HOST_STATUS_PIPE)PIDُ */
#define USB_HOST_STATUS_PIPE_PIDER					(0x1u << USB_HOST_STATUS_PIPE_PIDER_Pos)
#define USB_HOST_STATUS_PIPE_TOUTER_Pos				3				/**< \brief (USB_HOST_STATUS_PIPE)Ԓ߈ُ */
#define USB_HOST_STATUS_PIPE_TOUTER					(0x1u << USB_HOST_STATUS_PIPE_TOUTER_Pos)
#define USB_HOST_STATUS_PIPE_CRC16ER_Pos			4				/**< \brief (USB_HOST_STATUS_PIPE)CRC16ُ */
#define USB_HOST_STATUS_PIPE_CRC16ER				(0x1u << USB_HOST_STATUS_PIPE_CRC16ER_Pos)
#define USB_HOST_STATUS_PIPE_ERCNT_Pos				5				/**< \brief (USB_HOST_STATUS_PIPE)߲߈ُv */
#define USB_HOST_STATUS_PIPE_ERCNT_Msk				(0x7u << USB_HOST_STATUS_PIPE_ERCNT_Pos)
#define USB_HOST_STATUS_PIPE_ERCNT(value)			((USB_HOST_STATUS_PIPE_ERCNT_Msk & ((value) << USB_HOST_STATUS_PIPE_ERCNT_Pos)))
#define USB_HOST_STATUS_PIPE_MASK					0x00FFu			/**< \brief (USB_HOST_STATUS_PIPE)Օڼ޽ */

/** \brief UsbDeviceDescBankʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  __IO USB_DEVICE_ADDR_Type			ADDR;				/**< \briefψ:0x000 (R/W 32)DEVICE_DESC_BANK߲ ݸAްɏՕ̱ڽ */
  __IO USB_DEVICE_PCKSIZE_Type		PCKSIZE;			/**< \briefψ:0x004 (R/W 32)DEVICE_DESC_BANK߲ ݸA߹Ă̑傫 */
  __IO USB_DEVICE_EXTREG_Type		EXTREG;				/**< \briefψ:0x008 (R/W 16)DEVICE_DESC_BANK߲ ݸAg */
  __IO USB_DEVICE_STATUS_BK_Type	STATUS_BK;			/**< \briefψ:0x00A (R/W  8)DEVICE_DESC_BANK߲ ݸAݸ̏ */
	   RoReg8						Reserved1[0x5];
} UsbDeviceDescBank;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/** \brief UsbHostDescBankʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  __IO USB_HOST_ADDR_Type			ADDR;				/**< \briefψ:0x000 (R/W 32)HOST_DESC_BANKν ݸAްɏՕ̱ڽ */
  __IO USB_HOST_PCKSIZE_Type		PCKSIZE;			/**< \briefψ:0x004 (R/W 32)HOST_DESC_BANKν ݸA߹Ă̑傫 */
  __IO USB_HOST_EXTREG_Type			EXTREG;				/**< \briefψ:0x008 (R/W 16)HOST_DESC_BANKν ݸAg */
  __IO USB_HOST_STATUS_BK_Type		STATUS_BK;			/**< \briefψ:0x00A (R/W  8)HOST_DESC_BANKν ݸAݸ̏ */
	   RoReg8						Reserved1[0x1];
  __IO USB_HOST_CTRL_PIPE_Type		CTRL_PIPE;			/**< \briefψ:0x00C (R/W 16)HOST_DESC_BANKν ݸAνĐ߲*/
  __IO USB_HOST_STATUS_PIPE_Type	STATUS_PIPE;		/**< \briefψ:0x00E (R/W 16)HOST_DESC_BANKν ݸAνď߲*/
} UsbHostDescBank;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/** \brief UsbDeviceEndpointʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  __IO USB_DEVICE_EPCFG_Type		EPCFG;				/**< \briefψ:0x000 (R/W  8)DEVICE_ENDPOINT߲Č`Ԑݒ */
	   RoReg8						Reserved1[0x3];
  __O  USB_DEVICE_EPSTATUSCLR_Type	EPSTATUSCLR;		/**< \briefψ:0x004 ( /W  8)DEVICE_ENDPOINT߲ ߲ߏԉ */
  __O  USB_DEVICE_EPSTATUSSET_Type	EPSTATUSSET;		/**< \briefψ:0x005 ( /W  8)DEVICE_ENDPOINT߲ ߲ߏԐݒ */
  __I  USB_DEVICE_EPSTATUS_Type		EPSTATUS;			/**< \briefψ:0x006 (R/   8)DEVICE_ENDPOINT߲߲ߏ */
  __IO USB_DEVICE_EPINTFLAG_Type	EPINTFLAG;			/**< \briefψ:0x007 (R/W  8)DEVICE_ENDPOINT߲Ċ荞׸ */
  __IO USB_DEVICE_EPINTENCLR_Type	EPINTENCLR;			/**< \briefψ:0x008 (R/W  8)DEVICE_ENDPOINT߲Ċ荞݉׸ */
  __IO USB_DEVICE_EPINTENSET_Type	EPINTENSET;			/**< \briefψ:0x009 (R/W  8)DEVICE_ENDPOINT߲Ċ荞ݐݒ׸ */
	   RoReg8						Reserved2[0x16];
} UsbDeviceEndpoint;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/** \brief UsbHostPipeʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  __IO USB_HOST_PCFG_Type			PCFG;				/**< \briefψ:0x000 (R/W  8)HOST_PIPE߲Č`Ԑݒ */
	   RoReg8						Reserved1[0x2];
  __IO USB_HOST_BINTERVAL_Type		BINTERVAL;			/**< \briefψ:0x003 (R/W  8)HOST_PIPE߲߂޽ */
  __O  USB_HOST_PSTATUSCLR_Type		PSTATUSCLR;			/**< \briefψ:0x004 ( /W  8)HOST_PIPE߲ ߲ߏԉ */
  __O  USB_HOST_PSTATUSSET_Type		PSTATUSSET;			/**< \briefψ:0x005 ( /W  8)HOST_PIPE߲ ߲ߏԐݒ */
  __I  USB_HOST_PSTATUS_Type		PSTATUS;			/**< \briefψ:0x006 (R/   8)HOST_PIPE߲߲ߏ */
  __IO USB_HOST_PINTFLAG_Type		PINTFLAG;			/**< \briefψ:0x007 (R/W  8)HOST_PIPE߲ߊ荞׸ */
  __IO USB_HOST_PINTENCLR_Type		PINTENCLR;			/**< \briefψ:0x008 (R/W  8)HOST_PIPE߲ߊ荞׸މ */
  __IO USB_HOST_PINTENSET_Type		PINTENSET;			/**< \briefψ:0x009 (R/W  8)HOST_PIPE߲ߊ荞׸ސݒ */
	   RoReg8						Reserved2[0x16];
} UsbHostPipe;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/** \brief USB_DEVICE APBʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct { /* USB͑u */
  __IO USB_CTRLA_Type				CTRLA;				/**< \briefψ:0x000 (R/W  8)A */
	   RoReg8						Reserved1[0x1];
  __I  USB_SYNCBUSY_Type			SYNCBUSY;			/**< \briefψ:0x002 (R/   8)Z */
	   RoReg8						Reserved2[0x5];
  __IO USB_DEVICE_CTRLB_Type		CTRLB;				/**< \briefψ:0x008 (R/W 16)uB */
  __IO USB_DEVICE_DADD_Type			DADD;				/**< \briefψ:0x00A (R/W  8)DEVICEuڽ */
	   RoReg8						Reserved3[0x1];
  __I  USB_DEVICE_STATUS_Type		STATUS;				/**< \briefψ:0x00C (R/   8)u */
  __I  USB_FSMSTATUS_Type			FSMSTATUS;			/**< \briefψ:0x00D (R/   8)Lԋ@\ */
	   RoReg8						Reserved4[0x2];
  __I  USB_DEVICE_FNUM_Type			FNUM;				/**< \briefψ:0x010 (R/  16)uڰєԍ */
	   RoReg8						Reserved5[0x2];
  __IO USB_DEVICE_INTENCLR_Type		INTENCLR;			/**< \briefψ:0x014 (R/W 16)u荞݋ */
	   RoReg8						Reserved6[0x2];
  __IO USB_DEVICE_INTENSET_Type		INTENSET;			/**< \briefψ:0x018 (R/W 16)u荞݋ݒ */
	   RoReg8						Reserved7[0x2];
  __IO USB_DEVICE_INTFLAG_Type		INTFLAG;			/**< \briefψ:0x01C (R/W 16)u荞׸ */
	   RoReg8						Reserved8[0x2];
  __I  USB_DEVICE_EPINTSMRY_Type	EPINTSMRY;			/**< \briefψ:0x020 (R/  16)u߲Ċ荞ݗv */
	   RoReg8						Reserved9[0x2];
  __IO USB_DESCADD_Type				DESCADD;			/**< \briefψ:0x024 (R/W 32)Lqqڽ */
  __IO USB_PADCAL_Type				PADCAL;				/**< \briefψ:0x028 (R/W 16)USB߯ލZ */
	   RoReg8						Reserved10[0xD6];
	   UsbDeviceEndpoint			DeviceEndpoint[8];	/**< \briefψ:0x100 UsbDeviceEndpointQ [EPT_NUM] */
} UsbDevice;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/** \brief USB_HOSTʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct { /* USBν */
  __IO USB_CTRLA_Type				CTRLA;				/**< \briefψ:0x000 (R/W  8)A */
	   RoReg8						Reserved1[0x1];
  __I  USB_SYNCBUSY_Type			SYNCBUSY;			/**< \briefψ:0x002 (R/   8)Z */
	   RoReg8						Reserved2[0x5];
  __IO USB_HOST_CTRLB_Type			CTRLB;				/**< \briefψ:0x008 (R/W 16)νĐB */
  __IO USB_HOST_HSOFC_Type			HSOFC;				/**< \briefψ:0x00A (R/W  8)HOSTν ڰъJn */
	   RoReg8						Reserved3[0x1];
  __IO USB_HOST_STATUS_Type			STATUS;				/**< \briefψ:0x00C (R/W  8)νď */
  __I  USB_FSMSTATUS_Type			FSMSTATUS;			/**< \briefψ:0x00D (R/   8)Lԋ@\ */
	   RoReg8						Reserved4[0x2];
  __IO USB_HOST_FNUM_Type			FNUM;				/**< \briefψ:0x010 (R/W 16)HOSTν ڰєԍ */
  __I  USB_HOST_FLENHIGH_Type		FLENHIGH;			/**< \briefψ:0x012 (R/   8)HOSTν ڰђ */
	   RoReg8						Reserved5[0x1];
  __IO USB_HOST_INTENCLR_Type		INTENCLR;			/**< \briefψ:0x014 (R/W 16)νĊ荞݋ */
	   RoReg8						Reserved6[0x2];
  __IO USB_HOST_INTENSET_Type		INTENSET;			/**< \briefψ:0x018 (R/W 16)νĊ荞݋ݒ */
	   RoReg8						Reserved7[0x2];
  __IO USB_HOST_INTFLAG_Type		INTFLAG;			/**< \briefψ:0x01C (R/W 16)νĊ荞׸ */
	   RoReg8						Reserved8[0x2];
  __I  USB_HOST_PINTSMRY_Type		PINTSMRY;			/**< \briefψ:0x020 (R/  16)ν ߲ߊ荞ݗv */
	   RoReg8						Reserved9[0x2];
  __IO USB_DESCADD_Type				DESCADD;			/**< \briefψ:0x024 (R/W 32)Lqqڽ */
  __IO USB_PADCAL_Type				PADCAL;				/**< \briefψ:0x028 (R/W 16)USB߯ލZ */
	   RoReg8						Reserved10[0xD6];
	   UsbHostPipe					HostPipe[8];		/**< \briefψ:0x100 UsbHost߲ߌQ [EPT_NUM] */
} UsbHost;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/** \brief USB_DEVICELqqʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct { /* USB is Device */
	   UsbDeviceDescBank			DeviceDescBank[2];	/**< \briefψ:0x000 UsbDeviceDescBankQ */
} UsbDeviceDescriptor;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/** \brief USB_HOSTLqqʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct { /* USB is Host */
	   UsbHostDescBank				HostDescBank[2];	/**< \briefψ:0x000 UsbHostDescBankQ */
} UsbHostDescriptor;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#ifdef __GNUC__
 #define SECTION_USB_DESCRIPTOR
#endif

#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
	   UsbDevice					DEVICE;				/**< \briefψ:0x000 USB͑u */
	   UsbHost						HOST;				/**< \briefψ:0x000 USBν */
} Usb;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAMD21_USB_COMPONENT_ */
