/**
 * \file
 *
 * \brief DALI]u͕EEPROM`Ԑݒ
 *
 * 쌠 (c) 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#include "dali_top.h"

uint8_t create_bcc_code(uint8_t *buffer, uint8_t size);

void dali_eeprom_init(void)
{
	/* EEPROM͕핔޽\ݒ */
	enum status_code error_code = eeprom_emulator_init();

	if (error_code == STATUS_ERR_NO_MEMORY) {
		while (true) {
			/* ޲˭ނEEPROM̈悪ݒ肳ĂȂB */
		}
	}
	else if (error_code != STATUS_OK) {
		/* ͕EEPROM؏(̫ϯĂ܂͉񕜕s\Ɖ) */
		eeprom_emulator_erase_memory();
		eeprom_emulator_init();
	}
}

uint8_t create_bcc_code(uint8_t *buffer, uint8_t size)
{
	uint8_t i, ret=0;
	for (i = 0; i < size; i++)
	{
		ret ^= *(buffer + i);
	}
	return ret;
}

uint8_t dali_read_check_eeprom(uint8_t logical_page, uint8_t *buffer, uint8_t size)
{
	uint8_t ret;
	ret = eeprom_emulator_read_page(logical_page, buffer);
	if (ret == STATUS_OK) {
		/* BCCA傫BCC܂܂B */
		if (create_bcc_code(buffer, size) == buffer[size]) {
			ret = STATUS_OK;
		} else {
			ret = STATUS_ERR_BAD_DATA;
		}
	}
	return ret;
}

uint8_t dali_check_write_eeprom(uint8_t logical_page, uint8_t *buffer, uint8_t size)
{
	uint8_t ret;
	/* BCC쐬A傫BCC܂܂B */
	buffer[size] = create_bcc_code(buffer, size);
	ret = eeprom_emulator_write_page(logical_page, buffer);
	eeprom_emulator_commit_page_buffer();
	return ret;
}