/**
 * \file
 *
 * \brief SAM D20/D21/R21ʸۯ ײ
 *
 * 쌠 (c) 2012 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef SYSTEM_CLOCK_GCLK_H_INCLUDED
#define SYSTEM_CLOCK_GCLK_H_INCLUDED

/**
 * \addtogroup asfdoc_sam0_system_clock_group
 *
 * @{
 */

#include <compiler.h>

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \brief p\GCLK̈ꗗ
 *
 * p\GCLK̈ꗗB̗񋓂͂̓ɎgpGCLKI
 * ߂ɎӋ@\޲ ײނŎgp܂B
 *
 * p\GCLK퐔޲ˑłB
 */
enum gclk_generator {
	GCLK_GENERATOR_0,	/**< GCLK0 */
#if defined(__DOXYGEN__) || (GCLK_GEN_NUM_MSB > 0)
	GCLK_GENERATOR_1,	/**< GCLK1 */
#endif
#if defined(__DOXYGEN__) || (GCLK_GEN_NUM_MSB > 1)
	GCLK_GENERATOR_2,	/**< GCLK2 */
#endif
#if defined(__DOXYGEN__) || (GCLK_GEN_NUM_MSB > 2)
	GCLK_GENERATOR_3,	/**< GCLK3 */
#endif
#if defined(__DOXYGEN__) || (GCLK_GEN_NUM_MSB > 3)
	GCLK_GENERATOR_4,	/**< GCLK4 */
#endif
#if defined(__DOXYGEN__) || (GCLK_GEN_NUM_MSB > 4)
	GCLK_GENERATOR_5,	/**< GCLK5 */
#endif
#if defined(__DOXYGEN__) || (GCLK_GEN_NUM_MSB > 5)
	GCLK_GENERATOR_6,	/**< GCLK6 */
#endif
#if defined(__DOXYGEN__) || (GCLK_GEN_NUM_MSB > 6)
	GCLK_GENERATOR_7,	/**< GCLK7 */
#endif
#if defined(__DOXYGEN__) || (GCLK_GEN_NUM_MSB > 7)
	GCLK_GENERATOR_8,	/**< GCLK8 */
#endif
#if defined(__DOXYGEN__) || (GCLK_GEN_NUM_MSB > 8)
	GCLK_GENERATOR_9,	/**< GCLK9 */
#endif
#if defined(__DOXYGEN__) || (GCLK_GEN_NUM_MSB > 9)
	GCLK_GENERATOR_10,	/**< GCLK10 */
#endif
#if defined(__DOXYGEN__) || (GCLK_GEN_NUM_MSB > 10)
	GCLK_GENERATOR_11,	/**< GCLK11 */
#endif
#if defined(__DOXYGEN__) || (GCLK_GEN_NUM_MSB > 11)
	GCLK_GENERATOR_12,	/**< GCLK12 */
#endif
#if defined(__DOXYGEN__) || (GCLK_GEN_NUM_MSB > 12)
	GCLK_GENERATOR_13,	/**< GCLK13 */
#endif
#if defined(__DOXYGEN__) || (GCLK_GEN_NUM_MSB > 13)
	GCLK_GENERATOR_14,	/**< GCLK14 */
#endif
#if defined(__DOXYGEN__) || (GCLK_GEN_NUM_MSB > 14)
	GCLK_GENERATOR_15,	/**< GCLK15 */
#endif
#if defined(__DOXYGEN__) || (GCLK_GEN_NUM_MSB > 15)
	GCLK_GENERATOR_16,	/**< GCLK16 */
#endif
};

/**
 * \brief ʸۯ`Ԑݒ\
 *
 * ʸۯٗp`Ԑݒ\́B̍\͎̂gp҉pɂĕύX
 * O\ref system_gclk_gen_get_config_defaults()֐ɂďׂ
 * B
 */
struct system_gclk_gen_config {
	uint8_t source_clock;		/**< ۯَwW */
	bool high_when_disabled;	/**< \c trueȂAoق͋֎~HighłB */
	uint32_t division_factor;	/**< ͂Ɣrۯo͂̐W */
	bool run_in_standby;		/**< \c trueȂAۯ޲޲쒆ɋێ܂B */
	bool output_enable;			/**< \c trueȂAGPIO݂ւGCLKo͂܂B */
};

/**
 * \brief ʸۯ`Ԑݒ\
 *
 * ʸۯ ٗp`Ԑݒ\́B̍\͎̂gp҉pɂĕύXO
 * \ref system_gclk_chan_get_config_defaults()֐ɂďׂłB
 */
struct system_gclk_chan_config {
	enum gclk_generator source_generator;	/**< ʸۯ틟 */
};

/** \name ʸۯǗ
 * @{
 */

/**
 * \brief ʰ޳Pʕ޽ɓĂ邩𔻒f
 *
 * bȂʰ޳Ӌ@\Pʕʰ޳ ޽ɑ΂镡̸ۯ̈ɓnČ
 * ݓĂ邩m邽߂ɒׂ܂B͎gp҉pœ̂߂̋扻x
 * h߁Å֐ꂪł悤ȎԂ܂ŒPʕł̍XȂ鑀̒x
 * Ɏgp邱Ƃł܂B
 *
 * \return bȂʰ޳Pʕ̓
 *
 * \retval true  Pʕꍇ
 * \retval false Pʕis̏ꍇ
 */
static inline bool system_gclk_is_syncing(void)
{
	if (GCLK->STATUS.reg & GCLK_STATUS_SYNCBUSY) {
		return true;
	}

	return false;
}

void system_gclk_init(void);

/** @} */


/**
 * \name ʸۯǗ()
 * @{
 */

/**
 * \brief ʸۯ`Ԑݒ\̂ɏ
 *
 * ^ꂽʸۯ`Ԑݒ\̂mɊl̑gɏ܂B
 * ֐͎gp҉pɂĕύXOɂ̌`Ԑݒ\̂̑SĂ̐V
 * ̂ŌĂ΂ׂłB
 *
 * `Ԑݒ͎̒ʂłB:
 *  \li ۯ͋g番ȂŐ܂B
 *  \li 킪֎~鎞ɸۯo͂LowłB
 *  \li ͸ۯ͓͸ۯ 0狟܂B
 *  \li ۯ͋x~ɋ֎~܂B
 *  \li ۯo͕͂GPIO݂ɔz܂B
 *
 * \param[out]  config lɏ`Ԑݒ\
 */
static inline void system_gclk_gen_get_config_defaults(
		struct system_gclk_gen_config *const config)
{
	/*  */
	Assert(config);

	/* `Ԑݒl */
	config->division_factor    = 1;
	config->high_when_disabled = false;
	config->source_clock       = GCLK_SOURCE_OSC8M;
	config->run_in_standby     = false;
	config->output_enable      = false;
}

void system_gclk_gen_set_config(
		const uint8_t generator,
		struct system_gclk_gen_config *const config);

void system_gclk_gen_enable(
		const uint8_t generator);

void system_gclk_gen_disable(
		const uint8_t generator);

bool system_gclk_gen_is_enabled(
		const uint8_t generator);

/** @} */


/**
 * \name ʸۯǗ()
 * @{
 */

/**
 * \brief ʸۯ`Ԑݒ\̂ɏ
 *
 * ^ꂽʸۯ`Ԑݒ\̂m̊l̑gɏ܂B̊֐
 * gp҉pɂĕύXOɂ̌`Ԑݒ\̂̑SĂ̐V̂Ō
 * ΂ׂłB
 *
 * `Ԑݒ͎̒ʂłB:
 *  \li ۯ͈ʸۯ0狟܂B
 *  \li ۯ`Ԑݒ͐ݒ莞ɏݎ{܂B
 *
 * \param[out]  config lɏ`Ԑݒ\
 */
static inline void system_gclk_chan_get_config_defaults(
		struct system_gclk_chan_config *const config)
{
	/*  */
	Assert(config);

	/* `Ԑݒl */
	config->source_generator = GCLK_GENERATOR_0;
}

void system_gclk_chan_set_config(
		const uint8_t channel,
		struct system_gclk_chan_config *const config);

void system_gclk_chan_enable(
		const uint8_t channel);

void system_gclk_chan_disable(
		const uint8_t channel);

bool system_gclk_chan_is_enabled(
		const uint8_t channel);

void system_gclk_chan_lock(
		const uint8_t channel);

bool system_gclk_chan_is_locked(
		const uint8_t channel);

/** @} */


/**
 * \name ʸۯg擾
 * @{
 */

uint32_t system_gclk_gen_get_hz(
		const uint8_t generator);

uint32_t system_gclk_chan_get_hz(
		const uint8_t channel);

/** @} */

#ifdef __cplusplus
}
#endif

/** @} */

#endif
