/**
 * \file
 *
 * \brief NVMCTRLp\iLq
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAMD20_NVMCTRL_COMPONENT_
#define _SAMD20_NVMCTRL_COMPONENT_

/* ========================================================================== */
/** NVMCTRLpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAMD20_NVMCTRL sؐ */
/*@{*/

#define REV_NVMCTRL								0x102

/* -------- NVMCTRL_CTRLA : (NVMCTRLψ:0x00) (R/W 16)NVMA -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t CMD:7;				/*!< ޯ0` 6: w */
    uint16_t :1;				/*!< ޯ    7: \ */
    uint16_t CMDEX:8;			/*!< ޯ8`15: wߎs */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} NVMCTRL_CTRLA_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define NVMCTRL_CTRLA_OFFSET					0x00			/**< \brief (NVMCTRL_CTRLA offset)NVMA */
#define NVMCTRL_CTRLA_RESETVALUE				0x0000			/**< \brief (NVMCTRL_CTRLA reset_value)NVMA */

#define NVMCTRL_CTRLA_CMD_Pos					0				/**< \brief (NVMCTRL_CTRLA)w */
#define NVMCTRL_CTRLA_CMD_Msk					(0x7Fu << NVMCTRL_CTRLA_CMD_Pos)
#define NVMCTRL_CTRLA_CMD(value)				((NVMCTRL_CTRLA_CMD_Msk & ((value) << NVMCTRL_CTRLA_CMD_Pos)))
#define   NVMCTRL_CTRLA_CMD_ER_Val					0x2u			/**< \brief (NVMCTRL_CTRLA) */
#define   NVMCTRL_CTRLA_CMD_WP_Val					0x4u			/**< \brief (NVMCTRL_CTRLA)߰ޏ */
#define   NVMCTRL_CTRLA_CMD_EAR_Val					0x5u			/**< \brief (NVMCTRL_CTRLA)⏕ */
#define   NVMCTRL_CTRLA_CMD_WAP_Val					0x6u			/**< \brief (NVMCTRL_CTRLA)⏕񏑂 */
#define   NVMCTRL_CTRLA_CMD_SF_Val					0xAu			/**< \brief (NVMCTRL_CTRLA)ی̗w */
#define   NVMCTRL_CTRLA_CMD_WL_Val					0xFu			/**< \brief (NVMCTRL_CTRLA){ޯď */
#define   NVMCTRL_CTRLA_CMD_LR_Val					0x40u			/**< \brief (NVMCTRL_CTRLA)̈{ */
#define   NVMCTRL_CTRLA_CMD_UR_Val					0x41u			/**< \brief (NVMCTRL_CTRLA)̈ */
#define   NVMCTRL_CTRLA_CMD_SPRM_Val				0x42u			/**< \brief (NVMCTRL_CTRLA)d͍팸ݒ */
#define   NVMCTRL_CTRLA_CMD_CPRM_Val				0x43u			/**< \brief (NVMCTRL_CTRLA)d͍팸 */
#define   NVMCTRL_CTRLA_CMD_PBC_Val					0x44u			/**< \brief (NVMCTRL_CTRLA)߰ފɏՕ */
#define   NVMCTRL_CTRLA_CMD_SSB_Val					0x45u			/**< \brief (NVMCTRL_CTRLA)یޯĐݒ */
#define   NVMCTRL_CTRLA_CMD_SMR_Val					0x54u			/**< \brief (NVMCTRL_CTRLA)ԋ@\ؾ */
#define NVMCTRL_CTRLA_CMD_ER					(NVMCTRL_CTRLA_CMD_ER_Val	<< NVMCTRL_CTRLA_CMD_Pos)
#define NVMCTRL_CTRLA_CMD_WP					(NVMCTRL_CTRLA_CMD_WP_Val	<< NVMCTRL_CTRLA_CMD_Pos)
#define NVMCTRL_CTRLA_CMD_EAR					(NVMCTRL_CTRLA_CMD_EAR_Val	<< NVMCTRL_CTRLA_CMD_Pos)
#define NVMCTRL_CTRLA_CMD_WAP					(NVMCTRL_CTRLA_CMD_WAP_Val	<< NVMCTRL_CTRLA_CMD_Pos)
#define NVMCTRL_CTRLA_CMD_SF					(NVMCTRL_CTRLA_CMD_SF_Val	<< NVMCTRL_CTRLA_CMD_Pos)
#define NVMCTRL_CTRLA_CMD_WL					(NVMCTRL_CTRLA_CMD_WL_Val	<< NVMCTRL_CTRLA_CMD_Pos)
#define NVMCTRL_CTRLA_CMD_LR					(NVMCTRL_CTRLA_CMD_LR_Val	<< NVMCTRL_CTRLA_CMD_Pos)
#define NVMCTRL_CTRLA_CMD_UR					(NVMCTRL_CTRLA_CMD_UR_Val	<< NVMCTRL_CTRLA_CMD_Pos)
#define NVMCTRL_CTRLA_CMD_SPRM					(NVMCTRL_CTRLA_CMD_SPRM_Val	<< NVMCTRL_CTRLA_CMD_Pos)
#define NVMCTRL_CTRLA_CMD_CPRM					(NVMCTRL_CTRLA_CMD_CPRM_Val	<< NVMCTRL_CTRLA_CMD_Pos)
#define NVMCTRL_CTRLA_CMD_PBC					(NVMCTRL_CTRLA_CMD_PBC_Val	<< NVMCTRL_CTRLA_CMD_Pos)
#define NVMCTRL_CTRLA_CMD_SSB					(NVMCTRL_CTRLA_CMD_SSB_Val	<< NVMCTRL_CTRLA_CMD_Pos)
#define NVMCTRL_CTRLA_CMD_SMR					(NVMCTRL_CTRLA_CMD_SMR_Val	<< NVMCTRL_CTRLA_CMD_Pos)
#define NVMCTRL_CTRLA_CMDEX_Pos					8				/**< \brief (NVMCTRL_CTRLA)wߎs */
#define NVMCTRL_CTRLA_CMDEX_Msk					(0xFFu << NVMCTRL_CTRLA_CMDEX_Pos)
#define NVMCTRL_CTRLA_CMDEX(value)				((NVMCTRL_CTRLA_CMDEX_Msk & ((value) << NVMCTRL_CTRLA_CMDEX_Pos)))
#define   NVMCTRL_CTRLA_CMDEX_KEY_Val				0xA5u			/**< \brief (NVMCTRL_CTRLA) Execution Key */
#define NVMCTRL_CTRLA_CMDEX_KEY					(NVMCTRL_CTRLA_CMDEX_KEY_Val   << NVMCTRL_CTRLA_CMDEX_Pos)
#define NVMCTRL_CTRLA_MASK						0xFF7Fu			/**< \brief (NVMCTRL_CTRLA)Օڼ޽ */

/* -------- NVMCTRL_CTRLB : (NVMCTRLψ:0x04) (R/W 32)NVMB -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t :1;				/*!< ޯ     0: \ */
    uint32_t RWS:4;				/*!< ޯ 1` 4: NVMǂݍݑ҂ */
    uint32_t :2;				/*!< ޯ 5` 6: \ */
    uint32_t MANW:1;			/*!< ޯ     7: 蓮 */
    uint32_t SLEEPPRM:2;		/*!< ޯ 8` 9: x~d͍팸 */
    uint32_t :6;				/*!< ޯ10`15: \ */
    uint32_t READMODE:2;		/*!< ޯ16`17: NVMCTRLǂݍݓ */
    uint32_t CACHEDIS:1;		/*!< ޯ    18: ֎~ */
    uint32_t :13;				/*!< ޯ19`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} NVMCTRL_CTRLB_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define NVMCTRL_CTRLB_OFFSET					0x04			/**< \brief (NVMCTRL_CTRLB offset)NVMB */
#define NVMCTRL_CTRLB_RESETVALUE				0x00000000		/**< \brief (NVMCTRL_CTRLB reset_value)NVMB */

#define NVMCTRL_CTRLB_RWS_Pos					1				/**< \brief (NVMCTRL_CTRLB)NVMǂݍݑ҂ */
#define NVMCTRL_CTRLB_RWS_Msk					(0xFu << NVMCTRL_CTRLB_RWS_Pos)
#define NVMCTRL_CTRLB_RWS(value)				((NVMCTRL_CTRLB_RWS_Msk & ((value) << NVMCTRL_CTRLB_RWS_Pos)))
#define   NVMCTRL_CTRLB_RWS_SINGLE_Val				0x0u			/**< \brief (NVMCTRL_CTRLB)Pꎩ҂ */
#define   NVMCTRL_CTRLB_RWS_HALF_Val				0x1u			/**< \brief (NVMCTRL_CTRLB)҂ */
#define   NVMCTRL_CTRLB_RWS_DUAL_Val				0x2u			/**< \brief (NVMCTRL_CTRLB)2d҂ */
#define NVMCTRL_CTRLB_RWS_SINGLE				(NVMCTRL_CTRLB_RWS_SINGLE_Val	<< NVMCTRL_CTRLB_RWS_Pos)
#define NVMCTRL_CTRLB_RWS_HALF					(NVMCTRL_CTRLB_RWS_HALF_Val		<< NVMCTRL_CTRLB_RWS_Pos)
#define NVMCTRL_CTRLB_RWS_DUAL					(NVMCTRL_CTRLB_RWS_DUAL_Val		<< NVMCTRL_CTRLB_RWS_Pos)
#define NVMCTRL_CTRLB_MANW_Pos					7				/**< \brief (NVMCTRL_CTRLB)蓮 */
#define NVMCTRL_CTRLB_MANW						(0x1u << NVMCTRL_CTRLB_MANW_Pos)
#define NVMCTRL_CTRLB_SLEEPPRM_Pos				8				/**< \brief (NVMCTRL_CTRLB)x~d͍팸 */
#define NVMCTRL_CTRLB_SLEEPPRM_Msk				(0x3u << NVMCTRL_CTRLB_SLEEPPRM_Pos)
#define NVMCTRL_CTRLB_SLEEPPRM(value)			((NVMCTRL_CTRLB_SLEEPPRM_Msk & ((value) << NVMCTRL_CTRLB_SLEEPPRM_Pos)))
#define   NVMCTRL_CTRLB_SLEEPPRM_WAKEONACCESS_Val	0x0u			/**< \brief (NVMCTRL_CTRLB)񱸾ŋN */
#define   NVMCTRL_CTRLB_SLEEPPRM_WAKEUPINSTANT_Val	0x1u			/**< \brief (NVMCTRL_CTRLB)x~oŋN */
#define   NVMCTRL_CTRLB_SLEEPPRM_DISABLED_Val		0x3u			/**< \brief (NVMCTRL_CTRLB)d͍팸֎~ */
#define NVMCTRL_CTRLB_SLEEPPRM_WAKEONACCESS		(NVMCTRL_CTRLB_SLEEPPRM_WAKEONACCESS_Val	<< NVMCTRL_CTRLB_SLEEPPRM_Pos)
#define NVMCTRL_CTRLB_SLEEPPRM_WAKEUPINSTANT	(NVMCTRL_CTRLB_SLEEPPRM_WAKEUPINSTANT_Val	<< NVMCTRL_CTRLB_SLEEPPRM_Pos)
#define NVMCTRL_CTRLB_SLEEPPRM_DISABLED			(NVMCTRL_CTRLB_SLEEPPRM_DISABLED_Val << NVMCTRL_CTRLB_SLEEPPRM_Pos)
#define NVMCTRL_CTRLB_READMODE_Pos				16				/**< \brief (NVMCTRL_CTRLB)NVMCTRLǂݍݓ */
#define NVMCTRL_CTRLB_READMODE_Msk				(0x3u << NVMCTRL_CTRLB_READMODE_Pos)
#define NVMCTRL_CTRLB_READMODE(value)			((NVMCTRL_CTRLB_READMODE_Msk & ((value) << NVMCTRL_CTRLB_READMODE_Pos)))
#define NVMCTRL_CTRLB_CACHEDIS_Pos  18			/**< \brief (NVMCTRL_CTRLB)֎~ */
#define NVMCTRL_CTRLB_CACHEDIS					(0x1u << NVMCTRL_CTRLB_CACHEDIS_Pos)
#define NVMCTRL_CTRLB_MASK						0x0007039Eu		/**< \brief (NVMCTRL_CTRLB)Օڼ޽ */

/* -------- NVMCTRL_PARAM : (NVMCTRLψ:0x08) (R/W 32)Ұ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t NVMP:16;			/*!< ޯ 0`15: NVM- */
    uint32_t PSZ:3;				/*!< ޯ16`18: ߰ނ̑傫 */
    uint32_t :13;				/*!< ޯ19`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} NVMCTRL_PARAM_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define NVMCTRL_PARAM_OFFSET					0x08			/**< \brief (NVMCTRL_PARAM offset)Ұ */
#define NVMCTRL_PARAM_RESETVALUE				0x00000000		/**< \brief (NVMCTRL_PARAM reset_value)Ұ */

#define NVMCTRL_PARAM_NVMP_Pos					0				/**< \brief (NVMCTRL_PARAM)NVM- */
#define NVMCTRL_PARAM_NVMP_Msk					(0xFFFFu << NVMCTRL_PARAM_NVMP_Pos)
#define NVMCTRL_PARAM_NVMP(value)				((NVMCTRL_PARAM_NVMP_Msk & ((value) << NVMCTRL_PARAM_NVMP_Pos)))
#define NVMCTRL_PARAM_PSZ_Pos					16				/**< \brief (NVMCTRL_PARAM)߰ނ̑傫 */
#define NVMCTRL_PARAM_PSZ_Msk					(0x7u << NVMCTRL_PARAM_PSZ_Pos)
#define NVMCTRL_PARAM_PSZ(value)				((NVMCTRL_PARAM_PSZ_Msk & ((value) << NVMCTRL_PARAM_PSZ_Pos)))
#define NVMCTRL_PARAM_MASK						0x0007FFFFu		/**< \brief (NVMCTRL_PARAM)Օڼ޽ */

/* -------- NVMCTRL_INTENCLR : (NVMCTRLψ:0x0C) (R/W  8)荞݋ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  READY:1;			/*!< ޯ    0: NVM荞݋֎~ */
    uint8_t  ERROR:1;			/*!< ޯ    1: ُ튄荞݋֎~ */
    uint8_t  :6;				/*!< ޯ2` 7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg; 					/*!< ڼ޽ Ɏgp^ */
} NVMCTRL_INTENCLR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define NVMCTRL_INTENCLR_OFFSET					0x0C			/**< \brief (NVMCTRL_INTENCLR offset)荞݋ */
#define NVMCTRL_INTENCLR_RESETVALUE				0x00			/**< \brief (NVMCTRL_INTENCLR reset_value)荞݋ */

#define NVMCTRL_INTENCLR_READY_Pos				0				/**< \brief (NVMCTRL_INTENCLR)NVM荞݋֎~ */
#define NVMCTRL_INTENCLR_READY					(0x1u << NVMCTRL_INTENCLR_READY_Pos)
#define NVMCTRL_INTENCLR_ERROR_Pos				1				/**< \brief (NVMCTRL_INTENCLR)ُ튄荞݋֎~ */
#define NVMCTRL_INTENCLR_ERROR					(0x1u << NVMCTRL_INTENCLR_ERROR_Pos)
#define NVMCTRL_INTENCLR_MASK					0x03u 			/**< \brief (NVMCTRL_INTENCLR)Օڼ޽ */

/* -------- NVMCTRL_INTENSET : (NVMCTRLψ:0x10) (R/W  8)荞݋ݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  READY:1;			/*!< ޯ    0: NVM荞݋ */
    uint8_t  ERROR:1;			/*!< ޯ    1: ُ튄荞݋ */
    uint8_t  :6;				/*!< ޯ2` 7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg; 					/*!< ڼ޽ Ɏgp^ */
} NVMCTRL_INTENSET_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define NVMCTRL_INTENSET_OFFSET					0x10			/**< \brief (NVMCTRL_INTENSET offset)荞݋ݒ */
#define NVMCTRL_INTENSET_RESETVALUE				0x00			/**< \brief (NVMCTRL_INTENSET reset_value)荞݋ݒ */

#define NVMCTRL_INTENSET_READY_Pos				0				/**< \brief (NVMCTRL_INTENSET)NVM荞݋ */
#define NVMCTRL_INTENSET_READY					(0x1u << NVMCTRL_INTENSET_READY_Pos)
#define NVMCTRL_INTENSET_ERROR_Pos				1				/**< \brief (NVMCTRL_INTENSET)ُ튄荞݋ */
#define NVMCTRL_INTENSET_ERROR					(0x1u << NVMCTRL_INTENSET_ERROR_Pos)
#define NVMCTRL_INTENSET_MASK					0x03u 			/**< \brief (NVMCTRL_INTENSET)Օڼ޽ */

/* -------- NVMCTRL_INTFLAG : (NVMCTRLψ:0x14) (R/W  8)荞׸ޏ/ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  READY:1;			/*!< ޯ    0: NVM荞׸ */
    uint8_t  ERROR:1;			/*!< ޯ    1: ُ튄荞׸ */
    uint8_t  :6;				/*!< ޯ2` 7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg; 					/*!< ڼ޽ Ɏgp^ */
} NVMCTRL_INTFLAG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define NVMCTRL_INTFLAG_OFFSET					0x14			/**< \brief (NVMCTRL_INTFLAG offset)荞׸ޏ/ */
#define NVMCTRL_INTFLAG_RESETVALUE				0x00			/**< \brief (NVMCTRL_INTFLAG reset_value)荞׸ޏ/ */

#define NVMCTRL_INTFLAG_READY_Pos				0				/**< \brief (NVMCTRL_INTFLAG)NVM荞׸ */
#define NVMCTRL_INTFLAG_READY					(0x1u << NVMCTRL_INTFLAG_READY_Pos)
#define NVMCTRL_INTFLAG_ERROR_Pos				1				/**< \brief (NVMCTRL_INTFLAG)ُ튄荞׸ */
#define NVMCTRL_INTFLAG_ERROR					(0x1u << NVMCTRL_INTFLAG_ERROR_Pos)
#define NVMCTRL_INTFLAG_MASK					0x03u 			/**< \brief (NVMCTRL_INTFLAG)Օڼ޽ */

/* -------- NVMCTRL_STATUS : (NVMCTRLψ:0x18) (R/W 16) -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t PRM:1;				/*!< ޯ    0: d͍팸 */
    uint16_t LOAD:1;			/*!< ޯ    1: NVM߰ފɏՕݒ蒆 */
    uint16_t PROGE:1;			/*!< ޯ    2: ۸ݸވُ */
    uint16_t LOCKE:1;			/*!< ޯ    3: {ُ */
    uint16_t NVME:1;			/*!< ޯ    4: NVMُ */
    uint16_t :3;				/*!< ޯ5` 7: \ */
    uint16_t SB:1;				/*!< ޯ    8: یޯď */
    uint16_t :7;				/*!< ޯ9`15: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} NVMCTRL_STATUS_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define NVMCTRL_STATUS_OFFSET					0x18			/**< \brief (NVMCTRL_STATUS offset) */
#define NVMCTRL_STATUS_RESETVALUE				0x0000			/**< \brief (NVMCTRL_STATUS reset_value) */

#define NVMCTRL_STATUS_PRM_Pos					0				/**< \brief (NVMCTRL_STATUS)d͍팸 */
#define NVMCTRL_STATUS_PRM						(0x1u << NVMCTRL_STATUS_PRM_Pos)
#define NVMCTRL_STATUS_LOAD_Pos					1				/**< \brief (NVMCTRL_STATUS)NVM߰ފɏՕݒ蒆 */
#define NVMCTRL_STATUS_LOAD						(0x1u << NVMCTRL_STATUS_LOAD_Pos)
#define NVMCTRL_STATUS_PROGE_Pos				2				/**< \brief (NVMCTRL_STATUS)۸ݸވُ */
#define NVMCTRL_STATUS_PROGE					(0x1u << NVMCTRL_STATUS_PROGE_Pos)
#define NVMCTRL_STATUS_LOCKE_Pos				3				/**< \brief (NVMCTRL_STATUS){ُ */
#define NVMCTRL_STATUS_LOCKE					(0x1u << NVMCTRL_STATUS_LOCKE_Pos)
#define NVMCTRL_STATUS_NVME_Pos					4				/**< \brief (NVMCTRL_STATUS)NVMُ */
#define NVMCTRL_STATUS_NVME						(0x1u << NVMCTRL_STATUS_NVME_Pos)
#define NVMCTRL_STATUS_SB_Pos					8				/**< \brief (NVMCTRL_STATUS)یޯď */
#define NVMCTRL_STATUS_SB						(0x1u << NVMCTRL_STATUS_SB_Pos)
#define NVMCTRL_STATUS_MASK						0x011Fu			/**< \brief (NVMCTRL_STATUS)Օڼ޽ */

/* -------- NVMCTRL_ADDR : (NVMCTRLψ:0x1C) (R/W 32)ڽ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t ADDR:22;			/*!< ޯ 0`21: NVMڽ */
    uint32_t :10;				/*!< ޯ22`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} NVMCTRL_ADDR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define NVMCTRL_ADDR_OFFSET						0x1C			/**< \brief (NVMCTRL_ADDR offset)ڽ */
#define NVMCTRL_ADDR_RESETVALUE					0x00000000		/**< \brief (NVMCTRL_ADDR reset_value)ڽ */

#define NVMCTRL_ADDR_ADDR_Pos					0				/**< \brief (NVMCTRL_ADDR)NVMڽ */
#define NVMCTRL_ADDR_ADDR_Msk					(0x3FFFFFu << NVMCTRL_ADDR_ADDR_Pos)
#define NVMCTRL_ADDR_ADDR(value)				((NVMCTRL_ADDR_ADDR_Msk & ((value) << NVMCTRL_ADDR_ADDR_Pos)))
#define NVMCTRL_ADDR_MASK						0x003FFFFFu		/**< \brief (NVMCTRL_ADDR)Օڼ޽ */

/* -------- NVMCTRL_LOCK : (NVMCTRLψ:0x20) (R/W 16){ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t LOCK:16;			/*!< ޯ0`15: ̈{ޯ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} NVMCTRL_LOCK_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define NVMCTRL_LOCK_OFFSET						0x20			/**< \brief (NVMCTRL_LOCK offset){ */
#define NVMCTRL_LOCK_RESETVALUE					0x0000			/**< \brief (NVMCTRL_LOCK reset_value){ */

#define NVMCTRL_LOCK_LOCK_Pos					0				/**< \brief (NVMCTRL_LOCK)̈{ޯ */
#define NVMCTRL_LOCK_LOCK_Msk					(0xFFFFu << NVMCTRL_LOCK_LOCK_Pos)
#define NVMCTRL_LOCK_LOCK(value)				((NVMCTRL_LOCK_LOCK_Msk & ((value) << NVMCTRL_LOCK_LOCK_Pos)))
#define NVMCTRL_LOCK_MASK						0xFFFFu			/**< \brief (NVMCTRL_LOCK)Օڼ޽ */

/** \brief NVMCTRL APBʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  __IO NVMCTRL_CTRLA_Type		CTRLA;			/**< \briefψ:0x00 (R/W 16)NVMA */
	   RoReg8					Reserved1[0x2];
  __IO NVMCTRL_CTRLB_Type		CTRLB;			/**< \briefψ:0x04 (R/W 32)NVMB */
  __IO NVMCTRL_PARAM_Type		PARAM;			/**< \briefψ:0x08 (R/W 32)Ұ */
  __IO NVMCTRL_INTENCLR_Type	INTENCLR;		/**< \briefψ:0x0C (R/W  8)荞݋ */
	   RoReg8					Reserved2[0x3];
  __IO NVMCTRL_INTENSET_Type	INTENSET;		/**< \briefψ:0x10 (R/W  8)荞݋ݒ */
	   RoReg8					Reserved3[0x3];
  __IO NVMCTRL_INTFLAG_Type		INTFLAG;		/**< \briefψ:0x14 (R/W  8)荞׸ޏ/ */
	   RoReg8					Reserved4[0x3];
  __IO NVMCTRL_STATUS_Type		STATUS;			/**< \briefψ:0x18 (R/W 16) */
	   RoReg8					Reserved5[0x2];
  __IO NVMCTRL_ADDR_Type		ADDR;			/**< \briefψ:0x1C (R/W 32)ڽ */
  __IO NVMCTRL_LOCK_Type		LOCK;			/**< \briefψ:0x20 (R/W 16){ */
} Nvmctrl;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

/* ************************************************************************** */
/** s˭ޗpĳӋ@\API` */
/* ************************************************************************** */
/** \addtogroup fuses_api Ӌ@\ĳAPI */
/*@{*/


#define ADC_FUSES_BIASCAL_ADDR				(NVMCTRL_OTP4 + 4)
#define ADC_FUSES_BIASCAL_Pos				3				/**< \brief (NVMCTRL_OTP4)ADC޲Z */
#define ADC_FUSES_BIASCAL_Msk				(0x7u << ADC_FUSES_BIASCAL_Pos)
#define ADC_FUSES_BIASCAL(value)			((ADC_FUSES_BIASCAL_Msk & ((value) << ADC_FUSES_BIASCAL_Pos)))

#define ADC_FUSES_GAINCORR_ADDR				NVMCTRL_OTP4
#define ADC_FUSES_GAINCORR_Pos				3				/**< \brief (NVMCTRL_OTP4)ADCZ */
#define ADC_FUSES_GAINCORR_Msk				(0xFFFu << ADC_FUSES_GAINCORR_Pos)
#define ADC_FUSES_GAINCORR(value)			((ADC_FUSES_GAINCORR_Msk & ((value) << ADC_FUSES_GAINCORR_Pos)))

#define ADC_FUSES_LINEARITY_0_ADDR			NVMCTRL_OTP4
#define ADC_FUSES_LINEARITY_0_Pos			27				/**< \brief (NVMCTRL_OTP4)ADCޯ4`0 */
#define ADC_FUSES_LINEARITY_0_Msk			(0x1Fu << ADC_FUSES_LINEARITY_0_Pos)
#define ADC_FUSES_LINEARITY_0(value)		((ADC_FUSES_LINEARITY_0_Msk & ((value) << ADC_FUSES_LINEARITY_0_Pos)))

#define ADC_FUSES_LINEARITY_1_ADDR			(NVMCTRL_OTP4 + 4)
#define ADC_FUSES_LINEARITY_1_Pos			0				/**< \brief (NVMCTRL_OTP4)ADCޯ7`5 */
#define ADC_FUSES_LINEARITY_1_Msk			(0x7u << ADC_FUSES_LINEARITY_1_Pos)
#define ADC_FUSES_LINEARITY_1(value)		((ADC_FUSES_LINEARITY_1_Msk & ((value) << ADC_FUSES_LINEARITY_1_Pos)))

#define ADC_FUSES_OFFSETCORR_ADDR			NVMCTRL_OTP4
#define ADC_FUSES_OFFSETCORR_Pos			15				/**< \brief (NVMCTRL_OTP4)ADCψʕ␳ */
#define ADC_FUSES_OFFSETCORR_Msk			(0xFFFu << ADC_FUSES_OFFSETCORR_Pos)
#define ADC_FUSES_OFFSETCORR(value)			((ADC_FUSES_OFFSETCORR_Msk & ((value) << ADC_FUSES_OFFSETCORR_Pos)))

#define NVMCTRL_FUSES_BOOTPROT_ADDR			NVMCTRL_USER
#define NVMCTRL_FUSES_BOOTPROT_Pos			0				/**< \brief (NVMCTRL_USER)ް۰ނ̑傫 */
#define NVMCTRL_FUSES_BOOTPROT_Msk			(0x7u << NVMCTRL_FUSES_BOOTPROT_Pos)
#define NVMCTRL_FUSES_BOOTPROT(value)		((NVMCTRL_FUSES_BOOTPROT_Msk & ((value) << NVMCTRL_FUSES_BOOTPROT_Pos)))

#define NVMCTRL_FUSES_EEPROM_SIZE_ADDR		NVMCTRL_USER
#define NVMCTRL_FUSES_EEPROM_SIZE_Pos		4				/**< \brief (NVMCTRL_USER)EEPROM̑傫 */
#define NVMCTRL_FUSES_EEPROM_SIZE_Msk		(0x7u << NVMCTRL_FUSES_EEPROM_SIZE_Pos)
#define NVMCTRL_FUSES_EEPROM_SIZE(value)	((NVMCTRL_FUSES_EEPROM_SIZE_Msk & ((value) << NVMCTRL_FUSES_EEPROM_SIZE_Pos)))

#define NVMCTRL_FUSES_LOCKFIELD_ADDR		NVMCTRL_LOCKBIT
#define NVMCTRL_FUSES_LOCKFIELD_Pos			0				/**< \brief (NVMCTRL_LOCKBIT){̈ */
#define NVMCTRL_FUSES_LOCKFIELD_Msk			(0xFFu << NVMCTRL_FUSES_LOCKFIELD_Pos)
#define NVMCTRL_FUSES_LOCKFIELD(value)		((NVMCTRL_FUSES_LOCKFIELD_Msk & ((value) << NVMCTRL_FUSES_LOCKFIELD_Pos)))

#define NVMCTRL_FUSES_NVMP_ADDR				NVMCTRL_OTP1
#define NVMCTRL_FUSES_NVMP_Pos				16				/**< \brief (NVMCTRL_OTP1)NVM߰ސ */
#define NVMCTRL_FUSES_NVMP_Msk				(0xFFFFu << NVMCTRL_FUSES_NVMP_Pos)
#define NVMCTRL_FUSES_NVMP(value)			((NVMCTRL_FUSES_NVMP_Msk & ((value) << NVMCTRL_FUSES_NVMP_Pos)))

#define NVMCTRL_FUSES_NVM_LOCK_ADDR			NVMCTRL_OTP1
#define NVMCTRL_FUSES_NVM_LOCK_Pos			0				/**< \brief (NVMCTRL_OTP1)NVM{ */
#define NVMCTRL_FUSES_NVM_LOCK_Msk			(0xFFu << NVMCTRL_FUSES_NVM_LOCK_Pos)
#define NVMCTRL_FUSES_NVM_LOCK(value)		((NVMCTRL_FUSES_NVM_LOCK_Msk & ((value) << NVMCTRL_FUSES_NVM_LOCK_Pos)))

#define NVMCTRL_FUSES_PSZ_ADDR				NVMCTRL_OTP1
#define NVMCTRL_FUSES_PSZ_Pos				8				/**< \brief (NVMCTRL_OTP1)NVM߰ނ̑傫 */
#define NVMCTRL_FUSES_PSZ_Msk				(0xFu << NVMCTRL_FUSES_PSZ_Pos)
#define NVMCTRL_FUSES_PSZ(value)			((NVMCTRL_FUSES_PSZ_Msk & ((value) << NVMCTRL_FUSES_PSZ_Pos)))

#define NVMCTRL_FUSES_REGION_LOCKS_ADDR		(NVMCTRL_USER + 4)
#define NVMCTRL_FUSES_REGION_LOCKS_Pos		16				/**< \brief (NVMCTRL_USER)NVM̈{ */
#define NVMCTRL_FUSES_REGION_LOCKS_Msk		(0xFFFFu << NVMCTRL_FUSES_REGION_LOCKS_Pos)
#define NVMCTRL_FUSES_REGION_LOCKS(value)	((NVMCTRL_FUSES_REGION_LOCKS_Msk & ((value) << NVMCTRL_FUSES_REGION_LOCKS_Pos)))

#define SYSCTRL_FUSES_OSC32KCAL_ADDR		(NVMCTRL_OTP4 + 4)
#define SYSCTRL_FUSES_OSC32KCAL_Pos			6 /**< \brief (NVMCTRL_OTP4)OSC32KZ */
#define SYSCTRL_FUSES_OSC32KCAL_Msk			(0x7Fu << SYSCTRL_FUSES_OSC32KCAL_Pos)
#define SYSCTRL_FUSES_OSC32KCAL(value)		((SYSCTRL_FUSES_OSC32KCAL_Msk & ((value) << SYSCTRL_FUSES_OSC32KCAL_Pos)))

#define SYSCTRL_FUSES_BOD12USERLEVEL_ADDR	NVMCTRL_USER
#define SYSCTRL_FUSES_BOD12USERLEVEL_Pos	17				/**< \brief (NVMCTRL_USER)BOD12gp */
#define SYSCTRL_FUSES_BOD12USERLEVEL_Msk	(0x1Fu << SYSCTRL_FUSES_BOD12USERLEVEL_Pos)
#define SYSCTRL_FUSES_BOD12USERLEVEL(value)	((SYSCTRL_FUSES_BOD12USERLEVEL_Msk & ((value) << SYSCTRL_FUSES_BOD12USERLEVEL_Pos)))

#define SYSCTRL_FUSES_BOD12_ACTION_ADDR		NVMCTRL_USER
#define SYSCTRL_FUSES_BOD12_ACTION_Pos		23				/**< \brief (NVMCTRL_USER)BOD12 */
#define SYSCTRL_FUSES_BOD12_ACTION_Msk		(0x3u << SYSCTRL_FUSES_BOD12_ACTION_Pos)
#define SYSCTRL_FUSES_BOD12_ACTION(value)	((SYSCTRL_FUSES_BOD12_ACTION_Msk & ((value) << SYSCTRL_FUSES_BOD12_ACTION_Pos)))

#define SYSCTRL_FUSES_BOD12_EN_ADDR			NVMCTRL_USER
#define SYSCTRL_FUSES_BOD12_EN_Pos			22				/**< \brief (NVMCTRL_USER)BOD12 */
#define SYSCTRL_FUSES_BOD12_EN_Msk			(0x1u << SYSCTRL_FUSES_BOD12_EN_Pos)

#define SYSCTRL_FUSES_BOD33USERLEVEL_ADDR	NVMCTRL_USER
#define SYSCTRL_FUSES_BOD33USERLEVEL_Pos	8				/**< \brief (NVMCTRL_USER)BOD33gp */
#define SYSCTRL_FUSES_BOD33USERLEVEL_Msk	(0x3Fu << SYSCTRL_FUSES_BOD33USERLEVEL_Pos)
#define SYSCTRL_FUSES_BOD33USERLEVEL(value)	((SYSCTRL_FUSES_BOD33USERLEVEL_Msk & ((value) << SYSCTRL_FUSES_BOD33USERLEVEL_Pos)))

#define SYSCTRL_FUSES_BOD33_ACTION_ADDR		NVMCTRL_USER
#define SYSCTRL_FUSES_BOD33_ACTION_Pos		15				/**< \brief (NVMCTRL_USER)BOD33 */
#define SYSCTRL_FUSES_BOD33_ACTION_Msk		(0x3u << SYSCTRL_FUSES_BOD33_ACTION_Pos)
#define SYSCTRL_FUSES_BOD33_ACTION(value)	((SYSCTRL_FUSES_BOD33_ACTION_Msk & ((value) << SYSCTRL_FUSES_BOD33_ACTION_Pos)))

#define SYSCTRL_FUSES_BOD33_EN_ADDR			NVMCTRL_USER
#define SYSCTRL_FUSES_BOD33_EN_Pos			14				/**< \brief (NVMCTRL_USER)BOD33 */
#define SYSCTRL_FUSES_BOD33_EN_Msk			(0x1u << SYSCTRL_FUSES_BOD33_EN_Pos)

#define SYSCTRL_FUSES_ULPVREG_ADDR			NVMCTRL_OTP4
#define SYSCTRL_FUSES_ULPVREG_Pos			0				/**< \brief (NVMCTRL_OTP4)ULPkމ^] */
#define SYSCTRL_FUSES_ULPVREG_Msk			(0x7u << SYSCTRL_FUSES_ULPVREG_Pos)
#define SYSCTRL_FUSES_ULPVREG(value)		((SYSCTRL_FUSES_ULPVREG_Msk & ((value) << SYSCTRL_FUSES_ULPVREG_Pos)))

#define WDT_FUSES_ALWAYSON_ADDR				NVMCTRL_USER
#define WDT_FUSES_ALWAYSON_Pos				26				/**< \brief (NVMCTRL_USER)WDT펞ON */
#define WDT_FUSES_ALWAYSON_Msk				(0x1u << WDT_FUSES_ALWAYSON_Pos)

#define WDT_FUSES_ENABLE_ADDR				NVMCTRL_USER
#define WDT_FUSES_ENABLE_Pos				25				/**< \brief (NVMCTRL_USER)WDT */
#define WDT_FUSES_ENABLE_Msk				(0x1u << WDT_FUSES_ENABLE_Pos)

#define WDT_FUSES_EWOFFSET_ADDR				(NVMCTRL_USER + 4)
#define WDT_FUSES_EWOFFSET_Pos				3				/**< \brief (NVMCTRL_USER)WDTxψ */
#define WDT_FUSES_EWOFFSET_Msk				(0xFu << WDT_FUSES_EWOFFSET_Pos)
#define WDT_FUSES_EWOFFSET(value)			((WDT_FUSES_EWOFFSET_Msk & ((value) << WDT_FUSES_EWOFFSET_Pos)))

#define WDT_FUSES_PER_ADDR					NVMCTRL_USER
#define WDT_FUSES_PER_Pos					27				/**< \brief (NVMCTRL_USER)WDT */
#define WDT_FUSES_PER_Msk					(0xFu << WDT_FUSES_PER_Pos)
#define WDT_FUSES_PER(value)				((WDT_FUSES_PER_Msk & ((value) << WDT_FUSES_PER_Pos)))

#define WDT_FUSES_WEN_ADDR					(NVMCTRL_USER + 4)
#define WDT_FUSES_WEN_Pos					7				/**< \brief (NVMCTRL_USER)WDT싖 */
#define WDT_FUSES_WEN_Msk					(0x1u << WDT_FUSES_WEN_Pos)

#define WDT_FUSES_WINDOW_0_ADDR				NVMCTRL_USER
#define WDT_FUSES_WINDOW_0_Pos				31				/**< \brief (NVMCTRL_USER)WDTޯ0 */
#define WDT_FUSES_WINDOW_0_Msk				(0x1u << WDT_FUSES_WINDOW_0_Pos)

#define WDT_FUSES_WINDOW_1_ADDR				(NVMCTRL_USER + 4)
#define WDT_FUSES_WINDOW_1_Pos				0				/**< \brief (NVMCTRL_USER)WDTޯ3`1 */
#define WDT_FUSES_WINDOW_1_Msk				(0x7u << WDT_FUSES_WINDOW_1_Pos)
#define WDT_FUSES_WINDOW_1(value)			((WDT_FUSES_WINDOW_1_Msk & ((value) << WDT_FUSES_WINDOW_1_Pos)))

/*@}*/

#endif /* _SAMD20_NVMCTRL_COMPONENT_ */
