/**
 * \file
 *
 * \brief SERCOMp\iLq
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAMD20_SERCOM_COMPONENT_
#define _SAMD20_SERCOM_COMPONENT_

/* ========================================================================== */
/** SERCOMpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAMD20_SERCOM ʐM̪ */
/*@{*/

#define REV_SERCOM								0x101

/* -------- SERCOM_I2CM_CTRLA : (SERCOMψ:0x00) (R/W 32) I2CM I2CMA -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t SWRST:1;			/*!< ޯ     0: ĳ ؾ */
    uint32_t ENABLE:1;			/*!< ޯ     1:  */
    uint32_t MODE:3;			/*!< ޯ 2` 4: ` */
    uint32_t :2;				/*!< ޯ 5` 6: \ */
    uint32_t RUNSTDBY:1;		/*!< ޯ     7: ޲s */
    uint32_t :8;				/*!< ޯ 8`15: \ */
    uint32_t PINOUT:1;			/*!< ޯ    16: ݎg */
    uint32_t :3;				/*!< ޯ17`19: \ */
    uint32_t SDAHOLD:2;			/*!< ޯ20`21: SDAێ */
    uint32_t :6;				/*!< ޯ22`27: \ */
    uint32_t INACTOUT:2;		/*!< ޯ28`29: s޽ */
    uint32_t LOWTOUT:1;			/*!< ޯ    30: SCL Low */
    uint32_t :1;				/*!< ޯ    31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_I2CM_CTRLA_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_I2CM_CTRLA_OFFSET				0x00			/**< \brief (SERCOM_I2CM_CTRLA offset)I2CMA */
#define SERCOM_I2CM_CTRLA_RESETVALUE			0x00000000		/**< \brief (SERCOM_I2CM_CTRLA reset_value)I2CMA */

#define SERCOM_I2CM_CTRLA_SWRST_Pos				0				/**< \brief (SERCOM_I2CM_CTRLA)ĳ ؾ */
#define SERCOM_I2CM_CTRLA_SWRST					(0x1u << SERCOM_I2CM_CTRLA_SWRST_Pos)
#define SERCOM_I2CM_CTRLA_ENABLE_Pos 1			/**< \brief (SERCOM_I2CM_CTRLA) */
#define SERCOM_I2CM_CTRLA_ENABLE				(0x1u << SERCOM_I2CM_CTRLA_ENABLE_Pos)
#define SERCOM_I2CM_CTRLA_MODE_Pos				2				/**< \brief (SERCOM_I2CM_CTRLA)` */
#define SERCOM_I2CM_CTRLA_MODE_Msk				(0x7u << SERCOM_I2CM_CTRLA_MODE_Pos)
#define SERCOM_I2CM_CTRLA_MODE(value)			((SERCOM_I2CM_CTRLA_MODE_Msk & ((value) << SERCOM_I2CM_CTRLA_MODE_Pos)))
#define   SERCOM_I2CM_CTRLA_MODE_USART_EXT_CLK_Val	0x0u		/**< \brief (SERCOM_I2CM_CTRLA)OۯłUSART */
#define   SERCOM_I2CM_CTRLA_MODE_USART_INT_CLK_Val	0x1u		/**< \brief (SERCOM_I2CM_CTRLA)ۯłUSART */
#define   SERCOM_I2CM_CTRLA_MODE_SPI_SLAVE_Val		0x2u		/**< \brief (SERCOM_I2CM_CTRLA)OۯłSPI */
#define   SERCOM_I2CM_CTRLA_MODE_SPI_MASTER_Val		0x3u		/**< \brief (SERCOM_I2CM_CTRLA)ۯłSPI */
#define   SERCOM_I2CM_CTRLA_MODE_I2C_SLAVE_Val		0x4u		/**< \brief (SERCOM_I2CM_CTRLA)OۯłI2C */
#define   SERCOM_I2CM_CTRLA_MODE_I2C_MASTER_Val		0x5u		/**< \brief (SERCOM_I2CM_CTRLA)ۯłI2C */
#define SERCOM_I2CM_CTRLA_MODE_USART_EXT_CLK	(SERCOM_I2CM_CTRLA_MODE_USART_EXT_CLK_Val	<< SERCOM_I2CM_CTRLA_MODE_Pos)
#define SERCOM_I2CM_CTRLA_MODE_USART_INT_CLK	(SERCOM_I2CM_CTRLA_MODE_USART_INT_CLK_Val	<< SERCOM_I2CM_CTRLA_MODE_Pos)
#define SERCOM_I2CM_CTRLA_MODE_SPI_SLAVE		(SERCOM_I2CM_CTRLA_MODE_SPI_SLAVE_Val		<< SERCOM_I2CM_CTRLA_MODE_Pos)
#define SERCOM_I2CM_CTRLA_MODE_SPI_MASTER		(SERCOM_I2CM_CTRLA_MODE_SPI_MASTER_Val		<< SERCOM_I2CM_CTRLA_MODE_Pos)
#define SERCOM_I2CM_CTRLA_MODE_I2C_SLAVE		(SERCOM_I2CM_CTRLA_MODE_I2C_SLAVE_Val		<< SERCOM_I2CM_CTRLA_MODE_Pos)
#define SERCOM_I2CM_CTRLA_MODE_I2C_MASTER		(SERCOM_I2CM_CTRLA_MODE_I2C_MASTER_Val		<< SERCOM_I2CM_CTRLA_MODE_Pos)
#define SERCOM_I2CM_CTRLA_RUNSTDBY_Pos			7				/**< \brief (SERCOM_I2CM_CTRLA)޲s */
#define SERCOM_I2CM_CTRLA_RUNSTDBY				(0x1u << SERCOM_I2CM_CTRLA_RUNSTDBY_Pos)
#define SERCOM_I2CM_CTRLA_PINOUT_Pos			16				/**< \brief (SERCOM_I2CM_CTRLA)ݎg */
#define SERCOM_I2CM_CTRLA_PINOUT				(0x1u << SERCOM_I2CM_CTRLA_PINOUT_Pos)
#define SERCOM_I2CM_CTRLA_SDAHOLD_Pos			20				/**< \brief (SERCOM_I2CM_CTRLA)SDAێ */
#define SERCOM_I2CM_CTRLA_SDAHOLD_Msk			(0x3u << SERCOM_I2CM_CTRLA_SDAHOLD_Pos)
#define SERCOM_I2CM_CTRLA_SDAHOLD(value)		((SERCOM_I2CM_CTRLA_SDAHOLD_Msk & ((value) << SERCOM_I2CM_CTRLA_SDAHOLD_Pos)))
#define SERCOM_I2CM_CTRLA_INACTOUT_Pos			28				/**< \brief (SERCOM_I2CM_CTRLA)s޽ */
#define SERCOM_I2CM_CTRLA_INACTOUT_Msk			(0x3u << SERCOM_I2CM_CTRLA_INACTOUT_Pos)
#define SERCOM_I2CM_CTRLA_INACTOUT(value)		((SERCOM_I2CM_CTRLA_INACTOUT_Msk & ((value) << SERCOM_I2CM_CTRLA_INACTOUT_Pos)))
#define SERCOM_I2CM_CTRLA_LOWTOUT_Pos			30				/**< \brief (SERCOM_I2CM_CTRLA)SCL Low */
#define SERCOM_I2CM_CTRLA_LOWTOUT				(0x1u << SERCOM_I2CM_CTRLA_LOWTOUT_Pos)
#define SERCOM_I2CM_CTRLA_MASK					0x7031009Fu		/**< \brief (SERCOM_I2CM_CTRLA)Օڼ޽ */

/* -------- SERCOM_I2CS_CTRLA : (SERCOMψ:0x00) (R/W 32) I2CS I2CSA -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t SWRST:1;			/*!< ޯ     0: ĳ ؾ */
    uint32_t ENABLE:1;			/*!< ޯ     1:  */
    uint32_t MODE:3;			/*!< ޯ 2` 4: ` */
    uint32_t :2;				/*!< ޯ 5` 6: \ */
    uint32_t RUNSTDBY:1;		/*!< ޯ     7: ޲s */
    uint32_t :8;				/*!< ޯ 8`15: \ */
    uint32_t PINOUT:1;			/*!< ޯ    16: ݎg */
    uint32_t :3;				/*!< ޯ17`19: \ */
    uint32_t SDAHOLD:2;			/*!< ޯ20`21: SDAێ */
    uint32_t :8;				/*!< ޯ22`29: \ */
    uint32_t LOWTOUT:1;			/*!< ޯ    30: SCL Low */
    uint32_t :1;				/*!< ޯ    31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_I2CS_CTRLA_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_I2CS_CTRLA_OFFSET				0x00			/**< \brief (SERCOM_I2CS_CTRLA offset)I2CSA */
#define SERCOM_I2CS_CTRLA_RESETVALUE			0x00000000		/**< \brief (SERCOM_I2CS_CTRLA reset_value)I2CSA */

#define SERCOM_I2CS_CTRLA_SWRST_Pos				0				/**< \brief (SERCOM_I2CS_CTRLA)ĳ ؾ */
#define SERCOM_I2CS_CTRLA_SWRST					(0x1u << SERCOM_I2CS_CTRLA_SWRST_Pos)
#define SERCOM_I2CS_CTRLA_ENABLE_Pos			1				/**< \brief (SERCOM_I2CS_CTRLA) */
#define SERCOM_I2CS_CTRLA_ENABLE				(0x1u << SERCOM_I2CS_CTRLA_ENABLE_Pos)
#define SERCOM_I2CS_CTRLA_MODE_Pos				2				/**< \brief (SERCOM_I2CS_CTRLA)` */
#define SERCOM_I2CS_CTRLA_MODE_Msk				(0x7u << SERCOM_I2CS_CTRLA_MODE_Pos)
#define SERCOM_I2CS_CTRLA_MODE(value)			((SERCOM_I2CS_CTRLA_MODE_Msk & ((value) << SERCOM_I2CS_CTRLA_MODE_Pos)))
#define   SERCOM_I2CS_CTRLA_MODE_USART_EXT_CLK_Val	0x0u		/**< \brief (SERCOM_I2CS_CTRLA)OۯłUSART */
#define   SERCOM_I2CS_CTRLA_MODE_USART_INT_CLK_Val	0x1u		/**< \brief (SERCOM_I2CS_CTRLA)ۯłUSART */
#define   SERCOM_I2CS_CTRLA_MODE_SPI_SLAVE_Val		0x2u		/**< \brief (SERCOM_I2CS_CTRLA)OۯłSPI */
#define   SERCOM_I2CS_CTRLA_MODE_SPI_MASTER_Val		0x3u		/**< \brief (SERCOM_I2CS_CTRLA)ۯłSPI */
#define   SERCOM_I2CS_CTRLA_MODE_I2C_SLAVE_Val		0x4u		/**< \brief (SERCOM_I2CS_CTRLA)OۯłI2C */
#define   SERCOM_I2CS_CTRLA_MODE_I2C_MASTER_Val		0x5u		/**< \brief (SERCOM_I2CS_CTRLA)ۯłI2C */
#define SERCOM_I2CS_CTRLA_MODE_USART_EXT_CLK	(SERCOM_I2CS_CTRLA_MODE_USART_EXT_CLK_Val	<< SERCOM_I2CS_CTRLA_MODE_Pos)
#define SERCOM_I2CS_CTRLA_MODE_USART_INT_CLK	(SERCOM_I2CS_CTRLA_MODE_USART_INT_CLK_Val	<< SERCOM_I2CS_CTRLA_MODE_Pos)
#define SERCOM_I2CS_CTRLA_MODE_SPI_SLAVE		(SERCOM_I2CS_CTRLA_MODE_SPI_SLAVE_Val		<< SERCOM_I2CS_CTRLA_MODE_Pos)
#define SERCOM_I2CS_CTRLA_MODE_SPI_MASTER		(SERCOM_I2CS_CTRLA_MODE_SPI_MASTER_Val		<< SERCOM_I2CS_CTRLA_MODE_Pos)
#define SERCOM_I2CS_CTRLA_MODE_I2C_SLAVE		(SERCOM_I2CS_CTRLA_MODE_I2C_SLAVE_Val		<< SERCOM_I2CS_CTRLA_MODE_Pos)
#define SERCOM_I2CS_CTRLA_MODE_I2C_MASTER		(SERCOM_I2CS_CTRLA_MODE_I2C_MASTER_Val		<< SERCOM_I2CS_CTRLA_MODE_Pos)
#define SERCOM_I2CS_CTRLA_RUNSTDBY_Pos			7				/**< \brief (SERCOM_I2CS_CTRLA)޲s */
#define SERCOM_I2CS_CTRLA_RUNSTDBY				(0x1u << SERCOM_I2CS_CTRLA_RUNSTDBY_Pos)
#define SERCOM_I2CS_CTRLA_PINOUT_Pos			16				/**< \brief (SERCOM_I2CS_CTRLA)ݎg */
#define SERCOM_I2CS_CTRLA_PINOUT				(0x1u << SERCOM_I2CS_CTRLA_PINOUT_Pos)
#define SERCOM_I2CS_CTRLA_SDAHOLD_Pos			20				/**< \brief (SERCOM_I2CS_CTRLA)SDAێ */
#define SERCOM_I2CS_CTRLA_SDAHOLD_Msk			(0x3u << SERCOM_I2CS_CTRLA_SDAHOLD_Pos)
#define SERCOM_I2CS_CTRLA_SDAHOLD(value)		((SERCOM_I2CS_CTRLA_SDAHOLD_Msk & ((value) << SERCOM_I2CS_CTRLA_SDAHOLD_Pos)))
#define SERCOM_I2CS_CTRLA_LOWTOUT_Pos			30				/**< \brief (SERCOM_I2CS_CTRLA)SCL Low */
#define SERCOM_I2CS_CTRLA_LOWTOUT				(0x1u << SERCOM_I2CS_CTRLA_LOWTOUT_Pos)
#define SERCOM_I2CS_CTRLA_MASK					0x4031009Fu		/**< \brief (SERCOM_I2CS_CTRLA)Օڼ޽ */

/* -------- SERCOM_SPI_CTRLA : (SERCOMψ:0x00) (R/W 32) SPI SPIA -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t SWRST:1;			/*!< ޯ     0: ĳ ؾ */
    uint32_t ENABLE:1;			/*!< ޯ     1:  */
    uint32_t MODE:3;			/*!< ޯ 2` 4: ` */
    uint32_t :2;				/*!< ޯ 5` 6: \ */
    uint32_t RUNSTDBY:1;		/*!< ޯ     7: ޲s */
    uint32_t :8;				/*!< ޯ 8`15: \ */
    uint32_t DOPO:1;			/*!< ޯ    16: ްoݔzu */
    uint32_t :3;				/*!< ޯ17`19: \ */
    uint32_t DIPO:2;			/*!< ޯ20`21: ްݔzu */
    uint32_t :2;				/*!< ޯ22`23: \ */
    uint32_t FORM:4;			/*!< ޯ24`27: ڰь` */
    uint32_t CPHA:1;			/*!< ޯ    28: ۯʑ */
    uint32_t CPOL:1;			/*!< ޯ    29: ۯɐ */
    uint32_t DORD:1;			/*!< ޯ    30: ް */
    uint32_t :1;				/*!< ޯ    31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_SPI_CTRLA_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_SPI_CTRLA_OFFSET					0x00			/**< \brief (SERCOM_SPI_CTRLA offset)SPIA */
#define SERCOM_SPI_CTRLA_RESETVALUE				0x00000000		/**< \brief (SERCOM_SPI_CTRLA reset_value)SPIA */

#define SERCOM_SPI_CTRLA_SWRST_Pos				0				/**< \brief (SERCOM_SPI_CTRLA)ĳ ؾ */
#define SERCOM_SPI_CTRLA_SWRST					(0x1u << SERCOM_SPI_CTRLA_SWRST_Pos)
#define SERCOM_SPI_CTRLA_ENABLE_Pos				1				/**< \brief (SERCOM_SPI_CTRLA) */
#define SERCOM_SPI_CTRLA_ENABLE					(0x1u << SERCOM_SPI_CTRLA_ENABLE_Pos)
#define SERCOM_SPI_CTRLA_MODE_Pos				2				/**< \brief (SERCOM_SPI_CTRLA)` */
#define SERCOM_SPI_CTRLA_MODE_Msk				(0x7u << SERCOM_SPI_CTRLA_MODE_Pos)
#define SERCOM_SPI_CTRLA_MODE(value)			((SERCOM_SPI_CTRLA_MODE_Msk & ((value) << SERCOM_SPI_CTRLA_MODE_Pos)))
#define   SERCOM_SPI_CTRLA_MODE_USART_EXT_CLK_Val	0x0u		/**< \brief (SERCOM_SPI_CTRLA)OۯłUSART */
#define   SERCOM_SPI_CTRLA_MODE_USART_INT_CLK_Val	0x1u		/**< \brief (SERCOM_SPI_CTRLA)ۯłUSART */
#define   SERCOM_SPI_CTRLA_MODE_SPI_SLAVE_Val		0x2u		/**< \brief (SERCOM_SPI_CTRLA)OۯłSPI */
#define   SERCOM_SPI_CTRLA_MODE_SPI_MASTER_Val		0x3u		/**< \brief (SERCOM_SPI_CTRLA)ۯłSPI */
#define   SERCOM_SPI_CTRLA_MODE_I2C_SLAVE_Val		0x4u		/**< \brief (SERCOM_SPI_CTRLA)OۯłI2C */
#define   SERCOM_SPI_CTRLA_MODE_I2C_MASTER_Val		0x5u		/**< \brief (SERCOM_SPI_CTRLA)ۯłI2C */
#define SERCOM_SPI_CTRLA_MODE_USART_EXT_CLK		(SERCOM_SPI_CTRLA_MODE_USART_EXT_CLK_Val	<< SERCOM_SPI_CTRLA_MODE_Pos)
#define SERCOM_SPI_CTRLA_MODE_USART_INT_CLK		(SERCOM_SPI_CTRLA_MODE_USART_INT_CLK_Val	<< SERCOM_SPI_CTRLA_MODE_Pos)
#define SERCOM_SPI_CTRLA_MODE_SPI_SLAVE			(SERCOM_SPI_CTRLA_MODE_SPI_SLAVE_Val		<< SERCOM_SPI_CTRLA_MODE_Pos)
#define SERCOM_SPI_CTRLA_MODE_SPI_MASTER		(SERCOM_SPI_CTRLA_MODE_SPI_MASTER_Val		<< SERCOM_SPI_CTRLA_MODE_Pos)
#define SERCOM_SPI_CTRLA_MODE_I2C_SLAVE			(SERCOM_SPI_CTRLA_MODE_I2C_SLAVE_Val		<< SERCOM_SPI_CTRLA_MODE_Pos)
#define SERCOM_SPI_CTRLA_MODE_I2C_MASTER		(SERCOM_SPI_CTRLA_MODE_I2C_MASTER_Val		<< SERCOM_SPI_CTRLA_MODE_Pos)
#define SERCOM_SPI_CTRLA_RUNSTDBY_Pos			7				/**< \brief (SERCOM_SPI_CTRLA)޲s */
#define SERCOM_SPI_CTRLA_RUNSTDBY				(0x1u << SERCOM_SPI_CTRLA_RUNSTDBY_Pos)
#define SERCOM_SPI_CTRLA_DOPO_Pos				16				/**< \brief (SERCOM_SPI_CTRLA)ްoݔzu */
#define SERCOM_SPI_CTRLA_DOPO					(0x1u << SERCOM_SPI_CTRLA_DOPO_Pos)
#define SERCOM_SPI_CTRLA_DIPO_Pos				20				/**< \brief (SERCOM_SPI_CTRLA)ްݔzu */
#define SERCOM_SPI_CTRLA_DIPO_Msk				(0x3u << SERCOM_SPI_CTRLA_DIPO_Pos)
#define SERCOM_SPI_CTRLA_DIPO(value)			((SERCOM_SPI_CTRLA_DIPO_Msk & ((value) << SERCOM_SPI_CTRLA_DIPO_Pos)))
#define SERCOM_SPI_CTRLA_FORM_Pos				24				/**< \brief (SERCOM_SPI_CTRLA)ڰь` */
#define SERCOM_SPI_CTRLA_FORM_Msk				(0xFu << SERCOM_SPI_CTRLA_FORM_Pos)
#define SERCOM_SPI_CTRLA_FORM(value)			((SERCOM_SPI_CTRLA_FORM_Msk & ((value) << SERCOM_SPI_CTRLA_FORM_Pos)))
#define SERCOM_SPI_CTRLA_CPHA_Pos				28				/**< \brief (SERCOM_SPI_CTRLA)ۯʑ */
#define SERCOM_SPI_CTRLA_CPHA					(0x1u << SERCOM_SPI_CTRLA_CPHA_Pos)
#define SERCOM_SPI_CTRLA_CPOL_Pos				29				/**< \brief (SERCOM_SPI_CTRLA)ۯɐ */
#define SERCOM_SPI_CTRLA_CPOL					(0x1u << SERCOM_SPI_CTRLA_CPOL_Pos)
#define SERCOM_SPI_CTRLA_DORD_Pos				30				/**< \brief (SERCOM_SPI_CTRLA)ް */
#define SERCOM_SPI_CTRLA_DORD					(0x1u << SERCOM_SPI_CTRLA_DORD_Pos)
#define SERCOM_SPI_CTRLA_MASK					0x7F31009Fu		/**< \brief (SERCOM_SPI_CTRLA)Օڼ޽ */

/* -------- SERCOM_USART_CTRLA : (SERCOMψ:0x00) (R/W 32) USART USARTA -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t SWRST:1;			/*!< ޯ     0: ĳ ؾ */
    uint32_t ENABLE:1;			/*!< ޯ     1:  */
    uint32_t MODE:3;			/*!< ޯ 2` 4: ` */
    uint32_t :2;				/*!< ޯ 5` 6: \ */
    uint32_t RUNSTDBY:1;		/*!< ޯ     7: ޲s */
    uint32_t :8;				/*!< ޯ 8`15: \ */
    uint32_t TXPO:1;			/*!< ޯ    16: Mް ݔzu */
    uint32_t :3;				/*!< ޯ17`19: \ */
    uint32_t RXPO:2;			/*!< ޯ20`21: Mް ݔzu */
    uint32_t :2;				/*!< ޯ22`23: \ */
    uint32_t FORM:4;			/*!< ޯ24`27: ڰь` */
    uint32_t CMODE:1;			/*!< ޯ    28: ʐM` */
    uint32_t CPOL:1;			/*!< ޯ    29: ۯɐ */
    uint32_t DORD:1;			/*!< ޯ    30: ް */
    uint32_t :1;				/*!< ޯ    31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_USART_CTRLA_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_USART_CTRLA_OFFSET				0x00			/**< \brief (SERCOM_USART_CTRLA offset)USARTA */
#define SERCOM_USART_CTRLA_RESETVALUE			0x00000000		/**< \brief (SERCOM_USART_CTRLA reset_value)USARTA */

#define SERCOM_USART_CTRLA_SWRST_Pos			0				/**< \brief (SERCOM_USART_CTRLA)ĳ ؾ */
#define SERCOM_USART_CTRLA_SWRST				(0x1u << SERCOM_USART_CTRLA_SWRST_Pos)
#define SERCOM_USART_CTRLA_ENABLE_Pos			1				/**< \brief (SERCOM_USART_CTRLA) */
#define SERCOM_USART_CTRLA_ENABLE				(0x1u << SERCOM_USART_CTRLA_ENABLE_Pos)
#define SERCOM_USART_CTRLA_MODE_Pos				2				/**< \brief (SERCOM_USART_CTRLA)` */
#define SERCOM_USART_CTRLA_MODE_Msk				(0x7u << SERCOM_USART_CTRLA_MODE_Pos)
#define SERCOM_USART_CTRLA_MODE(value)			((SERCOM_USART_CTRLA_MODE_Msk & ((value) << SERCOM_USART_CTRLA_MODE_Pos)))
#define   SERCOM_USART_CTRLA_MODE_USART_EXT_CLK_Val	0x0u		/**< \brief (SERCOM_USART_CTRLA)OۯłUSART */
#define   SERCOM_USART_CTRLA_MODE_USART_INT_CLK_Val	0x1u		/**< \brief (SERCOM_USART_CTRLA)ۯłUSART */
#define   SERCOM_USART_CTRLA_MODE_SPI_SLAVE_Val		0x2u		/**< \brief (SERCOM_USART_CTRLA)OۯłSPI */
#define   SERCOM_USART_CTRLA_MODE_SPI_MASTER_Val	0x3u		/**< \brief (SERCOM_USART_CTRLA)ۯłSPI */
#define   SERCOM_USART_CTRLA_MODE_I2C_SLAVE_Val		0x4u		/**< \brief (SERCOM_USART_CTRLA)OۯłI2C */
#define   SERCOM_USART_CTRLA_MODE_I2C_MASTER_Val	0x5u		/**< \brief (SERCOM_USART_CTRLA)ۯłI2C */
#define SERCOM_USART_CTRLA_MODE_USART_EXT_CLK	(SERCOM_USART_CTRLA_MODE_USART_EXT_CLK_Val	<< SERCOM_USART_CTRLA_MODE_Pos)
#define SERCOM_USART_CTRLA_MODE_USART_INT_CLK	(SERCOM_USART_CTRLA_MODE_USART_INT_CLK_Val	<< SERCOM_USART_CTRLA_MODE_Pos)
#define SERCOM_USART_CTRLA_MODE_SPI_SLAVE		(SERCOM_USART_CTRLA_MODE_SPI_SLAVE_Val		<< SERCOM_USART_CTRLA_MODE_Pos)
#define SERCOM_USART_CTRLA_MODE_SPI_MASTER		(SERCOM_USART_CTRLA_MODE_SPI_MASTER_Val		<< SERCOM_USART_CTRLA_MODE_Pos)
#define SERCOM_USART_CTRLA_MODE_I2C_SLAVE		(SERCOM_USART_CTRLA_MODE_I2C_SLAVE_Val		<< SERCOM_USART_CTRLA_MODE_Pos)
#define SERCOM_USART_CTRLA_MODE_I2C_MASTER		(SERCOM_USART_CTRLA_MODE_I2C_MASTER_Val		<< SERCOM_USART_CTRLA_MODE_Pos)
#define SERCOM_USART_CTRLA_RUNSTDBY_Pos			7				/**< \brief (SERCOM_USART_CTRLA)޲s */
#define SERCOM_USART_CTRLA_RUNSTDBY				(0x1u << SERCOM_USART_CTRLA_RUNSTDBY_Pos)
#define SERCOM_USART_CTRLA_TXPO_Pos				16				/**< \brief (SERCOM_USART_CTRLA)Mް ݔzu */
#define SERCOM_USART_CTRLA_TXPO					(0x1u << SERCOM_USART_CTRLA_TXPO_Pos)
#define SERCOM_USART_CTRLA_RXPO_Pos				20				/**< \brief (SERCOM_USART_CTRLA)Mް ݔzu */
#define SERCOM_USART_CTRLA_RXPO_Msk				(0x3u << SERCOM_USART_CTRLA_RXPO_Pos)
#define SERCOM_USART_CTRLA_RXPO(value)			((SERCOM_USART_CTRLA_RXPO_Msk & ((value) << SERCOM_USART_CTRLA_RXPO_Pos)))
#define SERCOM_USART_CTRLA_FORM_Pos				24				/**< \brief (SERCOM_USART_CTRLA)ڰь` */
#define SERCOM_USART_CTRLA_FORM_Msk				(0xFu << SERCOM_USART_CTRLA_FORM_Pos)
#define SERCOM_USART_CTRLA_FORM(value)			((SERCOM_USART_CTRLA_FORM_Msk & ((value) << SERCOM_USART_CTRLA_FORM_Pos)))
#define SERCOM_USART_CTRLA_CMODE_Pos			28				/**< \brief (SERCOM_USART_CTRLA)ʐM` */
#define SERCOM_USART_CTRLA_CMODE				(0x1u << SERCOM_USART_CTRLA_CMODE_Pos)
#define SERCOM_USART_CTRLA_CPOL_Pos				29				/**< \brief (SERCOM_USART_CTRLA)ۯɐ */
#define SERCOM_USART_CTRLA_CPOL					(0x1u << SERCOM_USART_CTRLA_CPOL_Pos)
#define SERCOM_USART_CTRLA_DORD_Pos 30			/**< \brief (SERCOM_USART_CTRLA)ް */
#define SERCOM_USART_CTRLA_DORD					(0x1u << SERCOM_USART_CTRLA_DORD_Pos)
#define SERCOM_USART_CTRLA_MASK					0x7F31009Fu		/**< \brief (SERCOM_USART_CTRLA)Օڼ޽ */

/* -------- SERCOM_I2CM_CTRLB : (SERCOMψ:0x04) (R/W 32) I2CM I2CMB -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t :8;				/*!< ޯ 0` 7: \ */
    uint32_t SMEN:1;			/*!< ޯ     8: 싖 */
    uint32_t QCEN:1;			/*!< ޯ     9: vwߋ */
    uint32_t :6;				/*!< ޯ10`15: \ */
    uint32_t CMD:2;				/*!< ޯ16`17: w */
    uint32_t ACKACT:1;			/*!< ޯ    18:  */
    uint32_t :13;				/*!< ޯ19`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_I2CM_CTRLB_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_I2CM_CTRLB_OFFSET				0x04			/**< \brief (SERCOM_I2CM_CTRLB offset)I2CMB */
#define SERCOM_I2CM_CTRLB_RESETVALUE			0x00000000		/**< \brief (SERCOM_I2CM_CTRLB reset_value)I2CMB */

#define SERCOM_I2CM_CTRLB_SMEN_Pos				8				/**< \brief (SERCOM_I2CM_CTRLB)싖 */
#define SERCOM_I2CM_CTRLB_SMEN					(0x1u << SERCOM_I2CM_CTRLB_SMEN_Pos)
#define SERCOM_I2CM_CTRLB_QCEN_Pos				9				/**< \brief (SERCOM_I2CM_CTRLB)vwߋ */
#define SERCOM_I2CM_CTRLB_QCEN					(0x1u << SERCOM_I2CM_CTRLB_QCEN_Pos)
#define SERCOM_I2CM_CTRLB_CMD_Pos				16				/**< \brief (SERCOM_I2CM_CTRLB)w */
#define SERCOM_I2CM_CTRLB_CMD_Msk				(0x3u << SERCOM_I2CM_CTRLB_CMD_Pos)
#define SERCOM_I2CM_CTRLB_CMD(value)			((SERCOM_I2CM_CTRLB_CMD_Msk & ((value) << SERCOM_I2CM_CTRLB_CMD_Pos)))
#define SERCOM_I2CM_CTRLB_ACKACT_Pos			18				/**< \brief (SERCOM_I2CM_CTRLB) */
#define SERCOM_I2CM_CTRLB_ACKACT				(0x1u << SERCOM_I2CM_CTRLB_ACKACT_Pos)
#define SERCOM_I2CM_CTRLB_MASK					0x00070300u		/**< \brief (SERCOM_I2CM_CTRLB)Օڼ޽ */

/* -------- SERCOM_I2CS_CTRLB : (SERCOMψ:0x04) (R/W 32) I2CS I2CSB -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t :8;				/*!< ޯ 0` 7: \ */
    uint32_t SMEN:1;			/*!< ޯ     8: 싖 */
    uint32_t :5;				/*!< ޯ 9`13: \ */
    uint32_t AMODE:2;			/*!< ޯ14`15: ڽ */
    uint32_t CMD:2;				/*!< ޯ16`17: w */
    uint32_t ACKACT:1;			/*!< ޯ    18:  */
    uint32_t :13;				/*!< ޯ19`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_I2CS_CTRLB_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_I2CS_CTRLB_OFFSET				0x04			/**< \brief (SERCOM_I2CS_CTRLB offset)I2CSB */
#define SERCOM_I2CS_CTRLB_RESETVALUE			0x00000000		/**< \brief (SERCOM_I2CS_CTRLB reset_value)I2CSB */

#define SERCOM_I2CS_CTRLB_SMEN_Pos				8				/**< \brief (SERCOM_I2CS_CTRLB)싖 */
#define SERCOM_I2CS_CTRLB_SMEN					(0x1u << SERCOM_I2CS_CTRLB_SMEN_Pos)
#define SERCOM_I2CS_CTRLB_AMODE_Pos				14				/**< \brief (SERCOM_I2CS_CTRLB)ڽ */
#define SERCOM_I2CS_CTRLB_AMODE_Msk				(0x3u << SERCOM_I2CS_CTRLB_AMODE_Pos)
#define SERCOM_I2CS_CTRLB_AMODE(value)			((SERCOM_I2CS_CTRLB_AMODE_Msk & ((value) << SERCOM_I2CS_CTRLB_AMODE_Pos)))
#define SERCOM_I2CS_CTRLB_CMD_Pos				16				/**< \brief (SERCOM_I2CS_CTRLB)w */
#define SERCOM_I2CS_CTRLB_CMD_Msk				(0x3u << SERCOM_I2CS_CTRLB_CMD_Pos)
#define SERCOM_I2CS_CTRLB_CMD(value)			((SERCOM_I2CS_CTRLB_CMD_Msk & ((value) << SERCOM_I2CS_CTRLB_CMD_Pos)))
#define SERCOM_I2CS_CTRLB_ACKACT_Pos			18				/**< \brief (SERCOM_I2CS_CTRLB) */
#define SERCOM_I2CS_CTRLB_ACKACT				(0x1u << SERCOM_I2CS_CTRLB_ACKACT_Pos)
#define SERCOM_I2CS_CTRLB_MASK					0x0007C100u		/**< \brief (SERCOM_I2CS_CTRLB)Օڼ޽ */

/* -------- SERCOM_SPI_CTRLB : (SERCOMψ:0x04) (R/W 32) SPI SPIB -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t CHSIZE:3;			/*!< ޯ 0` 2: ̑傫 */
    uint32_t :3;				/*!< ޯ 3` 5: \ */
    uint32_t PLOADEN:1;			/*!< ޯ     6: ްOݒ苖 */
    uint32_t :7;				/*!< ޯ 7`13: \ */
    uint32_t AMODE:2;			/*!< ޯ14`15: ڽ */
    uint32_t :1;				/*!< ޯ    16: \ */
    uint32_t RXEN:1;			/*!< ޯ    17: M */
    uint32_t :14;				/*!< ޯ18`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_SPI_CTRLB_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_SPI_CTRLB_OFFSET					0x04			/**< \brief (SERCOM_SPI_CTRLB offset)SPIB */
#define SERCOM_SPI_CTRLB_RESETVALUE				0x00000000		/**< \brief (SERCOM_SPI_CTRLB reset_value)SPIB */

#define SERCOM_SPI_CTRLB_CHSIZE_Pos				0				/**< \brief (SERCOM_SPI_CTRLB)̑傫 */
#define SERCOM_SPI_CTRLB_CHSIZE_Msk				(0x7u << SERCOM_SPI_CTRLB_CHSIZE_Pos)
#define SERCOM_SPI_CTRLB_CHSIZE(value)			((SERCOM_SPI_CTRLB_CHSIZE_Msk & ((value) << SERCOM_SPI_CTRLB_CHSIZE_Pos)))
#define SERCOM_SPI_CTRLB_PLOADEN_Pos			6				/**< \brief (SERCOM_SPI_CTRLB)ްOݒ苖 */
#define SERCOM_SPI_CTRLB_PLOADEN				(0x1u << SERCOM_SPI_CTRLB_PLOADEN_Pos)
#define SERCOM_SPI_CTRLB_AMODE_Pos				14				/**< \brief (SERCOM_SPI_CTRLB)ڽ */
#define SERCOM_SPI_CTRLB_AMODE_Msk				(0x3u << SERCOM_SPI_CTRLB_AMODE_Pos)
#define SERCOM_SPI_CTRLB_AMODE(value)			((SERCOM_SPI_CTRLB_AMODE_Msk & ((value) << SERCOM_SPI_CTRLB_AMODE_Pos)))
#define SERCOM_SPI_CTRLB_RXEN_Pos				17				/**< \brief (SERCOM_SPI_CTRLB)M */
#define SERCOM_SPI_CTRLB_RXEN					(0x1u << SERCOM_SPI_CTRLB_RXEN_Pos)
#define SERCOM_SPI_CTRLB_MASK					0x0002C047u		/**< \brief (SERCOM_SPI_CTRLB)Օڼ޽ */

/* -------- SERCOM_USART_CTRLB : (SERCOMψ:0x04) (R/W 32) USART USARTB -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t CHSIZE:3;			/*!< ޯ 0` 2: ̑傫 */
    uint32_t :3;				/*!< ޯ 3` 5: \ */
    uint32_t SBMODE:1;			/*!< ޯ     6: ~ޯē */
    uint32_t :2;				/*!< ޯ 7` 8: \ */
    uint32_t SFDE:1;			/*!< ޯ     9: ڰъJno */
    uint32_t :3;				/*!< ޯ10`12: \ */
    uint32_t PMODE:1;			/*!< ޯ    13: è */
    uint32_t :2;				/*!< ޯ14`15: \ */
    uint32_t TXEN:1;			/*!< ޯ    16: M */
    uint32_t RXEN:1;			/*!< ޯ    17: M */
    uint32_t :14;				/*!< ޯ18`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_USART_CTRLB_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_USART_CTRLB_OFFSET				0x04			/**< \brief (SERCOM_USART_CTRLB offset)USARTB */
#define SERCOM_USART_CTRLB_RESETVALUE			0x00000000		/**< \brief (SERCOM_USART_CTRLB reset_value)USARTB */

#define SERCOM_USART_CTRLB_CHSIZE_Pos			0				/**< \brief (SERCOM_USART_CTRLB)̑傫 */
#define SERCOM_USART_CTRLB_CHSIZE_Msk			(0x7u << SERCOM_USART_CTRLB_CHSIZE_Pos)
#define SERCOM_USART_CTRLB_CHSIZE(value)		((SERCOM_USART_CTRLB_CHSIZE_Msk & ((value) << SERCOM_USART_CTRLB_CHSIZE_Pos)))
#define SERCOM_USART_CTRLB_SBMODE_Pos			6				/**< \brief (SERCOM_USART_CTRLB)~ޯē */
#define SERCOM_USART_CTRLB_SBMODE				(0x1u << SERCOM_USART_CTRLB_SBMODE_Pos)
#define SERCOM_USART_CTRLB_SFDE_Pos				9				/**< \brief (SERCOM_USART_CTRLB)ڰъJno */
#define SERCOM_USART_CTRLB_SFDE					(0x1u << SERCOM_USART_CTRLB_SFDE_Pos)
#define SERCOM_USART_CTRLB_PMODE_Pos			13				/**< \brief (SERCOM_USART_CTRLB)è */
#define SERCOM_USART_CTRLB_PMODE				(0x1u << SERCOM_USART_CTRLB_PMODE_Pos)
#define SERCOM_USART_CTRLB_TXEN_Pos				16				/**< \brief (SERCOM_USART_CTRLB)M */
#define SERCOM_USART_CTRLB_TXEN					(0x1u << SERCOM_USART_CTRLB_TXEN_Pos)
#define SERCOM_USART_CTRLB_RXEN_Pos				17				/**< \brief (SERCOM_USART_CTRLB)M */
#define SERCOM_USART_CTRLB_RXEN					(0x1u << SERCOM_USART_CTRLB_RXEN_Pos)
#define SERCOM_USART_CTRLB_MASK					0x00032247u		/**< \brief (SERCOM_USART_CTRLB)Օڼ޽ */

/* -------- SERCOM_I2CM_DBGCTRL : (SERCOMψ:0x08) (R/W  8) I2CM I2CMޯސ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  DBGSTOP:1;			/*!< ޯ    0: ޯޓ */
    uint8_t  :7;				/*!< ޯ1` 7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_I2CM_DBGCTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_I2CM_DBGCTRL_OFFSET				0x08			/**< \brief (SERCOM_I2CM_DBGCTRL offset)I2CMޯސ */
#define SERCOM_I2CM_DBGCTRL_RESETVALUE			0x00			/**< \brief (SERCOM_I2CM_DBGCTRL reset_value)I2CMޯސ */

#define SERCOM_I2CM_DBGCTRL_DBGSTOP_Pos			0				/**< \brief (SERCOM_I2CM_DBGCTRL)ޯޓ */
#define SERCOM_I2CM_DBGCTRL_DBGSTOP				(0x1u << SERCOM_I2CM_DBGCTRL_DBGSTOP_Pos)
#define SERCOM_I2CM_DBGCTRL_MASK				0x01u			/**< \brief (SERCOM_I2CM_DBGCTRL)Օڼ޽ */

/* -------- SERCOM_SPI_DBGCTRL : (SERCOMψ:0x08) (R/W  8) SPI SPIޯސ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  DBGSTOP:1;			/*!< ޯ    0: ޯޓ */
    uint8_t  :7;				/*!< ޯ1` 7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_SPI_DBGCTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_SPI_DBGCTRL_OFFSET				0x08			/**< \brief (SERCOM_SPI_DBGCTRL offset)SPIޯސ */
#define SERCOM_SPI_DBGCTRL_RESETVALUE			0x00			/**< \brief (SERCOM_SPI_DBGCTRL reset_value)SPIޯސ */

#define SERCOM_SPI_DBGCTRL_DBGSTOP_Pos			0				/**< \brief (SERCOM_SPI_DBGCTRL)ޯޓ */
#define SERCOM_SPI_DBGCTRL_DBGSTOP				(0x1u << SERCOM_SPI_DBGCTRL_DBGSTOP_Pos)
#define SERCOM_SPI_DBGCTRL_MASK					0x01u			/**< \brief (SERCOM_SPI_DBGCTRL)Օڼ޽ */

/* -------- SERCOM_USART_DBGCTRL : (SERCOMψ:0x08) (R/W  8) USART USARTޯސ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  DBGSTOP:1;			/*!< ޯ    0: ޯޓ */
    uint8_t  :7;				/*!< ޯ1` 7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_USART_DBGCTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_USART_DBGCTRL_OFFSET				0x08			/**< \brief (SERCOM_USART_DBGCTRL offset)USARTޯސ */
#define SERCOM_USART_DBGCTRL_RESETVALUE			0x00			/**< \brief (SERCOM_USART_DBGCTRL reset_value)USARTޯސ */

#define SERCOM_USART_DBGCTRL_DBGSTOP_Pos		0				/**< \brief (SERCOM_USART_DBGCTRL)ޯޓ */
#define SERCOM_USART_DBGCTRL_DBGSTOP			(0x1u << SERCOM_USART_DBGCTRL_DBGSTOP_Pos)
#define SERCOM_USART_DBGCTRL_MASK				0x01u			/**< \brief (SERCOM_USART_DBGCTRL)Օڼ޽ */

/* -------- SERCOM_I2CM_BAUD : (SERCOMψ:0x0A) (R/W 16) I2CM I2CMްڰ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t BAUD:8;			/*!< ޯ0` 7: ްڰĒl */
    uint16_t BAUDLOW:8;			/*!< ޯ8`15: ްڰĒl */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_I2CM_BAUD_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_I2CM_BAUD_OFFSET					0x0A			/**< \brief (SERCOM_I2CM_BAUD offset)I2CMްڰ */
#define SERCOM_I2CM_BAUD_RESETVALUE				0x0000			/**< \brief (SERCOM_I2CM_BAUD reset_value)I2CMްڰ */

#define SERCOM_I2CM_BAUD_BAUD_Pos				0				/**< \brief (SERCOM_I2CM_BAUD)ްڰĒl */
#define SERCOM_I2CM_BAUD_BAUD_Msk				(0xFFu << SERCOM_I2CM_BAUD_BAUD_Pos)
#define SERCOM_I2CM_BAUD_BAUD(value)			((SERCOM_I2CM_BAUD_BAUD_Msk & ((value) << SERCOM_I2CM_BAUD_BAUD_Pos)))
#define SERCOM_I2CM_BAUD_BAUDLOW_Pos			8				/**< \brief (SERCOM_I2CM_BAUD)ްڰĒl */
#define SERCOM_I2CM_BAUD_BAUDLOW_Msk			(0xFFu << SERCOM_I2CM_BAUD_BAUDLOW_Pos)
#define SERCOM_I2CM_BAUD_BAUDLOW(value)			((SERCOM_I2CM_BAUD_BAUDLOW_Msk & ((value) << SERCOM_I2CM_BAUD_BAUDLOW_Pos)))
#define SERCOM_I2CM_BAUD_MASK					0xFFFFu		/**< \brief (SERCOM_I2CM_BAUD)Օڼ޽ */

/* -------- SERCOM_SPI_BAUD : (SERCOMψ:0x0A) (R/W  8) SPI SPIްڰ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  BAUD:8;			/*!< ޯ0` 7: ްڰĒl */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_SPI_BAUD_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_SPI_BAUD_OFFSET					0x0A			/**< \brief (SERCOM_SPI_BAUD offset)SPIްڰ */
#define SERCOM_SPI_BAUD_RESETVALUE				0x00			/**< \brief (SERCOM_SPI_BAUD reset_value)SPIްڰ */

#define SERCOM_SPI_BAUD_BAUD_Pos				0				/**< \brief (SERCOM_SPI_BAUD)ްڰĒl */
#define SERCOM_SPI_BAUD_BAUD_Msk				(0xFFu << SERCOM_SPI_BAUD_BAUD_Pos)
#define SERCOM_SPI_BAUD_BAUD(value)				((SERCOM_SPI_BAUD_BAUD_Msk & ((value) << SERCOM_SPI_BAUD_BAUD_Pos)))
#define SERCOM_SPI_BAUD_MASK					0xFFu			/**< \brief (SERCOM_SPI_BAUD)Օڼ޽ */

/* -------- SERCOM_USART_BAUD : (SERCOMψ:0x0A) (R/W 16) USART USARTްڰ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t BAUD:16;			/*!< ޯ0`15: ްڰĒl */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_USART_BAUD_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_USART_BAUD_OFFSET				0x0A			/**< \brief (SERCOM_USART_BAUD offset)USARTްڰ */
#define SERCOM_USART_BAUD_RESETVALUE			0x0000			/**< \brief (SERCOM_USART_BAUD reset_value)USARTްڰ */

#define SERCOM_USART_BAUD_BAUD_Pos				0				/**< \brief (SERCOM_USART_BAUD)ްڰĒl */
#define SERCOM_USART_BAUD_BAUD_Msk				(0xFFFFu << SERCOM_USART_BAUD_BAUD_Pos)
#define SERCOM_USART_BAUD_BAUD(value)			((SERCOM_USART_BAUD_BAUD_Msk & ((value) << SERCOM_USART_BAUD_BAUD_Pos)))
#define SERCOM_USART_BAUD_MASK					0xFFFFu			/**< \brief (SERCOM_USART_BAUD)Օڼ޽ */

/* -------- SERCOM_I2CM_INTENCLR : (SERCOMψ:0x0C) (R/W  8) I2CM I2CM荞݋ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  MB:1;				/*!< ޯ    0: ݊荞݋֎~ */
    uint8_t  SB:1;				/*!< ޯ    1: ǂݍ݊荞݋֎~ */
    uint8_t  :6;				/*!< ޯ2` 7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_I2CM_INTENCLR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_I2CM_INTENCLR_OFFSET				0x0C			/**< \brief (SERCOM_I2CM_INTENCLR offset)I2CM荞݋ */
#define SERCOM_I2CM_INTENCLR_RESETVALUE			0x00			/**< \brief (SERCOM_I2CM_INTENCLR reset_value)I2CM荞݋ */

#define SERCOM_I2CM_INTENCLR_MB_Pos				0				/**< \brief (SERCOM_I2CM_INTENCLR)݊荞݋֎~ */
#define SERCOM_I2CM_INTENCLR_MB					(0x1u << SERCOM_I2CM_INTENCLR_MB_Pos)
#define SERCOM_I2CM_INTENCLR_SB_Pos				1				/**< \brief (SERCOM_I2CM_INTENCLR)ǂݍ݊荞݋֎~ */
#define SERCOM_I2CM_INTENCLR_SB					(0x1u << SERCOM_I2CM_INTENCLR_SB_Pos)
#define SERCOM_I2CM_INTENCLR_MASK				0x03u			/**< \brief (SERCOM_I2CM_INTENCLR)Օڼ޽ */

/* -------- SERCOM_I2CS_INTENCLR : (SERCOMψ:0x0C) (R/W  8) I2CS I2CS荞݋ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  PREC:1;			/*!< ޯ     0: ~荞݋֎~ */
    uint8_t  AMATCH:1;			/*!< ޯ     1: ڽ荞݋֎~ */
    uint8_t  DRDY:1;			/*!< ޯ     2: ް荞݋֎~ */
    uint8_t  :5;				/*!< ޯ 3` 7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_I2CS_INTENCLR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_I2CS_INTENCLR_OFFSET				0x0C			/**< \brief (SERCOM_I2CS_INTENCLR offset)I2CS荞݋ */
#define SERCOM_I2CS_INTENCLR_RESETVALUE			0x00			/**< \brief (SERCOM_I2CS_INTENCLR reset_value)I2CS荞݋ */

#define SERCOM_I2CS_INTENCLR_PREC_Pos			0				/**< \brief (SERCOM_I2CS_INTENCLR)~荞݋֎~ */
#define SERCOM_I2CS_INTENCLR_PREC				(0x1u << SERCOM_I2CS_INTENCLR_PREC_Pos)
#define SERCOM_I2CS_INTENCLR_AMATCH_Pos			1				/**< \brief (SERCOM_I2CS_INTENCLR)ڽ荞݋֎~ */
#define SERCOM_I2CS_INTENCLR_AMATCH				(0x1u << SERCOM_I2CS_INTENCLR_AMATCH_Pos)
#define SERCOM_I2CS_INTENCLR_DRDY_Pos			2				/**< \brief (SERCOM_I2CS_INTENCLR)ް荞݋֎~ */
#define SERCOM_I2CS_INTENCLR_DRDY				(0x1u << SERCOM_I2CS_INTENCLR_DRDY_Pos)
#define SERCOM_I2CS_INTENCLR_MASK				0x07u			/**< \brief (SERCOM_I2CS_INTENCLR)Օڼ޽ */

/* -------- SERCOM_SPI_INTENCLR : (SERCOMψ:0x0C) (R/W  8) SPI SPI荞݋ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  DRE:1;				/*!< ޯ    0: ް ڼ޽󊄂荞݋֎~ */
    uint8_t  TXC:1;				/*!< ޯ    1: M荞݋֎~ */
    uint8_t  RXC:1;				/*!< ޯ    2: M荞݋֎~ */
    uint8_t  :5;				/*!< ޯ3` 7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_SPI_INTENCLR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_SPI_INTENCLR_OFFSET				0x0C			/**< \brief (SERCOM_SPI_INTENCLR offset)SPI荞݋ */
#define SERCOM_SPI_INTENCLR_RESETVALUE			0x00			/**< \brief (SERCOM_SPI_INTENCLR reset_value)SPI荞݋ */

#define SERCOM_SPI_INTENCLR_DRE_Pos				0				/**< \brief (SERCOM_SPI_INTENCLR)ް ڼ޽󊄂荞݋֎~ */
#define SERCOM_SPI_INTENCLR_DRE					(0x1u << SERCOM_SPI_INTENCLR_DRE_Pos)
#define SERCOM_SPI_INTENCLR_TXC_Pos				1				/**< \brief (SERCOM_SPI_INTENCLR)M荞݋֎~ */
#define SERCOM_SPI_INTENCLR_TXC					(0x1u << SERCOM_SPI_INTENCLR_TXC_Pos)
#define SERCOM_SPI_INTENCLR_RXC_Pos				2				/**< \brief (SERCOM_SPI_INTENCLR)M荞݋֎~ */
#define SERCOM_SPI_INTENCLR_RXC					(0x1u << SERCOM_SPI_INTENCLR_RXC_Pos)
#define SERCOM_SPI_INTENCLR_MASK				0x07u			/**< \brief (SERCOM_SPI_INTENCLR)Օڼ޽ */

/* -------- SERCOM_USART_INTENCLR : (SERCOMψ:0x0C) (R/W  8) USART USART荞݋ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  DRE:1;				/*!< ޯ    0: ް ڼ޽󊄂荞݋֎~ */
    uint8_t  TXC:1;				/*!< ޯ    1: M荞݋֎~ */
    uint8_t  RXC:1;				/*!< ޯ    2: M荞݋֎~ */
    uint8_t  RXS:1;				/*!< ޯ    3: MJn荞݋֎~ */
    uint8_t  :4;				/*!< ޯ4` 7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_USART_INTENCLR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_USART_INTENCLR_OFFSET			0x0C			/**< \brief (SERCOM_USART_INTENCLR offset)USART荞݋ */
#define SERCOM_USART_INTENCLR_RESETVALUE		0x00			/**< \brief (SERCOM_USART_INTENCLR reset_value)USART荞݋ */

#define SERCOM_USART_INTENCLR_DRE_Pos			0				/**< \brief (SERCOM_USART_INTENCLR)ް ڼ޽󊄂荞݋֎~ */
#define SERCOM_USART_INTENCLR_DRE				(0x1u << SERCOM_USART_INTENCLR_DRE_Pos)
#define SERCOM_USART_INTENCLR_TXC_Pos			1				/**< \brief (SERCOM_USART_INTENCLR)M荞݋֎~ */
#define SERCOM_USART_INTENCLR_TXC				(0x1u << SERCOM_USART_INTENCLR_TXC_Pos)
#define SERCOM_USART_INTENCLR_RXC_Pos			2				/**< \brief (SERCOM_USART_INTENCLR)M荞݋֎~ */
#define SERCOM_USART_INTENCLR_RXC				(0x1u << SERCOM_USART_INTENCLR_RXC_Pos)
#define SERCOM_USART_INTENCLR_RXS_Pos			3				/**< \brief (SERCOM_USART_INTENCLR)MJn荞݋֎~ */
#define SERCOM_USART_INTENCLR_RXS				(0x1u << SERCOM_USART_INTENCLR_RXS_Pos)
#define SERCOM_USART_INTENCLR_MASK				0x0Fu			/**< \brief (SERCOM_USART_INTENCLR)Օڼ޽ */

/* -------- SERCOM_I2CM_INTENSET : (SERCOMψ:0x0D) (R/W  8) I2CM I2CM荞݋ݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  MB:1;				/*!< ޯ    0: ݊荞݋ */
    uint8_t  SB:1;				/*!< ޯ    1: ǂݍ݊荞݋ */
    uint8_t  :6;				/*!< ޯ2` 7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_I2CM_INTENSET_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_I2CM_INTENSET_OFFSET				0x0D			/**< \brief (SERCOM_I2CM_INTENSET offset)I2CM荞݋ݒ */
#define SERCOM_I2CM_INTENSET_RESETVALUE			0x00			/**< \brief (SERCOM_I2CM_INTENSET reset_value)I2CM荞݋ݒ */

#define SERCOM_I2CM_INTENSET_MB_Pos				0				/**< \brief (SERCOM_I2CM_INTENSET)݊荞݋ */
#define SERCOM_I2CM_INTENSET_MB					(0x1u << SERCOM_I2CM_INTENSET_MB_Pos)
#define SERCOM_I2CM_INTENSET_SB_Pos				1				/**< \brief (SERCOM_I2CM_INTENSET)ǂݍ݊荞݋ */
#define SERCOM_I2CM_INTENSET_SB					(0x1u << SERCOM_I2CM_INTENSET_SB_Pos)
#define SERCOM_I2CM_INTENSET_MASK				0x03u			/**< \brief (SERCOM_I2CM_INTENSET)Օڼ޽ */

/* -------- SERCOM_I2CS_INTENSET : (SERCOMψ:0x0D) (R/W  8) I2CS I2CS荞݋ݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  PREC:1;			/*!< ޯ    0: ~荞݋ */
    uint8_t  AMATCH:1;			/*!< ޯ    1: ڽ荞݋ */
    uint8_t  DRDY:1;			/*!< ޯ    2: ް荞݋ */
    uint8_t  :5;				/*!< ޯ3` 7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_I2CS_INTENSET_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_I2CS_INTENSET_OFFSET				0x0D			/**< \brief (SERCOM_I2CS_INTENSET offset)I2CS荞݋ݒ */
#define SERCOM_I2CS_INTENSET_RESETVALUE			0x00			/**< \brief (SERCOM_I2CS_INTENSET reset_value)I2CS荞݋ݒ */

#define SERCOM_I2CS_INTENSET_PREC_Pos			0				/**< \brief (SERCOM_I2CS_INTENSET)~荞݋ */
#define SERCOM_I2CS_INTENSET_PREC				(0x1u << SERCOM_I2CS_INTENSET_PREC_Pos)
#define SERCOM_I2CS_INTENSET_AMATCH_Pos			1				/**< \brief (SERCOM_I2CS_INTENSET)ڽ荞݋ */
#define SERCOM_I2CS_INTENSET_AMATCH				(0x1u << SERCOM_I2CS_INTENSET_AMATCH_Pos)
#define SERCOM_I2CS_INTENSET_DRDY_Pos			2				/**< \brief (SERCOM_I2CS_INTENSET)ް荞݋ */
#define SERCOM_I2CS_INTENSET_DRDY				(0x1u << SERCOM_I2CS_INTENSET_DRDY_Pos)
#define SERCOM_I2CS_INTENSET_MASK				0x07u			/**< \brief (SERCOM_I2CS_INTENSET)Օڼ޽ */

/* -------- SERCOM_SPI_INTENSET : (SERCOMψ:0x0D) (R/W  8) SPI SPI荞݋ݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  DRE:1;				/*!< ޯ    0: ް ڼ޽󊄂荞݋ */
    uint8_t  TXC:1;				/*!< ޯ    1: M荞݋ */
    uint8_t  RXC:1;				/*!< ޯ    2: M荞݋ */
    uint8_t  :5;				/*!< ޯ3` 7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_SPI_INTENSET_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_SPI_INTENSET_OFFSET				0x0D			/**< \brief (SERCOM_SPI_INTENSET offset)SPI荞݋ݒ */
#define SERCOM_SPI_INTENSET_RESETVALUE			0x00			/**< \brief (SERCOM_SPI_INTENSET reset_value)SPI荞݋ݒ */

#define SERCOM_SPI_INTENSET_DRE_Pos				0				/**< \brief (SERCOM_SPI_INTENSET)ް ڼ޽󊄂荞݋ */
#define SERCOM_SPI_INTENSET_DRE					(0x1u << SERCOM_SPI_INTENSET_DRE_Pos)
#define SERCOM_SPI_INTENSET_TXC_Pos				1				/**< \brief (SERCOM_SPI_INTENSET)M荞݋ */
#define SERCOM_SPI_INTENSET_TXC					(0x1u << SERCOM_SPI_INTENSET_TXC_Pos)
#define SERCOM_SPI_INTENSET_RXC_Pos				2				/**< \brief (SERCOM_SPI_INTENSET)M荞݋ */
#define SERCOM_SPI_INTENSET_RXC					(0x1u << SERCOM_SPI_INTENSET_RXC_Pos)
#define SERCOM_SPI_INTENSET_MASK				0x07u			/**< \brief (SERCOM_SPI_INTENSET)Օڼ޽ */

/* -------- SERCOM_USART_INTENSET : (SERCOMψ:0x0D) (R/W  8) USART USART荞݋ݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  DRE:1;				/*!< ޯ    0: ް ڼ޽󊄂荞݋ */
    uint8_t  TXC:1;				/*!< ޯ    1: M荞݋ */
    uint8_t  RXC:1;				/*!< ޯ    2: M荞݋ */
    uint8_t  RXS:1;				/*!< ޯ    3: MJn荞݋ */
    uint8_t  :4;				/*!< ޯ4` 7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_USART_INTENSET_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_USART_INTENSET_OFFSET			0x0D			/**< \brief (SERCOM_USART_INTENSET offset)USART荞݋ݒ */
#define SERCOM_USART_INTENSET_RESETVALUE		0x00			/**< \brief (SERCOM_USART_INTENSET reset_value)USART荞݋ݒ */

#define SERCOM_USART_INTENSET_DRE_Pos			0				/**< \brief (SERCOM_USART_INTENSET)ް ڼ޽󊄂荞݋ */
#define SERCOM_USART_INTENSET_DRE				(0x1u << SERCOM_USART_INTENSET_DRE_Pos)
#define SERCOM_USART_INTENSET_TXC_Pos			1				/**< \brief (SERCOM_USART_INTENSET)M荞݋ */
#define SERCOM_USART_INTENSET_TXC				(0x1u << SERCOM_USART_INTENSET_TXC_Pos)
#define SERCOM_USART_INTENSET_RXC_Pos			2				/**< \brief (SERCOM_USART_INTENSET)M荞݋ */
#define SERCOM_USART_INTENSET_RXC				(0x1u << SERCOM_USART_INTENSET_RXC_Pos)
#define SERCOM_USART_INTENSET_RXS_Pos			3				/**< \brief (SERCOM_USART_INTENSET)MJn荞݋ */
#define SERCOM_USART_INTENSET_RXS				(0x1u << SERCOM_USART_INTENSET_RXS_Pos)
#define SERCOM_USART_INTENSET_MASK				0x0Fu			/**< \brief (SERCOM_USART_INTENSET)Օڼ޽ */

/* -------- SERCOM_I2CM_INTFLAG : (SERCOMψ:0x0E) (R/W  8) I2CM I2CM荞׸ޏ/ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  MB:1;				/*!< ޯ    0: ݊荞 */
    uint8_t  SB:1;				/*!< ޯ    1: ǂݍ݊荞 */
    uint8_t  :6;				/*!< ޯ2` 7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_I2CM_INTFLAG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_I2CM_INTFLAG_OFFSET				0x0E			/**< \brief (SERCOM_I2CM_INTFLAG offset)I2CM荞׸ޏ/ */
#define SERCOM_I2CM_INTFLAG_RESETVALUE			0x00			/**< \brief (SERCOM_I2CM_INTFLAG reset_value)I2CM荞׸ޏ/ */

#define SERCOM_I2CM_INTFLAG_MB_Pos				0				/**< \brief (SERCOM_I2CM_INTFLAG)݊荞 */
#define SERCOM_I2CM_INTFLAG_MB					(0x1u << SERCOM_I2CM_INTFLAG_MB_Pos)
#define SERCOM_I2CM_INTFLAG_SB_Pos				1				/**< \brief (SERCOM_I2CM_INTFLAG)ǂݍ݊荞 */
#define SERCOM_I2CM_INTFLAG_SB					(0x1u << SERCOM_I2CM_INTFLAG_SB_Pos)
#define SERCOM_I2CM_INTFLAG_MASK				0x03u			/**< \brief (SERCOM_I2CM_INTFLAG)Օڼ޽ */

/* -------- SERCOM_I2CS_INTFLAG : (SERCOMψ:0x0E) (R/W  8) I2CS I2CS荞׸ޏ/ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  PREC:1;			/*!< ޯ    0: ~荞 */
    uint8_t  AMATCH:1;			/*!< ޯ    1: ڽ荞 */
    uint8_t  DRDY:1;			/*!< ޯ    2: ް荞 */
    uint8_t  :5;				/*!< ޯ3` 7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_I2CS_INTFLAG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_I2CS_INTFLAG_OFFSET				0x0E			/**< \brief (SERCOM_I2CS_INTFLAG offset)I2CS荞׸ޏ/ */
#define SERCOM_I2CS_INTFLAG_RESETVALUE			0x00			/**< \brief (SERCOM_I2CS_INTFLAG reset_value)I2CS荞׸ޏ/ */

#define SERCOM_I2CS_INTFLAG_PREC_Pos			0				/**< \brief (SERCOM_I2CS_INTFLAG)~荞*/
#define SERCOM_I2CS_INTFLAG_PREC				(0x1u << SERCOM_I2CS_INTFLAG_PREC_Pos)
#define SERCOM_I2CS_INTFLAG_AMATCH_Pos			1				/**< \brief (SERCOM_I2CS_INTFLAG)ڽ荞 */
#define SERCOM_I2CS_INTFLAG_AMATCH				(0x1u << SERCOM_I2CS_INTFLAG_AMATCH_Pos)
#define SERCOM_I2CS_INTFLAG_DRDY_Pos			2				/**< \brief (SERCOM_I2CS_INTFLAG)ް荞 */
#define SERCOM_I2CS_INTFLAG_DRDY				(0x1u << SERCOM_I2CS_INTFLAG_DRDY_Pos)
#define SERCOM_I2CS_INTFLAG_MASK				0x07u			/**< \brief (SERCOM_I2CS_INTFLAG)Օڼ޽ */

/* -------- SERCOM_SPI_INTFLAG : (SERCOMψ:0x0E) (R/W  8) SPI SPI荞׸ޏ/ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  DRE:1;				/*!< ޯ    0: ް ڼ޽󊄂荞 */
    uint8_t  TXC:1;				/*!< ޯ    1: M荞 */
    uint8_t  RXC:1;				/*!< ޯ    2: M荞 */
    uint8_t  :5;				/*!< ޯ3` 7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_SPI_INTFLAG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_SPI_INTFLAG_OFFSET				0x0E			/**< \brief (SERCOM_SPI_INTFLAG offset)SPI荞׸ޏ/ */
#define SERCOM_SPI_INTFLAG_RESETVALUE			0x00			/**< \brief (SERCOM_SPI_INTFLAG reset_value)SPI荞׸ޏ/ */

#define SERCOM_SPI_INTFLAG_DRE_Pos				0				/**< \brief (SERCOM_SPI_INTFLAG)ް ڼ޽󊄂荞 */
#define SERCOM_SPI_INTFLAG_DRE					(0x1u << SERCOM_SPI_INTFLAG_DRE_Pos)
#define SERCOM_SPI_INTFLAG_TXC_Pos				1				/**< \brief (SERCOM_SPI_INTFLAG)M荞 */
#define SERCOM_SPI_INTFLAG_TXC					(0x1u << SERCOM_SPI_INTFLAG_TXC_Pos)
#define SERCOM_SPI_INTFLAG_RXC_Pos				2				/**< \brief (SERCOM_SPI_INTFLAG)M荞 */
#define SERCOM_SPI_INTFLAG_RXC					(0x1u << SERCOM_SPI_INTFLAG_RXC_Pos)
#define SERCOM_SPI_INTFLAG_MASK					0x07u			/**< \brief (SERCOM_SPI_INTFLAG)Օڼ޽ */

/* -------- SERCOM_USART_INTFLAG : (SERCOMψ:0x0E) (R/W  8) USART USART荞׸ޏ/ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  DRE:1;				/*!< ޯ    0: ް ڼ޽󊄂荞 */
    uint8_t  TXC:1;				/*!< ޯ    1: M荞 */
    uint8_t  RXC:1;				/*!< ޯ    2: M荞 */
    uint8_t  RXS:1;				/*!< ޯ    3: MJn荞 */
    uint8_t  :4;				/*!< ޯ4` 7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_USART_INTFLAG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_USART_INTFLAG_OFFSET				0x0E			/**< \brief (SERCOM_USART_INTFLAG offset)USART荞׸ޏ/ */
#define SERCOM_USART_INTFLAG_RESETVALUE			0x00			/**< \brief (SERCOM_USART_INTFLAG reset_value)USART荞׸ޏ/ */

#define SERCOM_USART_INTFLAG_DRE_Pos			0				/**< \brief (SERCOM_USART_INTFLAG)ް ڼ޽󊄂荞 */
#define SERCOM_USART_INTFLAG_DRE				(0x1u << SERCOM_USART_INTFLAG_DRE_Pos)
#define SERCOM_USART_INTFLAG_TXC_Pos			1				/**< \brief (SERCOM_USART_INTFLAG)M荞 */
#define SERCOM_USART_INTFLAG_TXC				(0x1u << SERCOM_USART_INTFLAG_TXC_Pos)
#define SERCOM_USART_INTFLAG_RXC_Pos			2				/**< \brief (SERCOM_USART_INTFLAG)M荞 */
#define SERCOM_USART_INTFLAG_RXC				(0x1u << SERCOM_USART_INTFLAG_RXC_Pos)
#define SERCOM_USART_INTFLAG_RXS_Pos			3				/**< \brief (SERCOM_USART_INTFLAG)MJn荞 */
#define SERCOM_USART_INTFLAG_RXS				(0x1u << SERCOM_USART_INTFLAG_RXS_Pos)
#define SERCOM_USART_INTFLAG_MASK				0x0Fu			/**< \brief (SERCOM_USART_INTFLAG)Օڼ޽ */

/* -------- SERCOM_I2CM_STATUS : (SERCOMψ:0x10) (R/W 16) I2CM I2CM -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t BUSERR:1;			/*!< ޯ    0: ޽ُ */
    uint16_t ARBLOST:1;			/*!< ޯ    1: s */
    uint16_t RXNACK:1;			/*!< ޯ    2: 񉞓M */
    uint16_t :1;				/*!< ޯ    3: \ */
    uint16_t BUSSTATE:2;		/*!< ޯ4` 5: ޽ */
    uint16_t LOWTOUT:1;			/*!< ޯ    6: SCL Low */
    uint16_t CLKHOLD:1;			/*!< ޯ    7: ۯێ */
    uint16_t :7;				/*!< ޯ8`14: \ */
    uint16_t SYNCBUSY:1;		/*!< ޯ   15: Z */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_I2CM_STATUS_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_I2CM_STATUS_OFFSET				0x10			/**< \brief (SERCOM_I2CM_STATUS offset)I2CM */
#define SERCOM_I2CM_STATUS_RESETVALUE			0x0000			/**< \brief (SERCOM_I2CM_STATUS reset_value)I2CM */

#define SERCOM_I2CM_STATUS_BUSERR_Pos			0				/**< \brief (SERCOM_I2CM_STATUS)޽ُ */
#define SERCOM_I2CM_STATUS_BUSERR				(0x1u << SERCOM_I2CM_STATUS_BUSERR_Pos)
#define SERCOM_I2CM_STATUS_ARBLOST_Pos			1				/**< \brief (SERCOM_I2CM_STATUS)s */
#define SERCOM_I2CM_STATUS_ARBLOST				(0x1u << SERCOM_I2CM_STATUS_ARBLOST_Pos)
#define SERCOM_I2CM_STATUS_RXNACK_Pos			2				/**< \brief (SERCOM_I2CM_STATUS)񉞓M */
#define SERCOM_I2CM_STATUS_RXNACK				(0x1u << SERCOM_I2CM_STATUS_RXNACK_Pos)
#define SERCOM_I2CM_STATUS_BUSSTATE_Pos			4				/**< \brief (SERCOM_I2CM_STATUS)޽ */
#define SERCOM_I2CM_STATUS_BUSSTATE_Msk			(0x3u << SERCOM_I2CM_STATUS_BUSSTATE_Pos)
#define SERCOM_I2CM_STATUS_BUSSTATE(value)		((SERCOM_I2CM_STATUS_BUSSTATE_Msk & ((value) << SERCOM_I2CM_STATUS_BUSSTATE_Pos)))
#define SERCOM_I2CM_STATUS_LOWTOUT_Pos			6				/**< \brief (SERCOM_I2CM_STATUS)SCL Low */
#define SERCOM_I2CM_STATUS_LOWTOUT				(0x1u << SERCOM_I2CM_STATUS_LOWTOUT_Pos)
#define SERCOM_I2CM_STATUS_CLKHOLD_Pos			7				/**< \brief (SERCOM_I2CM_STATUS)ۯێ */
#define SERCOM_I2CM_STATUS_CLKHOLD				(0x1u << SERCOM_I2CM_STATUS_CLKHOLD_Pos)
#define SERCOM_I2CM_STATUS_SYNCBUSY_Pos			15				/**< \brief (SERCOM_I2CM_STATUS)Z */
#define SERCOM_I2CM_STATUS_SYNCBUSY				(0x1u << SERCOM_I2CM_STATUS_SYNCBUSY_Pos)
#define SERCOM_I2CM_STATUS_MASK					0x80F7u			/**< \brief (SERCOM_I2CM_STATUS)Օڼ޽ */

/* -------- SERCOM_I2CS_STATUS : (SERCOMψ:0x10) (R/W 16) I2CS I2CS -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t BUSERR:1;			/*!< ޯ    0: ޽ُ */
    uint16_t COLL:1;			/*!< ޯ    1: MՓ */
    uint16_t RXNACK:1;			/*!< ޯ    2: 񉞓M */
    uint16_t DIR:1;				/*!< ޯ    3: ǂ/ */
    uint16_t SR:1;				/*!< ޯ    4: Jnv */
    uint16_t :1;				/*!< ޯ    5: \ */
    uint16_t LOWTOUT:1;			/*!< ޯ    6: SCL Low */
    uint16_t CLKHOLD:1;			/*!< ޯ    7: ۯێ */
    uint16_t :7;				/*!< ޯ8`14: \ */
    uint16_t SYNCBUSY:1;		/*!< ޯ   15: Z */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_I2CS_STATUS_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_I2CS_STATUS_OFFSET				0x10			/**< \brief (SERCOM_I2CS_STATUS offset)I2CS */
#define SERCOM_I2CS_STATUS_RESETVALUE			0x0000			/**< \brief (SERCOM_I2CS_STATUS reset_value)I2CS */

#define SERCOM_I2CS_STATUS_BUSERR_Pos			0				/**< \brief (SERCOM_I2CS_STATUS)޽ُ */
#define SERCOM_I2CS_STATUS_BUSERR				(0x1u << SERCOM_I2CS_STATUS_BUSERR_Pos)
#define SERCOM_I2CS_STATUS_COLL_Pos				1				/**< \brief (SERCOM_I2CS_STATUS)MՓ */
#define SERCOM_I2CS_STATUS_COLL					(0x1u << SERCOM_I2CS_STATUS_COLL_Pos)
#define SERCOM_I2CS_STATUS_RXNACK_Pos			2				/**< \brief (SERCOM_I2CS_STATUS)񉞓M */
#define SERCOM_I2CS_STATUS_RXNACK				(0x1u << SERCOM_I2CS_STATUS_RXNACK_Pos)
#define SERCOM_I2CS_STATUS_DIR_Pos				3				/**< \brief (SERCOM_I2CS_STATUS)ǂ/ */
#define SERCOM_I2CS_STATUS_DIR					(0x1u << SERCOM_I2CS_STATUS_DIR_Pos)
#define SERCOM_I2CS_STATUS_SR_Pos				4				/**< \brief (SERCOM_I2CS_STATUS)Jnv */
#define SERCOM_I2CS_STATUS_SR					(0x1u << SERCOM_I2CS_STATUS_SR_Pos)
#define SERCOM_I2CS_STATUS_LOWTOUT_Pos			6				/**< \brief (SERCOM_I2CS_STATUS)SCL Low */
#define SERCOM_I2CS_STATUS_LOWTOUT				(0x1u << SERCOM_I2CS_STATUS_LOWTOUT_Pos)
#define SERCOM_I2CS_STATUS_CLKHOLD_Pos			7				/**< \brief (SERCOM_I2CS_STATUS)ۯێ */
#define SERCOM_I2CS_STATUS_CLKHOLD				(0x1u << SERCOM_I2CS_STATUS_CLKHOLD_Pos)
#define SERCOM_I2CS_STATUS_SYNCBUSY_Pos			15				/**< \brief (SERCOM_I2CS_STATUS)Z */
#define SERCOM_I2CS_STATUS_SYNCBUSY				(0x1u << SERCOM_I2CS_STATUS_SYNCBUSY_Pos)
#define SERCOM_I2CS_STATUS_MASK					0x80DFu			/**< \brief (SERCOM_I2CS_STATUS)Օڼ޽ */

/* -------- SERCOM_SPI_STATUS : (SERCOMψ:0x10) (R/W 16) SPI SPI -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t :2;				/*!< ޯ0` 1: \ */
    uint16_t BUFOVF:1;			/*!< ޯ    2: ɏՕ */
    uint16_t :12;				/*!< ޯ3`14: \ */
    uint16_t SYNCBUSY:1;		/*!< ޯ   15: Z */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_SPI_STATUS_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_SPI_STATUS_OFFSET				0x10			/**< \brief (SERCOM_SPI_STATUS offset)SPI */
#define SERCOM_SPI_STATUS_RESETVALUE			0x0000			/**< \brief (SERCOM_SPI_STATUS reset_value)SPI */

#define SERCOM_SPI_STATUS_BUFOVF_Pos			2				/**< \brief (SERCOM_SPI_STATUS)ɏՕ */
#define SERCOM_SPI_STATUS_BUFOVF				(0x1u << SERCOM_SPI_STATUS_BUFOVF_Pos)
#define SERCOM_SPI_STATUS_SYNCBUSY_Pos			15				/**< \brief (SERCOM_SPI_STATUS)Z */
#define SERCOM_SPI_STATUS_SYNCBUSY				(0x1u << SERCOM_SPI_STATUS_SYNCBUSY_Pos)
#define SERCOM_SPI_STATUS_MASK					0x8004u			/**< \brief (SERCOM_SPI_STATUS)Օڼ޽ */

/* -------- SERCOM_USART_STATUS : (SERCOMψ:0x10) (R/W 16) USART USART -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t PERR:1;			/*!< ޯ    0: è */
    uint16_t FERR:1;			/*!< ޯ    1: ڰшُ */
    uint16_t BUFOVF:1;			/*!< ޯ    2: ɏՕ */
    uint16_t :12;				/*!< ޯ3`14: \ */
    uint16_t SYNCBUSY:1;		/*!< ޯ   15: Z */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_USART_STATUS_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_USART_STATUS_OFFSET				0x10			/**< \brief (SERCOM_USART_STATUS offset)USART */
#define SERCOM_USART_STATUS_RESETVALUE			0x0000			/**< \brief (SERCOM_USART_STATUS reset_value)USART */

#define SERCOM_USART_STATUS_PERR_Pos			0				/**< \brief (SERCOM_USART_STATUS)è */
#define SERCOM_USART_STATUS_PERR				(0x1u << SERCOM_USART_STATUS_PERR_Pos)
#define SERCOM_USART_STATUS_FERR_Pos			1				/**< \brief (SERCOM_USART_STATUS)ڰшُ */
#define SERCOM_USART_STATUS_FERR				(0x1u << SERCOM_USART_STATUS_FERR_Pos)
#define SERCOM_USART_STATUS_BUFOVF_Pos			2				/**< \brief (SERCOM_USART_STATUS)ɏՕ */
#define SERCOM_USART_STATUS_BUFOVF				(0x1u << SERCOM_USART_STATUS_BUFOVF_Pos)
#define SERCOM_USART_STATUS_SYNCBUSY_Pos		15				/**< \brief (SERCOM_USART_STATUS)Z */
#define SERCOM_USART_STATUS_SYNCBUSY			(0x1u << SERCOM_USART_STATUS_SYNCBUSY_Pos)
#define SERCOM_USART_STATUS_MASK				0x8007u			/**< \brief (SERCOM_USART_STATUS)Օڼ޽ */

/* -------- SERCOM_I2CM_ADDR : (SERCOMψ:0x14) (R/W  8) I2CM I2CMڽ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  ADDR:8;			/*!< ޯ0` 7: ڽl */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_I2CM_ADDR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_I2CM_ADDR_OFFSET					0x14			/**< \brief (SERCOM_I2CM_ADDR offset)I2CMڽ */
#define SERCOM_I2CM_ADDR_RESETVALUE				0x00			/**< \brief (SERCOM_I2CM_ADDR reset_value)I2CMڽ */

#define SERCOM_I2CM_ADDR_ADDR_Pos				0				/**< \brief (SERCOM_I2CM_ADDR)ڽl */
#define SERCOM_I2CM_ADDR_ADDR_Msk				(0xFFu << SERCOM_I2CM_ADDR_ADDR_Pos)
#define SERCOM_I2CM_ADDR_ADDR(value)			((SERCOM_I2CM_ADDR_ADDR_Msk & ((value) << SERCOM_I2CM_ADDR_ADDR_Pos)))
#define SERCOM_I2CM_ADDR_MASK					0xFFu			/**< \brief (SERCOM_I2CM_ADDR)Օڼ޽ */

/* -------- SERCOM_I2CS_ADDR : (SERCOMψ:0x14) (R/W 32) I2CS I2CSڽ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t GENCEN:1;			/*!< ޯ     0: ČĂяoڽ */
    uint32_t ADDR:7;			/*!< ޯ 1` 7: ڽl */
    uint32_t :9;				/*!< ޯ 8`16: \ */
    uint32_t ADDRMASK:7;		/*!< ޯ17`23: ڽՕ */
    uint32_t :8;				/*!< ޯ24`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_I2CS_ADDR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_I2CS_ADDR_OFFSET					0x14			/**< \brief (SERCOM_I2CS_ADDR offset)I2CSڽ */
#define SERCOM_I2CS_ADDR_RESETVALUE				0x00000000		/**< \brief (SERCOM_I2CS_ADDR reset_value)I2CSڽ */

#define SERCOM_I2CS_ADDR_GENCEN_Pos				0				/**< \brief (SERCOM_I2CS_ADDR)ČĂяoڽ */
#define SERCOM_I2CS_ADDR_GENCEN					(0x1u << SERCOM_I2CS_ADDR_GENCEN_Pos)
#define SERCOM_I2CS_ADDR_ADDR_Pos				1				/**< \brief (SERCOM_I2CS_ADDR)ڽl */
#define SERCOM_I2CS_ADDR_ADDR_Msk				(0x7Fu << SERCOM_I2CS_ADDR_ADDR_Pos)
#define SERCOM_I2CS_ADDR_ADDR(value)			((SERCOM_I2CS_ADDR_ADDR_Msk & ((value) << SERCOM_I2CS_ADDR_ADDR_Pos)))
#define SERCOM_I2CS_ADDR_ADDRMASK_Pos			17				/**< \brief (SERCOM_I2CS_ADDR)ڽՕ */
#define SERCOM_I2CS_ADDR_ADDRMASK_Msk			(0x7Fu << SERCOM_I2CS_ADDR_ADDRMASK_Pos)
#define SERCOM_I2CS_ADDR_ADDRMASK(value)		((SERCOM_I2CS_ADDR_ADDRMASK_Msk & ((value) << SERCOM_I2CS_ADDR_ADDRMASK_Pos)))
#define SERCOM_I2CS_ADDR_MASK					0x00FE00FFu		/**< \brief (SERCOM_I2CS_ADDR)Օڼ޽ */

/* -------- SERCOM_SPI_ADDR : (SERCOMψ:0x14) (R/W 32) SPI SPIڽ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t ADDR:8;			/*!< ޯ 0` 7: ڽl */
    uint32_t :8;				/*!< ޯ 8`15: \ */
    uint32_t ADDRMASK:8;		/*!< ޯ16`23: ڽՕ */
    uint32_t :8;				/*!< ޯ24`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_SPI_ADDR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_SPI_ADDR_OFFSET					0x14			/**< \brief (SERCOM_SPI_ADDR offset)SPIڽ */
#define SERCOM_SPI_ADDR_RESETVALUE				0x00000000		/**< \brief (SERCOM_SPI_ADDR reset_value)SPIڽ */

#define SERCOM_SPI_ADDR_ADDR_Pos				0				/**< \brief (SERCOM_SPI_ADDR)ڽl */
#define SERCOM_SPI_ADDR_ADDR_Msk				(0xFFu << SERCOM_SPI_ADDR_ADDR_Pos)
#define SERCOM_SPI_ADDR_ADDR(value)				((SERCOM_SPI_ADDR_ADDR_Msk & ((value) << SERCOM_SPI_ADDR_ADDR_Pos)))
#define SERCOM_SPI_ADDR_ADDRMASK_Pos			16				/**< \brief (SERCOM_SPI_ADDR)ڽՕ */
#define SERCOM_SPI_ADDR_ADDRMASK_Msk			(0xFFu << SERCOM_SPI_ADDR_ADDRMASK_Pos)
#define SERCOM_SPI_ADDR_ADDRMASK(value)			((SERCOM_SPI_ADDR_ADDRMASK_Msk & ((value) << SERCOM_SPI_ADDR_ADDRMASK_Pos)))
#define SERCOM_SPI_ADDR_MASK					0x00FF00FFu		/**< \brief (SERCOM_SPI_ADDR)Օڼ޽ */

/* -------- SERCOM_I2CM_DATA : (SERCOMψ:0x18) (R/W  8) I2CM I2CMް -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  DATA:8;			/*!< ޯ0` 7: ްl */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_I2CM_DATA_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_I2CM_DATA_OFFSET					0x18			/**< \brief (SERCOM_I2CM_DATA offset)I2CMް */
#define SERCOM_I2CM_DATA_RESETVALUE				0x00			/**< \brief (SERCOM_I2CM_DATA reset_value)I2CMް */

#define SERCOM_I2CM_DATA_DATA_Pos				0				/**< \brief (SERCOM_I2CM_DATA)ްl */
#define SERCOM_I2CM_DATA_DATA_Msk				(0xFFu << SERCOM_I2CM_DATA_DATA_Pos)
#define SERCOM_I2CM_DATA_DATA(value)			((SERCOM_I2CM_DATA_DATA_Msk & ((value) << SERCOM_I2CM_DATA_DATA_Pos)))
#define SERCOM_I2CM_DATA_MASK					0xFFu			/**< \brief (SERCOM_I2CM_DATA)Օڼ޽ */

/* -------- SERCOM_I2CS_DATA : (SERCOMψ:0x18) (R/W  8) I2CS I2CSް -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  DATA:8;			/*!< ޯ0` 7: ްl */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_I2CS_DATA_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_I2CS_DATA_OFFSET					0x18			/**< \brief (SERCOM_I2CS_DATA offset)I2CSް */
#define SERCOM_I2CS_DATA_RESETVALUE				0x00			/**< \brief (SERCOM_I2CS_DATA reset_value)I2CSް */

#define SERCOM_I2CS_DATA_DATA_Pos				0				/**< \brief (SERCOM_I2CS_DATA)ްl */
#define SERCOM_I2CS_DATA_DATA_Msk				(0xFFu << SERCOM_I2CS_DATA_DATA_Pos)
#define SERCOM_I2CS_DATA_DATA(value)			((SERCOM_I2CS_DATA_DATA_Msk & ((value) << SERCOM_I2CS_DATA_DATA_Pos)))
#define SERCOM_I2CS_DATA_MASK					0xFFu			/**< \brief (SERCOM_I2CS_DATA)Օڼ޽ */

/* -------- SERCOM_SPI_DATA : (SERCOMψ:0x18) (R/W 16) SPI SPIް -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t DATA:9;			/*!< ޯ0` 8: ްl */
    uint16_t :7;				/*!< ޯ9`15: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_SPI_DATA_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_SPI_DATA_OFFSET						0x18			/**< \brief (SERCOM_SPI_DATA offset)SPIް */
#define SERCOM_SPI_DATA_RESETVALUE				0x0000			/**< \brief (SERCOM_SPI_DATA reset_value)SPIް */

#define SERCOM_SPI_DATA_DATA_Pos				0				/**< \brief (SERCOM_SPI_DATA)ްl */
#define SERCOM_SPI_DATA_DATA_Msk				(0x1FFu << SERCOM_SPI_DATA_DATA_Pos)
#define SERCOM_SPI_DATA_DATA(value)				((SERCOM_SPI_DATA_DATA_Msk & ((value) << SERCOM_SPI_DATA_DATA_Pos)))
#define SERCOM_SPI_DATA_MASK					0x01FFu			/**< \brief (SERCOM_SPI_DATA)Օڼ޽ */

/* -------- SERCOM_USART_DATA : (SERCOMψ:0x18) (R/W 16) USART USARTް -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t DATA:9;			/*!< ޯ0` 8: ްl */
    uint16_t :7;				/*!< ޯ9`15: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} SERCOM_USART_DATA_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SERCOM_USART_DATA_OFFSET				0x18			/**< \brief (SERCOM_USART_DATA offset)USARTް */
#define SERCOM_USART_DATA_RESETVALUE			0x0000			/**< \brief (SERCOM_USART_DATA reset_value)USARTް */

#define SERCOM_USART_DATA_DATA_Pos				0				/**< \brief (SERCOM_USART_DATA)ްl */
#define SERCOM_USART_DATA_DATA_Msk				(0x1FFu << SERCOM_USART_DATA_DATA_Pos)
#define SERCOM_USART_DATA_DATA(value)			((SERCOM_USART_DATA_DATA_Msk & ((value) << SERCOM_USART_DATA_DATA_Pos)))
#define SERCOM_USART_DATA_MASK					0x01FFu			/**< \brief (SERCOM_USART_DATA)Օڼ޽ */

/** \brief SERCOM_I2CMʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct { /* I2C呕u */
  __IO SERCOM_I2CM_CTRLA_Type		CTRLA;			/**< \briefψ:0x00 (R/W 32)I2CMA */
  __IO SERCOM_I2CM_CTRLB_Type		CTRLB;			/**< \briefψ:0x04 (R/W 32)I2CMB */
  __IO SERCOM_I2CM_DBGCTRL_Type		DBGCTRL;		/**< \briefψ:0x08 (R/W  8)I2CMޯސ */
	   RoReg8						Reserved1[0x1];
  __IO SERCOM_I2CM_BAUD_Type		BAUD;			/**< \briefψ:0x0A (R/W 16)I2CMްڰ */
  __IO SERCOM_I2CM_INTENCLR_Type	INTENCLR;		/**< \briefψ:0x0C (R/W  8)I2CM荞݋ */
  __IO SERCOM_I2CM_INTENSET_Type	INTENSET;		/**< \briefψ:0x0D (R/W  8)I2CM荞݋ݒ */
  __IO SERCOM_I2CM_INTFLAG_Type		INTFLAG;		/**< \briefψ:0x0E (R/W  8)I2CM荞׸ޏ/ */
	   RoReg8						Reserved2[0x1];
  __IO SERCOM_I2CM_STATUS_Type		STATUS;			/**< \briefψ:0x10 (R/W 16)I2CM */
	   RoReg8						Reserved3[0x2];
  __IO SERCOM_I2CM_ADDR_Type		ADDR;			/**< \briefψ:0x14 (R/W  8)I2CMڽ */
	   RoReg8						Reserved4[0x3];
  __IO SERCOM_I2CM_DATA_Type		DATA;			/**< \briefψ:0x18 (R/W  8)I2CMް */
} SercomI2cm;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/** \brief SERCOM_I2CSʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct { /* I2C]u */
  __IO SERCOM_I2CS_CTRLA_Type		CTRLA;			/**< \briefψ:0x00 (R/W 32)I2CSA */
  __IO SERCOM_I2CS_CTRLB_Type		CTRLB;			/**< \briefψ:0x04 (R/W 32)I2CSB */
	   RoReg8						Reserved1[0x4];
  __IO SERCOM_I2CS_INTENCLR_Type	INTENCLR;		/**< \briefψ:0x0C (R/W  8)I2CS荞݋ */
  __IO SERCOM_I2CS_INTENSET_Type	INTENSET;		/**< \briefψ:0x0D (R/W  8)I2CS荞݋ݒ */
  __IO SERCOM_I2CS_INTFLAG_Type		INTFLAG;		/**< \briefψ:0x0E (R/W  8)I2CS荞׸ޏ/ */
	   RoReg8						Reserved2[0x1];
  __IO SERCOM_I2CS_STATUS_Type		STATUS;			/**< \briefψ:0x10 (R/W 16)I2CS */
	   RoReg8						Reserved3[0x2];
  __IO SERCOM_I2CS_ADDR_Type		ADDR;			/**< \briefψ:0x14 (R/W 32)I2CSڽ */
  __IO SERCOM_I2CS_DATA_Type		DATA;			/**< \briefψ:0x18 (R/W  8)I2CSް */
} SercomI2cs;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/** \brief SERCOM_SPIʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct { /* SPI */
  __IO SERCOM_SPI_CTRLA_Type		CTRLA;			/**< \briefψ:0x00 (R/W 32)SPIA */
  __IO SERCOM_SPI_CTRLB_Type		CTRLB;			/**< \briefψ:0x04 (R/W 32)SPIB */
  __IO SERCOM_SPI_DBGCTRL_Type		DBGCTRL;		/**< \briefψ:0x08 (R/W  8)SPIޯސ */
	   RoReg8						Reserved1[0x1];
  __IO SERCOM_SPI_BAUD_Type			BAUD;			/**< \briefψ:0x0A (R/W  8)SPIްڰ */
	   RoReg8						Reserved2[0x1];
  __IO SERCOM_SPI_INTENCLR_Type		INTENCLR;		/**< \briefψ:0x0C (R/W  8)SPI荞݋ */
  __IO SERCOM_SPI_INTENSET_Type		INTENSET;		/**< \briefψ:0x0D (R/W  8)SPI荞݋ݒ */
  __IO SERCOM_SPI_INTFLAG_Type		INTFLAG;		/**< \briefψ:0x0E (R/W  8)SPI荞׸ޏ/ */
	   RoReg8						Reserved3[0x1];
  __IO SERCOM_SPI_STATUS_Type		STATUS;			/**< \briefψ:0x10 (R/W 16)SPI */
	   RoReg8						Reserved4[0x2];
  __IO SERCOM_SPI_ADDR_Type			ADDR;			/**< \briefψ:0x14 (R/W 32)SPIڽ */
  __IO SERCOM_SPI_DATA_Type			DATA;			/**< \briefψ:0x18 (R/W 16)SPIް */
} SercomSpi;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/** \brief SERCOM_USARTʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct { /* USART */
  __IO SERCOM_USART_CTRLA_Type		CTRLA;			/**< \briefψ:0x00 (R/W 32)USARTA */
  __IO SERCOM_USART_CTRLB_Type		CTRLB;			/**< \briefψ:0x04 (R/W 32)USARTB */
  __IO SERCOM_USART_DBGCTRL_Type	DBGCTRL;		/**< \briefψ:0x08 (R/W  8)USARTޯސ */
	   RoReg8						Reserved1[0x1];
  __IO SERCOM_USART_BAUD_Type		BAUD;			/**< \briefψ:0x0A (R/W 16)USARTްڰ */
  __IO SERCOM_USART_INTENCLR_Type	INTENCLR;		/**< \briefψ:0x0C (R/W  8)USART荞݋ */
  __IO SERCOM_USART_INTENSET_Type	INTENSET;		/**< \briefψ:0x0D (R/W  8)USART荞݋ݒ */
  __IO SERCOM_USART_INTFLAG_Type	INTFLAG;		/**< \briefψ:0x0E (R/W  8)USART荞׸ޏ/ */
	   RoReg8						Reserved2[0x1];
  __IO SERCOM_USART_STATUS_Type		STATUS;			/**< \briefψ:0x10 (R/W 16)USART */
	   RoReg8						Reserved3[0x6];
  __IO SERCOM_USART_DATA_Type		DATA;			/**< \briefψ:0x18 (R/W 16)USARTް */
} SercomUsart;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
	   SercomI2cm					I2CM;			/**< \briefψ:0x00 I2C呕u */
	   SercomI2cs					I2CS;			/**< \briefψ:0x00 I2C]u */
	   SercomSpi					SPI;			/**< \briefψ:0x00 SPI */
	   SercomUsart					USART;			/**< \briefψ:0x00 USART */
} Sercom;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAMD20_SERCOM_COMPONENT_ */
