/**
 * \file
 *
 * \brief DALI]uTC`Ԑݒ
 *
 * 쌠 (c) 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#include "dali_top.h"

#define DALI_PWM_OUT_PIN		PIN_PA13E_TC2_WO1
#define DALI_PWM_OUT_MUX		MUX_PA13E_TC2_WO1

struct tc_module tc0_instance, tc1_instance, tc2_instance, tc3_instance;

void dali_tc_init(void)
{
	struct tc_config config_tc;

	tc_get_config_defaults(&config_tc);

	/* DALIޯĕ/ɎgpTC0 */
	config_tc.clock_source = GCLK_GENERATOR_1;
	config_tc.counter_size    = TC_COUNTER_SIZE_8BIT;
	config_tc.wave_generation = TC_WAVE_GENERATION_MATCH_FREQ;
	config_tc.counter_8_bit.compare_capture_channel[0] = TC0_TOP;

	tc_init(&tc0_instance, DALI_BIT_MODULE, &config_tc);
	tc_enable(&tc0_instance);
	tc_register_callback(
			&tc0_instance,
			tc_callback_dali_bit_timer,
			TC_CALLBACK_OVERFLOW);

	tc_enable_callback(&tc0_instance, TC_CALLBACK_OVERFLOW);
	/* ŏ͂̊荞݂ȂB */
	REG_TC0_INTENCLR |= 1<<TC_CALLBACK_OVERFLOW;

	/* DALIڰ ݸނɎgpTC1 */
	config_tc.counter_size    = TC_COUNTER_SIZE_16BIT;
	config_tc.counter_16_bit.compare_capture_channel[0] = TC1_TOP;

	tc_init(&tc1_instance, DALI_FRAME_MODULE, &config_tc);
	tc_enable(&tc1_instance);
	tc_register_callback(
			&tc1_instance,
			tc_callback_dali_frame_timer,
			TC_CALLBACK_OVERFLOW);
	tc_enable_callback(&tc1_instance, TC_CALLBACK_OVERFLOW);

	/* DALIω/PWMo͂ɎgpTC2 */
	config_tc.clock_prescaler = TC_CLOCK_PRESCALER_DIV2;
	config_tc.wave_generation = TC_WAVE_GENERATION_MATCH_PWM;
	config_tc.counter_16_bit.compare_capture_channel[0] = TC2_TOP;

	config_tc.pwm_channel[0].enabled = true;
	config_tc.pwm_channel[0].pin_out     = DALI_PWM_OUT_PIN;
	config_tc.pwm_channel[0].pin_mux     = DALI_PWM_OUT_MUX;
	config_tc.waveform_invert_output     = TC_WAVEFORM_INVERT_OUTPUT_CHANNEL_1;
	
	tc_init(&tc2_instance, DALI_FADING_MODULE, &config_tc);
	tc_enable(&tc2_instance);
	tc_register_callback(
			&tc2_instance,
			tc_callback_dali_fading_timer,
			TC_CALLBACK_OVERFLOW);
	tc_enable_callback(&tc2_instance, TC_CALLBACK_OVERFLOW);

	/* OSCULP32KTC4DALIڽw̎Ɏgp܂B */
	config_tc.clock_source = GCLK_GENERATOR_2;
	config_tc.clock_prescaler = TC_CLOCK_PRESCALER_DIV1;
	config_tc.pwm_channel[0].enabled = false;
	tc_init(&tc3_instance, ADDR_SEED_MODULE, &config_tc);
	tc_enable(&tc3_instance);
}
