/**
 * \file
 *
 * \brief SAM D21/R21 TCCײނDMAƂł̑J
 *
 * 쌠 (c) 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

/**
 * \page asfdoc_sam0_tcc_dma_use_case TCCDMAg߂̑Jn̎
 *
 * xĈꗗ:
 *    - SAM D21/R21 Xplained Pro
 *
 * ̎gpʂŁATCCPWMM𐶐̂Ɏgp܂BłٽDMA
 * ]̎菕ňȉ̒lʂĕς܂B1/4A1/2A3/4B
 * PWMo͂LED쓮̂Ɏgp邱Ƃł܂Bg`͵۽߂gpČ
 * 邱Ƃł܂B
 * o͐M͎ۼтɂĕʂTCCقɋA҂邱ƂłAۈ󂪕ߊl
 * DMAɂĊɏՕɓ]܂B
 *
 * PWMo͎̗͂lɍ\ݒ肳܂B:
 * <table>
 *  <tr><th>       </td><th> </td><th>ڑ</td></tr>
 *  <tr><td>SAMD21 Xpro</td><td>PB30</td><td> LED0 </td></tr>
 *  <tr><td>SAMR21 Xpro</td><td>PA19</td><td> LED0 </td></tr>
 * </table>
 *
 * TCCPʕ͎̗lɍ\ݒ肳܂B:
 * - GCLK0(GCLK)ۯ
 * - APIʂTOPArAlݒ肷鎞2dɏՏ݂gp
 * - v܂͔rłިނȂ
 * - OuȂ
 * - PXPWMg`
 * - GCLKĐݒ芈
 * - ޲ősȂB
 * - Q܂͔g`gȂ
 * - g`o͂̔]Ȃ
 * - ߊlȂ
 * - ㏸v
 * - PsȂ
 * - 0ŌvJn
 * - vTOP0x1000ɐݒ
 * - (SAM D21 Xpro)0܂(SAM R21 Xpro)3͔rvl0x1000*3/4Ǝې
 *   ɐݒ
 * - 1͓͎ۂł̕ߊlɐݒ
 *
 * EVSYSPʕ̎ێ͎̗lɍ\ݒ肳܂B:
 * - TCCvߊl(SAM D21 Xpro)0܂(SAM R21 Xpro)3ېƂ
 *   I΂܂B
 * - ې͏㏸[oł̓łB
 * - TCCvߊl1͎ێgpłB
 *
 * DMACPʕDMA͎̗lɍ\ݒ肳܂B:
 * - 2DMAgp܂B
 * - DMA͎Ӌ@\Ngp܂B
 * - DMA͋Nŏ]s܂B
 * - DMA16ޯėʂ̏gp܂B
 * - DMA3]Ă̌ɓɏՕōĂьJԂ悤Ɍ`Ԑݒ肳
 *   ܂B
 * - rl𐧌䂷DMA
 *   - TCC0ꂪDMA]N
 *   - ]ڽ܂B
 *   - ]ڽTCC0r/ߊlڼ޽ɌŒ肳܂B
 * - ߊllǂDMA
 *   - 1łTCC0ߊlDMA]N
 *   - ]ڽTCC1r/ߊlڼ޽ɌŒ肳܂B
 *   - ]ڽ܂B
 *   - ߊllSRAM̔zɓ]܂B
 *
 * \section asfdoc_sam0_tcc_dma_use_case_setup Jn
 *
 * \subsection asfdoc_sam0_tcc_dma_use_case_prereq OKv
 * ̎gpʂɂĎOKv͂܂B
 *
 * \subsection asfdoc_sam0_tcc_dma_use_case_setup_code 
 *
 * gp鷯Ăɏ]āAǂ̊֐ɂ旧Ď剞p ̧Ɉȉǉ܂B:
 * - SAM D21 Xplained Pro:
 * \snippet samd21_xplained_pro/conf_quick_start_dma.h definition_pwm
 * \snippet samd21_xplained_pro/conf_quick_start_dma.h definition_feedback
 * \snippet samd21_xplained_pro/conf_quick_start_dma.h definition_dma_compare_trigger
 * \snippet samd21_xplained_pro/conf_quick_start_dma.h definition_dma_capture_trigger
 * - SAM R21 Xplained Pro:
 * \snippet samr21_xplained_pro/conf_quick_start_dma.h definition_pwm
 * \snippet samr21_xplained_pro/conf_quick_start_dma.h definition_feedback
 * \snippet samr21_xplained_pro/conf_quick_start_dma.h definition_dma_compare_trigger
 * \snippet samr21_xplained_pro/conf_quick_start_dma.h definition_dma_capture_trigger
 *
 * ̊֐̊Oňȉ剞p ̧قɒǉ܂B:
 * \snippet qs_tcc_dma.c module_inst
 * \snippet qs_tcc_dma.c capture_variables
 * \snippet qs_tcc_dma.c compare_variables
 *
 * ȉ̍\ݒ躰ނgp҉pɕ/\t܂B:
 * \snippet qs_tcc_dma.c config_event_for_capture
 * \snippet qs_tcc_dma.c config_dma_for_capture
 * \snippet qs_tcc_dma.c config_dma_for_wave
 * \snippet qs_tcc_dma.c setup
 *
 * gp҉p(ʓI\c main()̎n)ɒǉ܂B
 * \snippet qs_tcc_dma.c setup_init
 *
 * \subsection asfdoc_sam0_tcc_dma_use_case_setup_flow Ƃ̗
 * \subsubsection asfdoc_sam0_tcc_dma_use_case_setup_flow_tcc TCC`Ԑݒ
 * -# ꂪgpԂTCCײނ̏Ԃi[邽߂TCCPʕpPʕĳ
 *    ̍\̂쐬܂B
 *    \snippet qs_tcc_dma.c module_inst
 *    \note ͒PʕgpĂ茈ĉ͈͊OɂȂׂł͂
 *          ܂Bwǂ̏ꍇł͑SłB
 * -# ITCCӋ@\̌`Ԑݒ𒲐邽߂ɋL邱ƂłTCCP
 *    `Ԑݒ\̂쐬܂B
 *    \snippet qs_tcc_dma.c setup_config
 * -# Pʕ̊lTCC`Ԑݒ\̂܂B
 *    \snippet qs_tcc_dma.c setup_config_defaults
 *    \note ͑SĂ̒lm̊lɏ邱Ƃۏ؂邽߂Ɍ`
 *          ݒ\̂ĝɐ旧ďɎsׂłB
 * -# v핝Ag`Ar0l`Ԑݒ肷悤TCCݒς
 *    B
 *    \snippet qs_tcc_dma.c setup_change_config
 * -# ޲ ݂łPWMo͂`Ԑݒ肷悤TCCݒς܂B
 *    \snippet qs_tcc_dma.c setup_change_config_pwm
 * -# ]ސݒTCCPʕ`Ԑݒ肵܂B
 *    \snippet qs_tcc_dma.c setup_set_config
 * -# ]TCCPʕpۂ`Ԑݒ肵ċ܂B
 *    \snippet qs_tcc_dma.c setup_events
 * \subsubsection asfdoc_sam0_tcc_dma_use_case_setup_flow_event ۼь`Ԑݒ
 * 0ۂ1ɔz悤EVSYSPʕ`Ԑݒ肵܂B
 * -# ێ̂쐬܂B
 *    \snippet qs_tcc_dma.c capture_event_resource
 *    \note ͒PʕgpĂ茈ĉ͈͊OɂȂׂł͂
 *          ܂Bwǂ̏ꍇł͑SłB
 *
 * -# ێ`Ԑݒ\̂쐬܂B
 *    \snippet qs_tcc_dma.c event_setup_1
 * -# ێ`Ԑݒ\̂lŏ܂B
 *    \snippet qs_tcc_dma.c event_setup_2
 *    \note ͑SĂ̒lm̊lɏ邱Ƃۏ؂邽߂Ɍ`
 *          ݒ\̂ĝɐ旧ďɎsׂłB
 * -# ێ`Ԑݒ]ޒlɒ܂B
 *    \snippet qs_tcc_dma.c event_setup_3
 * -# `Ԑݒ\̂pĎ蓖ĂČ`Ԑݒ肵܂B
 *    \snippet qs_tcc_dma.c event_setup_4
 * -# Ɏgpt܂B
 *    \snippet qs_tcc_dma.c event_setup_5
 * \subsubsection asfdoc_sam0_tcc_dma_use_case_setup_flow_dma_capture ߊlTCC1pDMA`Ԑݒ
 * ߊllTCC1瓾悤DMACPʕ`Ԑݒ肵܂B
 * -# DMÂ쐬܂B
 *    \snippet qs_tcc_dma.c capture_dma_resource
 *    \note ͒PʕgpĂ茈ĉ͈͊OɂȂׂł͂
 *          ܂Bwǂ̏ꍇł͑SłB
 * -# DMA`Ԑݒ\̂쐬܂B
 *    \snippet qs_tcc_dma.c dma_setup_1
 * -# DMA`Ԑݒ\̂lŏ܂B
 *    \snippet qs_tcc_dma.c dma_setup_2
 *    \note ͑SĂ̒lm̊lɏ邱Ƃۏ؂邽߂Ɍ`
 *          ݒ\̂ĝɐ旧ďɎsׂłB
 * -# DMA`Ԑݒ𒲐܂B
 *    \snippet qs_tcc_dma.c dma_setup_3
 * -# `ԐݒDMA蓖Ă܂B
 *    \snippet qs_tcc_dma.c dma_setup_4
 * -# DMA]Lqq܂B
 *  -# DMA]Lqq쐬܂B
 *     \snippet qs_tcc_dma.c capture_dma_descriptor
 *     \note LqqqƁAqꂽڂ͂ꂪ(DMAײޯ ؋
 *           )ݒ肳OɌĉ͈͊OɂȂ܂Bwǂ̏ꍇA1
 *           LqqgpꍇA͍ŏ1đSł
 *           ׂłB
 *  -# DMA]Lqq\̂쐬܂B
 *  -# PDMA]̌`Ԑݒ𒲐̂ɋL邱ƂłDMA]Lqq`
 *     ݒ\̂쐬܂B
 *     \snippet qs_tcc_dma.c dma_setup_5
 *  -# DMA]Lqq`Ԑݒ\̂lŏ܂B
 *     \snippet qs_tcc_dma.c dma_setup_6
 *     \note ͑SĂ̒lm̊lɏ邱Ƃۏ؂邽߂Ɍ`
 *           ݒ\̂ĝɐ旧ďɎsׂłB
 *  -# DMA]Lqq`Ԑݒ𒲐܂B
 *     \snippet qs_tcc_dma.c dma_setup_7
 *  -# ^ꂽ`ԐݒDMA]Lqq쐬܂B
 *     \snippet qs_tcc_dma.c dma_setup_8
 * -# ꂽLqqDMA]ƂJn܂B
 *  -# DMA]Lqq蓖ĂDMAɒǉ܂B
 *     \snippet qs_tcc_dma.c dma_setup_10
 *     \note LqqǉAŌɒǉ̂Lqq҂s̍ŌɌq
 *           ܂B֏ꗗKvƂꍇAւ\z邽߂ɒPɍŏ̋L
 *           qqĂђǉ܂B
 *  -# 蓖ĂDMAƓ]LqqDMA]ƂJn܂B
 *     \snippet qs_tcc_dma.c dma_setup_11
 * \subsubsection asfdoc_sam0_tcc_dma_use_case_setup_flow_dma_compare rTCC0pDMA`Ԑݒ
 * TCC0rlXV悤DAMCPʕ`Ԑݒ肵܂B
 * ̗͕ߊlɑ΂ŌDMA`ԐݒiKƓłB
 * -# DMA蓖ĂČ`Ԑݒ肵܂B
 *    \snippet qs_tcc_dma.c compare_dma_resource
 *    \snippet qs_tcc_dma.c config_dma_resource_for_wave
 * -# DMA]Lqq܂B
 *    \snippet qs_tcc_dma.c compare_dma_descriptor
 *    \snippet qs_tcc_dma.c config_dma_descriptor_for_wave
 * -# LqqDMA]ƂJn܂B
 *    \snippet qs_tcc_dma.c config_dma_job_for_wave
 * -# vJnPWMMn߂邽߂TCCPʕ܂B
 *    \snippet qs_tcc_dma.c setup_enable
 *
 * \section asfdoc_sam0_tcc_dma_use_case_main gp
 *
 * \subsection asfdoc_sam0_tcc_dma_use_case_main_code 
 * ȉ̺ނgp҉pɕ/\t܂B:
 * \snippet qs_tcc_dma.c main
 *
 * \subsection asfdoc_sam0_tcc_dma_use_case_main_flow Ƃ̗
 * -# TCCPʕoRPWMg`ԖJԂɈڍs܂B
 *  \snippet qs_tcc_dma.c main_loop
 */
