/**
 * \file
 *
 * \brief DALI EEPROM`Ԑݒ
 *
 * 쌠 (c) 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef DALI_EEPROM_H
#define DALI_EEPROM_H

/**
 * \brief DALIްi[邽߂ɖ͕EEPROM
 *
 */
void dali_eeprom_init(void);

/**
 * \brief ͕EEPROM ߰ނDALIްǂŌ
 *
 * ͕EEPROM؋Ԃ͕EEPORM߰ންǂŌ܂B
 *
 * \param[in]   logical_page ǂޘ_EEPROM߰ޔԍ
 * \param[out]  buffer       ]ްւ̈ʒuwq
 * \param[in]   size         BCC܂܂ȂDALIް̑傫
 *
 * \return ̏Ԃԕ
 *
 * \retval STATUS_OK                  ߰ނɓǂ߂ꍇ
 * \retval STATUS_ERR_NOT_INITIALIZED EEPROM͕핔ĂȂꍇ
 * \retval STATUS_ERR_BAD_ADDRESS     L͕EEPROM؋ԊOڽꂽ
 *                                    ꍇ
 * \retval STATUS_ERR_BAD_DATA        sްӖBCCُ
 */
uint8_t dali_read_check_eeprom(uint8_t logical_page, uint8_t *buffer, uint8_t size);

/**
 * \brief DALIްBCC͕EEPROM ߰ނɏ
 *
 * ͕EEPROM߰ން͕EEPROM؋Ԃɏ܂B
 *
 * \note ߰ނɊi[ް͊RAM؂ɷ꓾Aꂽް
 *       Iȕs؂Ɉnɂ
 *       \ref eeprom_emulator_commit_page_buffer()֐Ă΂ׂłB
 *
 * \param[in]  logical_page _EEPROM߰ޔԍ
 * \param[in]  buffer       ް܂ްɏՕւ̈ʒuwq
 * \param[in]  size         BCC܂܂ȂDALIް̑傫
 *
 * \return ̏Ԃԕ
 *
 * \retval STATUS_OK                  ߰ނɏꂽꍇ
 * \retval STATUS_ERR_NOT_INITIALIZED EEPROM͕핔ĂȂꍇ
 * \retval STATUS_ERR_BAD_ADDRESS     L͕EEPROM؋ԊOڽꂽ
 *                                    ꍇ
 */
uint8_t dali_check_write_eeprom(uint8_t logical_page, uint8_t *buffer, uint8_t size);

#endif /* DALI_EEPROM_H */
